////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gestin de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_BS_RX_TX_H_
#define __RED_WIRELESS_BS_RX_TX_H_

#include <omnetpp.h>
#include <vector>
#include <time.h>
#include "BS_table.h"
#include "BS_queue.h"
#include "BS_mac.h"
#include "DATA_m.h"
#include "LSA_m.h"
/*
 * MODULO BS_rx_tx:
 * Recibe los mensajes procedentes de modulos externos (usuarios/BSs) para enviarlos al
 * submodulo BS_queue correspondiente, as como enva hacia el modulo externo pertinente
 * los mensajes de los submodulos BS_queue.
 */
typedef std::vector<double> double_vector_t; // VECTOR DE TIPO DOUBLE
typedef std::vector<Analysis> analysis_vector_t; // VECTOR DE TIPO ANALISIS

class BS_rx_tx : public cSimpleModule
{
	public:
		FILE * LSA_;
		FILE * retardo_intermedio;
		FILE * wireless_link_loads;
		FILE * carga_pasarela;
		FILE * datos_recibidos;
		FILE * paquetes_por_bs;
		FILE * retardo_wireless_pasarelas;
		FILE * saltos_metros;
		analysis_vector_t retardo_medio;
		Analysis retardo_pasarela;
		Analysis saltos;
		Analysis longitud;
		Analysis media_carga;
		BS_queue *cola_bs;
		BS_mac *control;
		cTopology top;
		cTopology::Node *nodeOut;
		int BSs;
		int pasarelas;
		int contador_LSAs;
		int prev_LSAs;
		int links;
		int bs_links;
		int indice_esta_bs;
		int esPasarela;
		int encontrado;
		double_vector_t arrived_packets;
		double_vector_t arrived_bytes;
		double_vector_t sent_packets;
		double_vector_t sent_bytes;
		double_vector_t packet_intensity;
		double_vector_t link_load;
		double_vector_t alt_link_load;
		double_vector_t node_load;
		double_vector_t alt_node_load;
		//double_vector_t gateway_arrival_rate;
		double_vector_t aux_samples;
		double carga;
		double paquetes_recibidos;
		double bytes_recibidos;
		double service_rate;
		double effective_capacity;
		double retardo_mensaje;
		double umbral_retardo;
		double tx_rate;
		double optical_tx_rate;
		double channel_bit_rate;
		simtime_t tiempo_canal;
		double T_cycle;
		double bw_cycle;
		double estimated_lambda;
		double t_frame;
		double_vector_t previous_estimated_lambda;
		simtime_t LSA_period;
		simtime_t offset_time;
		int aux_counter;
		int full_bs_queues;
		int prioridades;
		double mean_link_load;
		double mean_alt_link_load;
		double mean_node_load;
		double mean_alt_node_load;
		int total_enlaces;
		double paquetes_borrados_dara;

	protected:
		virtual void initialize();
		virtual void handleMessage(cMessage *msg);
		virtual void finish();
		virtual void insert_Packet(cMessage *msg);
		virtual int get_index_link(int ind);
		virtual void calculate_link_load();
		virtual double calculate_average_transfer_delay();
		virtual void calculate_delay_weight(int indice1, int indice2, cMessage *msg);
		virtual void calculate_weight_params(int ind);
};

#endif
