////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gestin de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_BS_TABLE_H_
#define __RED_WIRELESS_BS_TABLE_H_

#include <omnetpp.h>
#include <vector>
#include "DATA_m.h"
using namespace std;
/*
 * MODULO BS_table:
 * Contiene las diferentes tablas empleadas por el modulo BS para realizar el
 * encaminamiento de los paquetes:
 * array_de_rutas: Tabla con el nombre de los nodos que forman todas las rutas posibles.
 * array_de_longitudes: Tabla con la longitud (metros) de todas las rutas posibles.
 * array_de_retardos: Tabla con el retardo (segundos) de todas las rutas posibles.
 * rutas_optimas: Tabla con la ruta optima para cada usuario inalambrico.
 */
typedef std::vector<long> long_vector_t; // VECTOR DE TIPO ENTERO LARGO
typedef std::vector<double> double_vector_t; // VECTOR DE TIPO DOUBLE
typedef std::vector<char*> string_vector_t; // VECTOR DE TIPO CADENA DE CARACTERES
typedef std::vector<int> int_vector_t; // VECTOR DE TIPO ENTERO
typedef std::vector< int_vector_t > int_matrix_t; // MATRIZ DE TIPO ENTERO
typedef std::vector< long_vector_t > long_matrix_t; // MATRIZ DE TIPO ENTERO LARGO
typedef std::vector<double_vector_t> double_matrix_t; // MATRIZ DE TIPO DOUBLE
typedef std::vector< string_vector_t > string_matrix_t; // MATRIZ DE TIPO CADENA DE CARACTERES


class BS_table : public cSimpleModule
{
  protected:
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);
    virtual void finish();

  public:
    int filas;
    int columnas;
    string_matrix_t array_de_rutas;
    double_matrix_t array_de_longitudes;
    double_matrix_t array_de_retardos;
    double_matrix_t array_de_pesos;

    long_vector_t longitud_total_rutas;
    double_vector_t retardo_total_rutas;
    double_vector_t peso_total_rutas;
    int_vector_t saltos_total_rutas;

    int_matrix_t num_rutas;
    vector<vector<vector<int> > > indices_rutas;

    vector<vector<vector<char*> > > rutas_optimas_pasarelas;
    string_matrix_t rutas_optimas;

    int paquetes_borrados;
};

#endif
