////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti�n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_MAC_OLT_H_
#define __RED_WIRELESS_MAC_OLT_H_

#include <omnetpp.h>
#include <vector>
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include "OLT_Table.h"
#include "ONU_SISTqueue.h"
#include "analysis.h"
using namespace std;

/*
 * MODULO MAC_olt:
 */

//DEFINIMOS LOS TIPOS DE std DE LOS VECTORES Y MATRICES:
typedef std::vector<int> int_vector_t; // VECTOR TIPO ENTERO
typedef std::vector<double> double_vector_t; // VECTOR TIPO DOUBLE
typedef std::vector<simtime_t> simtime_t_vector_t; // VECTOR DE TIPO TIEMPO
typedef std::vector< int_vector_t > int_matrix_t; // MATRIZ DE TIPO ENTERO
typedef std::vector< double_vector_t > double_matrix_t; // MATRIZ DE TIPO DOUBLE



//MODIFICADO para la Red Neuronal
typedef std::vector<Analysis> analysis_vector_t; // VECTOR CLASE ANALISIS
typedef std::vector<analysis_vector_t> analysis_matrix_t; // MATRIZ CLASE ANALISIS
void* Algoritmo_Genetico(void *t);
void InitializeWindow();
void InitializePID(double kp, double ti, double td);
void recoger_bw_por_onu (cMessage *msg);
void PID (cMessage *msg);
void Neural_Network_init();
void Neural_Network_FeedPropagation();
void Neural_Network_BackPropagation();
double Tangente_Hiperbolica(double value);
double Sigmoide (double value);
double Derivada_Tang_Hiperbolica (double value);
double Derivada_Sigmoide(double value);


class MAC_OLT : public cSimpleModule
{
    private:

        FILE * B_alloc_demand;
        FILE * BW_acum;
        FILE * controlfich;
        FILE * evaluacion_retardo_slas_P0;
        FILE * evaluacion_retardo_slas_P1;
        FILE * B_alloc_periodico;
        FILE * bloqueo_cad_daspid_P1;
        FILE * BW_Mbps_sla;
        FILE * retardo_analisis;

        //MODIFICADO POR ALEJANDRO
        // PARAMETRO PARA OBTENER LA DESVIACIÓN MÁXIMA CON LA CLASE ANALISIS
        std::vector <Analysis> desviacionBwMax; // VECTOR DE CLASE ANALISIS PARA CREAR LA DESVIACIÓN MÁXIMA
        // PARAMETRO PARA OBTENER EL RETARDO GLOBAL CON LA CLASE ANALISIS
        std::vector<Analysis> retardo_global_P; // VECTOR DE CLASE ANALISIS PARA CREAR EL RETARDO GLOBAL
        // PARAMETROS PARA OBTENER EL RETARDO DE CADA SLA CON LA CLASE ANALISIS
        std::vector<Analysis> retardo_sla; // VECTOR DE CLASE ANALISIS PARA CREAR EL RETARDO GLOBAL DE CADA SLA
        // PARAMETROS PARA OBTENER EL RETARDO DE CADA SLA CON LA CLASE ANALISIS
        std::vector <std::vector < Analysis > > retardo_servicios_sla; // MATRIZ DE CLASE ANALISIS PARA CREAR EL RETARDO DE LOS SLAs POR SERVICIOS
        // PARAMETRO PARA OBTENER LA MEDIA DE LOS BYTES QUE SE QUEDAN EN LA COLAS DESPUES DE CADA CICLO CON LA CLASE ANALISIS
        std::vector<Analysis> media_bytes_total_onus; // VECTOR DE CLASE ANALISIS PARA CREAR LOS BYTES QUE SE QUEDAN EN LA COLAS DESPUES DE CADA CICLO


	public:

        int numInitStages() const; // FUNCION QUE INICIALIZA VARIAS ETAPAS.

        ONU_SISTqueue *onu_queue; // DEFINIMOS VARIABLE PARA PODER ENTRAR EN EL MODULO OLT_TABLE
        OLT_Table *table_module; // DEFINIMOS VARIABLE PARA PODER ENTRAR EN EL MODULO OLT_TABLE

        std::vector <Analysis> desviacion;

        vector<vector<vector<vector<double> > > > vector_ventana;

        double_vector_t B_demand; // VECTOR DEL ANCHO DE BANDA DEMANDADO
        double_vector_t t_slot; // VECTOR DE TIEMPO DE SLOT DE LA ONU
        double_vector_t t_slot_initialization; // VECTOR DE TIEMPO DE SLOT DE LA ONU
        double_vector_t T_alloc; // VECTOR DE TIEMPO ASIGNADO PARA TRANSMITIR
        double_vector_t B_ex_sla; // VECTOR DEL ANCHO DE BANDA ASOCIADO A CADA ONU SEGUN EL SLA ASOCIADO A LA ONU
        double_vector_t B_max_dmb; // VECTOR DEL ANCHO DE BANDA MAXIMO PARA CADA ONU
        double_vector_t B_max_sla_ant; //ANCHO DE BANDA MAXIMO POR SLA
        double_vector_t error; //VECTOR QUE GUARDA EL ERROR POR ONU DEL PID
        double_vector_t B_Mbps;
        double_vector_t desviacionBwMaxGuar;
        double_vector_t cont_var_BwMax;
        double_vector_t var;
        double_vector_t var_Mbps;
        double_vector_t cont_var;
        double_vector_t error_abs;
        double_vector_t error_rel;
        double_vector_t var_Mbps_instantaneo;
        double_vector_t sum_error_delay;
        double_vector_t error_ant_delay;
        double_vector_t paquetes_borrados_P1;
        double_vector_t paquetes_recibidos_P1;

        int_vector_t B_extra; // VECTOR DEL ANCHO DE BANDA EXTRA QUE SE ASIGNA A MAYORES
        int_vector_t SLA_onu; // VECTOR EN EL QUE SE INTRODUCIRA LOS PESOS ASOCIADOS AL SLA QUE CORRESPONDE A CADA ONU
        int_vector_t Wsla; // VECTOR DE LOS PESOS DE CADA SLA
        int_vector_t numsla; // VECTOR QUE NOS GUARDA EL NUMERO DE SLA ASOCIADO A CADA ONU
        int_vector_t numero_sla; //VECTOR QUE GUARDA EL NUMERO DE SLA PARA MANDAR EL GATE
        int_vector_t BW_sla;

        double_matrix_t delay_onu; // Suma del retardo de todos los paquetes recibidos en un ciclo de cada ONU y prioridad
        double_matrix_t retardo_alg_SLA;
        double_matrix_t retardo_acum_SLA;
        double_matrix_t retardo_alg_ONU;
        double_matrix_t retardo_max_ONU;

        int_matrix_t paq_onu; // Numero total de paquetes recibidos en un ciclo de cada ONU y prioridad

        simtime_t_vector_t delay_pon2; // VECTOR DEL RETARDO DEL SEGMENTO DE LA RED QUE UNE EL SPLITTER Y CADA ONU
        simtime_t_vector_t delay_total; // VECTOR DE LA SUMA DE LOS RETARDOS DE CADA SEGMENTO DE LA RED (OLT-SPLITTER Y SPLITTER-ONU)
        simtime_t_vector_t tiempo_tx_sig; //VECTOR PARA LAS VARIABLES DE TIEMPO DE LA SIGUIENTE ONU

        simtime_t tstarttime; // VARIABLE DEL TIEMPO DE INICIO DE TRANSMISION
        simtime_t tiempo_tx_siguiente; // VARIABLE DE TIEMPO DE TRANSMISION DE LA SIGUIENTE ONU
        simtime_t tiempo_sim_delay_datarate; // VARIABLE DE TIEMPO DE LA SUMA DEL TIEMPO DE SIMULACION, RETARDO Y TIEMPO DE TRANSMISION DEL PAQUETE GATE
        simtime_t delay_pon1; // RETARDO DEL SEGMENTO DE LA RED QUE UNE EL OLT Y EL SPLITTER

        double delay; // RETARDO DE NUESTRA RED DEPENDIENDO DE LA LONGITUD TOTAL DE LA RED
        double W_min; // PESO MANIMO CON UN VALOR FIJO DE 0.34
        double long_max; // LONGITUD MAXIMA QUE TIENE UNA ONU PARA TRANSMITIR DEPENDIENDO DEL B_cycle Y DEL NUMERO DE ONUs
        double B_basico; // ANCHO DE BANDA BASICO PARA TRANSMITIR QUE TIENE CADA ONU.
        double sumatorio; // VARIABLE QUE NOS INDICA EL SUMATORIO DE CADA PESO ASOCIADO A UN SLA POR SU NUMERO DE ONUS ASOCIADOS A SLA
        double tiempo_inic_HILO;

        int id_onu; // IDENTIFICADOR DE LA ONU
        int aux; //VARIABLE AUXILIAR
        int id;
        int intento;
        int prueba;
        int flagPrioridad;
        int flag_control_delay;
        int no_capacidad; //?
        int primera_vez;
        int aux_cont;
        int cont_auxiliar;
        int contador_aux;

        long sumqueue; // VARIABLE DEL TAMANYO DE LA SUMA DE LOS PAQUETES DE LAS COLAS
        long sumbdemand; // VARIABLE DEL TAMANYO DE LA SUMA DEL ANCHO DE BANDA DEMANDADO
        long B_sobra; // VARIABLE DEL ANCHO DE BANDA DE SOBRA
        long B_exceded; // VARIABLE DEL ANCHO DE BANDA EN EXCESO


        //MODIFICADO POR ALEJANDRO
        //Variables añadidas a la inicialización del OLT_RX
        int_vector_t num_sla;   // VECTOR PARA GUARDAR EL IDENTIFICADOR DEL SLA DE LA ONU ASOCIADA
        int_vector_t tam_packet_queue; // TAMANYO EN BYTES QUE QUEDAN EN LAS COLAS DESPUES DE CADA CICLO
        simtime_t_vector_t retardo_P; // VECTOR DONDE GUARDAMOS EL RETARDO GLOBAL DE LOS SERVICIOS
        simtime_t_vector_t retardo; // VECTOR DONDE GUARDAMOS EL RETARDO DE LOS SLAs
        double numReceived; // VARIABLE PARA CONTAR EL NUMERO DE PAQUETES ETHERNET RECIBIDOS
        double total_bytes_received; //VARIABLE PARA CONTAR EL NUMERO DE BYTRES RECIBIDOS
        double total_bits_received; //VARIABLE PARA CONTAR EL NUMERO DE BITS RECIBIDOS
        double tiempoSimulacion;
        double tiempo_fin_training;


        // MODIFICADO POR DAVID para el algoritmo TWDM
        double_vector_t B_alloc_lambda_prueba; // VECTOR DEL ANCHO DE BANDA DEMANDADO
        double_vector_t B_total_wdm;
        double overhead;
        int cont3;
        int cont4;


        // MODIFICADO ALGORITMO FEXDBABandwidth
        double_vector_t B_init;
        double_vector_t B_min;
        double_vector_t B_max_onu;
        double_vector_t B_excess_onu;
        double_vector_t w_onu;
        double_vector_t pi_onu;
        double_vector_t xm_onu;
        double_matrix_t jitter_servicios_sla;
        double_matrix_t jitter_servicios_sla_anterior;
        double_matrix_t jitter_servicios_sla_max;
        double_matrix_t retardoAnterior;
        int contprueba;
        int contadorFair;


	protected:

	    virtual void initialize(int stage);
	    virtual void handleMessage(cMessage *msg);

	    virtual void centralizedmethod_DMB(cMessage *msg); // DEFINICION DE LA FUNCION DEL METODO DMB DEL OLT
	    virtual void pollingmethod_IPACT(cMessage *msg); // DEFINICION DE LA FUNCION DEL METODO IPACT DEL OLT
	    virtual void wdmmethod (cMessage *msg); //DEFINICION DE LA FUNCION PARA EL METODO CON MODULACION WDM
	    virtual void DBA_polling_PID (cMessage *msg);
	    virtual void DBA_polling_DaSPID (cMessage *msg); //NUEVA//
	    virtual void PID_control_delay (cMessage *msg); //NUEVA//
	    virtual void recoger_delay_por_sla (int sla, double retardo, int prioridad); //NUEVA//
	    //virtual void PID (cMessage *msg);
	    //virtual void recoger_bw_por_onu (cMessage *msg);
	    virtual void calcularvarianza (cMessage *msg);
	    virtual void finish();


	    // MODIFICADO ALGORITMO FEXDBABandwidth
	    virtual void FairExcessBandwidht(cMessage *msg);
	    virtual void recoger_Bdemand(cMessage *msg);


	    //MODIFICADO POR ALEJANDRO
	    long double throughput;


};

#endif
