////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA                                                                                                          //
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti���n de recursos en //
//           redes de acceso FiWi                                                                                               //
// AUTOR: Ana Emma Lopez Mato                                                                                                           //
// TUTOR: Noemi Merayo Alvarez                                                                                                      //
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION                   //
// UNIVERSIDAD DE VALLADOLID                                                                                                    //
//////////////////////////////////////////////////////////////////////////////////////

#include "MAC_ONU.h"
#include "MAC_OLT.h"
#include <vector>
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include "ONU_Table.h"
#include "OLT_Rx.h"


/*
 * MODULO MAC_onu:
 */
Define_Module(MAC_ONU);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION NUMINITSTAGES()--> ESTA FUNCION INICIALIZA VARIAS ETAPAS. SE DEFINE PARA QUE DEVUELVA EL NUMERO DE ETAPAS DE INICIO.  //
//                           EN NUESTRO CASO, LA FUNCION DEVUELVE EL VALOR 1 YA QUE SOLO TENEMOS UNA ETAPA DE INICIALIZACION.   //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int MAC_ONU::numInitStages() const{return 1;}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPU��S DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS      //
//                        PARAMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE //
//                        ASIGNAN ESTRUCTURAS DE DATOS DINAMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  //
//                        PARA EL FUNCIONAMIENTO DE ESTE MODULO.                                                                //
//                        LA FUNCION INITIALIZE(INT STAGE) SE UTILIZA PARA INICIALIZAR VARIAS ETAPAS SEGUN EL VALOR STAGE.      //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MAC_ONU::initialize(int stage)
{
    //Definimos una serie de parametros que necesitaremos para la utilizacion/actualizacion del CAD
    max_control_admision.resize(3); // UNO POR SLA
    max_control_admision[0] = 0.015;
    max_control_admision[1] = 0.06;
    max_control_admision[2] = 0.18;

    tiempo_inic_actualizacionCAD = 50;//Cada cuanto se envia el mensaje para actualizar el valor del CAD
    delay_max_permitido=0;
    delay_ventana=0;

    numsla_onu.resize((int)par("numOnu"),0); // VECTOR QUE GUARDA EL IDENTIFICADOR DE SLA ASOCIADO A LA ONU. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL NUMERO DE ONUS DE NUESTRA RED
    //lambda; //VARIABLE PARA ESTABLECER PORQUE LAMBDA ENVIAREMOS EL PAQUETE REPORT

    // DEFININOS EL PROCESO PARA PODER ENTRAR DESDE ESTE MODULO AL MODULO ONU_TABLE
    cModule *c_onutable_module;
    if(stage==0)
    {
        c_onutable_module = getParentModule()->getSubmodule("onu_table"); // CAMINO PARA LLEGAR HASTA EL MODULO ONU_TABLE
        onutable_module = check_and_cast<ONU_Table *>(c_onutable_module); // ENTRAMOS Y CHEQUEAMOS EL MODULO ONU_TABLE
    }

     //-----automensaje para la actualizacion del CAD-----
    cMessage *msgprueba = new cMessage ("mensaje actualizacion cad");
    msgprueba->setKind(14); // IDENTIFICAMOS EL AUTOMENSAJE CON EL IDENTIFICADOR = 14
    //scheduleAt(tiempo_inic_actualizacionCAD, msgprueba);

    T_cycle_prev = 0.0;
    T_init_prev = 0.0;
    B_alloc_prev = 0.0;


}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//                                        UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O      //
//                                        EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//                                        DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL   //
//                                        CODIGO IMPLEMENTADO.                                                                  //                                                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MAC_ONU::handleMessage(cMessage *msg)
{
    // VARIABLES
    int type = msg->getKind(); // VARIABLE TYPE PARA IDENTIFICAR LOS MENSAJES DE LA RED
    int destAddress = 9; // DEFINIMOS EL IDENTIFICADOR DE LA DIRECCION DE DESTINO DE LOS PAQUETES REPORT
    int srcAddress = getParentModule()->getIndex(); // DEFINIMOS EL IDENTIFICADOR DE LA DIRECCION FUENTE DE LOS PAQUETES GATE
    int tamqueuereport[(int)par("numqueue")]; // VARIABLE DE TAMANYO DE LAS COLAS DEL MENSAJE REPORT CON TAMANYO IGUAL AL NUMERO DE COLAS QUE DEFINAMOS

    // GENERAMOS CON EL BUCLE FOR LA VARIABLE DEL TAMANYO DE LAS COLAS
    for(int b=0; b<(int)par("numqueue"); b++)
    {
        tamqueuereport[b] = 0; // DAMOS EL VALOR 0 A LA VARIABLE DEL TAMANYO DE LAS COLAS DEL PAQUETE REPORT
    }
    double bandwitch;
    double T_init_actual = 0.0;

    // ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA LOS MENSAJES QUE LLEGUEN A ESTE MODULO
    switch(type)
    {
        case 0:
            // LLEGA UN PAQUETE GATE CON IDENTIFICADOR = 0
            if(msg->getKind()==0)
            {
                GATEmsg *gatemsg = check_and_cast<GATEmsg *>(msg); // CHEQUEAMOS EL PAQUETE GATE

                lambda=gatemsg->getLambdagate();
                //ev<<" Paquete 'Gate' recibido por lambda: "<<lambda<<endl;

                numsla_onu[this->getParentModule()->getIndex()] = gatemsg->getNumsla(); // ASIGNAMOS EL IDENTIFICADOR DEL SLA ASOCIADO A LA ONU AL VECTOR numsla_onu[]

                // COMPARAMOS EL METODO DE EXTRACCION DE PAQUETES QUE SE DEFINE EN OMNETPP.INI
                if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
                {
                    // VISUALIZAMOS POR PANTALLA CAMPOS DEL PAQUETE GATE
                    //ev<<" Onu "<<gatemsg->getDestAddress()<<endl;
                    //ev<<" Tiempo de comienzo a transmitir: "<<gatemsg->getGrant_IniTime()<<endl;
                    //ev<<" Ancho de Banda de slot: "<<gatemsg->getGrant_IntervalTx(0)<<endl;

                    // GUARDAMOS EN LA TABLA CREADA EN EL MODULO ONU_TABLE LOS VALORES DEL TIEMPO DE INICIO DE TRANSMISION Y DE ANCHO DE BANDA DE SLOT
                    onutable_module->table_onu_gate_time[0] = gatemsg->getGrant_IniTime();
                    onutable_module->table_onu_gate[0] = gatemsg->getGrant_IntervalTx(0);

                    T_init_actual = SIMTIME_DBL(onutable_module->table_onu_gate_time[0]);
                    T_cycle_prev = T_init_actual - T_init_prev;
                    //ev<<" Tiempo de incio de tx del ciclo anterior: " << T_init_pr//ev<<endl;
                    //ev<<" Tiempo de incio de tx del ciclo siguiente: " << T_init_actual << endl;
                    //ev<<" Duracion del ciclo anterior: " << T_cycle_pr//ev<<endl;
                    // Para el proximo ciclo:
                    T_init_prev = T_init_actual;
                    B_alloc_prev = (double) 8*onutable_module->table_onu_gate[0];
                }
                else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
                {
                    // GUARDAMOS EN LA TABLA DEL MODULO ONU_TABLE EL TIEMPO DE INICIO DE TRANSMISION Y LO VISUALIZAMOS POR PANTALLA
                    onutable_module->table_onu_gate_time[0] = gatemsg->getGrant_IniTime();
                    //ev<<" Tiempo de comienzo a transmitir: "<<gatemsg->getGrant_IniTime()<<endl;

                    // MEDIANTE EL FOR, GUARDAMOS EN LA TABLA DEL MODULO ONU_TABLE EL ANCHO DE BANDA DE SLOT DE CADA COLA Y LO VISUALIZAMOS POR PANTALLA
                    for(int i=0; i<(int)par("numqueue"); i++)
                    {
                        onutable_module->table_onu_gate[i] = gatemsg->getGrant_IntervalTx(i);
                        //ev<<" Ancho de Banda de slot de la cola "<<i<<": "<<gatemsg->getGrant_IntervalTx(i)<<"Bytes"<<endl;
                    }
                }

                // COMPARAMOS EL IDENTIFICADOR DE LA DIRECCION DE DESTINO CON EL PROPIO IDENTIFICADOR DE LA ONU
                if(gatemsg->getDestAddress() == getParentModule()->getIndex())
                {
                    // CREAMOS UN AUTOMENSAJE PARA GENERAR EL MENSAJE REPORT
                    cMessage *msg = new cMessage ("mensaje inicial report");
                    msg->setKind(5); // IDENTIFICADOR DEL AUTOMENSAJE
                    scheduleAt(onutable_module->table_onu_gate_time[0], msg);
                    // EL AUTOMENSAJE SE MANDA EN EL INSTANTE QUE CONTENIA EL CAMPO getGrant_IniTime() DEL PAQUETE GATE
                }

                delete gatemsg; // BORRAMOS EL PAQUETE GATE
            }
            break;

        case 1:
            // LLEGA UN PAQUETE ETHERNET CON IDENTIFICADOR = 1
             if(msg->getKind()==1)
            {
                //ev<<" Envio mensaje Ethernet (Id. " << msg->getId() << ") al modulo 'ONU_WDMSplitter'." << endl;
                send(msg, "macrxuserOut"); // ENVIA EL PAQUETE ETHERNET QUE SON PARA ELLA HACIA EL MODULO ONU_RXUSER
            }
            break;

        case 5:
            // LLEGA UN AUTOMENSAJE CON IDENTIFICADOR = 5 PARA GENERAR EL PAQUETE REPORT
            if(msg->getKind()==5)
            {
                delete msg; // BORRAMOS EL AUTOMENSAJE YA QUE NO SE UTILIZA MAS VECES

                //CREAMOS EL PAQUETE REPORT
                REPORTmsg *packet = new REPORTmsg("report");
                packet->setByteLength(64); // TAMANYO DEL PAQUETE REPORT
                packet->setSrcAddress(srcAddress); // DIRECCION DE ORIGEN O FUENTE
                packet->setDestAddress(destAddress); // DIRECCION DE DESTINO
                packet->setPriority((int)par("numqueue")); // PRIORIDAD DEL PAQUETE REPORT
                packet->setLambdareport(lambda); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE REPORT
                packet->setKind(2);// IDENTIFICADOR DEL PAQUETE REPORT
                packet->setQueue_estadoArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ESTADO DE LAS COLAS DE LA ONU
                packet->setNumsla(numsla_onu[getIndex()]); // IDENTIFICADOR DEL SLA DE LA ONU
                //packet->setQueue_sizeArraySize((int)par("numqueue"));
                // BUCLE FOR PARA ASIGNAR EL ESTADO DE LAS COLAS
                //int aux_pckts = 0;
                for(int i=0; i<(int)par("numqueue"); i++)
                {
                    //aux_pckts = (int) check_and_cast<ONU_SISTqueue *>(getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i))->queue.getLength();
                    packet->setQueue_estado(i,tamqueuereport[i]);
                    //packet->setQueue_size(i,aux_pckts);
                }
                packet->setBandwitchArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ANCHO DE BANDA DEMANDADO DE LA ONU

                // DEPENDIENDO DEL METODO DE EXTRACCION DE PAQUETES, SE DEFINE UN ANCHO DE BANDA GENERAL O UNO PARA CADA COLA
                if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
                {
                    // DAMOS A LA VARIABLE bandwitch EL VALOR QUE ESTABA GUARDADO EN LA TABLA DEL MODULO ONU_TABLE
                    // TAMANYO TOTAL DE BYTES QUE TENEMOS PARA SACAR MENSAJES DE LAS COLAS
                    bandwitch = onutable_module->table_onu_gate[0];
                    packet->setBandwitch(0,bandwitch);
                    //ev<<" Bandwitch para transmitir paquetes: "<<packet->getBandwitch(0)<<endl;
                }
                else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
                {
                    // BUCLE FOR PARA DEFINIR UN ANCHO DE BANDA PARA CADA COLA
                    for(int i=0; i<(int)par("numqueue"); i++)
                    {
                        // DEFINIMOS EL ANCHO DE BANDA PARA CADA COLA
                        // TAMANYO TOTAL DE BYTES QUE TENEMOS PARA SACAR MENSAJES DE CADA COLA
                        bandwitch = onutable_module->table_onu_gate[i];
                        packet->setBandwitch(i,bandwitch);
                        //ev<<" Bandwitch para transmitir paquetes cola "<<i<<": "<<packet->getBandwitch(i)<<endl;
                    }
                }

                // ENVIAMOS LOS PAQUETES REPORT HACIA EL MODULO DEL GENERADOR
                send(packet, "macgenOut");
            }
            break;


        case 14: //Para la actualizaci��n din��mica del CAD
                    //ev<<"HA LLEGADO AQUI CASE 14"<<endl;
                if(type==14){
                    //ev<<"ESTAMOS EN EL IF"<<endl;

                    /* Como estamos en MAC_ONU.cc estas dos l��neas no ser��n necesarias como en ONU_SISTqueue
                    MAC_ONU *onu_mac;
                    onu_mac = check_and_cast<MAC_ONU *>(this->getParentModule()->getParentModule()->getSubmodule("onu_mac"));*/

                    MAC_OLT *olt_mac;
                    olt_mac = check_and_cast<MAC_OLT *>(this->getParentModule()->getParentModule()->getSubmodule("olt")->getSubmodule("olt_mac"));
                    olt_mac->paquetes_recibidos_P1[numsla_onu[this->getParentModule()->getParentModule()->getIndex()]]++;


                    //  int num_ONU=(int) this->getParentModule()->getParentModule()->getParentModule()->par("numOnu");
                    /*Para comprobar los paquetes que llegan a cada SLA
                    ev<< "Los paquetes recibidos para SLA0 son"<<olt_mac->paquetes_recibidos_P1[0]<<endl;
                    ev<< "Los paquetes recibidos para SLA1 son"<<olt_mac->paquetes_recibidos_P1[1]<<endl;
                    ev<< "Los paquetes recibidos para SLA2 son"<<olt_mac->paquetes_recibidos_P1[2]<<endl; */

                    //PARA COMPROBAR EL SLA EN EL QUE ESTAMOS Y EN FUNCI��N DE ELLO ESTABLECER LOS RETARDOS
                    for(int m=0;m<(int)par("numSLA");m++){
                        if(m==0){

                            delay_max_permitido=olt_mac->retardo_max_ONU[0][1]; //[onuSla][prioridad]Tomamos[0] ya que el SLA0 se constituye de las onus 0,1
                            delay_ventana=olt_mac->retardo_alg_SLA[0][1]; //Permite recoger el retardo de ventana existente a cada momento para SLA0 P1
                            //ev <<" Retardo max permitido SLA0: " << delay_max_permitido << endl;
                            //ev <<" Retardo de la ventana SLA0: " << delay_ventana << endl;

                                if(delay_ventana>delay_max_permitido){ //Comprobaci��n con la que se reajusta el valor del CAD
                                    max_control_admision[m]=max_control_admision[m]-(0.10*max_control_admision[m]);
                                    if(max_control_admision[m]<delay_max_permitido){
                                        max_control_admision[m]=delay_max_permitido;
                                    }
                                    else{
                                        max_control_admision[m]=max_control_admision[m];
                                    }
                                    //ev <<" Maximo control de admision para: " << m << " es " <<max_control_admision[m] << endl;
                                }

                                if(delay_ventana<delay_max_permitido){
                                    max_control_admision[m]=max_control_admision[m]+(0.10*max_control_admision[m]);
                                    if(max_control_admision[m]>(5*delay_max_permitido)){
                                        max_control_admision[m]=(5*delay_max_permitido);
                                    }
                                    else{
                                        max_control_admision[m]=max_control_admision[m];
                                    }
                                    //ev <<" Maximo control de admision para: " << m << " es " << max_control_admision[m] << endl;
                                }
                        }
                        if(m==1){
                            delay_max_permitido=olt_mac->retardo_max_ONU[2][1];//Tomamos [2] ya que el SLA1 se constituye de las onus de 2 a 7
                            delay_ventana=olt_mac->retardo_alg_SLA[1][1]; //Permite recoger el retardo de ventana existente a cada momento para SLA1 P1
                            //ev <<" Retardo max permitido SLA1: " << delay_max_permitido << endl;
                            //ev <<" Retardo de la ventana SLA1: " << delay_ventana << endl;

                            if(delay_ventana>delay_max_permitido){ //Comprobaci��n con la que se reajusta el valor del CAD
                                max_control_admision[m]=max_control_admision[m]-(0.10*max_control_admision[m]);
                                        if(max_control_admision[m]<delay_max_permitido){
                                            max_control_admision[m]=delay_max_permitido;
                                        }
                                        else{
                                            max_control_admision[m]=max_control_admision[m];
                                        }
                                //ev <<" Maximo control de admision para: " << m << " es " <<max_control_admision[m] << endl;
                            }

                            if(delay_ventana<delay_max_permitido){
                                max_control_admision[m]=max_control_admision[m]+(0.10*max_control_admision[m]);
                                        if(max_control_admision[m]>(5*delay_max_permitido)){
                                            max_control_admision[m]=(5*delay_max_permitido);
                                        }
                                        else{
                                            max_control_admision[m]=max_control_admision[m];
                                        }
                                //ev <<" Maximo control de admision para: " << m << " es " << max_control_admision[m] << endl;
                            }

                        }
                        if(m==2){
                            delay_max_permitido=olt_mac->retardo_max_ONU[8][1]; //Tomamos[8] ya que el SLA2 se constituye de las onus de 8 a 15
                            delay_ventana=olt_mac->retardo_alg_SLA[2][1]; //Permite recoger el retardo de ventana existente a cada momento para SLA2 P1
                            //ev <<" Retardo max permitido SLA2: " << delay_max_permitido << endl;
                            //ev <<" Retardo de la ventana SLA2: " << delay_ventana << endl;

                            if(delay_ventana>delay_max_permitido){ //Comprobaci��n con la que se reajusta el valor del CAD
                                max_control_admision[m]=max_control_admision[m]-(0.10*max_control_admision[m]);
                                    if(max_control_admision[m]<delay_max_permitido){
                                        max_control_admision[m]=delay_max_permitido;
                                    }
                                    else{
                                        max_control_admision[m]=max_control_admision[m];
                                    }
                                //ev <<" Maximo control de admision para: " << m << " es " <<max_control_admision[m] << endl;
                            }

                            if(delay_ventana<delay_max_permitido){
                                max_control_admision[m]=max_control_admision[m]+(0.10*max_control_admision[m]);
                                    if(max_control_admision[m]>(5*delay_max_permitido)){
                                        max_control_admision[m]=(5*delay_max_permitido);
                                    }
                                    else{
                                        max_control_admision[m]=max_control_admision[m];
                                    }
                                //ev <<" Maximo control de admision para: " << m << " es " << max_control_admision[m] << endl;
                            }
                        }

                        /*if(delay_ventana>delay_max_permitido){ //Comprobaci��n con la que se reajusta el valor del CAD
                            max_control_admision[m]=max_control_admision[m]-(0.10*max_control_admision[m]);
                            ev <<" Maximo control de admision para: " << m << " es " <<max_control_admision[m] << endl;
                        }

                        if(delay_ventana<delay_max_permitido){
                            max_control_admision[m]=max_control_admision[m]+(0.10*max_control_admision[m]);
                            ev <<" Maximo control de admision para: " << m << " es " << max_control_admision[m] << endl;
                        }*/

                    }

                    tiempo_inic_actualizacionCAD=tiempo_inic_actualizacionCAD+50; //Para que se realize din��micamente la actualizaci��n del valor del CAD (+1seg en este caso)

                    cMessage *msgPrueba = new cMessage ("mensaje actualizacion cad");
                    msgPrueba->setKind(14); // IDENTIFICAMOS EL AUTOMENSAJE CON EL IDENTIFICADOR = 8
                    scheduleAt(tiempo_inic_actualizacionCAD, msgPrueba);


                    //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL VALOR DEL CAD PARA LA CLASE P1, POR CADA SLA:
                    Valor_cad_daspid_P1=fopen("results/Valor_CAD_DaSPID_P1.txt", "a+");
                    //" T \t  SLA_0  \t  SLA_1  \t  SLA_2  \n"
                    fprintf(Valor_cad_daspid_P1," %g \t %g \t %g \t %g \n" , SIMTIME_DBL(simTime()), max_control_admision[0], max_control_admision[1], max_control_admision[2]);
                    fclose(Valor_cad_daspid_P1);

                }
            break;

        default:
            delete msg;
            break;
    }
}

