////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti���n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_MAC_ONU_H_
#define __RED_WIRELESS_MAC_ONU_H_

#include <omnetpp.h>
#include <vector>
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include "ONU_Table.h"


/*
 * MODULO MAC_onu:
 */

//DEFINIMOS LOS TIPOS DE std DE LOS VECTORES Y MATRICES:
typedef std::vector<int> int_vector_t; // VECTOR TIPO DOUBLE
typedef std::vector<double> double_vector_t; // VECTOR TIPO DOUBLE
typedef std::vector< double_vector_t > double_matrix_t; // MATRIZ DE TIPO DOUBLE

class MAC_ONU : public cSimpleModule
{
	private:
		FILE * Valor_cad_daspid_P1;
		ONU_Table *onutable_module; // DEFINIMOS VARIABLE PARA PODER ENTRAR EN EL MODULO ONU_TABLE
		int lambda; //VARIABLE PARA ESTABLECER PORQUE LAMBDA SE ENVIARA EL PAQUETE REPORT

	protected:
    	 virtual void initialize(int stage);
    	 virtual void handleMessage(cMessage *msg);

	public:
		int numInitStages() const; // FUNCION QUE INICIALIZA VARIAS ETAPAS.
		double T_cycle_prev;
		double T_init_prev;
		double B_alloc_prev;
		int_vector_t numsla_onu; // VECTOR QUE GUARDA EL IDENTIFICADOR DE SLA ASOCIADO A LA ONU

		double tiempo_inic_actualizacionCAD;    //Cada cuanto se envia el mensaje para actualizar el valor del CAD
		double delay_max_permitido; //Parametro con el que trabaja el CAD dinamico
		double delay_ventana;   //Parametro con el que trabaja el CAD dinamico
		double_vector_t max_control_admision;

};

#endif
