////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti�n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#include "OLT_Rx.h"
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include "DATA_m.h"
#include "analysis.h"
#include <string.h>
#include <stdio.h>
#include <vector>
#include "MAC_OLT.h"
#include <math.h>


/*
 * MODULO OLT_rx:
 */
Define_Module(OLT_Rx);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPUES DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS      //
//						  PARAMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE //
//						  ASIGNAN ESTRUCTURAS DE DATOS DINAMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  //
//						  PARA EL FUNCIONAMIENTO DE ESTE MODULO.			   													//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void OLT_Rx::initialize()
{
	contador = 0;
	volcado = 0;
	num_sla.resize((int)par("numOnu"),0); // VECTOR PARA GUARDAR EL IDENTIFICADOR DEL SLA DE LA ONU ASOCIADA. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL NUMERO DE ONUS DE NUESTRA RED
	numReceived = 0; // INICIALIZAMOS EL NUMERO DE PAQUETES ETHERNET RECIBIDOS A 0
	WirelessRx = 0;
	OpticalRx = 0;
	OpticalBytes = 0;
	WirelessBytes = 0;
	onus = (int) par("numOnu");
	prioridades = (int)par("numqueue");
	carga_onu.resize(onus);
	TotalBytes.resize(onus,0);
	PriorityBytes.resize(onus);
	for(int i=0;i<onus;i++)
	{
		PriorityBytes[i].resize(prioridades);
	}
	carga_prioridades.resize(onus);
	for(int i=0;i<onus;i++)
	{
		carga_prioridades[i].resize(prioridades);
	}
	carga_cola = 0.0;
	carga_prioridad = 0.0;
	throughput = 0; //INICIALIZAMOS A 0 LA SUMA DE LOS PAQUETES ETHERNET QUE LLEGAN
	total_bits=0; //INICIALIZAMOS A 0 LA SUMA DE LOS PAQUETES ETHERNET EN BITS
	total_bits_throughput = 0; //INICIALIZAMOS A 0 LA VARIABLE EN BITS POR SEGUNDO
	total_bits_report = 0; //INICIALIZAMOS A 0 LA SUMA DE LOS PAQUETES REPORT EN BITS
	throughput_report = 0; //INICIALIZAMOS A 0 LA SUMA DE LOS PAQUETES REPORT QUE LLEGAN
	total_bits_throughput_report = 0; //INICIALIZAMOS A 0 LA SUMA DE LOS PAQUETES REPORT EN BITS
	throughput_cabecera = 0;  //INICIALIZAMOS A 0 LA SUMA DE LOS PAQUETES ETHERNET QUE LLEGAN SIN LA CABECERA
	total_bits_cabecera = 0; //INICIALIZAMOS A 0 LA SUMA DE LOS PAQUETES ETHERNET EN BITS SIN LA CABECERA
	total_bits_throughput_cabecera = 0; //INICIALIZAMOS A 0 LA SUMA DE LOS PAQUETES ETHERNET SIN LA CABECERA EN BITS
	B_guarda = 0;
	B_guarda_total = 0;
	total_bw_perdido_bits=0;
	total_time_perdido=0;
	media=0;
	numpaquetes=0;
	plr_total=0;

	retardo_global_P.resize(prioridades);
	retardo_sla.resize((int)par("numSLA"));
	retardo_servicios_sla.resize((int)par("numSLA"));
	for(int i=0; i<(int)retardo_servicios_sla.size(); i++)
	{
		retardo_servicios_sla[i].resize(prioridades);
	}
	media_bytes_total_onus.resize(prioridades);
	retardo_P.resize(prioridades,0);
	retardo.resize((int)par("numSLA"),0);
	tam_packet_queue.resize(prioridades,0);
	var_Mbps.resize((int)par("numSLA"),0);
	cont_var.resize((int)par("numSLA"),0);
	desviacion.resize((int)par("numSLA"));
	plr_sla.resize((int)par("numSLA"));
	throughput_sla.resize((int)par("numSLA")+2,0);
	cont_aux=1;
	total_bits_sla.resize((int)par("numSLA")+2,0);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//										  UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O  	//
//										  EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//										  DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL	//
//										  CODIGO IMPLEMENTADO.																	//                                                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void OLT_Rx::handleMessage(cMessage *msg)
{
	// VARIABLES
	int type = msg->getKind(); // VARIABLE TYPE PARA IDENTIFICAR LOS MENSAJES DE LA RED
	long size;
	long size_throughput;
	long size_cabecera;
	double T_guarda = 0.000001; // TIEMPO DE GUARDA QUE SE ESPERA ENTRA LA TRANSMISION DE DOS ONUS (CAMBIAR DE MANERA MANUAL)
	double T_guarda_bits;

	// ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA LOS MENSAJES QUE LLEGUEN A ESTE MODULO
	switch(type)
	{
		case 1:
			// LLEGA UN PAQUETE ETHERNET CON IDENTIFICADOR = 1
			if(msg->getKind()==1)
			{
				ETHERNETmsg *ethernetmsg=check_and_cast<ETHERNETmsg*>(msg); // CHEQUEAMOS EL PAQUETE ETHERNET
				// VARIABLES
				int id_servicio = ethernetmsg->getId_servicio(); // PARAMETRO QUE INDICA EL IDENTIFICADOR DEL SERVICIO DE LA ONU
				int numero_sla = num_sla[ethernetmsg->getSrcAddress()]; // PARAMETRO QUE INDICA EL IDENTIFICADOR DEL SLA ASOCIADO A LA ONU
				//double tx_rate = 0.0, bit_rate = 0.0, time_creation = 0.0;
                double bit_rate = 0.0, time_creation = 0.0;
                long int tx_rate=0;

				// Si el mensaje Ethernet recibido es de prioridad P0 o P1, controlamos su retardo:
				if(ethernetmsg->getPriority()<2)
				{
					double aux_delay = SIMTIME_DBL(simTime() - ethernetmsg->getTimestamp());
					mac_olt=check_and_cast<MAC_OLT *>(getParentModule()->getSubmodule("olt_mac"));
					mac_olt->delay_onu[ethernetmsg->getSrcAddress()][ethernetmsg->getPriority()] += aux_delay;
					mac_olt->paq_onu[ethernetmsg->getSrcAddress()][ethernetmsg->getPriority()]++;
					//ev<<" Paquetes recibidos de esa ONU y esa prioridad en este ciclo de transmision: " << mac_olt->paq_onu[ethernetmsg->getSrcAddress()][ethernetmsg->getPriority()] << endl;
					//ev<<" Retardo total de estos paquetes: " << mac_olt->delay_onu[ethernetmsg->getSrcAddress()][ethernetmsg->getPriority()] << endl;
				}
				// Para el algoritmo DaSPID, se cambia la disposicion de las ONUs en los SLAs:
				// Tambien para el IPACT normal, porque vamos a hacer pruebas para compararlos:
				if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3_DaSPID4")==4 || (int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3_DaSPID4")==1)
				{
					if(ethernetmsg->getSrcAddress()<2)
					{
						throughput_sla[0]=throughput_sla[0]+ethernetmsg->getByteLength();
					}
					else if(ethernetmsg->getSrcAddress()>=2 && ethernetmsg->getSrcAddress()<8)
					{
						throughput_sla[1]=throughput_sla[1]+ethernetmsg->getByteLength();
					}
					else if(ethernetmsg->getSrcAddress()>=8 && ethernetmsg->getSrcAddress()<16)
					{
						throughput_sla[2]=throughput_sla[2]+ethernetmsg->getByteLength();
					}
				}
				else
				{
					if(ethernetmsg->getSrcAddress()<5)
					{
						throughput_sla[0]=throughput_sla[0]+ethernetmsg->getByteLength();
					}
					else if(ethernetmsg->getSrcAddress()>=5 && ethernetmsg->getSrcAddress()<=15)
					{
						throughput_sla[1]=throughput_sla[1]+ethernetmsg->getByteLength();
					}
					else if(ethernetmsg->getSrcAddress()>=16 && ethernetmsg->getSrcAddress()<=35)
					{
						throughput_sla[2]=throughput_sla[2]+ethernetmsg->getByteLength();
					}
				}
                size = ethernetmsg->getByteLength(); //RECOGEMOS EL TAMANYO DE LOS PAQUETES ETHERNET RECIBIDOS
                throughput = throughput+size; //ACTUALIZAMOS LA SUMA DE TODOS LOS PAQUETES ETHERNET

				if(simTime()>=5*cont_aux)
				//if(simTime()>=1000*cont_aux)
				{
					cont_aux++;
					total_bits_sla[0]=throughput_sla[0]*8/simTime();
					total_bits_sla[1]=throughput_sla[1]*8/simTime();
					total_bits_sla[2]=throughput_sla[2]*8/simTime();
					throughput=throughput*8/simTime();

					//FICHERO PARA LA RECOGIDA DE LOS DATOS ESTADASTICOS DE LA MODULACION WDM
					//SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
					tamano_throughput_sla=fopen("results/tamano_throughput_slas.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
					fprintf(tamano_throughput_sla,"%g\t" , (double)total_bits_sla[0]);
					fprintf(tamano_throughput_sla,"\t");
					fprintf(tamano_throughput_sla,"%g\t" , (double)total_bits_sla[1]);
					fprintf(tamano_throughput_sla,"\t");
					fprintf(tamano_throughput_sla,"%g\t" , (double)total_bits_sla[2]);
					fprintf(tamano_throughput_sla,"\t");
					fprintf(tamano_throughput_sla,"%g\t" , (double)throughput);
					fprintf(tamano_throughput_sla,"\n");
					fclose(tamano_throughput_sla); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS
				}

				size_cabecera=size-38; //AL PAQUETE ETHERNET QUE RECIBIMOS LE QUITAMOS LOS 38 BYTES DE CABECERA
				throughput_cabecera = throughput_cabecera+size_cabecera; //ACTUALIZAMOS LA SUMA DE LOS PAQUETES ETHERNET SIN CABECERA

				////ev<<" Longitud del paquete Ethernet recibido: " << size << " Bytes" << endl;
				////ev<<" Longitud total de los paquetes recibidos: " << throughput << " Bytes" << endl;

				//COMPARAMOS EL TIEMPO DE SIMULACION CON EL VALOR 1 (SE EMPIEZAN A CREAR LOS PAQUETES ETHERNET) PARA EMPEZAR A COGER ESTADASTICAS MANUALMENTE Y CON LA CLASE ANALISIS
				if(simTime()>=1)
				{
					// RECOGIDA DE ESTADISTICAS DEL RETARDO GLOBAL CON LA CLASE ANALISIS PARA TODAS LAS CLASES DE SERVICIOS
					  retardo_P[id_servicio] = simTime() - ethernetmsg->getTime_enter_queue(); // PARAMETRO PARA CALCULAR EL RETARDO CON LA CLASE ANALISIS
					  retardo_global_P[id_servicio].analyze(SIMTIME_DBL(retardo_P[id_servicio])); // RECOGEMOS EL RESULTADO CON LA CLASE ANALISIS

					// RECOGEMOS LAS ESTADISTICAS DEL RETARDO POR SLA CON LA CLASE ANALISIS
					// COMPARAMOS SI ES DE POLLING O CENTRALIZADO YA QUE SOLO SE TRABAJA CON LOS SLAs EN EL ALGORITMO CENTRALIZADO DMB
					if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3_DaSPID4")==0)
					//if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3")==0)
					{
						// RECOGEMOS LAS ESTADASTICAS DEL RETARDO POR SLA CON LA CLASE ANALISIS
						retardo[numero_sla] =  simTime() - ethernetmsg->getTime_enter_queue(); // PARAMETRO PARA CALCULAR EL RETARDO CON LA CLASE ANALISIS
						retardo_sla[numero_sla].analyze(SIMTIME_DBL(retardo[numero_sla])); // RECOGEMOS EL RESULTADO CON LA CLASE ANALISIS
						retardo_servicios_sla[numero_sla][id_servicio].analyze(SIMTIME_DBL(retardo_P[id_servicio])); // RECOGEMOS EL RESULTADO CON LA CLASE ANALISIS
					}
					else if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3_DaSPID4")==2)
					//else if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3")==2)
					{
						// RECOGEMOS LAS ESTADASTICAS DEL RETARDO POR SLA CON LA CLASE ANALISIS
						retardo[numero_sla] =  simTime() - ethernetmsg->getTime_enter_queue(); // PARAMETRO PARA CALCULAR EL RETARDO CON LA CLASE ANALISIS
						retardo_sla[numero_sla].analyze(SIMTIME_DBL(retardo[numero_sla])); // RECOGEMOS EL RESULTADO CON LA CLASE ANALISIS
						retardo_servicios_sla[numero_sla][id_servicio].analyze(SIMTIME_DBL(retardo_P[id_servicio])); // RECOGEMOS EL RESULTADO CON LA CLASE ANALISIS
					}
				}

				TotalBytes[ethernetmsg->getSrcAddress()] = TotalBytes[ethernetmsg->getSrcAddress()] + (double) ethernetmsg->getByteLength();
				PriorityBytes[ethernetmsg->getSrcAddress()][ethernetmsg->getPriority()] = PriorityBytes[ethernetmsg->getSrcAddress()][ethernetmsg->getPriority()] + (double) ethernetmsg->getByteLength();
				//tx_rate = (double) this->getParentModule()->par("txrate");
                tx_rate = (long int) this->getParentModule()->par("txrate");

				bit_rate = tx_rate/10;
				time_creation = (double) SIMTIME_DBL(simTime());
				carga_cola = (double) (TotalBytes[ethernetmsg->getSrcAddress()] * 8 / (time_creation * bit_rate));
				carga_prioridad = (double) (PriorityBytes[ethernetmsg->getSrcAddress()][ethernetmsg->getPriority()] * 8 / (time_creation * bit_rate));
				carga_onu[ethernetmsg->getSrcAddress()].analyze(carga_cola);
				carga_prioridades[ethernetmsg->getSrcAddress()][ethernetmsg->getPriority()].analyze(carga_prioridad);
				numReceived++; // INCREMENTAMOS EN UNO EL CONTADOR DE NUMERO DE PAQUETES ETHERNET RECIBIDOS
				if(ethernetmsg->getIsWireless() == 1)
				{
					WirelessRx++;
					WirelessBytes = WirelessBytes + (double) ethernetmsg->getByteLength();
					// Retardo extremo a extremo
					delay_wir = simTime() - ethernetmsg->getTimestamp();
					retardo_inalambrico.analyze(SIMTIME_DBL(delay_wir));
				}
				else if(ethernetmsg->getIsWireless() == 0)
				{
					OpticalRx++;
					OpticalBytes = OpticalBytes + (double) ethernetmsg->getByteLength();
					delay_opt = simTime() - ethernetmsg->getTimestamp();
					retardo_optico.analyze(SIMTIME_DBL(delay_opt));
				}
				if(ethernetmsg->getIsWireless()==1)
				{
					//ev<<" Paquete Ethernet de origen inalambrico Recibido y Borrado."<<endl;
					//ev<<" Tiempo transcurrido desde el origen al destino: " << delay_wir << "s." << endl;
				}
				else
				{
					//ev<<" Paquete Ethernet de la ONU[" << ethernetmsg->getSrcAddress() << "] (Id. " << ethernetmsg->getId() << ") de prioridad P" << ethernetmsg->getPriority() << " recibido y borrado." << endl;
					//ev<<" Tiempo transcurrido desde el origen al destino: " << delay_opt << "s." << endl;
				}
				delete ethernetmsg; // BORRAMOS LOS PAQUETES ETHERNET
				////ev<<" 	*******" << endl;
				//ev<<" Paquete Ethernet Recibido y Borrado."<<endl;

				// COMPARAMOS SI EL NUMERO DE ITERACCIONES ES MAYOR O IGUAL UN CIERTO NUMERO, O QUE LA FUNCION ANALISIS CONVERJA
				if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3_DaSPID4")==0)
				//if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3")==0)
				{
					// METODO CENTRALIZADO O DMB
					// PONEMOS EL SIGUIENTE CODIGO PARA QUE SE PARE LA SIMULACION Y SE INVOQUE LA FUNCION FINISH()
					// TENEMOS QUE MODIFICAR MANUALMENTE LAS VARIABLES QUE QUEREMOS QUE LLEGUEN A UN CIERTO NUMERO DE ITERACIONES
					// PARA QUE FINALICE LA SIMULACION Y SE INVOQUE LA FUNCION FINISH()
					// retardo_global_P[] -> RETARDO GLOBAL DE CADA SERVICIO
					// retardo_sla[] -> RETARDO GLOBAL DE CADA SLA
					// retardo_servicios_sla[][] -> RETARDO DE CADA SERVICIO ASOCIADO A CADA SLA

					if( retardo_global_P[0].number_iterations() >= 30 && retardo_sla[0].number_iterations() >= 30)// TENEMOS QUE ANYADIR LAS VARIABLES // numReceived >= 5000000)//retardo_global_P[0].converged() && retardo_sla[0].converged()) // NUMERO DE PAQUETES QUE LLEGAN O SI LA FUNCION ANALSIS CONVERGE
					{
						total_bits=throughput*8; //LA SUMA EN BYTES DE LOS PAQUETES ETHERNET LA PASAMOS A BITS
						total_bits_throughput=total_bits/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

						total_bits_cabecera=throughput_cabecera*8; //LA SUMA EN BYTES DE LOS PAQUETES ETHERNET SIN LA CABECERA LA PASAMOS A BITS
						total_bits_throughput_cabecera=total_bits_cabecera/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

						total_bits_report=throughput_report*8; //LA SUMA EN BYTES DE LOS PAQUETES REPORT SIN LA CABECERA LA PASAMOS A BITS
						total_bits_throughput_report=total_bits_report/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

						B_guarda_total=B_guarda/simTime();

						total_time_perdido=total_bw_perdido_bits/simTime();

						media=plr_total/numpaquetes; //VALOR MEDIO DE PLR, ENTRE 0 Y 1

						//endSimulation(); // LLAMAMOS A LA FUNCION TERMINAR SIMULACION
						//callFinish(); // LLAMAMOS A LA FUNCION FINALIZAR
					}
				}
				else if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3_DaSPID4")==1)
				//else if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3")==1)
				{
					// METODO DE POLLING O IPACT
					// PONEMOS EL SIGUIENTE CODIGO PARA QUE SE PARE LA SIMULACION Y SE INVOQUE LA FUNCION FINISH()
					// TENEMOS QUE MODIFICAR MANUALMENTE LAS VARIABLES QUE QUEREMOS QUE LLEGUEN A UN CIERTO NUMERO DE ITERACIONES
					// PARA QUE FINALICE LA SIMULACION Y SE INVOQUE LA FUNCION FINISH()
					// retardo_global_P[] -> RETARDO GLOBAL DE CADA SERVICIO

					//Comentamos este if para que la simulación no se detenga tras las 30 iteraciones
					/*if( retardo_global_P[0].number_iterations() >= 30 ) // TENEMOS QUE ANYADIR LAS VARIABLES // numReceived >= 5000000)//retardo_global_P[0].converged()) // NUMERO DE PAQUETES QUE LLEGAN O SI LA FUNCION ANALSIS CONVERGE
					{
						total_bits=throughput*8; //LA SUMA EN BYTES DE LOS PAQUETES ETHERNET LA PASAMOS A BITS
					    total_bits_throughput=total_bits/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

						total_bits_cabecera=throughput_cabecera*8; //LA SUMA EN BYTES DE LOS PAQUETES ETHERNET SIN LA CABECERA LA PASAMOS A BITS
						total_bits_throughput_cabecera=total_bits_cabecera/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

						total_bits_report=throughput_report*8; //LA SUMA EN BYTES DE LOS PAQUETES REPORT SIN LA CABECERA LA PASAMOS A BITS
						total_bits_throughput_report=total_bits_report/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

						B_guarda_total=B_guarda/simTime();

						total_time_perdido=total_bw_perdido_bits/simTime();

						media=plr_total/numpaquetes; //VALOR MEDIO DE PLR, ENTRE 0 Y 1

						endSimulation(); // LLAMAMOS A LA FUNCION TERMINAR SIMULACION
						callFinish(); // LLAMAMOS A LA FUNCION FINALIZAR
					}*/
					/*if(simTime() >= 3000)
					{
						endSimulation(); // LLAMAMOS A LA FUNCION TERMINAR SIMULACION
						callFinish(); // LLAMAMOS A LA FUNCION FINALIZAR
					}*/
				}
				else if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3_DaSPID4")==2)
				//else if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3")==2)
				{
					// METODO DE WDM
					// PONEMOS EL SIGUIENTE CODIGO PARA QUE SE PARE LA SIMULACION Y SE INVOQUE LA FUNCION FINISH()
					// TENEMOS QUE MODIFICAR MANUALMENTE LAS VARIABLES QUE QUEREMOS QUE LLEGUEN A UN CIERTO NUMERO DE ITERACIONES
					// PARA QUE FINALICE LA SIMULACION Y SE INVOQUE LA FUNCION FINISH()
					// retardo_global_P[] -> RETARDO GLOBAL DE CADA SERVICIO
					//if( retardo_global_P[0].number_iterations() >= 15 ) // TENEMOS QUE ANYADIR LAS VARIABLES // numReceived >= 5000000)//retardo_global_P[0].converged()) // NUMERO DE PAQUETES QUE LLEGAN O SI LA FUNCION ANALSIS CONVERGE
					//if( retardo_global_P[0].number_iterations() >= 20 ) // TENEMOS QUE ANYADIR LAS VARIABLES // numReceived >= 5000000)//retardo_global_P[0].converged()) // NUMERO DE PAQUETES QUE LLEGAN O SI LA FUNCION ANALSIS CONVERGE
					if( retardo_sla[0].number_iterations() >= 20 &&  retardo_sla[1].number_iterations() >= 20 && retardo_sla[2].number_iterations() >= 20)
					{
						    total_bits=throughput*8; //LA SUMA EN BYTES DE LOS PAQUETES ETHERNET LA PASAMOS A BITS
						    total_bits_throughput=total_bits/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

							total_bits_cabecera=throughput_cabecera*8; //LA SUMA EN BYTES DE LOS PAQUETES ETHERNET SIN LA CABECERA LA PASAMOS A BITS
							total_bits_throughput_cabecera=total_bits_cabecera/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

							total_bits_report=throughput_report*8; //LA SUMA EN BYTES DE LOS PAQUETES REPORT SIN LA CABECERA LA PASAMOS A BITS
							total_bits_throughput_report=total_bits_report/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

							B_guarda_total=B_guarda/simTime();

							total_time_perdido=total_bw_perdido_bits/simTime();

							media=plr_total/numpaquetes; //VALOR MEDIO DE PLR, ENTRE 0 Y 1

						    //endSimulation(); // LLAMAMOS A LA FUNCION TERMINAR SIMULACION
							//callFinish(); // LLAMAMOS A LA FUNCION FINALIZAR
					}
				}
				else if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3_DaSPID4")==3)
				//else if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3")==3)
				{
					// METODO DE POLLING CON PID
					// PONEMOS EL SIGUIENTE CODIGO PARA QUE SE PARE LA SIMULACION Y SE INVOQUE LA FUNCION FINISH()
					// TENEMOS QUE MODIFICAR MANUALMENTE LAS VARIABLES QUE QUEREMOS QUE LLEGUEN A UN CIERTO NUMERO DE ITERACIONES
					// PARA QUE FINALICE LA SIMULACION Y SE INVOQUE LA FUNCION FINISH()
					// retardo_global_P[] -> RETARDO GLOBAL DE CADA SERVICIO
					//if( retardo_global_P[0].number_iterations() >= 15 ) // TENEMOS QUE ANYADIR LAS VARIABLES // numReceived >= 5000000)//retardo_global_P[0].converged()) // NUMERO DE PAQUETES QUE LLEGAN O SI LA FUNCION ANALSIS CONVERGE
					//if( retardo_global_P[0].number_iterations() >= 20 ) // TENEMOS QUE ANYADIR LAS VARIABLES // numReceived >= 5000000)//retardo_global_P[0].converged()) // NUMERO DE PAQUETES QUE LLEGAN O SI LA FUNCION ANALSIS CONVERGE
					//if( retardo_sla[0].number_iterations() >= 20 &&  retardo_sla[1].number_iterations() >= 20 && retardo_sla[2].number_iterations() >= 20)
					
					if(simTime()>=2000)
					{
							 total_bits=throughput*8; //LA SUMA EN BYTES DE LOS PAQUETES ETHERNET LA PASAMOS A BITS
							 total_bits_throughput=total_bits/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

							 total_bits_cabecera=throughput_cabecera*8; //LA SUMA EN BYTES DE LOS PAQUETES ETHERNET SIN LA CABECERA LA PASAMOS A BITS
							 total_bits_throughput_cabecera=total_bits_cabecera/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

							 total_bits_report=throughput_report*8; //LA SUMA EN BYTES DE LOS PAQUETES REPORT SIN LA CABECERA LA PASAMOS A BITS
							 total_bits_throughput_report=total_bits_report/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

							 B_guarda_total=B_guarda/simTime();

							 total_time_perdido=total_bw_perdido_bits/simTime();

							 media=plr_total/numpaquetes; //VALOR MEDIO DE PLR, ENTRE 0 Y 1

							 for(int i=0; i<(int)par("numSLA"); i++)
							 {
								 //VARIABLES PARA PODER ENTRAR DESDE ESTE MODULO AL MODULO MAC_OLT Y PODER PASARLE LA INFORMACION A LAS VARIABLES
								 mac_olt=check_and_cast<MAC_OLT *>(getParentModule()->getSubmodule("olt_mac"));
								 var_Mbps[i]=mac_olt->var_Mbps[i];
								 cont_var[i]=mac_olt->cont_var[i];
								 desviacion[i]=mac_olt->desviacion[i];
							}
							 //endSimulation(); // LLAMAMOS A LA FUNCION TERMINAR SIMULACION
							 //callFinish(); // LLAMAMOS A LA FUNCION FINALIZAR
					}
				}
				/////// ALGORITMO DaSPID (Delay-aware SLA PID) ///////
				else if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3_DaSPID4")==4)
				{
					// METODO DE POLLING CON DaSPID (Delay-aware SLA PID)
					// PONEMOS EL SIGUIENTE CODIGO PARA QUE SE PARE LA SIMULACION Y SE INVOQUE LA FUNCION FINISH()
					// TENEMOS QUE MODIFICAR MANUALMENTE LAS VARIABLES QUE QUEREMOS QUE LLEGUEN A UN CIERTO NUMERO DE ITERACIONES
					// PARA QUE FINALICE LA SIMULACION Y SE INVOQUE LA FUNCION FINISH()
					// retardo_global_P[] -> RETARDO GLOBAL DE CADA SERVICIO
					//if( retardo_global_P[0].number_iterations() >= 15 ) // TENEMOS QUE ANYADIR LAS VARIABLES // numReceived >= 5000000)//retardo_global_P[0].converged()) // NUMERO DE PAQUETES QUE LLEGAN O SI LA FUNCION ANALSIS CONVERGE
					//if( retardo_global_P[0].number_iterations() >= 20 ) // TENEMOS QUE ANYADIR LAS VARIABLES // numReceived >= 5000000)//retardo_global_P[0].converged()) // NUMERO DE PAQUETES QUE LLEGAN O SI LA FUNCION ANALSIS CONVERGE
					//if( retardo_sla[0].number_iterations() >= 20 &&  retardo_sla[1].number_iterations() >= 20 && retardo_sla[2].number_iterations() >= 20)

					if(simTime()>=5000)
					{
							 total_bits=throughput*8; //LA SUMA EN BYTES DE LOS PAQUETES ETHERNET LA PASAMOS A BITS
							 total_bits_throughput=total_bits/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

							 total_bits_cabecera=throughput_cabecera*8; //LA SUMA EN BYTES DE LOS PAQUETES ETHERNET SIN LA CABECERA LA PASAMOS A BITS
							 total_bits_throughput_cabecera=total_bits_cabecera/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

							 total_bits_report=throughput_report*8; //LA SUMA EN BYTES DE LOS PAQUETES REPORT SIN LA CABECERA LA PASAMOS A BITS
							 total_bits_throughput_report=total_bits_report/simTime(); //CALCULAMOS LOS GIGABIT POR SEGUNDO

							 B_guarda_total=B_guarda/simTime();

							 total_time_perdido=total_bw_perdido_bits/simTime();

							 media=plr_total/numpaquetes; //VALOR MEDIO DE PLR, ENTRE 0 Y 1

							 for(int i=0; i<(int)par("numSLA"); i++)
							 {
								 //VARIABLES PARA PODER ENTRAR DESDE ESTE MODULO AL MODULO MAC_OLT Y PODER PASARLE LA INFORMACION A LAS VARIABLES
								 mac_olt=check_and_cast<MAC_OLT *>(getParentModule()->getSubmodule("olt_mac"));
								 var_Mbps[i]=mac_olt->var_Mbps[i];
								 cont_var[i]=mac_olt->cont_var[i];
								 desviacion[i]=mac_olt->desviacion[i];
							}
							 //endSimulation(); // LLAMAMOS A LA FUNCION TERMINAR SIMULACION
							 //callFinish(); // LLAMAMOS A LA FUNCION FINALIZAR
					}
				}

				/*
				if(simTime()>=10*contador && volcado == 0)
				{
					contador++;
					//volcadoFicheros();
					carga_onus = fopen("results/carga_onus.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
						for(int i=0; i<onus; i++)
						{
							fprintf(carga_onus, "Carga ONU %i: %g\n", i, (double)carga_onu[i].average());
						}
						fprintf(carga_onus,"\n");
						fclose(carga_onus); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

					// SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
					carga_prioridades_onus = fopen("results/carga_prioridades_onus.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
						for(int i=0; i<onus; i++)
						{
							fprintf(carga_prioridades_onus, "ONU[%i]:\n",i);
							for(int j=0; j<prioridades; j++)
							{
								fprintf(carga_prioridades_onus, "\tCarga cola P%i: %g\n", j, (double)carga_prioridades[i][j].average());
							}
						}
						fprintf(carga_prioridades_onus,"\n");
						fclose(carga_prioridades_onus); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS
				}
				*/
			}
			break;

		case 2:
			// LLEGA UN PAQUETE REPORT CON IDENTIFICADOR = 2
			if(msg->getKind()==2)
			{
				REPORTmsg *reportmsg=check_and_cast<REPORTmsg*>(msg);

				num_sla[reportmsg->getSrcAddress()] = reportmsg->getNumsla(); // GUARDAMOS EN EL VECTOR num_sla[] EL IDENTIFICADOR DEL SLA Y LO VISUALIZAMOS POR PANTALLA
				//ev<<" Numero del SLA asociado a la ONU"<<reportmsg->getSrcAddress()<<": SLA"<<num_sla[reportmsg->getSrcAddress()]<<endl;

				size_throughput = reportmsg->getByteLength(); //RECOGEMOS EL TAMANYO DE LOS PAQUETES REPORT RECIBIDOS
				throughput_report = throughput_report+size_throughput; //ACTUALIZAMOS LA SUMA DE TODOS LOS PAQUETES ETHERNET

				T_guarda_bits=T_guarda*1000000000;
				B_guarda=B_guarda+T_guarda_bits;

				total_bw_perdido_bits=total_bw_perdido_bits+reportmsg->getBand();

				// COGEMOS LAS ESTADASTICAS DE LA MEDIA DE TODAS LAS ONUS CUANDO EL TIEMPO DE SIMULACION SEA MAYOR O IGUAL A 1
				if(simTime()>=1)
				{
					// RECORREMOS EL BUCLE FOR PARA GUARDAR EN EL VECTOR tam_packet_queue[] LOS BYTES QUE QUEDAN EN CADA COLA DESPUES DE CADA CICLO
					for(int i=0; i<prioridades; i++)
					{
						tam_packet_queue[i] = reportmsg->getQueue_estado(i); // GUARDAMOS LOS BYTES QUE QUEDAN EN CADA COLA DESPUES DE CADA CICLO
						media_bytes_total_onus[i].analyze(tam_packet_queue[i]); // RECOGEMOS EL RESULTADO CON LA CLASE ANALISIS
					}

					// PONEMOS EL SIGUIENTE CODIGO PARA QUE SE PARE LA SIMULACION Y SE INVOQUE LA FUNCION FINISH()
					// TENEMOS QUE MODIFICAR MANUALMENTE LAS VARIABLES QUE QUEREMOS QUE LLEGUEN A UN CIERTO NUMERO DE ITERACIONES
					// PARA QUE FINALICE LA SIMULACION Y SE INVOQUE LA FUNCION FINISH()
					// media_bytes_total_onus[] -> MEDIA POR SERVICIOS DE TODAS LAS ONU
					//if( media_bytes_total_onus[0].number_iterations() >= 25 ) // TENEMOS QUE ANYADIR LAS VARIABLES // numReceived >= 5000000)//media_bytes_total_onus[0].converged()) // NUMERO DE PAQUETES QUE LLEGAN O SI LA FUNCION ANALSIS CONVERGE
					//{

						//endSimulation(); // LLAMAMOS A LA FUNCION TERMINAR SIMULACION
						//callFinish(); // LLAMAMOS A LA FUNCION FINALIZAR
					//}
				}
				send(reportmsg, "oltrxOut"); // ENVIA EL PAQUETE REPORT HACIA LA CAPA MAC DEL OLT
			}
			break;

		default:
			delete msg;
			break;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION VOLCADOFICHEROS()--> ESCRIBE EN UNO O VARIOS FICHEROS DE TEXTO LOS DATOS DE MAYOR INTERES DE LA	/
//							   SIMULACION, PARA SU POSTERIOR ANALISIS.										/
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
void OLT_Rx::volcadoFicheros()
{
	//volcado = 1;

	//RECOGIDA DE ESTADISTICAS CON LA CLASE ANALISIS!! GUARDAMOS LOS DATOS EN UN ARCHIVO
	// SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
	carga_onus = fopen("results/carga_onus.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
		for(int i=0; i<onus; i++)
		{
			fprintf(carga_onus, "Carga ONU %i: %g\n", i, (double)carga_onu[i].average());
		}
		fprintf(carga_onus,"\n");
		fclose(carga_onus); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

	// SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
	carga_prioridades_onus = fopen("results/carga_prioridades_onus.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
		for(int i=0; i<onus; i++)
		{
			fprintf(carga_prioridades_onus, "ONU[%i]:\n",i);
			for(int j=0; j<prioridades; j++)
			{
				fprintf(carga_prioridades_onus, "\tCarga cola P%i: %g\n", j, (double)carga_prioridades[i][j].average());
			}
		}
		fprintf(carga_prioridades_onus,"\n");
		fclose(carga_prioridades_onus); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

	//RECOGIDA DE ESTADISTICAS CON LA CLASE ANALISIS!! GUARDAMOS LOS DATOS EN UN ARCHIVO
	// SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
	retardo_total=fopen("results/retardo_total.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
		fprintf(retardo_total, "Retardo medio paquetes wireless: %g\n", (double)retardo_inalambrico.average());
		fprintf(retardo_total, "Retardo medio paquetes opticos: %g\n", (double)retardo_optico.average());
		fprintf(retardo_total,"\n");
		fclose(retardo_total); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

	//RECOGIDA DE ESTADISTICAS CON LA CLASE ANALISIS!! GUARDAMOS LOS DATOS EN UN ARCHIVO
	// SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
	retardo_analisis=fopen("results/retardo_analisis.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
		// RECORREMOS ESTE BUCLE FOR PARA OBTENER LA MEDIA GLOBAL DE CADA SERVICIO
		for(int i=0; i<prioridades; i++)
		{
			fprintf(retardo_analisis,"COLA P%i\n", i);
			fprintf(retardo_analisis,"Media del retardo global: %g\n", (double)retardo_global_P[i].average()); // MEDIA DEL RETARDO
			fprintf(retardo_analisis,"Intervalo de confianza: %g\n", (double)retardo_global_P[i].half_confidence_interval()); // DESVIACION DEL RETARDO
		}
		fprintf(retardo_analisis,"Total paquetes recibidos: %g\n", numReceived);
		fclose(retardo_analisis); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

		// ARCHIVO PARA RECOGER LOS DATOS DEL RETARDO POR CADA SLA GLOBAL Y POR TIPO DE SERVICIOS
		// SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
		retardo_analisis_sla=fopen("results/retardo_analisis_sla.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
		for(int i=0; i<(int)par("numSLA"); i++)
		{
			fprintf(retardo_analisis_sla,"SLA %i\n", i);
			fprintf(retardo_analisis_sla,"Media del retardo global: %g\n", (double)retardo_sla[i].average()); // MEDIA DEL RETARDO GLOBAL DE CADA SLA
			// RECORREMOS ESTE BUCLE FOR PARA OBTENER LA MEDIA DE CADA SERVICIO ASOCIADA A CADA SLA
			for(int j=0; j<prioridades; j++)
			{
				fprintf(retardo_analisis_sla,"Retardo del servicio P%i: %g\n", j, (double)retardo_servicios_sla[i][j].average());
			}
			fprintf(retardo_analisis_sla,"Intervalo de confianza del retardo global: %g\n", (double)retardo_sla[i].half_confidence_interval()); // DESVIACION DEL RETARDO GLOBAL DE CADA SLA
			// RECORREMOS ESTE BUCLE FOR PARA OBTENER EL INTERVALO DE CONFIANZA DE CADA SERVICIO ASOCIADO A CADA SLA
			for(int j=0; j<prioridades; j++)
			{
				fprintf(retardo_analisis_sla,"Intervalo de confianza del retardo del servicio %i: %g\n", j, (double)retardo_servicios_sla[i][j].half_confidence_interval()); // MEDIA DEL RETARDO GLOBAL DE CADA SLA
			}
			fprintf(retardo_analisis_sla,"---\n");
		}
		fclose(retardo_analisis_sla); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

		// RECOGIDA DE ESTADISTICAS DE LAS MEDIAS DE LOS BYTES QUE QUEDAN EN LAS COLAS DE TODAS LAS ONUs DESPUES DE CADA CICLO CON LA CLASE ANALISIS Y LO GUARDAMOS LOS DATOS EN UN ARCHIVO
		// SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
		media_total_onu=fopen("results/media_total_onu.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
			for(int i=0; i<prioridades; i++)
			{
					fprintf(media_total_onu,"Media de los bytes sobrantes en la cola %i tras cada ciclo: %g\n", i, (double)media_bytes_total_onus[i].average()); // MEDIA DE LOS BYTES QUE QUEDAN EN LAS COLAS DESPUES DE CADA CICLO
			}
			fclose(media_total_onu); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

		//FICHERO PARA LA RECOGIDA DE LOS DATOS ESTADASTICOS DE LA MODULACION WDM
		//SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
		tamano_throughput=fopen("results/tamano_throughput.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
		fprintf(tamano_throughput,"Throughput (bps) de los paquetes ETHERNET: %g\n" , (double)total_bits_throughput); //BITS POR SEGUNDO DE THROUGHPUT DE LOS PAQUETES ETHERNET
		fprintf(tamano_throughput,"Throughput (bps) de los paquetes REPORT: %g\n" , (double)total_bits_throughput_report);//BITS POR SEGUNDO DE THROUGHPUT DE LOS PAQUETES REPORT
		fprintf(tamano_throughput,"Throughput (bps) de los paquetes ETHERNET sin los bits de cabecera: %g\n" , (double)total_bits_throughput_cabecera); //BITS POR SEGUNDO DE THROUGPUT DE LOS PAQUETES ETHERNET SIN LOS BITS DE CABECERA
		fprintf(tamano_throughput,"Ancho de banda de guarda total (bits): %Lg\n" ,(long double)B_guarda_total); //BITS DE ANCHO DE BANDA DE GUARDA
		fprintf(tamano_throughput,"Tiempo perdido en total (segundos): %Lg\n" ,(long double)total_time_perdido); //TIEMPO DESALINEAMIENTO
		fprintf(tamano_throughput,"Ancho de banda perdido en total (bits): %Lg\n" ,(long double)total_bw_perdido_bits); //NUMERO DE BITS DE DESALINEAMIENTO
		fprintf(tamano_throughput,"Total bits de los paquetes REPORT: %Lg\n" ,(long double)total_bits_report); //NUMERO DE BITS QUE TIENEN LOS MENSAJES REPORT
		fclose(tamano_throughput); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

		//FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE LA PLR (Packet Loss Ratio)
		//SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
		plr_file=fopen("results/plr.txt", "a+"); //ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
		//fprintf(plr_file,"%g\t" , (double)plr.average()); //METODO ANALISIS PARA EL PLR
		//fprintf(plr_file,"\t");
		//fprintf(plr_file,"%g\t" , (double)media); //METODO DE RECOGIDA DE ESTADASTICAS MANUAL PARA EL PLR
		//fprintf(plr_file,"\n");
		fprintf(plr_file, "PACKET LOSS RATIO\n");
		for(int i=0; i<(int)par("numSLA"); i++)
		{
			fprintf(plr_file, "Media PLR del SLA %i: %g\n" , i, (double)plr_sla[i].average());
		}

		fclose(plr_file); //CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

		//FICHERO PARA LA RECOGIDA DE LOS DATOS ESTADISTICOS DE LA MODULACION WDM
		//SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
		//tamano_throughput_sla=fopen("results/tamano_throughput_slas.doc", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
		//fprintf(tamano_throughput_sla,"%g\t" , (double)throughput_sla[0]);
		//fprintf(tamano_throughput_sla,"\t");
		//fprintf(tamano_throughput_sla,"%g\t" , (double)throughput_sla[1]);
		//fprintf(tamano_throughput_sla,"\t");
		//fprintf(tamano_throughput_sla,"%g\t" , (double)throughput_sla[2]);
		//fprintf(tamano_throughput_sla,"\n");

		//fclose(tamano_throughput_sla); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

		//FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE LA VARIANZA
		//SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
		varianza=fopen("results/varianza.txt" , "a+");
		for(int i=0; i<(int)par("numSLA"); i++)
		{

			fprintf(varianza, "Varianza SLA %i: %Lg\n", i, (long double) sqrt(var_Mbps[i]/cont_var[i]));
			fprintf(varianza,"\t");
		}
		fprintf(varianza,"---\n");

		for(int i=0; i<(int)par("numSLA"); i++)
		{
			fprintf(varianza, "Margen de error SLA %i: %Lg\n", i, (long double) 1.960*sqrt(var_Mbps[i]/(cont_var[i]-1))/sqrt(cont_var[i]));
		}
		fprintf(varianza,"---\n");

		for(int i=0; i<(int)par("numSLA"); i++)
		{
			fprintf(varianza, "Desviacion SLA %i: %g\n", i, (double) desviacion[i].average());
		}
		fprintf(varianza,"---\n");

		fclose(varianza); //CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION FINISH()--> ESTA FUNCION SE INVOCA CUANDO LA SIMULACION HA TERMINADO CON EXITO SIN QUE SE PRODUZCA NINGUN ERROR. 		//
//					  LO USAMOS PARA LA RECOGIDA DE ESTADASTICAS Y VISUALIZACION POR PANTALLA O MEDIANTE UN ARCHIVO.            //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void OLT_Rx::finish()
{
	// VISUALIZAMOS POR PANTALLA LA RECOGIDA DE ESTADISTICAS MANUAL CUANDO LLAMAMOS A LA FUNCION FINISH()
	//ev<<" OLT " << endl;
	//ev<<" Paquetes Ethernet Totales Recibidos: " << numReceived << endl;
	volcadoFicheros();
}
