////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti�n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_RX_H_
#define __RED_WIRELESS_RX_H_

#include <omnetpp.h>
#include <vector>
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include "analysis.h"
#include "MAC_OLT.h"


/*
 * MODULO OLT_rx:
 */
typedef std::vector<int> int_vector_t; // VECTOR TIPO ENTERO
typedef std::vector<int_vector_t> int_matrix_t; // MATRIZ TIPO ENTERO
typedef std::vector<long int> long_int_vector_t; // VECTOR TIPO ENTERO LARGO
typedef std::vector<double> double_vector_t; // VECTOR TIPO DOUBLE
typedef std::vector<double_vector_t> double_matrix_t; // MATRIZ TIPO DOUBLE
typedef std::vector<simtime_t> simtime_t_vector_t; // VECTOR TIPO SIM_TIME
typedef std::vector<Analysis> analysis_vector_t; // VECTOR CLASE ANALISIS
typedef std::vector<analysis_vector_t> analysis_matrix_t; // MATRIZ CLASE ANALISIS

class OLT_Rx : public cSimpleModule
{
	private:
	// DEFINIMOS LOS PARAMETROS PARA LA CLASE ANALISIS
		// PARAMETRO PARA OBTENER EL RETARDO GLOBAL CON LA CLASE ANALISIS
		std::vector<Analysis> retardo_global_P; // VECTOR DE CLASE ANALISIS PARA CREAR EL RETARDO GLOBAL

		// PARAMETRO PARA OBTENER LA CARGA TOTAL CON LA CLASE ANALISIS
		std::vector<Analysis> carga_onu;

		// PARAMETRO PARA OBTENER LA CARGA TOTAL, POR PRIORIDADES, CON LA CLASE ANALISIS
		analysis_matrix_t carga_prioridades;

		// PARAMETROS PARA OBTENER EL RETARDO DE CADA SLA CON LA CLASE ANALISIS
		std::vector<Analysis> retardo_sla; // VECTOR DE CLASE ANALISIS PARA CREAR EL RETARDO GLOBAL DE CADA SLA

		// PARAMETROS PARA OBTENER EL RETARDO DE CADA SLA CON LA CLASE ANALISIS
		std::vector <std::vector < Analysis > > retardo_servicios_sla; // MATRIZ DE CLASE ANALISIS PARA CREAR EL RETARDO DE LOS SLAs POR SERVICIOS

		// PARAMETRO PARA OBTENER LA MEDIA DE LOS BYTES QUE SE QUEDAN EN LA COLAS DESPUES DE CADA CICLO CON LA CLASE ANALISIS
		std::vector<Analysis> media_bytes_total_onus; // VECTOR DE CLASE ANALISIS PARA CREAR LOS BYTES QUE SE QUEDAN EN LA COLAS DESPUES DE CADA CICLO

		// DEFINIMOS LOS ARCHIVOS DONDE SE GUARDAN LOS RESULTADOS DE RECOGER LAS ESTADASTICAS
		FILE * retardo_analisis_sla; // ARCHIVO DONDE SE GUARDARAN LOS RESULTADOS DE LA CLASE ANALISIS PARA EL RETARDO DE LOS SLAs
		FILE * retardo_analisis; // ARCHIVO DONDE SE GUARDARAN LOS RESULTADOS DE LA CLASE ANALISIS PARA EL RETARDO GLOBAL
		FILE * media_total_onu; // ARCHIVO DONDE GUARDAMOS LA MEDIA DE LAS COLAS
		FILE * tamano_throughput; //ARCHIVO DONDE GUARDAMOS EL THROUGHPUT
		FILE * plr_file; //ARCHIVO DONDE GUARDAMOS EL PLR
		FILE * varianza; //ARCHIVO DONDE GUARDAMOS LA VARIANZA
		FILE * tamano_throughput_sla;
		FILE * retardo_total;
		FILE * carga_onus;
		FILE * carga_prioridades_onus;

		int_vector_t num_sla; // VECTOR PARA GUARDAR EL IDENTIFICADOR DEL SLA DE LA ONU ASOCIADA
		simtime_t_vector_t retardo_P; // VECTOR DONDE GUARDAMOS EL RETARDO GLOBAL DE LOS SERVICIOS
		simtime_t_vector_t retardo; // VECTOR DONDE GUARDAMOS EL RETARDO DE LOS SLAs
		double numReceived; // VARIABLE PARA CONTAR EL NUMERO DE PAQUETES ETHERNET RECIBIDOS
		long WirelessRx;
		long OpticalRx;
		double_vector_t TotalBytes;
		double_matrix_t PriorityBytes;
		double OpticalBytes;
		double WirelessBytes;
		double carga_cola;
		double carga_prioridad;
		int onus;
		int prioridades;
		simtime_t delay;
		simtime_t delay_opt;
		simtime_t delay_wir;
		int_vector_t tam_packet_queue; // TAMANYO EN BYTES QUE QUEDAN EN LAS COLAS DESPUES DE CADA CICLO

	protected:
		virtual void initialize();
		virtual void handleMessage(cMessage *msg);
		long double throughput;
		long double total_bits;
		double total_bits_throughput;
		long double total_bits_report;
		long double throughput_report;
		double total_bits_throughput_report;
		long double throughput_cabecera;
		long double total_bits_cabecera;
		double total_bits_throughput_cabecera;
		long double B_guarda;
		long double B_guarda_total;
		long double total_bw_perdido_bits;
		long double total_time_perdido;
		double media;

	public:
		Analysis retardo_inalambrico;
		Analysis retardo_optico;
		Analysis plr;
		double numpaquetes;
		double plr_total;
		MAC_OLT *mac_olt;
		double_vector_t var_Mbps;
		double_vector_t cont_var;
		std::vector <Analysis> desviacion;
		std::vector <Analysis> plr_sla;
		double_vector_t throughput_sla;
		int cont_aux;
		int contador;
		double_vector_t total_bits_sla;
		virtual void volcadoFicheros();
		int volcado;
		virtual void finish();
};

#endif
