////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti�n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_OLT_TABLE_H_
#define __RED_WIRELESS_OLT_TABLE_H_

#include <omnetpp.h>
#include <vector>
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
/*
 * MODULO OLT_Table:
 */
//DEFINIMOS LOS TIPOS DE std DE LOS VECTORES Y MATRICES:
typedef std::vector<int> int_vector_t; // VECTOR TIPO ENTERO
typedef std::vector<simtime_t> simtime_t_vector_t; // VECTOR TIPO TIEMPO
typedef std::vector< int_vector_t > int_matrix_t; // MATRIZ DE TIPO ENTERO

class OLT_Table : public cSimpleModule
{
	public:
		int_matrix_t table_olt_report; // MATRIZ DE TIPO ENTERO PARA GUARDAR EL TAMANYO DE LAS COLAS, ANCHO DE BANA ASIGANDO Y DEMANDADO
		simtime_t_vector_t table_olt_report_time; // VECTOR DE TIPO TIEMPO PARA GUARDAR EL TIEMPO EN EL QUE SE ENVIA EL RECEPTOR
        simtime_t_vector_t table_olt_wavelength_time; // VECTOR DE TIPO TIEMPO PARA GUARDAR EL TIEMPO EN EL QUE SE ENVIA EL RECEPTOR

		int numInitStages() const; // FUNCION QUE INICIALIZA VARIAS ETAPAS.



	protected:
		virtual void initialize(int stage);
		virtual void handleMessage(cMessage *msg);
};

#endif
