////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gestin de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#include "OLT_Tx.h"
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
/*
 * MODULO OLT_Tx:
 */
Define_Module(OLT_Tx);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPUÉS DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS      //
//						  PARAMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE //
//						  ASIGNAN ESTRUCTURAS DE DATOS DINAMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  //
//						  PARA EL FUNCIONAMIENTO DE ESTE MODULO.			   													//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void OLT_Tx::initialize()
{
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//										  UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O  	//
//										  EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//										  DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL	//
//										  CODIGO IMPLEMENTADO.																	//                                                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void OLT_Tx::handleMessage(cMessage *msg)
{
	// VARIABLES
	int type = msg->getKind(); // VARIABLE TYPE PARA IDENTIFICAR LOS MENSAJES DE LA RED

	// ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA LOS MENSAJES QUE LLEGUEN A ESTE MODULO
	switch(type)
	{
		case 0:
			// LLEGA UN PAQUETE GATE CON IDENTIFICADOR = 0
			if(msg->getKind()==0)
			{
				//GATEmsg *gatemsg=check_and_cast<GATEmsg*>(msg); // CHEQUEAMOS EL PAQUETE GATE
				/*
				// VISUALIZAMOS LOS CAMPOS DEL PAQUETE GATE
				ev<<" Paquete Gate."<<endl;
				ev<<" Origen OLT ID: "<<gatemsg->getSrcAddress()<<endl;
				ev<<" Destino ONU "<<gatemsg->getDestAddress()<<endl;
				ev<<" Longitud de onda de envio, Lambda "<< gatemsg->getLambdagate()<<endl;
				ev<<" Tipo "<<gatemsg->getKind()<<endl;
				ev<<" Tiempo iniciar Tx "<<gatemsg->getGrant_IniTime()<<endl;
				ev<<"  "<<endl;
				*/
				send(msg, "olttxOut"); // ENVIAMOS LOS PAQUETES GATE HACIA EL WDMSPLITTER DEL OLT
			}
			break;

		case 1:
			// LLEGA UN PAQUETE ETHERNET CON IDENTIFICADOR = 1
			////ev<<" Enviamos el paquete " << msg->getName() << endl;
			send(msg, "olttxOut"); // ENVIAMOS LOS PAQUETES ETHERNET HACIA LA CAPA MAC DEL OLT
			break;

		default:
			delete msg;
			break;
	}
}
