////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti���n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#include "OLT_WDMSplitter.h"
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include "DATA_m.h"
#include "ONU_WDMSplitter.h"


// MODIFICADO POR DAVID
FILE * B_alloc_aprovechado_longitudonda;
FILE * B_por_onu;
int cont5;
int cont8;


/*
 * MODULO OLT_WDMSplitter:
 */

Define_Module(OLT_WDMSplitter);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPUES DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS      //
//						  PARAMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE //
//						  ASIGNAN ESTRUCTURAS DE DATOS DINAMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  //
//						  PARA EL FUNCIONAMIENTO DE ESTE MODULO.			   													//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void OLT_WDMSplitter::initialize()
{


    // MODIFICADO POR DAVID: Para inicializar las variables
    B_alloc_lambda.resize((int)par("numlong"),0);
    B_alloc_por_onu.resize((int)par("numOnu"),0);; //VECTOR QUE GUARDA EL ANCHO DE BANDA
    cont8=1;
    cont5=1;


}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//										  UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O  	//
//										  EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//										  DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL	//
//										  CODIGO IMPLEMENTADO.																	//                                                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void OLT_WDMSplitter::handleMessage(cMessage *msg)
{
	// VARIABLES
	int type = msg->getKind(); // VARIABLE TYPE PARA IDENTIFICAR LOS MENSAJES DE LA RED
	int p= gateSize("wdmnet"); // TAMANYO DE LA PUERTA wdmnet DEL MODULO OLT_WDMSPLITTER

	// ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA LOS MENSAJES QUE LLEGUEN A ESTE MODULO
	switch(type)
	{
		case 0:
			// LLEGA UN PAQUETE GATE CON IDENTIFICADOR = 0
			if(msg->getKind()==0)
			{
				GATEmsg *gatemsg=check_and_cast<GATEmsg*>(msg); // CHEQUEAMOS EL PAQUETE GATE

				// ENVIAMOS EL PAQUETE GATE HACIA EL SPLITTER POR LA LONGITUD DE ONDA QUE NOS INDICA EL PARAMETRO gatemsg->getLambdagate()
				send(gatemsg, "wdmnet$o", gatemsg->getLambdagate());
			}
			break;

		case 1:
			// LLEGA UN PAQUETE ETHERNET CON IDENTIFICADOR = 1
			if(msg->getKind()==1)
			{
				ETHERNETmsg *ethernetmsg=check_and_cast<ETHERNETmsg*>(msg);
				// DEFINIMOS EL PARAMETRO ingate QUE NOS INDICA EL PUNTERO DE LA PUERTA POR LA CUAL ENTRA EL MENSAJE QUE LLEGA
				cGate *ingate = ethernetmsg->getArrivalGate();


                // MODIFICADO POR DAVID
			    int onu = ethernetmsg->getSrcAddress(); // VARIABLE QUE NOS INDICA EL IDENTIFICADOR DE LA ONU CORRESPONDIENTE

                // Visualizamos el ancho de banda aprovechado por longitud de onda y el total
                B_alloc_lambda[ethernetmsg->getLambdaethernet()]= B_alloc_lambda[ethernetmsg->getLambdaethernet()]+8*(ethernetmsg->getByteLength());

                if(simTime()>=5*cont8)
                {
                    cont8++;

                    B_alloc_aprovechado_longitudonda=fopen("results/B_alloc_aprovechado_longitudonda.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
                    fprintf(B_alloc_aprovechado_longitudonda,"%g\t", SIMTIME_DBL(simTime()));
                    fprintf(B_alloc_aprovechado_longitudonda,"\t");
                    fprintf(B_alloc_aprovechado_longitudonda,"%g\t" , (double)((B_alloc_lambda[0]/simTime())/1000000));
                    fprintf(B_alloc_aprovechado_longitudonda,"\t");
                    fprintf(B_alloc_aprovechado_longitudonda,"%g\t" , (double)((B_alloc_lambda[1]/simTime())/1000000));
                    fprintf(B_alloc_aprovechado_longitudonda,"\t");
                    fprintf(B_alloc_aprovechado_longitudonda,"%g\t" , (double)((B_alloc_lambda[2]/simTime())/1000000));
                    fprintf(B_alloc_aprovechado_longitudonda,"\t");
                    fprintf(B_alloc_aprovechado_longitudonda,"%g\t" , (double)((B_alloc_lambda[3]/simTime())/1000000));
                    fprintf(B_alloc_aprovechado_longitudonda,"\t");
                    fprintf(B_alloc_aprovechado_longitudonda,"%g\t" , (double)(((B_alloc_lambda[0]+B_alloc_lambda[1]+B_alloc_lambda[2]+B_alloc_lambda[3])/simTime())/1000000000));
                    fprintf(B_alloc_aprovechado_longitudonda,"\n");
                    fprintf(B_alloc_aprovechado_longitudonda,"\t");
                    fprintf(B_alloc_aprovechado_longitudonda,"%g\t" , (double)B_alloc_lambda[0]);
                    fprintf(B_alloc_aprovechado_longitudonda,"\t");
                    fprintf(B_alloc_aprovechado_longitudonda,"%g\t" , (double)B_alloc_lambda[1]);
                    fprintf(B_alloc_aprovechado_longitudonda,"\t");
                    fprintf(B_alloc_aprovechado_longitudonda,"%g\t" , (double)B_alloc_lambda[2]);
                    fprintf(B_alloc_aprovechado_longitudonda,"\t");
                    fprintf(B_alloc_aprovechado_longitudonda,"%g\t" , (double)B_alloc_lambda[3]);
                    fprintf(B_alloc_aprovechado_longitudonda,"\t");
                    fprintf(B_alloc_aprovechado_longitudonda,"\n");
                    fclose(B_alloc_aprovechado_longitudonda); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS
                }


                // Visualizamos el ancho de banda aprovechado por ONU
                B_alloc_por_onu[onu] = B_alloc_por_onu[onu] + 8*(ethernetmsg->getByteLength());

                if(simTime()>=5*cont5)
                {
                    cont5++;

                    B_por_onu=fopen("results/B_por_onu.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
                    fprintf(B_por_onu,"%g\t", SIMTIME_DBL(simTime()));
                    fprintf(B_por_onu,"\t");
                    fprintf(B_por_onu,"%g\t" , (double)(B_alloc_por_onu[0]/simTime())/1000000);
                    fprintf(B_por_onu,"\t");
                    fprintf(B_por_onu,"%g\t" , (double)(B_alloc_por_onu[2]/simTime())/1000000);
                    fprintf(B_por_onu,"\t");
                    fprintf(B_por_onu,"%g\t" , (double)(B_alloc_por_onu[8]/simTime())/1000000);
                    fprintf(B_por_onu,"\t");
                    fprintf(B_por_onu,"\n");
                    fclose(B_por_onu); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS
                }



				// COMPARAMOS EL NOMBRE DE LA PUERTA POR LA QUE ENTRA EL MENSAJE CON LA PUERTA wdmnet$i
				if(ingate->getName() == gate("wdmnet$i",intuniform(0,p-1))->getName())
				{
					if(ethernetmsg->getIsWireless()==1)
					{
						//ev<<" Envio de paquete Ethernet de origen inalambrico al modulo 'OLT_Rx'."<<endl;
					}
					else
					{
						received_messages++;
						//ev<<" Envio mensaje Ethernet (Id. " << ethernetmsg->getId() << ") al modulo 'OLT_Rx'."<< endl;
						//ev<<" Total paquetes Ethernet recibidos de las fuentes opticas: " << received_messages << endl;
					}
					send(ethernetmsg, "wdmrxOut"); // ENVIAMOS EL PAQUETE ETHERNET HACIA EL RECEPTOR
				}
				else
				{
					// ENVIAMOS EL PAQUETE ETHERNET HACIA EL SPLITTER POR LA LONGITUD DE ONDA QUE NOS INDICA EL PARAMETRO ethernetmsg->getLambdaethernet()
					send(ethernetmsg, "wdmnet$o", ethernetmsg->getLambdaethernet());
				}
			}
			break;

		case 2:
			// LLEGA UN PAQUETE REPORT CON IDENTIFICADOR = 2
			if(msg->getKind()==2)
			{
				REPORTmsg *reportmsg = check_and_cast<REPORTmsg*>(msg); // CHEQUEAMOS EL PAQUETE REPORT
				send(reportmsg, "wdmrxOut"); // ENVIAMOS EL PAQUETE REPORT HACIA EL RECEPTOR DEL OLT
			}
			break;

		default:
			delete msg;
			break;
	}
}
