////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA                                                                                                          //
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti���n de recursos en //
//           redes de acceso FiWi                                                                                               //
// AUTOR: Ana Emma Lopez Mato                                                                                                           //
// TUTOR: Noemi Merayo Alvarez                                                                                                      //
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION                   //
// UNIVERSIDAD DE VALLADOLID                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////

#include "ONU_GENTraffic.h"
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include <omnetpp.h>
#include <vector>
#include <time.h>
#include "analysis.h"
#include "ONU_Table.h"
#include "OLT_Rx.h"
#include "MAC_ONU.h"


// MODIFICADO POR DAVID: Variables utilizadas para comprobar que se asigna correctamente la carga que tenemos
FILE * prueba_fuente_0;
FILE * prueba_fuente_12;
int cont3;
int cont4;


/*
 * MODULO ONU_GENTraffic:
 */
// DEPENDIENDO DE LA VERSION DE LA FUENTE SELF SIMILAR CON LA QUE QUEREMOS TRABAJAR, DEBEMOS ELEGIR UNAS CABECERAS U OTRAS.
// PARA ELEGIR LA VERSION DE LA FUENTE CON LA QUE QUERAMS TRABAJAR, TENEMOS QUE COMENTAR Y DESCOMENTAR LAS CABECERAS Y
// LO QUE ESTA EN LAS FUNCIONES INITIALIZE() Y HANDLEMESSAGE() PARA CADA VERSION DE LA FUENTE

// FUENTE SELF SIMILAR VERSION 2 /////////////////////////////////
/*
#include "_types.h"
#include "_util.h"
#include "_rand_MT.h"
#include "_link.h"
#include "trace.h"
#include "aggreg.h"
*/
// FIN DE LA FUENTE VERSION 2//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// FUENTE SELF SIMILAR VERSION 3 //////////////////////////////////
/*
#include "trf_gen_v3.h"
#include "avltree.h"
#include "_types.h"
*/
// FIN DE LA FUENTE VERSION 3//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// GENERAMOS EL CODIGO Y LAS FUNCIONES DEL MODULO SIMPLE
Define_Module(ONU_GENTraffic);

// INICIO DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 2 /////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//CONSTRUCTOR--> ESTABLECE LOS MIEMBROS DEL PUNTERO DEL GENERADOR EN NULL.                                                      //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
ONU_GENTraffic::ONU_GENTraffic()
{
    pAG = NULL; // PUNTERO AL GENERADOR DE PAQUETES CON VALOR NULL O VACIO
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//DESTRUCTOR--> ELIMINA TODO LO QUE FUE ASIGNADO COMO NUEVO EN EL PUNTERO AL GENERADOR DE PAQUETES.                             //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
ONU_GENTraffic::~ONU_GENTraffic()
{
    delete pAG; // BORRAMOS EL PUNTERO AL GENERADOR DE PAQUETES
}

// FINAL DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 2 ////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



// INICIO DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 3 ////////////////////////////////////////////////////////////////////
/*
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// DEVUELVE LA LLAMADA DE LA FUNCION QUE CREA NUEVOS SUBS.STREAMS CON LA DISTRIBUCION DESEADA.                                  //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Stream* CreateStream( load_t load, float mean_burst,int id )
{
return new StreamPareto( load, mean_burst, SHAPE_PARETO ); // TIPO DE GENERADOR DE TRAFICO DE PARETO.
//return new StreamExpon( load, mean_burst ) ; // TIPO DE GENERACION DE TRAFICO EXPONENCIAL

}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// DEVUELVE LA LLAMADA DE LA FUNCION QUE GENERA LOS TAMANYOS DE LOS PAQUETES CON LA DISTRIBUCION DESEADA.                       //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
pckt_size_t PacketSize( void ) // TAMANYO DEL PAQUETE A GENERAR
{
long int packetSize = (long int) 1500; // TAMANYO DEL PAQUETE FIJO = 1500 BYTES
//int packetSize = intuniform(MIN_PACKET_SIZE,MAX_PACKET_SIZE); // TAMANYO DEL PAQUETE DEFINIDO EN EL ARCHIVO ONU_GENTRAFFIC.H

return (pckt_size_t)(packetSize); // DEVUELVE EL TAMANYO DEL PAQUETE SELECCIONADO
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//CONSTRUCTOR--> ESTABLECE LOS MIEMBROS DEL PUNTERO DEL GENERADOR EN NULL.                                                      //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
ONU_GENTraffic::ONU_GENTraffic()
{
    pSRC=NULL; // PUNTERO AL GENERADOR DE PAQUETES CON VALOR NULL O VACIO
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//DESTRUCTOR--> ELIMINA TODO LO QUE FUE ASIGNADO COMO NUEVO EN EL PUNTERO AL GENERADOR DE PAQUETES.                             //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
ONU_GENTraffic::~ONU_GENTraffic()
{
    delete pSRC; // BORRAMOS EL PUNTERO AL GENERADOR DE PAQUETES
}
*/
// FINAL DEL CODIGO PARA LA FUENTE SELF SIMILAR VERSION 3 ///////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPUES DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS      //
//                        PARAMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE //
//                        ASIGNAN ESTRUCTURAS DE DATOS DINAMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  //
//                        PARA EL FUNCIONAMIENTO DE ESTE MODULO.                                                                //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_GENTraffic::initialize()
{
    volcado = 0;
    contador = 0;
    isGateway = 0;
    // Inicializacion de las variables (aunque no se vayan a usar):
    load_dmb.resize((int)par("numqueue"),0);
    onu=0;
    sla=0;
    tamsumpop.resize((int)par("numqueue"),0);
    suma_tam_packets = 0;

    time_creation = 0;
    suma_total.resize((int)par("numqueue"),0);
    packet_64 = 0;
    packet_594 = 0;
    packet_1500 = 0;
    totalpacket = 0;

    fuente_0 = 0.0;
    fuente_12 = 0.0;
    cont3=1;
    cont4=1;

    //int indiceOnu = this->getParentModule()->getParentModule()->getIndex();
    //int pasarelas = this->getParentModule()->getParentModule()->getParentModule()->par("numGW");
    /*if(this->getParentModule()->getParentModule()->gate("gatewirelessInOut$o",0)->isConnected())
    {
        isGateway = 1;
    }*/


    //ACTIVAR//
    if(isGateway == 0) // Si no es pasarela, inicializa fuentes Onu:
    {
    // INICIO DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 2 ///////////////////////////////////////////////////////////////////////
        // COMPARAMOS EL NUMERO DE COLAS O SERVICIOS DE LA ONU
        if((int)par("numqueue")==1)
        {
            // LA ONU SOLO TIENE UN SERVICIO
            load_dmb[getIndex()] = (double)par("node_load"); // VARIABLE CARGA DEL NODO DE LA ONU Y LA VISUALIZAMOS POR PANTALLA
            //ev<<" Carga de los nodos de las ONU: " << load_dmb[getIndex()] << endl;
        }
        else if((int)par("numqueue")>=2)
        {
            // LA ONU TIENE 2 O MAS SERVICIOS
            if(getIndex()==0)
            {
                // SERVICIO P0
                //ev<<" Carga de los nodos de las ONU: 0.0448" << endl;
            }
            else if(getIndex()>=1)
            {
                load_dmb[getIndex()] = (double)par("node_load"); // VARIABLE CARGA DEL NODO DE LA ONU Y LA VISUALIZAMOS POR PANTALLA
                //ev<<" Carga de los nodos de las ONU: "<<load_dmb[getIndex()]<<endl;
            }
        }

        packetSize = 1500;  // TAMANYO DEL PAQUETE FIJO PARA LA FUENTE SELF SIMILAR VERSION 2
        //packetSize = intuniform(MIN_PACKET_SIZE,MAX_PACKET_SIZE); // TAMANYO DEL PAQUETE VARIABLE ENTRE DOS VALORES PARA LA FUENTE SELF SIMILAR VERSION 2
        int streams = (int)par("numstreamV2_32_128_256"); // NUMERO DE FUENTES O SUB-STREAMS
        int method_generator = (int)par("longpacketfixed0_trimodal1"); // PARAMETRO PARA DEFINIR LA LONGITUD O TAMANYO DE LOS PAQUETES DE LA RED ( LONGITUD O TAMANYO DE LOS PAQUETES DE LA RED FIJA O LONGITUD O TAMANYO DE LOS PAQUETES DE LA RED TRIMODAL )

        // COMPARAMOS CON EL SWITCH EL METODO CON EL QUE TRABAJA EL GENERADOR ( MONOMODAL O TRIMODAL )
        switch(method_generator)
        {
            case 0:
                // MONOMODAL-> 1 SERVICIO
                pAG =new Generator; // PUNTERO PARA EL GENERADOR
                for( int src = 0; src < streams; src++ )
                {
                pAG->AddSource( new SourcePareto( src, 0, packetSize, 0, load_dmb[getIndex()]/streams, 1.4, 1.2 ));
                }
                break;

            case 1:
                // TRIMODAL-> 3 SERVICIOS

                switch((int)par("numstreamV2_32_128_256"))
                {
                    case 32:
                        pAG =new Generator; // PUNTERO PARA EL GENERADOR
                        // MEDIANTE EL BUCLE FOR REPARTIMOS LAS FUENTES O STREAMS PARA GENERAR PAQUETES DE VARIOS TAMANYOS O LONGITUDES
                        for( int src = 0; src < streams; src++ )
                        {
                            if(src<3)
                            {
                                packetSize = 64;
                                pAG->AddSource( new SourcePareto( src, 0, packetSize, 0, load_dmb[getIndex()]/streams, 1.4, 1.2 ));
                            }
                            else if(src>=3 && src<8)
                            {
                                packetSize = 594;
                                pAG->AddSource( new SourcePareto( src, 0, packetSize, 0, load_dmb[getIndex()]/streams, 1.4, 1.2 ));
                            }
                            else if(src>=8)
                            {
                                packetSize = 1500;
                                pAG->AddSource( new SourcePareto( src, 0, packetSize, 0, load_dmb[getIndex()]/streams, 1.4, 1.2 ));
                            }
                        }
                        break;

                    case 128:
                        pAG =new Generator; // PUNTERO PARA EL GENERADOR
                        // MEDIANTE EL BUCLE FOR REPARTIMOS LAS FUENTES O STREAMS PARA GENERAR PAQUETES DE VARIOS TAMANYOS O LONGITUDES
                        for( int src = 0; src < streams; src++ )
                        {
                            if(src<12)
                            {
                                packetSize = 64;
                                pAG->AddSource( new SourcePareto( src, 0, packetSize, 0, load_dmb[getIndex()]/streams, 1.4, 1.2 ));
                            }
                            else if(src>=12 && src<32)
                            {
                                packetSize = 594;
                                pAG->AddSource( new SourcePareto( src, 0, packetSize, 0, load_dmb[getIndex()]/streams, 1.4, 1.2 ));
                            }
                            else if(src>=32)
                            {
                                packetSize = 1500;
                                pAG->AddSource( new SourcePareto( src, 0, packetSize, 0, load_dmb[getIndex()]/streams, 1.4, 1.2 ));
                            }
                        }
                        break;

                    case 256:
                        pAG =new Generator; // PUNTERO PARA EL GENERADOR
                        // MEDIANTE EL BUCLE FOR REPARTIMOS LAS FUENTES O STREAMS PARA GENERAR PAQUETES DE VARIOS TAMANYOS O LONGITUDES
                        for( int src = 0; src < streams; src++ )
                        {
                            if(src<24)
                            {
                                packetSize = 64;
                                pAG->AddSource( new SourcePareto( src, 0, packetSize, 0, load_dmb[getIndex()]/streams, 1.4, 1.2 ));
                            }
                            else if(src>=24 && src<64)
                            {
                                packetSize = 594;
                                pAG->AddSource( new SourcePareto( src, 0, packetSize, 0, load_dmb[getIndex()]/streams, 1.4, 1.2 ));
                            }
                            else if(src>=64)
                            {
                                packetSize = 1500;
                                pAG->AddSource( new SourcePareto( src, 0, packetSize, 0, load_dmb[getIndex()]/streams, 1.4, 1.2 ));
                            }
                        }
                        break;
                }

        }

        //CREAMOS UN AUTOMENSAJE PARA CREAR LOS PAQUETES ETHERNET QUE MANDA LA ONU HACIA EL OLT
        cMessage *msg = new cMessage ("Mensaje inicial"); //ACTIVAR//
        msg->setKind(5); // IDENTIFICADOR DEL AUTOMENSAJE// //ACTIVAR//
        scheduleAt(1, msg); //ACTIVAR//
    // FINAL DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 2 ////////////////////////////////////////////////////////////////////////

    // INICIO DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 3 ////////////////////////////////////////////////////////////////////////
    /*
        // INICIALIZACION DE LAS VARIABLES DEFINIDAS EN EL ARCHIVO ONU_GENTRAFFIC.H
        load = (int)par("node_load");
        pSRC=new PacketGenerator ( 0, MIN_IFG, MEAN_BURST_SIZE, CreateStream, PacketSize, SUB_STREAMS, load);

        // CREAMOS UN AUTOMENSAJE PARA CREAR LOS PAQUETES ETHERNET QUE MANDA LA ONU HACIA EL OLT
        cMessage *msg = new cMessage ("mensaje inicial");
        msg->setKind(5); // IDENTIFICADOR DEL AUTOMENSAJE
        scheduleAt(1, msg);
    */
    // FINAL DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 3 //////////////////////////////////////////////////////////////////////////

    // ACTIVAR
    }
    else
    {
        //ev<<" Esta ONU actua de pasarela con la parte inalambrica" << endl;
    }
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//                                        UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O      //
//                                        EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//                                        DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL   //
//                                        CODIGO IMPLEMENTADO.                                                                  //                                                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_GENTraffic::handleMessage(cMessage *msg)
{
    //VARIABLES
    int type = msg->getKind(); // VARIABLE TYPE PARA IDENTIFICAR LOS MENSAJES DE LA RED
    int method = (int)par("insercionmethod_separatequeue0_priorityqueue1"); // PARAMETRO PARA ELEGIR EL METODO DE COLAS ( METODO DE COLAS SEPARADAS O METODO DE PRIORIDAD DE COLAS )
        //double buffer = (double)par("tambuffer"); // TAMANYO TOTAL DEL BUFFER Y VISUALIZACION POR PANTALLA
    //ev<<" Tamanyo del Buffer: "<<buffer<<endl;
    // TASA DE BITS POR LONGITUD DE ONDA UTILIZADA
    //double txrate = (double)par("txrate"); // TASA DE TRANSMISION EN BITS POR SEGUNDO
    long int txrate = (long int)par("txrate"); // TASA DE TRANSMISION EN BITS POR SEGUNDO

    wavelength_bit_rate = txrate/10; // DIVIDIMOS LA TASAS DE TRANSMISION ENTRE 10 PARA QUE TENGAMOS EL PARAMETRO = 10e8 PARA TENER UN TAMANYO DE BUFFER DE 10 MBytes
    int destAddress = 9; // DIRECCION DE DESTINO DEL PAQUETE ETHERNET
    int srcAddress = getParentModule()->getParentModule()->getIndex(); // DIRECCION FUENTE O DE ORIGEN DEL PAQUETE ETHERNET
    int priority = getIndex(); // PARAMETRO DE LA PRIORIDAD QUE SE ASIGNA POR EL IDENTIFICADOR DE LA FUENTE QUE SE CREA


    onu=srcAddress;
    if(onu==0) //if(onu==0)
    {
        sla=0;
    }
    else if(onu>=1 && onu<6)//else if(onu>=1 && onu<=5)
    {
        sla=1;
    }
    else if(onu>=6)//else if(onu>=6)
    {
        sla=2;
    }
    // ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA LOS MENSAJES QUE LLEGUEN A ESTE MODULO
    switch(type)
    {
        case 5:
            // LLEGA UN AUTOMENSAJE CON IDENTIFICADOR = 5 PARA GENERAR EL PAQUETE ETHERNET
            if(msg->getKind()==5)
            {
                if((int)par("numqueue") == 1)
                {
                //  ev<<" TRABAJAMOS CON UN FUENTE SELF SIMILAR AL SOLO TENER UNA PRIORIDAD"<<endl;
// INICIO DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 2 ////////////////////////////////////////////////////////////////////
                    Generator &AG=*pAG;
                    AG.GetNextPacket();
                    Trace trc= AG.PeekNextPacket();
                    bytestamp_t tiempo=AG.GetTime();
                    bytestamp_t ByteStamp= AG.GetByteStamp();
                    bytestamp_t intervalo=ByteStamp-tiempo;

                    // CALCULAMOS LA VARIABLE interarrivaltime A PARTIR DEL INTERVALO DETERMINADO EN BYTES
                    simtime_t interarrivaltime = (simtime_t)(intervalo*8/wavelength_bit_rate);

                    //CREAMOS PAQUETE ETHERNET PARA ENVIAR AL OLT
                    ETHERNETmsg *packet = new ETHERNETmsg("Ethernet");
                    packet->setIsWireless(0); // MENSAJE DE FUENTE OPTICA (isWireless = 0):
                    packet->setSrcAddress(srcAddress); // DIRECCION FUENTE O DE ORIGEN
                    packet->setDestAddress(destAddress); // DIRECCION DE DESTINO
                    packet->setByteLength(trc.PacketSize); // TAMANYO DEL PAQUETE ETHERNET
                    packet->setPriority(priority); // PRIORIDAD DEL PAQUETE ETHERNET
                    packet->setLambdaethernet(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE ETHERNET
                    packet->setKind(1); // IDENTIFICADOR DEL PAQUETE ETHERNET
                    packet->setId_servicio(getIndex());

                    simtime_t time_sch = (simtime_t) (simTime()+interarrivaltime);
                    scheduleAt(time_sch,msg); //PROGRAMAMOS UN AUTOMENSAJE PARA EL INSTANTE SimTime()+interarrivalTime

                    //ev<<" Generacion de un nuevo paquete de datos 'ETHERNET' de la ONU[" << this->getParentModule()->getParentModule()->getIndex() << "] " << endl;
                    ////ev<<"   Longitud de este paquete: " << packet->getByteLength() << " Bytes" << endl;

                    // CALCULAMOS LA SUMA TOTAL DEL TAMANYO DE LOS PAQUETES GENERADOS POR LA ONU EN BYTES Y LO VISUALIZAMOS POR PANTALLA
                    suma_tam_packets = suma_tam_packets + (double) trc.PacketSize;
                    ////ev<<"   Suma bytes paquetes ONU " << getParentModule()->getParentModule()->getIndex() << ": " << suma_tam_packets << " Bytes" << endl;

                    time_creation = (simtime_t) simTime(); // TIEMPO DE CREACCION DEL PAQUETE ETHERNET
                    packet->setTimestamp(time_creation);
                    // CALCULAMOS LA CARGA DEL NODO DE LA ONU Y LA VISUALIZAMOS POR PANTALLA CADA VEZ QUE SE GENERA UN PAQUETE ETHERNET
                    double tiempo_creacion = (double) SIMTIME_DBL(time_creation);
                    total_load = (double) (suma_tam_packets*8/(tiempo_creacion*wavelength_bit_rate)); // FORMULA PARA CALCULAR LA CARGA DEL NODO DE LA ONU
                    ////ev<<"   Tiempo de creacion (s): " << tiempo_creacion << endl;
                    ////ev<<"   Tasa de transmision de la lambda (bps): " <<  << endl;
                    //ev<<"     Carga Total del Nodo de la ONU[" << this->getParentModule()->getParentModule()->getIndex() << "]: " << total_load << endl;

                    //RECOGIDA DE ESTADISTICAS DE LA CARGA TOTAL
                    load_carga.analyze(total_load);

                    totalpacket++; // SUMA TOTAL DE TODOS LOS PAQUETES CREADOS POR LA ONU

                    if(packet->getByteLength()==64)
                    {
                        // PAQUETES CREADOS DE 64 BYTES
                        packet_64++;
                    }
                    else if(packet->getByteLength()==594)
                    {
                        // PAQUETES CREADOS DE 594 BYTES
                        packet_594++;
                    }
                    else if(packet->getByteLength()==1500)
                    {
                        // PAQUETES CREADOS DE 1500 BYTES
                        packet_1500++;
                    }

                    // ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA EL METODO DE INSERCION DE PAQUETES DE LAS COLAS
                    switch(method)
                    {
                        case 0:
                            //ev<<" Metodo de Colas Separadas."<<" Tamanyo Buffer Total: "<< buffer<<"Bytes"<<endl;
                            //ev<<" Tamanyo Colas Totales."<<endl;

                            // VISUALIZAMOS POR PANTALLA EL TAMANYO DE LAS COLAS ENTRANDO DESDE ESTE MODULO AL MODULO ONU_SISTQUEUE Y COMPROBANDO SU TAMANYO
                            for(int i=0; i<(int)par("numqueue"); i++)
                            {
                                cModule *c_onu_queue;
                                c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
                                onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);
                                //ev<<" Tamanyo cola "<<i<<"-> "<<onu_queue->tamqueue[i]<<"Bytes"<<endl;
                            }
                            //delete packet;
                            separatequeue(packet); // LLAMADA A LA FUNCION DEL METODO DE INSERCION DE PAQUETES DE COLAS SEPARADAS
                            break;

                        case 1:
                            //ev<<" Metodo de Prioridad de Colas."<<" Tamanyo Buffer Total: "<< buffer<<"Bytes"<<endl;

                            // VISUALIZAMOS POR PANTALLA EL TAMANYO DE LAS COLAS ENTRANDO DESDE ESTE MODULO AL MODULO ONU_SISTQUEUE Y COMPROBANDO SU TAMANYO
                            for(int i=0; i<(int)par("numqueue"); i++)
                            {
                                cModule *c_onu_queue;
                                c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
                                onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);
                                //ev<<" Tamanyo cola P"<<i<<" -> "<<onu_queue->tamqueue[i]<<" Bytes"<<endl;
                            }
                            //delete packet;
                            priorityqueue(packet); // LLAMADA A LA FUNCION DEL METODO DE INSERCION DE PAQUETES DE PRIORIDAD DE COLAS
                            break;

                        default:
                            //ev<<" ERROR AL ELEGIR EL METODO DE COLAS, ELEGIR 0 o 1."<<endl;
                            delete packet;
                            break;
                    }

// FINAL DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 2////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// INICIO DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 3 ///////////////////////////////////////////////////////////////////////////
/*
                    PacketGenerator &SRC=*pSRC;
                    Packet pckt; // DEFINIMOS EL PAQUETE
                    pckt = SRC.GetNextPacket(); // SIGUIENTE PAQUETE

                    // CALCULAMOS LA VARIABLE interarrivaltime A PARTIR DEL INTERVALO DETERMINADO EN BYTES
                    interarrivalTime = (simtime_t)(((double)pckt.Interval*8)/wavelength_bit_rate);

                    //CREAMOS PAQUETE ETHERNET PARA ENVIAR AL OLT
                    ETHERNETmsg *packet = new ETHERNETmsg("Ethernet");
                    packet->setSrcAddress(srcAddress); // DIRECCION FUENTE O DE ORIGEN
                    packet->setDestAddress(destAddress); // DIRECCION DE DESTINO
                    packet->setByteLength(pckt.PcktSize); // TAMANYO DEL PAQUETE ETHERNET
                    packet->setPriority(priority); // PRIORIDAD DEL PAQUETE ETHERNET
                    packet->setLambdaethernet(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE ETHERNET
                    packet->setKind(1); // IDENTIFICADOR DEL PAQUETE ETHERNET
                    packet->setId_servicio(getIndex());

                    //VISUALIZAMOS POR PANTALLA LOS CAMPOS DEL PAQUETE ETHERNET
                    ev<<" Paquete Ethernet "<<endl;
                    ev<<" Origen ONU "<<packet->getSrcAddress()<<endl;
                    ev<<" Destino OLT con ID "<<packet->getDestAddress()<<endl;
                    ev<<" Prioridad: "<<packet->getPriority()<<endl;
                    ev<<" Longitud de onda de envio, Lambda "<<packet->getLambdaethernet()<<endl;
                    ev<<" Tamanyo Paquete Ethernet: "<<packet->getByteLength()<<endl;
                    ev<<" Tipo "<<packet->getKind()<<endl;
                    ev<<" Identificador servicio P"<<packet->getId_servicio()<<endl;

                    scheduleAt(simTime()+interarrivalTime,msg); //PROGRAMAMOS UN AUTOMENSAJE PARA EL INSTANTE SimTime()+interarrivalTime

                    // CALCULAMOS LA SUMA TOTAL DEL TAMANYO DE LOS PAQUETES GENERADOS POR LA ONU EN BYTES Y LO VISUALIZAMOS POR PANTALLA
                    suma_tam_packets = suma_tam_packets + pckt.PcktSize;
                    ev<<" suma tamanyo paquetes ONU "<<getParentModule()->getParentModule()->getIndex()<<": "<<suma_tam_packets<<"Bytes"<<endl;

                    time_creation = simTime(); // TIEMPO DE CREACCION DEL PAQUETE ETHERNET

                    // CALCULAMOS LA CARGA DEL NODO DE LA ONU Y LA VISUALIZAMOS POR PANTALLA CADA VEZ QUE SE GENERA UN PAQUETE ETHERNET
                    total_load = suma_tam_packets*8/(SIMTIME_DBL(time_creation)*); // FORMULA PARA CALCULAR LA CARGA DEL NODO DE LA ONU
                    ev<<" Carga Total del Nodo de la ONU: "<<total_load<<endl;

                    //RECOGIDA DE ESTADISTICAS DE LA CARGA TOTAL
                    load_carga.analyze(total_load);

                    // ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA EL METODO DE INSERCION DE PAQUETES DE LAS COLAS
                    switch(method)
                    {
                        case 0:
                            ev<<" Metodo de Colas Separadas."<<" Tamanyo Buffer Total: "<< buffer<<"Bytes"<<endl;
                            ev<<" Tamanyo Colas Totales."<<endl;

                            // VISULAIZAMOS POR PANTALLA EL TAMANYO DE LAS COLAS ENTRANDO DESDE ESTE MODULO AL MODULO ONU_SISTQUEUE Y COMPROBANDO SU TAMANYO
                            for(int i=0; i<(int)par("numqueue"); i++)
                            {
                                cModule *c_onu_queue;
                                c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
                                onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);
                                ev<<" Tamanyo cola "<<i<<"-> "<<onu_queue->tamqueue[i]<<"Bytes"<<endl;
                            }
                            separatequeue(packet); // LLAMADA A LA FUNCION DEL METODO DE INSERCION DE PAQUETES DE COLAS SEPARADAS
                            break;

                        case 1:
                            ev<<" Metodo de Prioridad de Colas."<<" Tamanyo Buffer Total: "<< buffer<<"Bytes"<<endl;

                            // VISUALIZAMOS POR PANTALLA EL TAMANYO DE LAS COLAS ENTRANDO DESDE ESTE MODULO AL MODULO ONU_SISTQUEUE Y COMPROBANDO SU TAMANYO
                            for(int i=0; i<(int)par("numqueue"); i++)
                            {
                                cModule *c_onu_queue;
                                c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
                                onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);
                                ev<<" Tamanyo cola "<<i<<"-> "<<onu_queue->tamqueue[i]<<"Bytes"<<endl;
                            }
                            priorityqueue(packet); // LLAMADA A LA FUNCION DEL METODO DE INSERCION DE PAQUETES DE PRIORIDAD DE COLAS
                            break;

                        default:
                            ev<<" ERROR AL ELEGIR EL METODO DE COLAS, ELEGIR 0 o 1."<<endl;
                            delete packet;
                            break;
                    }
*/
// FINAL DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 3 ////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

                }
                else if((int)par("numqueue") >= 2)
                {
                    if(getIndex() == 0)
                    {
                        //ev<<" TRABAJAMOS CON UN FUENTE DE TASA CONSTANTE YA QUE TENEMOS UNA PRIORIDAD "<<getIndex()<<endl;
                        // FUENTE CONSTANTE DE PAQUETES DE 70 BYTES QUE SE MANDAN DURANTE 125 MICROSEGUNDOS
                        //CREAMOS PAQUETE ETHERNET PARA ENVIAR AL OLT
                        ETHERNETmsg *packet = new ETHERNETmsg("Ethernet");
                        packet->setIsWireless(0); // MENSAJE DE FUENTE OPTICA (isWireless = 0):
                        packet->setSrcAddress(srcAddress); // DIRECCION FUENTE O DE ORIGEN
                        packet->setDestAddress(destAddress); // DIRECCION DE DESTINO
                        packet->setByteLength(70); // TAMANYO DEL PAQUETE ETHERNET
                        packet->setPriority(priority); // PRIORIDAD DEL PAQUETE ETHERNET
                        packet->setLambdaethernet(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE ETHERNET
                        packet->setKind(1); // IDENTIFICADOR DEL PAQUETE ETHERNET
                        packet->setId_servicio(getIndex());

                        scheduleAt(simTime()+0.000125,msg); //PROGRAMAMOS UN AUTOMENSAJE PARA EL INSTANTE SimTime()+interarrivalTime

                        //ev<<" Generacion de un nuevo paquete de datos 'ETHERNET' de la ONU[" << this->getParentModule()->getParentModule()->getIndex() << "] " << endl;
                        ////ev<<"   Longitud de este paquete: " << packet->getByteLength() << " Bytes" << endl;

                        // CALCULAMOS LA SUMA TOTAL DEL TAMANYO DE LOS PAQUETES GENERADOS POR LA ONU EN BYTES Y LO VISUALIZAMOS POR PANTALLA
                        suma_tam_packets = suma_tam_packets + (double) packet->getByteLength();
                        //ev<<"     Suma bytes paquetes ONU "<<getParentModule()->getParentModule()->getIndex()<<": "<<suma_tam_packets<<"Bytes"<<endl;

                        time_creation = simTime(); // TIEMPO DE CREACCION DEL PAQUETE ETHERNET
                        packet->setTimestamp(time_creation);
                        // CALCULAMOS LA CARGA DEL NODO DE LA ONU Y LA VISUALIZAMOS POR PANTALLA CADA VEZ QUE SE GENERA UN PAQUETE ETHERNET
                        double tiempo_creacion = (double) SIMTIME_DBL(time_creation);
                        total_load = (double) (suma_tam_packets*8/(tiempo_creacion*wavelength_bit_rate)); // FORMULA PARA CALCULAR LA CARGA DEL NODO DE LA ONU
                        //ev<<"     Carga Total del Nodo de la ONU[" << this->getParentModule()->getParentModule()->getIndex() << "]: " << total_load << endl;


                        fuente_0 = (double) (((suma_tam_packets*8)/time_creation)/1000000);
                        //ev<<"     FUENTE 0 " << fuente_0 << endl;


                        //RECOGIDA DE ESTADISTICAS DE LA CARGA TOTAL
                        load_carga.analyze(total_load);
                        totalpacket++;

                        // ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA EL METODO DE INSERCION DE PAQUETES DE LAS COLAS
                        switch(method)
                            {
                                case 0:
                                        //ev<<" Metodo de Colas Separadas."<<" Tamanyo Buffer Total: "<< buffer<<"Bytes"<<endl;
                                    //ev<<" Tamanyo Colas Totales."<<endl;

                                    // VISULAIZAMOS POR PANTALLA EL TAMANYO DE LAS COLAS ENTRANDO DESDE ESTE MODULO AL MODULO ONU_SISTQUEUE Y COMPROBANDO SU TAMANYO
                                    for(int i=0; i<(int)par("numqueue"); i++)
                                    {
                                        cModule *c_onu_queue;
                                        c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
                                        onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);
                                        //ev<<" Longitud cola "<<i<<"-> "<<onu_queue->tamqueue[i]<<"Bytes"<<endl;
                                    }
                                    //delete packet;
                                        separatequeue(packet); // LLAMADA A LA FUNCION DEL METODO DE INSERCION DE PAQUETES DE COLAS SEPARADAS
                                        break;

                                case 1:
                                        //ev<<" Metodo de Prioridad de Colas."<<" Tamanyo Buffer Total: "<< buffer<<"Bytes"<<endl;

                                    // VISUALIZAMOS POR PANTALLA EL TAMANYO DE LAS COLAS ENTRANDO DESDE ESTE MODULO AL MODULO ONU_SISTQUEUE Y COMPROBANDO SU TAMANYO
                                    for(int i=0; i<(int)par("numqueue"); i++)
                                    {
                                        cModule *c_onu_queue;
                                        c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
                                        onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);
                                        //ev<<" Longitud cola P"<<i<<" -> "<<onu_queue->tamqueue[i]<<" Bytes"<<endl;
                                    }
                                    //delete packet;
                                    priorityqueue(packet); // LLAMADA A LA FUNCION DEL METODO DE INSERCION DE PAQUETES DE PRIORIDAD DE COLAS
                                    break;

                                default:
                                    //ev<<" ERROR AL ELEGIR EL METODO DE COLAS, ELEGIR 0 o 1."<<endl;
                                    delete packet;
                                    break;
                            }

                    }
                    else if(getIndex() >=1)
                    {
                    //  ev<<" TRABAJAMOS CON UN FUENTE SELF SIMILAR AL TENER LA PRIORIDAD "<<getIndex()<<" > QUE PRIORIDAD 0"<<endl;

// INICIO DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 2 //////////////////////////////////////////////////////////////////////////

                        Generator &AG=*pAG;
                        AG.GetNextPacket();
                        Trace trc= AG.PeekNextPacket();

                        bytestamp_t tiempo=AG.GetTime();
                        bytestamp_t ByteStamp= AG.GetByteStamp();
                        bytestamp_t intervalo=ByteStamp-tiempo;

                        // CALCULAMOS LA VARIABLE interarrivaltime A PARTIR DEL INTERVALO DETERMINADO EN BYTES
                        simtime_t interarrivaltime = (simtime_t)(intervalo*8/wavelength_bit_rate);

                        //CREAMOS PAQUETE ETHERNET PARA ENVIAR AL OLT
                        ETHERNETmsg *packet = new ETHERNETmsg("Ethernet");
                        packet->setIsWireless(0); // MENSAJE DE FUENTE OPTICA (isWireless = 0):
                        packet->setSrcAddress(srcAddress); // DIRECCION FUENTE O DE ORIGEN
                        packet->setDestAddress(destAddress); // DIRECCION DE DESTINO
                        packet->setByteLength(trc.PacketSize); // TAMANYO DEL PAQUETE ETHERNET
                        packet->setPriority(priority); // PRIORIDAD DEL PAQUETE ETHERNET
                        packet->setLambdaethernet(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE ETHERNET
                        packet->setKind(1); // IDENTIFICADOR DEL PAQUETE ETHERNET
                        packet->setId_servicio(getIndex());
                        //ev<<" Generacion de un nuevo paquete de datos 'ETHERNET' de la ONU[" << this->getParentModule()->getParentModule()->getIndex() << "] " << endl;

                        scheduleAt(simTime()+interarrivaltime,msg); //PROGRAMAMOS UN AUTOMENSAJE PARA EL INSTANTE SimTime()+interarrivalTime

                        // CALCULAMOS LA SUMA TOTAL DE LA LONGITUD DE LOS PAQUETES GENERADOS POR LA ONU EN BYTES Y LO VISUALIZAMOS POR PANTALLA
                        suma_tam_packets = suma_tam_packets + (double) trc.PacketSize;
                        //ev<<" Suma del Tamanyo de los Paquetes de la Onu ONU "<<getParentModule()->getParentModule()->getIndex()<<": "<<suma_tam_packets<<"Bytes"<<endl;

                        time_creation = simTime(); // TIEMPO DE CREACCION DEL PAQUETE ETHERNET
                        packet->setTimestamp(time_creation);
                        // CALCULAMOS LA CARGA DEL NODO DE LA ONU Y LA VISUALIZAMOS POR PANTALLA CADA VEZ QUE SE GENERA UN PAQUETE ETHERNET
                        double tiempo_creacion = (double) SIMTIME_DBL(time_creation);
                        total_load = (double) (suma_tam_packets*8/(tiempo_creacion*wavelength_bit_rate)); // FORMULA PARA CALCULAR LA CARGA DEL NODO DE LA ONU
                        //ev<<"     Carga Total del Nodo de la ONU[" << this->getParentModule()->getParentModule()->getIndex() << "]: " << total_load << endl;


                        fuente_12 = (double) (((suma_tam_packets*8)/time_creation)/1000000);
                        //ev<<"     FUENTE 1 O 2 " << fuente_12 << endl;


                        //RECOGIDA DE ESTADISTICAS DE LA CARGA TOTAL
                        load_carga.analyze(total_load);

                        totalpacket++; // SUMA TOTAL DE TODOS LOS PAQUETES CREADOS POR LA ONU

                        if(packet->getByteLength()==64)
                        {
                            // PAQUETES CREADOS DE 64 BYTES
                            packet_64++;
                        }
                        else if(packet->getByteLength()==594)
                        {
                            // PAQUETES CREADOS DE 594 BYTES
                            packet_594++;
                        }
                        else if(packet->getByteLength()==1500)
                        {
                            // PAQUETES CREADOS DE 1500 BYTES
                            packet_1500++;
                        }

                        // ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA EL METODO DE INSERCION DE PAQUETES DE LAS COLAS
                        switch(method)
                        {
                            case 0:
                                //ev<<" Metodo de Colas Separadas."<<" Tamanyo Buffer Total: "<< buffer<<"Bytes"<<endl;
                                //ev<<" Tamanyo Colas Totales."<<endl;

                                // VISULAIZAMOS POR PANTALLA EL TAMANYO DE LAS COLAS ENTRANDO DESDE ESTE MODULO AL MODULO ONU_SISTQUEUE Y COMPROBANDO SU TAMANYO
                                for(int i=0; i<(int)par("numqueue"); i++)
                                {
                                    cModule *c_onu_queue;
                                    c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
                                    onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);
                                //  ev<<" Tamanyo cola "<<i<<"-> "<<onu_queue->tamqueue[i]<<"Bytes"<<endl;
                                }
                                //delete packet;
                                separatequeue(packet); // LLAMADA A LA FUNCION DEL METODO DE INSERCION DE PAQUETES DE COLAS SEPARADAS
                                break;

                                case 1:
                                //  ev<<" Metodo de Prioridad de Colas."<<" Tamanyo Buffer Total: "<< buffer<<"Bytes"<<endl;

                                    // VISULAIZAMOS POR PANTALLA EL TAMANYO DE LAS COLAS ENTRANDO DESDE ESTE MODULO AL MODULO ONU_SISTQUEUE Y COMPROBANDO SU TAMANYO
                                    for(int i=0; i<(int)par("numqueue"); i++)
                                    {
                                        cModule *c_onu_queue;
                                        c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
                                        onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);
                                        //ev<<" Tamanyo cola P"<<i<<" -> "<<onu_queue->tamqueue[i]<<" Bytes"<<endl;
                                    }
                                    //delete packet;
                                    priorityqueue(packet); // LLAMADA A LA FUNCION DEL METODO DE INSERCION DE PAQUETES DE PRIORIDAD DE COLAS
                                    break;

                                default:
                                    //ev<<" ERROR AL ELEGIR EL METODO DE COLAS, ELEGIR 0 o 1."<<endl;
                                    delete packet;
                                    break;
                        }

// FINAL DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 2 /////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// INICIO DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 3 ////////////////////////////////////////////////////////////////////////
/*
                        PacketGenerator &SRC=*pSRC;
                        Packet pckt; // DEFINIMOS EL PAQUETE
                        pckt = SRC.GetNextPacket(); // SIGUIENTE PAQUETE

                        // CALCULAMOS LA VARIABLE interarrivaltime A PARTIR DEL INTERVALO DETERMINADO EN BYTES
                        interarrivalTime = (simtime_t)(((double)pckt.Interval*8)/wavelength_bit_rate);

                        //CREAMOS PAQUETE ETHERNET PARA ENVIAR AL OLT
                        ETHERNETmsg *packet = new ETHERNETmsg("Ethernet");
                        packet->setSrcAddress(srcAddress); // DIRECCION FUENTE O DE ORIGEN
                        packet->setDestAddress(destAddress); // DIRECCION DE DESTINO
                        packet->setByteLength(pckt.PcktSize); // TAMANYO DEL PAQUETE ETHERNET
                        packet->setPriority(priority); // PRIORIDAD DEL PAQUETE ETHERNET
                        packet->setLambdaethernet(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE ETHERNET
                        packet->setKind(1); // IDENTIFICADOR DEL PAQUETE ETHERNET
                        packet->setId_servicio(getIndex());

                        //VISUALIZAMOS POR PANTALLA LOS CAMPOS DEL PAQUETE ETHERNET
                        ev<<" Paquete Ethernet "<<endl;
                        ev<<" Origen ONU "<<packet->getSrcAddress()<<endl;
                        ev<<" Destino OLT con ID "<<packet->getDestAddress()<<endl;
                        ev<<" Prioridad: "<<packet->getPriority()<<endl;
                        ev<<" Longitud de onda de envio, Lambda "<<packet->getLambdaethernet()<<endl;
                        ev<<" Tamanyo Paquete Ethernet: "<<packet->getByteLength()<<endl;
                        ev<<" Tipo "<<packet->getKind()<<endl;
                        ev<<" Identificador servicio P"<<packet->getId_servicio()<<endl;

                        scheduleAt(simTime()+interarrivalTime,msg); //PROGRAMAMOS UN AUTOMENSAJE PARA EL INSTANTE SimTime()+interarrivalTime

                        // CALCULAMOS LA SUMA TOTAL DEL TAMANYO DE LOS PAQUETES GENERADOS POR LA ONU EN BYTES Y LO VISUALIZAMOS POR PANTALLA
                        suma_tam_packets = suma_tam_packets + pckt.PcktSize;
                        ev<<" suma tamanyo paquetes ONU "<<getParentModule()->getParentModule()->getIndex()<<": "<<suma_tam_packets<<"Bytes"<<endl;

                        time_creation = simTime(); // TIEMPO DE CREACCION DEL PAQUETE ETHERNET

                        // CALCULAMOS LA CARGA DEL NODO DE LA ONU Y LA VISUALIZAMOS POR PANTALLA CADA VEZ QUE SE GENERA UN PAQUETE ETHERNET
                        total_load = suma_tam_packets*8/(SIMTIME_DBL(time_creation)*wavelength_bit_rate); // FORMULA PARA CALCULAR LA CARGA DEL NODO DE LA ONU
                        ev<<" Carga Total del Nodo de la ONU: "<<total_load<<endl;

                        //RECOGIDA DE ESTADISTICAS DE LA CARGA TOTAL
                        load_carga.analyze(total_load);

                        // ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA EL METODO DE INSERCION DE PAQUETES DE LAS COLAS
                        switch(method)
                        {
                            case 0:
                                ev<<" Metodo de Colas Separadas."<<" Tamanyo Buffer Total: "<< buffer<<"Bytes"<<endl;
                                ev<<" Tamanyo Colas Totales."<<endl;

                                // VISULAIZAMOS POR PANTALLA EL TAMANYO DE LAS COLAS ENTRANDO DESDE ESTE MODULO AL MODULO ONU_SISTQUEUE Y COMPROBANDO SU TAMANYO
                                for(int i=0; i<(int)par("numqueue"); i++)
                                {
                                    cModule *c_onu_queue;
                                    c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
                                    onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);
                                    ev<<" Tamanyo cola "<<i<<"-> "<<onu_queue->tamqueue[i]<<"Bytes"<<endl;
                                }
                                separatequeue(packet); // LLAMADA A LA FUNCION DEL METODO DE INSERCION DE PAQUETES DE COLAS SEPARADAS
                                break;

                            case 1:
                                ev<<" Metodo de Prioridad de Colas."<<" Tamanyo Buffer Total: "<< buffer<<"Bytes"<<endl;

                                // VISULAIZAMOS POR PANTALLA EL TAMANYO DE LAS COLAS ENTRANDO DESDE ESTE MODULO AL MODULO ONU_SISTQUEUE Y COMPROBANDO SU TAMANYO
                                for(int i=0; i<(int)par("numqueue"); i++)
                                {
                                    cModule *c_onu_queue;
                                    c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
                                    onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);
                                    ev<<" Tamanyo cola "<<i<<"-> "<<onu_queue->tamqueue[i]<<"Bytes"<<endl;
                                }
                                priorityqueue(packet); // LLAMADA A LA FUNCION DEL METODO DE INSERCION DE PAQUETES DE PRIORIDAD DE COLAS
                                break;

                            default:
                                ev<<" ERROR AL ELEGIR EL METODO DE COLAS, ELEGIR 0 o 1."<<endl;
                                delete packet;
                                break;
                        }
*/
// FINAL DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 3 ////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                    }


                }


            }
            break;

        default:
                delete msg;
                break;
    }
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION SEPARATEQUEUE(cMessage *msg)--> FUNCION SE INVOCA CUANDO EL GENERADOR DE LA ONU CREA UN PAQUETE ETHERNET Y LO MANDA   //
//                  HACIA LAS COLAS DONDE SE INSERTAN MIENTRAS SE LE ASIGNA UN ANCHO DE BANDA PARA TRANSMITIR.                  //
//                  ESTA FUNCION INSERTA LOS PAQUETES EN LA COLA CORRESPONDIENTE DESPUES DE COMPROBAR SI HAY ESPACIO EN DICHAS  //
//                  COLAS, SINO HAY ESPACIO LIBRE BORRA EL PAQUETE GENERADO ANTES DE SER ENVIADO A LA COLA. EL TAMANYO DE LAS   //
//                  COLAS SE DEFINE MEDIANTE UN TAMANYO TOTAL DE BUFFER QUE SE REPARTE ENTRE EL NUMERO DE COLAS QUE SE DEFINEN  //
//                  EN LA RED. EL BUFFER SE MIDE EN BYTES.                                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_GENTraffic::separatequeue(cMessage *msg)
{
    // EJECUTAMOS EL METODO DE INSERCION DE COLAS SEPARADAS
    // VARIABLES
    double buffer = (double)par("tambuffer"); // TAMANYO TOTAL DEL BUFFER EN BYTES
    double bloqueo;
    ETHERNETmsg *ethernetmsg=check_and_cast<ETHERNETmsg*>(msg); // CHEQUEAMOS EL PAQUETE ETHERNET
    // VARIABLES PARA PODER ENTRAR DESTE ESTE MODULO AL MODULO ONU_SISTQUEUE Y PODER OBTENER INFORMACION SOBRE LAS COLAS
    cModule *c_onu_queue;
    c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",ethernetmsg->getPriority());
    onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);
    // VISUALIZAMOS POR PANTALLA EL TAMANYO DE LA COLA DONDE INSERTAREMOS EL MENSAJE CREADO POR LA FUENTE
    //ev<<" Longitud de la Cola "<<ethernetmsg->getPriority()<<" donde insertamos paquete"<<"-> "<<onu_queue->tamqueue[ethernetmsg->getPriority()]<<"Bytes"<<endl;
    // COMPARAMOS SI EL TAMANYO DEL BUFFER PARA CADA COLA ES MAYOR O MENOR QUE EL TAMANYO DE LA COLA MAS EL TAMANYO DEL MENSAJE ETHERNET
    if(buffer/(int)par("numqueue") >= onu_queue->tamqueue[ethernetmsg->getPriority()] + ethernetmsg->getByteLength() )
    {
        //ev<<" Como Longitud total Cola "<<buffer/(int)par("numqueue")<<" >= "<<onu_queue->tamqueue[ethernetmsg->getPriority()] + ethernetmsg->getByteLength()<<". Enviamos Paquete."<<endl;
        bloqueo=0.0; //ENVIO PAQUETE
        //VARIABLES PARA PODER ENTRAR DESDE ESTE MODULO AL MODULO OLT_Rx Y PODER PASARLE LA INFORMACION A LA VARIABLE PLR
        cModule *c_plr;
        c_plr=getParentModule()->getParentModule()->getParentModule()->getSubmodule("olt")->getSubmodule("olt_rx");
        olt_plr=check_and_cast<OLT_Rx *>(c_plr);
        olt_plr->plr.analyze(bloqueo);
        //ev<<" Envio mensaje Ethernet (Id. " << ethernetmsg->getId() << ") al modulo 'ONU_mac'." << endl;
        send(ethernetmsg, "onugenOut", ethernetmsg->getPriority()); // EN ESTE CASO, ENVIAMOS EL PAQUETE ETHERNET HACIA LA COLA CORRESPONDIENTE
    }
    else if(buffer/(int)par("numqueue") < onu_queue->tamqueue[ethernetmsg->getPriority()] + ethernetmsg->getByteLength() )
    {
        //ev<<" Como Longitud total Cola "<<buffer/(int)par("numqueue")<<" < "<<onu_queue->tamqueue[ethernetmsg->getPriority()] + ethernetmsg->getByteLength()<<". Borramos Paquete. Cola LLena"<<endl;
        bloqueo=1.0; //BORRO PAQUETE

        //VARIABLES PARA PODER ENTRAR DESDE ESTE MODULO AL MODULO OLT_Rx Y PODER PASARLE LA INFORMACION A LA VARIABLE PLR
        cModule *c_plr;
        c_plr=getParentModule()->getParentModule()->getParentModule()->getSubmodule("olt")->getSubmodule("olt_rx");
        olt_plr=check_and_cast<OLT_Rx *>(c_plr);
        olt_plr->plr.analyze(bloqueo);
        //ev<<" BORRADO mensaje Ethernet (Id. " << ethernetmsg->getId() << ")." << endl;
        delete ethernetmsg; // EN ESTE CASO, BORRAMOS EL MENSAJE ETHERNET YA QUE NO SE PUEDE INSERTAR EN LA COLA AL ESTAR LLENA
    }
    olt_plr->plr_total=olt_plr->plr_total+bloqueo; //SUMATORIO DE LA VARIABLE BLOQUEO
    olt_plr->numpaquetes++; //ACTUALIZAMOS EL NUMERO DE PAQUETES ETHERNET
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION PRIORITYQUEUE(cMessage *msg)--> FUNCION SE INVOCA CUANDO EL GENERADOR DE LA ONU CREA UN PAQUETE ETHERNET Y LO MANDA   //
//                  HACIA LAS COLAS DONDE SE INSERTAN MIENTRAS SE LE ASIGNA UN ANCHO DE BANDA PARA TRANSMITIR.                  //
//                  ESTA FUNCION INSERTA LOS PAQUETES EN LA COLA CORRESPONDIENTE DESPUES DE COMPROBAR SI HAY ESPACIO EN EL      //
//                  BUFFER TOTAL. SINO HAY ESPACIO LIBRE EN EL BUFFER, SE BORRA UN PAQUETE DE LA COLA DE PRIORIDAD MAS BAJA Y SE//
//                  INSERTA EL PAQUETE EN LA COLA CORRESPONDIENTE. SI AL BORRAR EL PAQUETE DE LA COLA DE PRIORIDAD MENOR NO SE  //
//                  PUEDE INSERTAR EL PAQUETE GENERADO, Y EN LA COLA DE MENOR PRIORIDAD NO HAY MAS PAQUETES PARA ELIMINAR, SE   //
//                  BORRA UN PAQUETE DE LA COLA DE PRIORIDAD INMEDIATAMENTE SUPERIOR A LA MAS BAJA Y DESPUES SE INSERTA EL      //
//                  PAQUETE SI YA HAY SITIO EN EL BUFFER. SI EL PAQUETE FUERA DE PRIORIDAD MENOR, SE BORRARIAN PAQUETES         //
//                  ANTERIORES DE DICHA COLA HASTA QUE SE PUEDA INSERTAR EL PAQUETE GENERADO.EL TAMANYO DEL BUFFER EN BYTES ES  //
//                  GLOBAL PARA TODAS LAS COLAS YA QUE SE COMPARA CON LAS SUMA DE TODOS LOS PAQUETES GENERADOS EN BYTES.        //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_GENTraffic::priorityqueue(cMessage *msg)
{
    // EJECUTAMOS EL METODO DE INSERCION DE PRIORIDAD DE COLAS

    // VARIABLES
    double buffer = (double)par("tambuffer"); // TAMANYO TOTAL DEL BUFFER EN BYTES
    double bloqueo;

    ETHERNETmsg *ethernetmsg=check_and_cast<ETHERNETmsg*>(msg); // CHEQUEAMOS EL PAQUETE ETHERNET

    ////ev<<" SLA " << sla << endl;

    // VARIABLES PARA PODER ENTRAR DESTE ESTE MODULO AL MODULO ONU_SISTQUEUE Y PODER OBTENER INFORMACION SOBRE LAS COLAS
    for(int i=0; i<(int)par("numqueue"); i++)
    {
        cModule *c_onu_queue;
        c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
        onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);
        suma_total[getIndex()] = suma_total[getIndex()] + onu_queue->tamqueue[i];
    }
    //ev<<" Suma de los Bytes de los Paquetes que estan insertados en todas las colas de la Red PON: "<<suma_total[getIndex()]<<endl;

    // DAMOS A LA VARIABLE tamsumqueue EL VALOR DE LA SUMA TOTAL DE LOS BYTES QUE HAY EN TODAS LAS COLAS MAS EL TAMANYO DEL MENSAJE QUE GENERA LA FUENTE
    tamsumqueue = suma_total[getIndex()] + ethernetmsg->getByteLength();

    ////ev<<" Bytes de este paquete Ethernet: " << ethernetmsg->getByteLength() << endl;
    ////ev<<" Suma de bytes en la cola de la misma prioridad (P" << getIndex() << ") :" << suma_total[getIndex()] << endl;

    // COMPARAMOS SI EL TAMANYO TOTAL DEL BUFFER ES MAYOR O MENOR QUE LA SUMA DEL TAMANYO DE TODOS LOS PAQUETES QUE LLEGAN A LAS COLAS
    if(buffer >= tamsumqueue)
    {
        ////ev<<" Longitud Total Buffer (" << buffer << " bytes) >= "<<"Suma Bytes Colas (" << tamsumqueue  << " bytes) --> ENVIO PAQUETE." << endl;
        bloqueo = 0.0; //ENVIO PAQUETE
        //VARIABLES PARA PODER ENTRAR DESDE ESTE MODULO AL MODULO OLT_Rx Y PODER PASARLE LA INFORMACION A LA VARIABLE PLR
        cModule *c_plr;
        c_plr=getParentModule()->getParentModule()->getParentModule()->getSubmodule("olt")->getSubmodule("olt_rx");
        olt_plr=check_and_cast<OLT_Rx *>(c_plr);
        olt_plr->plr.analyze(bloqueo);
        olt_plr->plr_sla[sla].analyze(bloqueo);
        //ev<<" Envio mensaje Ethernet (Id. " << ethernetmsg->getId() << ") al modulo 'ONU_mac'." << endl;
        send(ethernetmsg, "onugenOut", ethernetmsg->getPriority()); // EN ESTE CASO, SE ENVIA EL PAQUETE ETHERNET HACIA LAS COLAS
    }
    else if(buffer < tamsumqueue)
    {
        // EN ESTE CASO, EL PAQUETE NO ENTRA EN LAS COLAS Y TENEMOS QUE ELIMINAR UNO DE MENOR PRIORIDAD PARA INSERTAR EL PAQUETE NUEVO
        // VISUALIZAMOS POR PANTALLA QUE EL TAMANYO DE LA SUMA DE LAS COLAS ES MAYOR QUE EL TAMANYO TOTAL DEL BUFFER
        ////ev<<" Longitud Total Buffer (" << buffer << " bytes) < " << "Suma Bytes Colas (" << tamsumqueue << " bytes) --> NECESARIO ELIMINAR PAQUETES!"<<endl;

        // COMPROBAMOS LAS COLAS MENOR A MAYOR PRIORIDAD PARA ELIMINAR UN PAQUETE ANTERIOR PARA INSERTAR EL NUEVO
        //int i = (int)par("numqueue")-1, fuera = -1; ///////
        //while(i>=0 && fuera < 0) ///////
        for(int i=(int)par("numqueue")-1; i>=0; i--)
        {
            // VARIABLES PARA PODER ENTRAR DESTE ESTE MODULO AL MODULO ONU_SISTQUEUE Y PODER OBTENER INFORMACION SOBRE LAS COLAS
            cModule *c_onu_queue;
            c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
            onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);

            // COMPARAMOS SI LA PRIORIDAD DEL PAQUETE QUE LLEGA ES LA MAS BAJA O ES DE MAYOR PRIORIDAD
            if(ethernetmsg->getPriority() == i)
            {
                // SI EL PAQUETE QUE LLEGA ES DE LA MENOR PRIORIDAD, DIRECTAMENTE SE BORRA
                ////ev<<" Borramos el paquete que llega porque es de menos prioridad" << endl;
                // RESTAMOS EL TAMANYO DEL PAQUETE QUE SE BORRA A LA SUMA DEL TAMANYO DE LOS PAQUETES QUE LLEGAN A LAS COLAS DE LA ONU Y LO VISUALIZAMOS POR PANTALLA
                ////ev<<" Longitud del paquete borrado: " << ethernetmsg->getByteLength() << " bytes" << endl;
                tamsumqueue = tamsumqueue - ethernetmsg->getByteLength();
                ////ev<<" Suma del Tamanyo de las Colas -> " << tamsumqueue << "Bytes" << endl;

                bloqueo=1.0; //BORRADO PAQUETE

                //VARIABLES PARA PODER ENTRAR DESDE ESTE MODULO AL MODULO OLT_Rx Y PODER PASARLE LA INFORMACION A LA VARIABLE PLR
                cModule *c_plr;
                c_plr=getParentModule()->getParentModule()->getParentModule()->getSubmodule("olt")->getSubmodule("olt_rx");
                olt_plr=check_and_cast<OLT_Rx *>(c_plr);
                olt_plr->plr.analyze(bloqueo);
                olt_plr->plr_sla[sla].analyze(bloqueo);
                //ev<<" BORRADO mensaje Ethernet (Id. " << ethernetmsg->getId() << "). " << endl;
                delete ethernetmsg; // BORRAMOS EL PAQUETE ETHERNET
                //fuera = 1; ///////
                break; // SALIMOS DEL BUCLE FOR
            }
            else if(ethernetmsg->getPriority() < i && onu_queue->queue.getLength()>0)
            {
                // SI EL PAQUETE QUE LLEGA ES PRIORIDAD MAYOR QUE LA COLA EN LA QUE NOS ENCONTRAMOS.
                // SI ADEMAS EN NUMERO DE PAQUETES DE ESTA COLA ES MAYOR QUE 0,
                // BORRAMOS PAQUETES HASTA QUE PODAMOS INSERTAR EL NUEVO PAQUETE

                // RECORREMOS TODOS LOS PAQUETES DE LA COLA DESDE EL MAS ANTIGUO PARA ELIMINARLOS Y PODER INSERTAR EL PAQUETE NUEVO
                //int salir = -1; ///////
                //while (onu_queue->queue.getLength()>0 && salir < 0) ///////
                for(int j=0; j<=onu_queue->queue.getLength(); j++)
                {
                    // LLAMAMOS DE FORMA REMOTA A LA FUNCION ELIMINAR ELEMENTOS IMPLIMENTADA EN EL MODULO ONU_SISTQUEUE
                    onu_queue->deleteelement(ethernetmsg);

                    // VISUALIZAMOS POR PANTALLA EL TAMANYO DEL PAQUETE QUE VAMOS A ELIMINAR
                    //ev<<" Sacamos el mensaje con longitud "<<onu_queue->tamqueuepop<<"Bytes de la cola "<<i<<" y borramos. Comprobamos si entra el mensaje que llego."<<endl;

                    // RESTAMOS EL TAMANYO DEL PAQUETE QUE SACAMOS A LA SUMA DEL TAMANYO DE LOS PAQUETES QUE LLEGAN A LAS COLAS
                    tamsumqueue = tamsumqueue - onu_queue->tamqueuepop;
                    //ev<<" Tamanyo Total de la Suma de las Colas-> "<<tamsumqueue<<"Bytes"<<endl;

                    // SUMA DEL TAMANYO DE LOS PAQUETES QUE SALEN DE LAS COLAS PARA RESTARSELO AL TAMANYO DE CADA COLA Y LO VISULAIZAMOS POR PANTALLA
                    tamsumpop[i] = tamsumpop[i] + onu_queue->tamqueuepop;

                    // COMPARAMOS SI EL TAMANYO TOTAL DEL BUFFER ES MAYOR QUE LA SUMA DEL TAMANYO DE LOS PAQUETES QUE LLEGAN A LAS COLAS DESPUES DE RESTAR EL PAQUETE ELIMINADO
                    if(buffer > tamsumqueue)
                    {
                        // SI HAY UN TAMANYO SUFICIENTE EN LA COLA PARA INSERTAR EL NUEVO PAQUETE, LO ENVIAMOS HACIA LAS COLAS
                        //ev<<" Como Tamanyo Total Buffer "<<buffer<<" > "<<"Tamanyo Total Colas "<<tamsumqueue<<"Bytes"<<". Enviamos el paquete a la cola "<<ethernetmsg->getPriority()<<endl;

                        bloqueo=0.0; //ENVIO PAQUETE

                        //VARIABLES PARA PODER ENTRAR DESDE ESTE MODULO AL MODULO OLT_Rx Y PODER PASARLE LA INFORMACION A LA VARIABLE PLR
                        cModule *c_plr;
                        c_plr=getParentModule()->getParentModule()->getParentModule()->getSubmodule("olt")->getSubmodule("olt_rx");
                        olt_plr=check_and_cast<OLT_Rx *>(c_plr);
                        olt_plr->plr.analyze(bloqueo);
                        olt_plr->plr_sla[sla].analyze(bloqueo);
                        //ev<<" Envio mensaje Ethernet (Id. " << ethernetmsg->getId() << ") al modulo 'ONU_mac'." << endl;
                        send(ethernetmsg, "onugenOut", ethernetmsg->getPriority()); // ENVIAMOS EL PAQUETE ETHERNET HACIA LA COLA CORRESPONDIENTE
                        //salir = 1; ///////
                        //fuera = 1; ///////
                        break;// SALIMOS DEL BUCLE FOR QUE RECORRE LA COLA EN LA QUE ESTAMOS
                    }
                }
                // COMPARAMOS SI EL TAMANYO TOTAL DEL BUFFER ES MAYOR QUE LA SUMA DEL TAMANYO DE LOS PAQUETES QUE LLEGAN A LAS COLAS DESPUES DE RESTAR EL PAQUETE ELIMINADO
                if(buffer > tamsumqueue)
                {
                    //fuera = 1; ///////
                    break; // SALIMOS DEL BUCLE FOR QUE RECORRE TODAS LAS COLAS
                }
            }
            //i--; ///////
        }
    }

    // DAMOS EL VALOR CERO A LAS DOS VARIABLES PARA PODER HACER LO CALCULOS NECESARIOS EN SIGUIENTES SITUACIONES CORRECTAMENTE
    for(int i=0; i<(int)par("numqueue"); i++)
    {
        suma_total[i] = 0;
    }

    olt_plr->plr_total=olt_plr->plr_total+bloqueo; //SUMATORIO DE LA VARIABLE BLOQUEO
    olt_plr->numpaquetes++; //ACTUALIZAMOS EL NUMERO DE PAQUETES ETHERNET

    tamsumqueue = 0;

    if(simTime()>=5*contador) // && volcado == 0)
    {
        volcadoFicheros();
        volcadoFicheros_fuente_0();
        volcadoFicheros_fuente_12();
        contador++;
    }

}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION VOLCADOFICHEROS()--> ESCRIBE EN UNO O VARIOS FICHEROS DE TEXTO LOS DATOS DE MAYOR INTERES DE LA   /
//                             SIMULACION, PARA SU POSTERIOR ANALISIS.                                      /
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_GENTraffic::volcadoFicheros()
{
    volcado = 1;
    // RECOGIDA DE ESTADISTICAS Y LO GUARDAMOS LOS DATOS EN EL ARCHIVO CARGA_PAQUETES
    // SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
    carga_paquetes=fopen("results/carga_paquetes.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS

        //fprintf(carga_paquetes,"Carga total de la fuente %i de la ONU %i: %g\t", getIndex(), this->getParentModule()->getParentModule()->getIndex(), (double)load_carga.average()); // CARGA DEL NODO DE LA ONU
        //fprintf(carga_paquetes,"FUENTE 0: %g\t", (double)fuente_0); // CARGA DEL NODO DE LA ONU
        //fprintf(carga_paquetes,"FUENTES 1 o 2: %g\t", (double)fuente_12); // CARGA DEL NODO DE LA ONU

	fprintf(carga_paquetes,"%g\t", (double)load_carga.average());
        fprintf(carga_paquetes,"%g\t", (double)fuente_0); // CARGA DEL NODO DE LA ONU
        fprintf(carga_paquetes,"%g\t", (double)fuente_12); // CARGA DEL NODO DE LA ONU

        fprintf(carga_paquetes,"\n");
        fclose(carga_paquetes); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

    // RECOGIDA DE ESTADISTICAS DE LOS PAQUETES GENERADOS Y LO GUARDAMOS LOS DATOS EN EL ARCHIVO PAQUETES
    // SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
    paquetes=fopen("results/paquetes.txt", "a+");
        fprintf(paquetes,"ONU [%i]: Fuente P%i \n", this->getParentModule()->getParentModule()->getIndex(), getIndex());
        fprintf(paquetes,"Total\t");
        fprintf(paquetes,"64 Bytes\t");
        fprintf(paquetes,"594 Bytes\t");
        fprintf(paquetes,"1500 Bytes\n");
        fprintf(paquetes,"%li \t", totalpacket); // SUMA TOTAL DE PAQUETES GENERADOS
        fprintf(paquetes," %li \t", packet_64); // PAQUETES GENERADOS DE 64 BYTES
        fprintf(paquetes," %li \t", packet_594); // PAQUETES GENERADOS DE 594 BYTES
        fprintf(paquetes," %li\t", packet_1500); // PAQUETES GENERADOS DE 1500 BYTES
        fprintf(paquetes,"\n");
        fclose(paquetes); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION FINISH()--> ESTA FUNCION SE INVOCA CUANDO LA SIMULACION HA TERMINADO CON EXITO SIN QUE SE PRODUZCA NINGUN ERROR.      //
//                    LO USAMOS PARA LA RECOGIDA DE ESTADISTICAS Y VISUALIZACION POR PANTALLA O MEDIANTE UN ARCHIVO.            //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_GENTraffic::finish()
{
    // VISUALIZAMOS POR PANTALLA LA RECOGIDA DE ESTADISTICAS DE LA CARGA CUANDO LLAMAMOS A LA FUNCION FINISH()
    //ev<<" Estadisticas tomadas en el Modulo ONU_GENTraffic"<<endl;
    //ev<<" Carga del nodo de la ONU: "<<total_load<<endl;
    volcadoFicheros();
    volcadoFicheros_fuente_0();
    volcadoFicheros_fuente_12();
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION volcadoFicheros_fuente_0()--> ESCRIBE EN UN FICHERO DE TEXTO LOS DATOS DE CARGA PARA LA FUENTE CONSTANTE  //
//          DE TIPO CBR.                                                                                            //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_GENTraffic::volcadoFicheros_fuente_0()
{
    //volcado = 1;
    // RECOGIDA DE ESTADISTICAS Y LO GUARDAMOS LOS DATOS EN EL ARCHIVO CARGA_PAQUETES
    // SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
    prueba_fuente_0=fopen("results/prueba_fuente_0.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS

        //fprintf(prueba_fuente_0,"Carga total de la fuente %i de la ONU %i: %g\t", getIndex(), this->getParentModule()->getParentModule()->getIndex(), (double)load_carga.average()); // CARGA DEL NODO DE LA ONU
        //fprintf(prueba_fuente_0,"FUENTE 0: %g\t", (double)fuente_0); // CARGA DEL NODO DE LA ONU

        fprintf(prueba_fuente_0,"%g\t", (double)fuente_0); // CARGA DEL NODO DE LA ONU

        fprintf(prueba_fuente_0,"\n");
        fclose(prueba_fuente_0); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS


}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION volcadoFicheros_fuente_12()--> ESCRIBE EN UN FICHERO DE TEXTO LOS DATOS DE CARGA PARA LAS                 //
//          FUENTES DE TIPO SELF-SIMILAR.                                                                           //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_GENTraffic::volcadoFicheros_fuente_12()
{
    //volcado = 1;
    // RECOGIDA DE ESTADISTICAS Y LO GUARDAMOS LOS DATOS EN EL ARCHIVO CARGA_PAQUETES
    // SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
    prueba_fuente_12=fopen("results/prueba_fuente_12.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS

        //fprintf(prueba_fuente_12,"Carga total de la fuente %i de la ONU %i: %g\t", getIndex(), this->getParentModule()->getParentModule()->getIndex(), (double)load_carga.average()); // CARGA DEL NODO DE LA ONU
        //fprintf(prueba_fuente_12,"FUENTES 1 o 2: %g\t", (double)fuente_12); // CARGA DEL NODO DE LA ONU

	fprintf(prueba_fuente_12,"%g\t", (double)fuente_12); // CARGA DEL NODO DE LA ONU

        fprintf(prueba_fuente_12,"\n");
        fclose(prueba_fuente_12); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

}
