////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti�n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_GENTRAFFIC_H_
#define __RED_WIRELESS_GENTRAFFIC_H_

#include <omnetpp.h>
#include <vector>
#include <time.h>
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include "ONU_SISTqueue.h"
#include "analysis.h"
#include "ONU_Table.h"
#include "OLT_Rx.h"
#include "MAC_ONU.h"
using namespace std;


/*
 * MODULO ONU_GENTraffic:
 */

// DEPENDIENDO DE LA VERSION DE LA FUENTE SELF SIMILAR CON LA QUE QUEREMOS TRABAJAR, DEBEMOS ELEGIR UNAS CABECERAS U OTRAS.
// FUENTE SELF SIMILAR VERSION 2 //////////////////////////////////////////////////////////////////////////////////////////////////

#include "_types.h"
#include "_util.h"
#include "_rand_MT.h"
#include "_link.h"
#include "trace.h"
#include "aggreg.h"

// PARA DEFINIR PAQUETES DE TAMANYO VARIABLE EN LA FUENTE SELF SIMILAR VERSION 2
//#define MIN_PACKET_SIZE 64    	// MINIMO TAMANYO DEL PAQUETE
//#define MAX_PACKET_SIZE 1518  	// MAXIMO TAMANYO DEL PAQUETE

// FIN DE LA FUENTE VERSION 2//////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



// FUENTE SELF SIMILAR VERSION 3 ///////////////////////////////////////////////////////////////////////////////////////////////////
/*
#include "trf_gen_v3.h"
#include "avltree.h"
#include "_types.h"

#define MIN_IFG         0    	// DISTANCIA MINIMA ENTRE EL MARCO
#define MIN_PACKET_SIZE 64    	// MINIMO TAMANYO DEL PAQUETE
#define MAX_PACKET_SIZE 1518  	// MAXIMO TAMANYO DEL PAQUETE
#define SHAPE_PARETO    1.4F 	 // PARAMETRO ALFA PARA LA DISTRIBUCION DE PARETO
#define MEAN_BURST_SIZE 4000 	// TAMANYO MEDIO DE ESTALLIDO DE UNA RAFAGA INDIVIDUAL
#define SUB_STREAMS 256		// NUMERO DE FLUJO DE SUB_STREAMS O FUENTES
using namespace GEN;
*/
// FIN DE LA FUENTE SELF SIMILAR VERSION 3 /////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//DEFINIMOS LOS TIPOS DE std DE LOS VECTORES Y MATRICES
typedef std::vector<int> int_vector_t; // VECTOR DE TIPO ENTERO
typedef std::vector<double> double_vector_t; // VECTOR DE TIPO DOUBLE

class ONU_GENTraffic : public cSimpleModule
{
	private:

		Analysis load_carga; // VARIABLE PARA CALCULAR LA CARGA TOTAL DEL NODO CON LA CLASE ANALISIS
		FILE * carga_paquetes; // ARCHIVO EN EL QUE SE GUARDAN LOS RESULTADOS DE LA CARGA DE LOS PAQUETES DE LA CLASE ANALISIS
		FILE * paquetes; // ARCHIVO EN EL QUE SE GUARDAN LOS RESULTADOS DEL NUMERO DE PAQUETES QUE SE GENERAN POR CADA SERVICIO

	public:

// INICIO DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 2 ////////////////////////////////////////////////////////////////

		ONU_GENTraffic(); // CONSTRUCTOR
		virtual ~ONU_GENTraffic(); //  DESTRUCTOR
		Generator *pAG; // PUNTERO AL GENERADOR DE PAQUETES PARA LA FUENTE SELF SIMILAR VERSION 2
		int packetSize; // VARIABLE DEL TAMANYO DEL PAQUETE QUE GENERAMOS EN LAS FUENTES
		double_vector_t load_dmb; // VECTOR QUE INDICA LA CARGA DEL NODO DE LA ONU
		OLT_Rx *olt_plr;
		int onu;
		int sla;
		int isGateway;

// FINAL DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 2 /////////////////////////////////////////////////////////////////

// INICIO DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 3 ////////////////////////////////////////////////////////////////////
/*
		PacketGenerator *pSRC; // PUNTERO AL GENERADOR DE PAQUETES
		// ATRIBUTO PARA ESTABLECER EL INTERVALO interarrivalTime ENTRE PAQUETES DE PARAMETROS (DIFERENCIA ENTRE EL PAQUETE ACTUAL Y EL SIGUIENTE).
		// ESTE PARAMETRO SE HA DE CONVERTIR EN BIT Y DESPUES A TIEMPO EN FUNCION DE LA VELOCIDAD DE TRANSMISION.
		simtime_t interarrivalTime;
		double load; // VARIABLE QUE INDICA LA CARGA DEL NODO DE LA ONU
		double packet_size; // TAMANYO DEL PAQUETE
		ONU_GENTraffic(); // CONSTRUCTOR
		virtual ~ONU_GENTraffic(); // DESTRUCTOR
*/
// FINAL DE CODIGO PARA LA FUENTE SELF SIMILAR VERSION 3 ///////////////////////////////////////////////////////////////////////

		//ONU_Table *onutable_module;

		double wavelength_bit_rate; // TASA DE BITS POR LONGITUD DE ONDA UTILIZADA PARA LAS DOS VERSIONES DE LAS FUENTES
        double total_load; // CARGA TOTAL DEL NODO DE LA ONU
		ONU_SISTqueue *onu_queue; // DEFINIMOS VARIABLE PARA PODER ENTRAR EN EL MODULO OLT_TABLE
		long tamsumqueue; // TAMANYO DE LA SUMA DEL TAMANYO DE LOS PAQUETES QUE LLEGAN A LAS COLAS DE LA ONU
		int_vector_t tamsumpop; // VECTOR DEL TAMANYO DE LA SUMA DE LOS BYTES DE LOS PAQUETES EXTRAIDOS DE LAS COLAS

		double suma_tam_packets; // VARIABLE DE LA SUMA TOTAL DEL TAMANYO DE LOS PAQUETES GENERADOS POR LA ONU EN BYTES
		simtime_t time_creation; // TIEMPO DE CREACCION DEL PAQUETE
		int_vector_t suma_total; // VECTOR DE LA SUMA DE TODOS LOS BYTES QUE HAY EN LAS COLAS

		// VARIABLES USADAS PARA LA VERSION TRIMODAL
		long packet_64; // VARIABLE DEL NUMERO DE PAQUETES CREADOS DE 64 BYTES POR LA FUENTE SELF SIMILAR VERSION 2
		long packet_594; // VARIABLE DEL NUMERO DE PAQUETES CREADOS DE 594 BYTES POR LA FUENTE SELF SIMILAR VERSION 2
		long packet_1500; // VARIABLE DEL NUMERO DE PAQUETES CREADOS DE 150 BYTES POR LA FUENTE SELF SIMILAR VERSION 2
		long totalpacket; // VARIABLE DEL NUMERO DE PAQUETES TOTAL CREADOS POR LA FUENTE SELF SIMILAR VERSION 2

		double fuente_0;
		double fuente_12;


	protected:
        int volcado;
        int contador;

		virtual void initialize();
		virtual void handleMessage(cMessage *msg);

		virtual void separatequeue(cMessage *msg); // FUNCION DEL METODO DE INSERCION DE PAQUETES DE COLAS SEPARADAS
		virtual void priorityqueue(cMessage *msg); // FUNCION DEL METODO DE INSERCION DE PAQUETES DE PRIORIDAD DE COLAS

		virtual void volcadoFicheros();
		virtual void finish(); // DEFINICION DE LA FUNCION FINALIZAR


		// MODIFICADO POR DAVID: Para ver por separado las cargas
        virtual void volcadoFicheros_fuente_0();
        virtual void volcadoFicheros_fuente_12();

};

#endif
