////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gestin de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#include "ONU_Point_to_Point.h"
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
/*
 * MODULO ONU_Point_to_Point:
 */
Define_Module(ONU_Point_to_Point);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPUES DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS      //
//						  PARAMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE //
//						  ASIGNAN ESTRUCTURAS DE DATOS DINAMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  //
//						  PARA EL FUNCIONAMIENTO DE ESTE MODULO.			   													//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_Point_to_Point::initialize()
{
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//										  UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O  	//
//										  EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//										  DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL	//
//										  CODIGO IMPLEMENTADO.																	//                                                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_Point_to_Point::handleMessage(cMessage *msg)
{
	// VARIABLES
	int type = msg->getKind(); // VARIABLE TYPE PARA IDENTIFICAR LOS MENSAJES DE LA RED

	// ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA LOS MENSAJES QUE LLEGUEN A ESTE MODULO
	switch(type)
	{
		case 0:
			// LLEGA UN PAQUETE GATE CON IDENTIFICADOR = 0
			if(msg->getKind()==0)
			{
				GATEmsg *gatemsg = check_and_cast<GATEmsg *>(msg); // CHEQUEAMOS EL PAQUETE GATE

				// VISUALIZAMOS ALGUNOS CAMPOS DEL PAQUETE GATE
				//ev<<" Paquete 'Gate' Recibido."<<endl;
				//ev<<" Direccion de destino: "<<gatemsg->getDestAddress()<<endl;
				//ev<<" Mi ID es: "<<getParentModule()->getIndex()<<endl;

				// COMPARAMOS SI EL IDENTIFICADOR DE LA ONU EN LA QUE NOS ENCONTRAMOS ES IGUAL A LA DIRECCION DE DESTINO QUE CONTIENE EL PAQUETE GATE
				if(getParentModule()->getIndex()==gatemsg->getDestAddress())
				{
					//ev<<" El paquete Gate recibido es para esta ONU, pasa a la capa MAC."<<endl;
					send(gatemsg, "onuptpmacOut"); // SI EL PAQUETE ES PARA ESTA ONU, SE ENVIA HACIA LA CAPA MAC DE LA ONU
				}
				else
				{
					//ev<<" Este paquete Gate no es para esta ONU, Eliminando."<<endl;
					delete gatemsg; // EN ESTE CASO, COMO EL PAQUETE GATE NO ES PARA ESTA ONU, ELIMINAMOS EL PAQUETE GATE
				}
			}
			break;

		case 1:
			// LLEGA UN PAQUETE ETHERNET CON IDENTIFICADOR = 1
			if(msg->getKind()==1)
			{
				ETHERNETmsg *ethernetmsg=check_and_cast<ETHERNETmsg*>(msg); // CHEQUEAMOS EL PAQUETE ETHERNET

				// VISUALIZAMOS ALGUNOS CAMPOS DEL PAQUETE ETHERNET
				//ev<<" Paquete Ethernet Recibido."<<endl;
				//ev<<" Direccion de destino: "<<ethernetmsg->getDestAddress()<<endl;
				//ev<<" Mi ID es: "<<getParentModule()->getIndex()<<endl;

				// COMPARAMOS SI EL IDENTIFICADOR DE LA ONU EN LA QUE NOS ENCONTRAMOS ES IGUAL A LA DIRECCION DE DESTINO QUE CONTIENE EL PAQUETE ETHERNET
				if(getParentModule()->getIndex()==ethernetmsg->getDestAddress())
				{
					//ev<<" El paquete Ethernet recibido es para esta ONU, pasa a la capa MAC."<<endl;
					send(ethernetmsg, "onuptpmacOut"); // SI EL PAQUETE ES PARA ESTA ONU, SE ENVIA HACIA LA CAPA MAC DE LA ONU
				}
				else
				{
					//ev<<" Este paquete Ethernet no es para esta ONU, Eliminando."<<endl;
					delete ethernetmsg; // EN ESTE CASO, COMO EL PAQUETE ETHERNET NO ES PARA ESTA ONU, ELIMINAMOS EL PAQUETE ETHERNET
				}
			}
			break;

		default:
			delete msg;
			break;
	}
}

