////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti�n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#include "ONU_Rx_Report.h"
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include <omnetpp.h>
#include <vector>
#include <time.h>
#include "analysis.h"
/*
 * MODULO ONU_Rx_Report:
 */
Define_Module(ONU_Rx_Report);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPUES DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS      //
//						  PARAMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE //
//						  ASIGNAN ESTRUCTURAS DE DATOS DINAMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  //
//						  PARA EL FUNCIONAMIENTO DE ESTE MODULO.			   													//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_Rx_Report::initialize()
{
	// INICIALIZACION AL VALOR 0 DE VARIABLES
	sumpacketextrac = 0; // SUMA DE LOS PAQUETES QUE SE CHEQUEAN EN EL METODO DE EXTRACION ESTRICTA DE PAQUETES
	sumextract = 0; // VARIABLE DE LA SUMA DE LOS PAQUETES QUE SE EXTRAEN EN EL METODO DE EXTRACION ESTRICTA DE PAQUETES
	tamsumqueue = 0; // TAMANYO DE LA SUMA DEL TAMANYO DE LOS PAQUETES QUE LLEGAN A LAS COLAS DE LA ONU
	sumpacket.resize((int)par("numqueue"),0); // RESERVAMOS TAMANYO E INICIALIZAMOS A 0 EL VECTOR DE LA SUMA DE LOS PAQUETES QUE SE CHEQUEAN EN LAS COLAS
	sumqueuepop.resize((int)par("numqueue"),0); // RESERVAMOS TAMANYO E INICIALIZAMOS A 0 EL VECTOR DE LA SUMA TOTAL DE BYTES EXTRAIDOS DE LAS COLAS
	bytes_queue.resize((int)par("numqueue"),0); // VECTOR DE LOS BYTES QUE QUEDAN EN LA COLA DESPUES DE CADA CICLO. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL NUMERO DE COLAS O SERVICIOS DE NUESTRA RED
	media.resize((int)par("numqueue"),0); // VECTOR QUE NOS INDICA LA MEDIA. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL NUMERO DE COLAS O SERVICIOS DE NUESTRA RED
	media_bytes_queue.resize((int)par("numqueue"));
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//										  UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O  	//
//										  EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//										  DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL	//
//										  CODIGO IMPLEMENTADO.																	//                                                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_Rx_Report::handleMessage(cMessage *msg)
{
	// VARIABLES
	int type = msg->getKind(); // VARIABLE TYPE PARA IDENTIFICAR LOS MENSAJES DE LA RED
	int extraction = (int)par("extractionmethod_StrictPQ0_Centralized1"); // PARAMETRO PARA ELEGIR EL METODO DE EXTRACCION DE COLAS ( METODO DE EXTRACCION DE COLAS DE PRIORIDAD EXTRICTA O METODO DE EXTRACCION DE COLAS CENTRALIZADO )

	// ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA LOS MENSAJES QUE LLEGUEN A ESTE MODULO
	switch(type)
	{
		case 2:
			// LLEGA UN PAQUETE REPORT CON IDENTIFICADOR = 2
			if(msg->getKind()==2)
			{
				//ev<<" Recibimos paquete Report y sacamos paquetes de las colas."<<endl;

				// ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA EL METODO DE EXTRACCION DE PAQUETES DE LAS COLAS
				switch(extraction)
					{
						case 0:
							//ev<<" Metodo de Extracción de Colas de Prioridad Estricta."<<endl;
							strictpriorityqueue(msg); // LLAMADA A LA FUNCION DEL METODO DE EXTRACCION DE PAQUETES DE COLAS DE PRIORIDAD ESTRICTA
							break;

						case 1:
							//ev<<" Metodo de Extracción de Colas Centralizado."<<endl;
							centralizedmethod(msg); // LLAMADA A LA FUNCION DEL METODO DE EXTRACCION DE PAQUETES DE COLAS CENTRALIZADO
							break;

						default:
							//ev<<" ERROR AL ELEGIR EL METODO DE EXTRACCION DE PAQUETES DE COLAS, ELEGIR 0 ó 1."<<endl;
							delete msg;
							break;
					}
			}
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION STRICTPRIORITYQUEUE(CMESSAGE *MSG)--> FUNCION QUE NOS INDICA UN METODO PARA LA EXTRACCION DE PAQUETES DE LAS COLAS.	 //
//					ESTE METODO ES DE EXTRACCION DE PAQUETES DE LAS COLAS DE PRIORIDAD ESTRICTA. EL TAMANYO EN BYTES QUE TENEMOS	 //
//					PARA TRANSMITIR PAQUETES DE LAS COLAS SE NOS INDICA PARA TODAS LAS COLA JUNTAS EN GLOBAL. CUANDO LLEGA EL 	 //
//					PAQUETE REPORT AL MODULO SIMPLE ONU_Rx_Report, RECORREMOS LAS COLAS DE MAYOR PRIORIDAD A MENOR PRIORIDAD PARA//
//					OBTENER EL TAMANYO DEL PRIMER PAQUETE QUE ESTA INSERTADO EN LA COLA A EXTRAER, Y DEPENDIENDO DEL TAMANYO TOTAL //
//					EN BYTES DE TODAS LAS COLAS QUE TENEMOS PARA TRANSMITIR, EXTRAEMOS PAQUETES DE LA COLA DE MAYOR PRIORIDAD 	 //
//					HASTA QUE SE QUEDA SIN PAQUETES Y SEGUIMOS HACIA COLAS DE MENOR PRIORIDAD HASTA	QUE COMPLETAMOS EL TAMANYO 	 //
//					TOTAL DE BYTES QUE TIENE LA ONU PARA TRANSMITIR.															 //
//					MEDIANTE ESTE METODO DAMOS PRIORIDAD AL TRAFICO DE MAYOR PRIORIDAD.										 //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_Rx_Report::strictpriorityqueue(cMessage *msg)
{
	// EJECUTAMOS EL METODO DE EXTRACCION DE COLAS DE PRIORIDAD ESTRICTA
	REPORTmsg *reportmsg=check_and_cast<REPORTmsg*>(msg); // CHEQUEAMOS EL PAQUETE REPORT
	// RECORREMOS LAS COLAS PARA VISUALIZAR POR PANTALLA EL TAMANYO DE LAS COLAS
	for(int i=0; i<(int)par("numqueue"); i++)
	{
		// VARIABLES PARA PODER ENTRAR DESTE ESTE MODULO AL MODULO ONU_SISTQUEUE Y PODER OBTENER INFORMACION SOBRE LAS COLAS
		cModule *c_onu_queue;
		c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
		onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);
		tamsumqueue = tamsumqueue + onu_queue->tamqueue[i];
		////ev<<" Tamaño cola " << i << "-> " << onu_queue->tamqueue[i] << "Bytes" << endl;

	}
	// RECORREMOS LAS COLAS PARA COMPROBAR SI TIENEN PAQUETES Y EXTRAER LOS BYTES QUE NOS PROPORCION EL OLT
	for(int i=0; i<(int)par("numqueue"); i++)
	{
		// VARIABLES PARA PODER ENTRAR DESTE ESTE MODULO AL MODULO ONU_SISTQUEUE Y PODER OBTENER INFORMACION SOBRE LAS COLAS
		cModule *c_onu_queue;
		c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
		onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);

		// COMPARAMOS SI LA COLA EN LA QUE NOS ENCONTRAMOS TIENE PAQUETES INSERTADOS EN ELLA,
		// ADEMAS COMPARAMOS SI EL ANCHO DE BANDA ASIGANDO POR EL OLT ES MAYOR O IGUAL A LA SUMA DE PAQUETES QUE EXTRAEMOS MAS EL TAMANYO DEL PAQUETE REPORT QUE SE MANDA EN ESE ANCHO DE BANDA ASIGNADO HACIA LA ONU
		if(onu_queue->queue.getLength()>0 && reportmsg->getBandwitch(0) >= sumpacketextrac + reportmsg->getByteLength())
		{
			// RECORREMOS TODOS LOS PAQUETES DE LA COLA DESDE EL MAS ANTIGUO PARA EXTRAERLOS
			for(int j=0; (j=onu_queue->queue.getLength()); j++)
			{
				// LLAMAMOS A LA FUNCION CHEQUEAR PAQUETE PARA COMPROBAR QUE PODEMOS EXTRAERLO Y LO VISUALIZAMOS POR LA PANTALLA
				onu_queue->checkpacket();
				//ev<<" "<<endl;
				//ev<<" Tamaño paquete chequeado cola "<<i<<"-> "<< onu_queue->tamqueueextract<<"Bytes"<<endl;
				// SUMA DE LOS PAQUETES QUE SE CHEQUEAN Y LO VISUALIZAMOS POR PANTALLA
				sumpacketextrac = sumpacketextrac + onu_queue->tamqueueextract;
				//ev<<" Suma paquetes que se extraen-> "<<sumpacketextrac<<"Bytes"<<endl;

				// COMPROBAMOS SI EL ANCHO DE BANDA ASIGANDO POR EL OLT ES MAYOR O MENOR QUE LA SUMA DE PAQUETES QUE EXTRAEMOS MAS EL TAMANYO DEL PAQUETE REPORT QUE SE MANDA EN ESE ANCHO DE BANDA ASIGNADO HACIA LA ONU
				if(reportmsg->getBandwitch(0) >= sumpacketextrac + reportmsg->getByteLength())
				{
					// SI EL ANCHO DE BANDA ASIGNADO ES MAYOR, SE EXTRAE EL PAQUETE Y SE ENVIA HACIA EL OLT
					//ev<<" Extraemos y enviamos paquete a el OLT."<<endl;
					onu_queue->extractionelement(i); // LLAMAMOS DE FORMA REMOTA A LA FUNCION EXTRAER PAQUETES IMPLEMENTADA EN EL MODULO ONU_SISTQUEUE
					// SUMA DE LOS PAQUETES QUE EXTRAEMOS EN ESTA COLA
					sumextract = sumextract + onu_queue->tamextract;
				}
				else if(reportmsg->getBandwitch(0) < sumpacketextrac + reportmsg->getByteLength())
				{
					// SI EL ANCHO DE BANDA ASIGNADO ES MENOR, NO SE EXTRAEN MAS PAQUETES
					//ev<<" No extraemos más paquetes porque no entra en el Ancho de Banda de Slot."<<endl;
					break; // SALIMOS DEL BUCLE FOR QUE RECORRE TODOS LOS PAQUETES DE LA COLA EN LA QUE NOS ENCONTRAMOS
				}
			}
		}
		else if(reportmsg->getBandwitch(0) < sumpacketextrac + reportmsg->getByteLength())
		{
			tamsumqueue = tamsumqueue - sumextract; // RESTAMOS EL TAMANYO DE LOS PAQUETES QUE HEMOS EXTRAIDO A LA SUMA DEL TAMANYO DE LOS PAQUETES DE LAS COLAS
			break; // SALIMOS DEL BUCLE FOR QUE RECORRE TODAS LAS COLAS
		}
	}

	// COMPROBAMOS SI EL ANCHO DE BANDA ASIGANDO POR EL OLT ES MAYOR QUE LA SUMA DE PAQUETES QUE EXTRAEMOS MAS EL TAMANYO DEL PAQUETE REPORT QUE SE MANDA EN ESE ANCHO DE BANDA ASIGNADO HACIA LA ONU
	if(reportmsg->getBandwitch(0) >= sumpacketextrac + reportmsg->getByteLength())
	{
		tamsumqueue = tamsumqueue - sumextract; // RESTAMOS EL TAMANYO DE LOS PAQUETES QUE HEMOS EXTRAIDO A LA SUMA DEL TAMANYO DE LOS PAQUETES DE LAS COLAS
	}
	/* Hasta aqui es la extraccion de paquetes Ethernet */

	//ev<<endl<<" Actualizamos el tamaño de las colas y lo reescribimos en el Report."<<endl;
	// ACTUALIZAMOS EL VALOR DE LAS COLAS QUE LLEVARA EL REPORT HASTA EL OLT Y LO VISUALIZAMOS POR PANTALLA
	for(int i=0; i<(int)par("numqueue"); i++)
	{
		// VARIABLES PARA PODER ENTRAR DESTE ESTE MODULO AL MODULO ONU_SISTQUEUE Y PODER OBTENER INFORMACION SOBRE LAS COLAS
		cModule *c_onu_queue;
		c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
		onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);

		// VISUALIZAMOS POR PANTALLA EL TAMANYO DE LAS COLAS Y LO INTRODUCIMOS EN EL PAQUETE REPORT PARA MANDARLO HACIA EL OLT
		//ev<<" Tamaño cola "<<i<<"-> "<<onu_queue->tamqueue[i]<<"Bytes"<<endl;
		reportmsg->setQueue_estado(i,onu_queue->tamqueue[i]); // INTRODUCIMOS EL VALOR OBTENIDO ANTERIORMENTE PARA MANDARLO EN EL PAQUETE REPORT
		//reportmsg->setQueue_size(i,(int)onu_queue->queue.getLength()); // INTRODUCIMOS EL VALOR OBTENIDO ANTERIORMENTE PARA MANDARLO EN EL PAQUETE REPORT
		bytes_queue[i] = reportmsg->getQueue_estado(i); // INTRODUCIMOS EN LA VARIABLE bytes_queue[] EL VALOR DEL TAMANYO DE LOS BYTES QUE QUEDAN LA COLA
		//ev<<" Bytes que quedan en la cola"<<i<<": "<<bytes_queue[i]<<endl; // VISUALIZAMOS EL VALOR POR PANTALLA
	}
	// CALCULAMOS LA MEDIA DE LOS BYTES QUE SE QUEDAN EN LA COLA CADA CICLO
	if(simTime()>=1)// && getIndex()==0)
	{
		// BUCLE FOR PARA RECORRER TODAS LAS COLAS QUE TENGAMOS Y GUARDAR EN LA VARIABLE media[] LOS BYTES QUE QUEDAN EN LAS COLAS DESPUES DE CADA CICLO
		for(int i=0; i<(int)par("numqueue"); i++)
		{
			media[i] = bytes_queue[i]; // GUARDAMOS EN LA VARIABLE media[] LOS BYTES QUE QUEDAN EN LAS COLAS DESPUES DE CADA CICLO
			media_bytes_queue[i].analyze(media[i]);
		}
		// SI QUEREMOS QUE LA SIMULACION TERMINE Y LLAME A LA FUNCION FINISH() PARA RECOGER LAS ESTADASTICAS DE LA MEDIA DE LOS
		// BYTES QUE QUEDAN EN LAS COLAS DESPUES DE CADA CICLO.
		// PARA PARAR LA SIMULACION EL VALOR DEL NUMERO DE ITERACIONES DE LA CLASE ANALISIS DEL PARAMETRO QUE CALCULA LA MEDIA
		// DEBE SER IGUAL O MAYOR AL QUE INTRODUZCAMOS MANUALMENTE
		// DEPENDIENDO DEL NUMERO DE COLAS QUE TENGAMOS, DEBEMOS INTRODUCIR LAS VARIABLES CORESPONDIENTES

		//if( media_bytes_queue[0].number_iterations() >= 20)
		//{
		//	endSimulation(); // LLAMAMOS A LA FUNCION TERMINAR SIMULACION
		//	callFinish(); // LLAMAMOS A LA FUNCION FINISH()
		//}
	}
	//ENVIAMOS EL PAQUETE REPORT HACIA LA COLA DE ALMACENAMIENTO DE ESTOS PAQUETES DESPUES DE ACTUALIZAR EL ESTADO DE LAS COLAS
	send(reportmsg, "rxqueuereportOut");//, (int)par("numqueue"));
	sumpacketextrac = 0; // ACTUALIZAMOS EL VALOR DE LA VARIABLE sumpacketextra A UN VALOR DE 0 PARA EL PROXIMO CICLO DE EXTRACCION DE PAQUETES
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION CENTRALIZEDMETHOD(CMESSAGE *MSG)--> FUNCION QUE NOS INDICA UN METODO PARA LA EXTRACCION DE PAQUETES DE LAS COLAS.		//
//					ESTE METODO ES DE EXTRACCION DE PAQUETES DE LAS COLAS CENTRALIZADO. EL TAMANYO EN BYTES QUE TENEMOS PARA 	//
//					TRANSMITIR PAQUETES DE LAS COLAS SE NOS INDICA PARA COLA POR SEPARADO. CUANDO LLEGA EL PAQUETE REPORT AL 	//
//					MODULO SIMPLE ONU_Rx_Report, RECORREMOS LAS COLAS DE MAYOR PRIORIDAD A MENOR PRIORIDAD PARA OBTENER EL 		//
//					TAMANYO DEL PRIMER PAQUETE QUE ESTA INSERTADO EN LA COLA A EXTRAER, Y DEPENDIENDO DEL TAMANYO EN BYTES 		//
//					ASIGNADO A LA COLA EN LA EXTRAEMOS PAQUETES, SACAMOS PAQUETES DE LA COLA DE MAYOR PRIORIDAD A COLAS DE MENOR//
//					PRIORIDAD HASTA	QUE COMPLETAMOS EL TAMANYO TOTAL DE BYTES QUE TIENE ESA ONU PARA TRANSMITIR.					//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_Rx_Report::centralizedmethod(cMessage *msg)
{

	// EJECUTAMOS EL METODO DE EXTRACCION DE COLAS CENTRALIZADO
	REPORTmsg *reportmsg=check_and_cast<REPORTmsg*>(msg); // CHEQUEAMOS EL PAQUETE REPORT

	// RECORREMOS LAS COLAS PARA COMPROBAR SI TIENEN PAQUETES Y EXTRAER LOS BYTES QUE NOS PROPORCION EL OLT
	for(int i=0; i<(int)par("numqueue"); i++)
	{
		// VARIABLES PARA PODER ENTRAR DESTE ESTE MODULO AL MODULO ONU_SISTQUEUE Y PODER OBTENER INFORMACION SOBRE LAS COLAS
		cModule *c_onu_queue;
		c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
		onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);

		// COMPARAMOS SI LA COLA EN LA QUE NOS ENCONTRAMOS TIENE PAQUETES INSERTADOS EN ELLA,
		// ADEMAS COMPARAMOS SI EL ANCHO DE BANDA ASIGANDO POR EL OLT ES MAYOR O IGUAL A LA SUMA DE PAQUETES QUE EXTRAEMOS EN LA COLA EN LA QUE NOS ENCONTRAMOS MAS EL TAMANYO DEL PAQUETE REPORT QUE SE MANDA EN ESE ANCHO DE BANDA ASIGNADO HACIA LA ONU
		if(onu_queue->queue.getLength()>0 && reportmsg->getBandwitch(i) >= sumpacket[i] + reportmsg->getByteLength())
		{
			// RECORREMOS TODOS LOS PAQUETES DE LA COLA DESDE EL MAS ANTIGUO PARA EXTRAERLOS
			for(int j=0; (j=onu_queue->queue.getLength()); j++)
			{
				// LLAMAMOS A LA FUNCION CHEQUEAR PAQUETE PARA COMPROBAR QUE PODEMOS EXTRAERLO Y LO VISUALIZAMOS POR LA PANTALLA
				onu_queue->checkpacket();
				//ev<<" "<<endl;
				//ev<<" Tamaño paquete chequeado cola "<<i<<"-> "<< onu_queue->tamqueueextract<<"Bytes"<<endl;
				// SUMA DE LOS PAQUETES QUE SE CHEQUEAN EN LA COLA QUE NOS ENCONTRAMOS
				sumpacket[i] = sumpacket[i] + onu_queue->tamqueueextract;
				//ev<<" Suma paquetes que se extraen en la cola "<<i<<"-> "<<sumpacket[i]<<"Bytes"<<endl;

				// COMPROBAMOS SI EL ANCHO DE BANDA ASIGANDO POR EL OLT ES MAYOR O MENOR QUE LA SUMA DE PAQUETES QUE EXTRAEMOS EN LA COLA EN LA QUE NOS ENCONTRAMOS MAS EL TAMANYO DEL PAQUETE REPORT QUE SE MANDA EN ESE ANCHO DE BANDA ASIGNADO HACIA LA ONU
				if(reportmsg->getBandwitch(i) >= sumpacket[i] + reportmsg->getByteLength())
				{
					// SI EL ANCHO DE BANDA ASIGNADO ES MAYOR, SE EXTRAE EL PAQUETE Y SE ENVIA HACIA EL OLT
					//ev<<" Extraemos y enviamos paquete a la Onu."<<endl;
					onu_queue->extractionelement(i); // LLAMAMOS DE FORMA REMOTA A LA FUNCION EXTRAER PAQUETES IMPLEMENTADA EN EL MODULO ONU_SISTQUEUE
					// SUMA DE LOS PAQUETES QUE EXTRAEMOS EN TODAS LAS COLAS Y LO VISUALIZAMOS POR PANTALLA
					sumextract = sumextract + onu_queue->tamextract;
					//ev<<" Suma total de Bytes Extraidos-> "<<sumextract<<"Bytes"<<endl;
					// SUMA TOTAL DEL TAMANYO DE LOS PAQUETES EXTRAIDOS EN LA COLA EN LA QUE NOS ENCONTRAMOS Y LO VISUALIZAMOS POR PANTALLA
					sumqueuepop[i] = sumqueuepop[i] + onu_queue->tamextract;
					//ev<<" Suma total de Bytes Extraidos de la cola "<<i<<"-> "<<sumqueuepop[i]<<"Bytes"<<endl;
				}
				else if(reportmsg->getBandwitch(i) < sumpacket[i] + reportmsg->getByteLength())
				{
					// SI EL ANCHO DE BANDA ASIGNADO ES MENOR, NO SE EXTRAEN MAS PAQUETES
					//ev<<" No extraemos más paquetes porque no entra en el Ancho de Banda de Slot."<<endl;
					break; // SALIMOS DEL BUCLE FOR QUE RECORRE TODOS LOS PAQUETES DE LA COLA EN LA QUE NOS ENCONTRAMOS
				}
			}
		}
	}


	// RESTAMOS EL TAMANYO DE LOS PAQUETES QUE HEMOS EXTRAIDO A LA SUMA DEL TAMANYO DE LOS PAQUETES DE LAS COLAS
	tamsumqueue = tamsumqueue - sumextract;

	//ev<<"             "<<endl;
	//ev<<" Actualizamos el tamaño de las colas y lo reescribimos en el Report."<<endl;

	// ACTUALIZAMOS EL VALOR DE LAS COLAS QUE LLEVARA EL REPORT HASTA EL OLT Y LO VISUALIZAMOS POR PANTALLA
	for(int i=0; i<(int)par("numqueue"); i++)
	{
		// VARIABLES PARA PODER ENTRAR DESTE ESTE MODULO AL MODULO ONU_SISTQUEUE Y PODER OBTENER INFORMACION SOBRE LAS COLAS
		cModule *c_onu_queue;
		c_onu_queue = getParentModule()->getParentModule()->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",i);
		onu_queue = check_and_cast<ONU_SISTqueue *>(c_onu_queue);

		// VISUALIZAMOS POR PANTALLA EL TAMANYO DE LAS COLAS Y LO INTRODUCIMOS EN EL PAQUETE REPORT PARA MANDARLO HACIA EL OLT
		//ev<<" Tamaño cola "<<i<<"-> "<<onu_queue->tamqueue[i]<<"Bytes"<<endl;
		reportmsg->setQueue_estado(i,onu_queue->tamqueue[i]);
		//reportmsg->setQueue_size(i,(int)onu_queue->queue.getLength()); // INTRODUCIMOS EL VALOR OBTENIDO ANTERIORMENTE PARA MANDARLO EN EL PAQUETE REPORT
		bytes_queue[i] = reportmsg->getQueue_estado(i); // INTRODUCIMOS EN LA VARIABLE bytes_queue[] EL VALOR DEL TAMANYO DE LOS BYTES QUE QUEDAN LA COLA
		//ev<<" Bytes que quedan en la cola"<<i<<": "<<bytes_queue[i]<<endl; // VISUALIZAMOS EL VALOR POR PANTALLA
	}

	// CALCULAMOS LA MEDIA DE LOS BYTES QUE SE QUEDAN EN LA COLA CADA CICLO
	if(simTime()>=1)
	{
		// BUCLE FOR PARA RECORRER TODAS LAS COLAS QUE TENGAMOS Y GUARDAR EN LA VARIABLE media[] LOS BYTES QUE QUEDAN EN LAS COLAS DESPUES DE CADA CICLO
		// BUCLE FOR PARA RECORRER TODAS LAS COLAS QUE TENGAMOS Y GUARDAR EN LA VARIABLE media[] LOS BYTES QUE QUEDAN EN LAS COLAS DESPUES DE CADA CICLO
		for(int i=0; i<(int)par("numqueue"); i++)
		{
			media[i] = bytes_queue[i]; // GUARDAMOS EN LA VARIABLE media[] LOS BYTES QUE QUEDAN EN LAS COLAS DESPUES DE CADA CICLO
			media_bytes_queue[i].analyze(media[i]);
		}

		// SI QUEREMOS QUE LA SIMULACION TERMINE Y LLAME A LA FUNCION FINISH() PARA RECOGER LAS ESTADASTICAS DE LA MEDIA DE LOS
		// BYTES QUE QUEDAN EN LAS COLAS DESPUES DE CADA CICLO.
		// PARA PARAR LA SIMULACION EL VALOR DEL NUMERO DE ITERACIONES DE LA CLASE ANALISIS DEL PARAMETRO QUE CALCULA LA MEDIA
		// DEBE SER IGUAL O MAYOR AL QUE INTRODUZCAMOS MANUALMENTE
		// DEPENDIENDO DEL NUMERO DE COLAS QUE TENGAMOS, DEBEMOS INTRODUCIR LAS VARIABLES CORESPONDIENTES

		//if( media_bytes_queue[0].number_iterations() >= 30)
		//{
		//	endSimulation(); // LLAMAMOS A LA FUNCION TERMINAR SIMULACION
		//	callFinish(); // LLAMAMOS A LA FUNCION FINISH()
		//}
	}

	//ENVIAMOS EL PAQUETE REPORTR HACIA LA COLA DE ALMACENAMIENTO DE ESTOS PAQUETES DESPUES DE ACTUALIZAR EL ESTADO DE LAS COLAS
	send(reportmsg, "rxqueuereportOut");//, (int)par("numqueue"));

}

void ONU_Rx_Report::finish()
{

	// RECOGIDA DE ESTADISTICAS DE LAS MEDIAS DE LOS BYTES QUE QUEDAN EN LAS COLAS DESPUES DE CADA CICLO CON LA CLASE ANALISIS Y LO GUARDAMOS LOS DATOS EN UN ARCHIVO
	// SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
	media_queue_onu=fopen("results/media_queue_onu.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
	if(this->getParentModule()->getParentModule()->getIndex()==0)
	{
		fprintf(media_queue_onu,"Cantidad promedio de Bytes que quedan en las colas tras cada ciclo: \n");
		for(int i=0; i<(int)par("numqueue"); i++)
		{
			fprintf(media_queue_onu,"P%i \t\t\t",i);
		}
		fprintf(media_queue_onu,"\n");
	}
	for(int i=0; i<(int)par("numqueue"); i++)
	{
		fprintf(media_queue_onu,"%g\t", (double)media_bytes_queue[i].average()); // MEDIA DE LOS BYTES QUE QUEDAN EN LAS COLAS DESPUES DE CADA CICLO
	}

	fprintf(media_queue_onu,"\n");

	fclose(media_queue_onu); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS
}


