////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti�n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_RX_REPORT_H_
#define __RED_WIRELESS_RX_REPORT_H_

#include <omnetpp.h>
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include <vector>
#include <time.h>
#include "ONU_SISTqueue.h"
#include "analysis.h"
/*
 * MODULO ONU_Rx_Report:
 */
//DEFINIMOS LOS TIPOS DE std DE LOS VECTORES Y MATRICES:
typedef std::vector<int> int_vector_t; // VECTOR DE TIPO ENTERO
typedef std::vector<double> double_vector_t; // VECTOR DE TIPO DOUBLE

class ONU_Rx_Report : public cSimpleModule
{
	public:
		ONU_SISTqueue *onu_queue; // DEFINIMOS VARIABLE PARA PODER ENTRAR EN EL MODULO OLT_TABLE
		long sumpacketextrac; // VARIABLE DE LA SUMA DE LOS PAQUETES QUE SE CHEQUEAN EN EL METODO DE EXTRACION ESTRICTA DE PAQUETES
		long sumextract; // VARIABLE DE LA SUMA DE LOS PAQUETES QUE SE EXTRAEN EN EL METODO DE EXTRACION ESTRICTA DE PAQUETES
		long tamsumqueue; // TAMANYO DE LA SUMA DEL TAMANYO DE LOS PAQUETES QUE LLEGAN A LAS COLAS DE LA ONU
		int_vector_t sumpacket; // VECTOR DE LA SUMA DE LOS PAQUETES QUE SE CHEQUEAN EN LAS COLAS
		int_vector_t sumqueuepop; // VECTOR DE LA SUMA TOTAL DE BYTES EXTRAIDOS DE LAS COLAS
		int_vector_t bytes_queue; // VECTOR DE LOS BYTES QUE QUEDAN EN LA COLA DESPUES DE CADA CICLO
		double_vector_t media; // VECTOR PARA INDICAR LA MEDIA


	// DEFINIMOS LOS PARAMETROS PARA LA CLASE ANALISIS
		// PARAMETRO PARA OBTENER LA MEDIA DE LOS BYTES QUE SE QUEDAN EN LA COLAS DESPUES DE CADA CICLO CON LA CLASE ANALISIS
		std::vector<Analysis> media_bytes_queue; // VECTOR DE CLASE ANALISIS PARA CREAR LOS BYTES QUE SE QUEDAN EN LA COLAS DESPUES DE CADA CICLO
		FILE * media_queue_onu; // ARCHIVO DONDE GUARDAMOS LA MEDIA DE LAS COLAS


	protected:
		virtual void initialize();
		virtual void handleMessage(cMessage *msg);

		virtual void strictpriorityqueue(cMessage *msg); // FUNCION DEL METODO DE EXTRACCION DE PAQUETES DE COLAS DE PRIORIDAD ESTRICTA
        virtual void centralizedmethod(cMessage *msg); // FUNCION DEL METODO DE EXTRACCION DE PAQUETES DE COLAS CENTRALIZADO

        virtual void finish(); // DEFINICION DE LA FUNCION FINALIZAR
};

#endif
