////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gestin de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#include "ONU_Rxuser.h"
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
/*
 * MODULO ONU_Rxuser:
 */
Define_Module(ONU_Rxuser);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPUÉS DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS      //
//						  PARAMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE //
//						  ASIGNAN ESTRUCTURAS DE DATOS DINAMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  //
//						  PARA EL FUNCIONAMIENTO DE ESTE MODULO.			   													//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_Rxuser::initialize()
{
	nombreonu = getParentModule()->getIndex(); // IDENTIFICADOR DE LA ONU
	numReceived = 0; // INICIALIZAMOS EL NÚMERO DE PAQUETES ETHERNET RECIBIDOS A 0
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//										  UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O  	//
//										  EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//										  DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL	//
//										  CODIGO IMPLEMENTADO.																	//                                                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_Rxuser::handleMessage(cMessage *msg)
{
	// VARIABLES
	simtime_t eed;

	// RECOGIDA DE ESTADISTICAS MANUALMENTE
	eed = simTime() - msg->getCreationTime(); // PARAMETRO PARA CALCULAR EL RETARDO EXTREMO A EXTREMOS MANUALMENTE
	eedStats.collect(eed); // RECOGEMOS EL RESULTADO

	ETHERNETmsg *ethernetmsg=check_and_cast<ETHERNETmsg*>(msg); // CHEQUEAMOS EL PAQUETE ETHERNET

	// VISUALIZAMOS POR PANTALLA CUANDO RECIBIMOS EL PAQUETE ETHERNET
	//ev <<" Paquete Ethernet recibido y borrado."<<endl;

	numReceived++; // INCREMENTAMOS EN UNO EL CONTADOR DE NÚMERO DE PAQUETES ETHERNET RECIBIDOS

	delete ethernetmsg; // BORRAMOS EL MENSAJE ETHERNET
}

void ONU_Rxuser::finish()
{
	// VISUALIZAMOS POR PANTALLA LA RECOGIDA DE ESTADISTICAS DE ESTE MODULO DE CUANDO LLAMAMOS A LA FUNCION FINISH()
	//ev<<" ONU " << nombreonu << endl;
	//ev<<" Estadísticas en el ONU_Rxuser para paquetes Ethernet"<<endl;
	////ev<<" Retardo medio: " << eedStats.getMean() << endl;
	////ev<<" Paquetes Ethernet Totales Recibidos: " << numReceived << endl;

}
