////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti�n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#include "ONU_SISTqueue.h"
#include "MAC_OLT.h"
#include "MAC_ONU.h"
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include "DATA_m.h"
#include "analysis.h"
#include <string.h>
#include <stdio.h>
#include <vector>
#include <math.h>


/*
 * MODULO ONU_SISTqueue:
 */
Define_Module(ONU_SISTqueue);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPUES DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS	//
//						  PARAMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE 			//
//						  ASIGNAN ESTRUCTURAS DE DATOS DINAMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  			//
//						  PARA EL FUNCIONAMIENTO DE ESTE MODULO.																					   													//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_SISTqueue::initialize()
{
	//max_control_admision.resize((int)this->getParentModule()->getParentModule()->getParentModule()->par("numSLA"));
	/*max_control_admision.resize(3); // UNO POR SLA
	max_control_admision[0] = 0.015;
	max_control_admision[1] = 0.06;
	max_control_admision[2] = 0.18;*/
	volcado = 0;
	contador = 0;
	paquetes_recibidos = 0;
	bytes_recibidos = 0;
	isGateway = 0;
	num_colas = (int) par("numqueue");
	carga_cola = 0.0;
	queue.setName("queue"); // DEFINIMOS EL NOMBRE DE LA COLA
	// INICIALIZAMOS LAS VARIABLES AL VALOR 0
	tamqueuepop = 0; // VARIABLE DEL TAMANYO DE LOS PAQUETES QUE BORRAMOS DE LAS COLAS
	tamqueueextract = 0; // VARIABLE DEL TAMANYO DE LOS PAQUETES QUE CHEQUEAMOS ANTES DE SACARLOS DE LAS COLAS

	// RESERVAMOS TAMANYO PARA LA VARIABLE tamqueue Y LA INICIALIZAMOS AL VALOR 0
	tamqueue.resize(num_colas,0); // VARIABLE DEL TAMANYO DE LOS PAQUETES QUE EXTRAEMOS DE LAS COLAS
	total_bytes = 0;
	if(this->getParentModule()->getParentModule()->gate("gatewirelessInOut$o",0)->isConnected())
	{
		isGateway = 1;
	}
	int aux_cont = 0;
	for(int i=0; i<(int)this->getParentModule()->getParentModule()->par("numOnu"); i++)
	{
		if(check_and_cast<ONU_SISTqueue *>(this->getParentModule()->getParentModule()->getParentModule()->getSubmodule("onu",i)->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",0))->isGateway == 1)
		{
			aux_cont++;
		}
	}
	indices_gw_onu.resize(aux_cont);
	int aux=0;
	for(int j=0; j<(int)this->getParentModule()->getParentModule()->par("numOnu"); j++)
	{
		if(check_and_cast<ONU_SISTqueue *>(this->getParentModule()->getParentModule()->getParentModule()->getSubmodule("onu",j)->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",0))->isGateway == 1)
		{
			indices_gw_onu[aux] = j;
			aux++;
		}
	}
	//ev <<" Indices de las ONUs pasarela: 	";
	for(int a=0; a<(int)indices_gw_onu.size(); a++)
	{
		//ev <<indices_gw_onu[a] << "  ";
	}
	//ev <<endl;
	aux_counter = 0;
	full_onus_gw = 0;
	//double buffer = (double) this->getParentModule()->getParentModule()->par("tambuffer");
	////ev <<" Capacidad de la cola P" << getIndex() << ": " << buffer << " bytes" << endl;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//										  UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O  	//
//										  EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//										  DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL	//
//										  CODIGO IMPLEMENTADO.																	//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_SISTqueue::handleMessage(cMessage *msg)
{
		// VARIABLES
		int type = msg->getKind(); // VARIABLE TYPE PARA IDENTIFICAR LOS MENSAJES DE LA RED
		int admision = 0; // Variable para el control de admision en el caso de DaSPID
		//double tx_rate, bit_rate, time_creation, hops, meters;
		double bit_rate, time_creation, hops, meters;
		long int tx_rate;
		// ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA LOS MENSAJES QUE LLEGUEN A ESTE MODULO
		switch(type)
		{
		case 1:
			// LLEGA UN PAQUETE ETHERNET CON IDENTIFICADOR = 1
			if(type==1)
			{
				ETHERNETmsg *ethernetmsg = check_and_cast<ETHERNETmsg*>(msg); // CHEQUEAMOS EL PAQUETE ETHERNET
				int olt_method = (int) this->getParentModule()->getParentModule()->getParentModule()->par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3_DaSPID4");
				/////// CONTROL DE ADMISION DE PAQUETES EN FUNCION DEL RETARDO ESTIMADO PARA LA CLASE DE SERVICIO P1 ///////
				if(olt_method == 4 && ethernetmsg->getPriority() == 1)
				{
					// Acceso remoto a la cola P0 de esta misma ONU para obtener el numero de Bytes que almacena:
					ONU_SISTqueue *cola_onu;
					cola_onu = check_and_cast<ONU_SISTqueue *>(this->getParentModule()->getSubmodule("onu_sistqueue",0));
					// Suma de los bits presentes en las colas P0 y P1 de esta ONU para saber cuantos bits tiene por delante
					// el paquete recibido y estimar lo que le va a tocar esperar hasta ser transmitido:
					double bits_antes = (double) 8*cola_onu->tamqueue[0] + (double) 8*tamqueue[1];
					//ev <<" Bits previstos para enviar antes que este nuevo paquete: " << bits_antes << endl;
					// Acceso remoto a la capa MAC de esta ONU para obtener el B_alloc que le fue asignado en el ultimo ciclo y
					// el intervalo de tiempo entre las dos ultimas transmisiones de esta ONU:
					MAC_ONU *onu_mac;
					onu_mac = check_and_cast<MAC_ONU *>(this->getParentModule()->getParentModule()->getSubmodule("onu_mac"));
					double B_alloc_ultimo = (double) onu_mac->B_alloc_prev;
					//ev <<" BW asignado en el ultimo ciclo a esta ONU: " << B_alloc_ultimo << endl;
					double T_ciclo_ultimo = (double) onu_mac->T_cycle_prev;
					//ev <<" Duracion del ultimo ciclo de transmision de esta ONU: " << T_ciclo_ultimo << endl;
					double delay_estimado = (double) T_ciclo_ultimo*(bits_antes/B_alloc_ultimo);
					//ev <<" Retardo estimado para este paquete de clase P1: " << delay_estimado << endl;
					MAC_OLT *olt_mac;
					olt_mac = check_and_cast<MAC_OLT *>(this->getParentModule()->getParentModule()->getParentModule()->getSubmodule("olt")->getSubmodule("olt_mac"));
					olt_mac->paquetes_recibidos_P1[onu_mac->numsla_onu[this->getParentModule()->getParentModule()->getIndex()]]++;

					//ev<< "Los paquetes recibidos para SLA0 son"<<olt_mac->paquetes_recibidos_P1[0]<<endl;
					//ev<< "Los paquetes recibidos para SLA1 son"<<olt_mac->paquetes_recibidos_P1[1]<<endl;
					//ev<< "Los paquetes recibidos para SLA2 son"<<olt_mac->paquetes_recibidos_P1[2]<<endl;

					//ev << " ONU[" << this->getParentModule()->getParentModule()->getIndex() << "] --> SLA" << onu_mac->numsla_onu[this->getParentModule()->getParentModule()->getIndex()] << endl;


					if(delay_estimado < onu_mac->max_control_admision[onu_mac->numsla_onu[this->getParentModule()->getParentModule()->getIndex()]])
					{
						//ev<<"aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"<<endl;
						admision = 0; // Bloqueo += 0.0;
					}
					else
					{		//ev<<"bbbbbbbbbbbbbbbbbbbbbbbbbbb"<<endl;
							admision = 1; // Bloqueo += 1.0;
							olt_mac->paquetes_borrados_P1[onu_mac->numsla_onu[this->getParentModule()->getParentModule()->getIndex()]]++;
					}
					//ev <<" ONU[" << this->getParentModule()->getParentModule()->getIndex() << "] asociada al SLA"<< onu_mac->numsla_onu[this->getParentModule()->getParentModule()->getIndex()] << ", cuyo limite de retardo es " << max_control_admision[onu_mac->numsla_onu[this->getParentModule()->getParentModule()->getIndex()]] << endl;
					if(admision == 0)
					{
					    //ev<< "PAQUETE NOOO_BORRADO en el tiempo "<<(double)SIMTIME_DBL(simTime())<<"con DELAY ESTIMADO "<<delay_estimado<<" max_cad de la ONU "<<onu_mac->numsla_onu[this->getParentModule()->getParentModule()->getIndex()]<< " ES "<<onu_mac->max_control_admision[onu_mac->numsla_onu[this->getParentModule()->getParentModule()->getIndex()]]<<endl;
						//ev<<" Envio del paquete 'Ethernet' a la cola P1. "<< endl;
						paquetes_recibidos++;
						bytes_recibidos = bytes_recibidos + (double) ethernetmsg->getByteLength();
						//tx_rate = (double) this->par("txrate");
                        tx_rate = (long int) this->par("txrate");

						bit_rate = tx_rate/10;
						time_creation = (double) SIMTIME_DBL(simTime());
						carga_cola = (double) (bytes_recibidos * 8 / (time_creation * bit_rate));
						carga.analyze(carga_cola);
						// SUMAMOS EL TAMANYO DE LOS PAQUETES QUE INSERTAMOS EN LAS COLAS
						tamqueue[ethernetmsg->getPriority()] = tamqueue[ethernetmsg->getPriority()] + ethernetmsg->getByteLength();
						// VEMOS EL TIEMPO EN EL QUE EL PAQUETE ETHERNET SE INSERTA EN LA COLA PARA DESPU�S CALCULAR EL RETARDO
						// INTRODUCIMOS EN EL PAQUETE ETHERNET EL TIEMPO EN EL QUE EL PAQUETE SE INSERTA EN LA COLA
						ethernetmsg->setTime_enter_queue(simTime());
						//ev<<" Tiempo de insercion del paquete Ethernet en cola: "<<ethernetmsg->getTime_enter_queue()<<endl;
						queue.insert(ethernetmsg); // INSERTAMOS EL PAQUETE EN LA COLA QUE NOS INDIQUE LA PRIORIDAD DEL PAQUETE ETHERNET
					}
					else if(admision == 1)
					{
						//ev<< "PAQUETE BORRADO en el tiempo"<<simTime<<"con DELAY ESTIMADO"<<delay_estimado<<"max_cad"<<onu_mac->max_control_admision[onu_mac->numsla_onu[this->getParentModule()->getParentModule()->getIndex()]]<<endl;
						delete ethernetmsg;
						//ev <<" Borrado del paquete 'Ethernet' de clase P1 por superar las expectativas de retardo maximo." << endl;
					}
				}
				else
				{
					////ev<<" Envio del paquete 'Ethernet'"<< endl;
					paquetes_recibidos++;
					bytes_recibidos = bytes_recibidos + (double) ethernetmsg->getByteLength();
					tx_rate = (long int) this->par("txrate");
					bit_rate = tx_rate/10;
					time_creation = (double) SIMTIME_DBL(simTime());

				    //ev << "tx_rate ONU_SIS: " << tx_rate << endl;


					carga_cola = (double) (bytes_recibidos * 8 / (time_creation * bit_rate));
					carga.analyze(carga_cola);
					// SUMAMOS EL TAMANYO DE LOS PAQUETES QUE INSERTAMOS EN LAS COLAS
					tamqueue[ethernetmsg->getPriority()] = tamqueue[ethernetmsg->getPriority()] + ethernetmsg->getByteLength();
					// VEMOS EL TIEMPO EN EL QUE EL PAQUETE ETHERNET SE INSERTA EN LA COLA PARA DESPU�S CALCULAR EL RETARDO
					// INTRODUCIMOS EN EL PAQUETE ETHERNET EL TIEMPO EN EL QUE EL PAQUETE SE INSERTA EN LA COLA
					ethernetmsg->setTime_enter_queue(simTime());
					//ev<<" Tiempo de insercion del paquete Ethernet en cola: "<<ethernetmsg->getTime_enter_queue()<<endl;
					queue.insert(ethernetmsg); // INSERTAMOS EL PAQUETE EN LA COLA QUE NOS INDIQUE LA PRIORIDAD DEL PAQUETE ETHERNET
				}
			}
			break;

			case 2:
				// LLEGA UN PAQUETE REPORT CON IDENTIFICADOR = 2
				if(type==2)
				{
					REPORTmsg *reportmsg=check_and_cast<REPORTmsg*>(msg); // CHEQUEAMOS EL PAQUETE REPORT
					// ENVIAMOS EL PAQUETE REPORT HACIA EL MODULO ONU_WDMSPLITTER Y VISUALIZAMOS POR PANTALLA CUANDO LO MANDAMOS
						//send(reportmsg, "onuqueuewdmOut", reportmsg->getPriority());
					send(reportmsg, "onuqueuewdmOut");
					////ev <<" Envio del paquete 'Report' " << endl;
				}
				break;

			case 12:
				if(type==12)
				{
					// Conversion del mensaje de tipo inalambrico a optico:
					ETHERNETmsg *msgethernet = check_and_cast<ETHERNETmsg*>(WirelessToOptical(msg));
					paquetes_recibidos++;
					// Variable con el total de paquetes llegados a todas las ONUs pasarela:
					check_and_cast<ONU_SISTqueue *>(this->getParentModule()->getParentModule()->getParentModule()->getSubmodule("onu",15)->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",0))->paquetes_recibidos++;
					//long total_paquetes = (long)check_and_cast<ONU_SISTqueue *>(this->getParentModule()->getParentModule()->getParentModule()->getSubmodule("onu",15)->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",0))->paquetes_recibidos;
					bytes_recibidos = bytes_recibidos + (double) msgethernet->getByteLength();
					delay_packets = simTime() - msgethernet->getTimestamp();
					//ev <<" Retardo paquete wireless: " << delay_packets << endl;
					retardo.analyze(SIMTIME_DBL(delay_packets));
					check_and_cast<ONU_SISTqueue *>(this->getParentModule()->getParentModule()->getParentModule()->getSubmodule("onu",15)->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",0))->retardo.analyze(SIMTIME_DBL(delay_packets));
					/*
					tx_rate = (double) this->par("txrate");
					//tx_rate = (double) this->par("tasabinaria");
					bit_rate = tx_rate/10;
					time_creation = (double) SIMTIME_DBL(msgethernet->getTimestamp());
					carga_cola = (double) (bytes_recibidos * 8 / (time_creation * bit_rate));
					carga.analyze(carga_cola);
					*/
					hops = (double) msgethernet->getRelleno();
					//ev <<" Nodos intermedios (BSs) por los que ha pasado el paquete: " << hops << endl;
					meters = (double) msgethernet->getLength();
					//ev <<" Distancia (metros) recorrida por el paquete: " << meters << endl;
					saltos.analyze(hops);
					longitud.analyze(meters);
					insertPacket(msgethernet);
					//delete msgethernet;
					//ev <<" 	******* " << endl;
					//ev <<" Total paquetes recibidos: " << paquetes_recibidos << endl;
					/*
					// PARA PARAR LA SIMULACION CUANDO LLEGAN 100000 PAQUETES EN TOTAL A LAS ONUs PASARELA:
					if(total_paquetes >= 100000) // Si han llegado 100000 paquetes en total a todas las ONUs pasarela...
					{
						endSimulation(); // LLAMAMOS A LA FUNCION TERMINAR SIMULACION
						callFinish(); // LLAMAMOS A LA FUNCION FINALIZAR
					}
					*/
					/*
					// PARA PARAR LA SIMULACION CUANDO LLEGAN 100000 PAQUETES A CADA ONU PASARELA DE LA RED:
					if(paquetes_recibidos>=100000 && aux_counter==0)
					{
						aux_counter = 1;
						check_and_cast<ONU_SISTqueue *>(this->getParentModule()->getParentModule()->getParentModule()->getSubmodule("onu",15)->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",0))->full_onus_gw++;
					}
					if(check_and_cast<ONU_SISTqueue *>(this->getParentModule()->getParentModule()->getParentModule()->getSubmodule("onu",15)->getSubmodule("onu_squeue")->getSubmodule("onu_sistqueue",0))->full_onus_gw == (int)indices_gw_onu.size()) // Si han llegado 100000 paquetes en total a todas las ONUs pasarela...
					{
						endSimulation(); // LLAMAMOS A LA FUNCION TERMINAR SIMULACION
						callFinish(); // LLAMAMOS A LA FUNCION FINALIZAR
					}
					*/
					/*
					if (simTime()>=10*contador && volcado == 0)
					{
						contador++;
						//volcadoFicheros();
						// SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
						carga_colas = fopen("results/carga_colas.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
						if(getIndex() == 0) // En la primera cola de cada ONU, se imprime esta cabecera:
						{
							if(isGateway == 1)
							{
								fprintf(carga_colas,"ONU [%i] (pasarela)\n", this->getParentModule()->getParentModule()->getIndex());
							}
							else if(isGateway == 0)
							{
								fprintf(carga_colas,"ONU [%i] (NO pasarela)\n", this->getParentModule()->getParentModule()->getIndex());
							}
						}
						if(getIndex() != num_colas) // La ultima cola es para los REPORT, no cuenta
						{
							fprintf(carga_colas,"Carga total de la cola P%i: %g \n", getIndex(), (double)carga.average());
						}
						fclose(carga_colas); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS
					}
					*/
				}
				break;

			default:
				delete msg;
				//ev <<" MENSAJE BORRADO" << endl;
				break;
		}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION DELETEELEMENT(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO 			//
//					ONU_GENTraffic GENERA UN PAQUETE ETHERNET Y TIENE QUE INSERTARLO EN LA COLA Y NO HAY TANYANO SUFICIENTE PARA //
//					HACERLO Y TENEMOS QUE ELIMINAR MENSAJES ANTIGUOS PARA INSERTAR EL NUEVO PAQUETE CREADO.                     //
//					ESTA FUNCION EXTRAE UN PAQUETE QUE SE ENCONTRABA YA EN LA COLA Y LO ELIMINA, PERO ANTES OBTENEMOS EL 		//
//					TAMANYO DEL PAQUETE ETHERNET ELIMINADO PARA RESTARLO DEL TAMANYO TOTAL DE BYTES QUE TIENE ALMACENADO LA COLA	//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_SISTqueue::deleteelement(cMessage *msg)
{
	// FUNCION PARA ELIMINAR LOS PAQUETES DEL PRINCIPIO DE LAS COLAS

	ETHERNETmsg *ethernetmsg=check_and_cast<ETHERNETmsg*>(msg); // CHEQUEAMOS EL PAQUETE ETHERNET

	ethernetmsg = (ETHERNETmsg *)queue.pop(); // EXTRAEMOS EL PAQUETE ETHERNET
	tamqueuepop = ethernetmsg->getByteLength(); // TAMANYO DEL PAQUETE ETHERNET EXTRAIDO DE LA COLA

	// RESTAMOS AL TAMANYO DE LA COLAS EL TAMANYO DEL PAQUETE QUE SE BORRA PARA PODER INSERTAR UN PAQUETE MAS ACTUAL
	tamqueue[ethernetmsg->getPriority()] = tamqueue[ethernetmsg->getPriority()] - tamqueuepop;
	delete ethernetmsg; // BORRAMOS EL PAQUETE ETHERNET
	////ev <<" MENSAJE BORRADO DE LA COLA" << endl;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION CHECKPACKET()--> ESTA FUNCION SE INVOCA CADA VEZ QUE EL MODULO ONU_Rx_Report RECIBE UN PAQUETE REPORT. DE ESTA MANERA //
//					PODEMOS AVERIGUAR EL TAMANYO DEL PRIMER PAQUETE DE LA COLA SIN NECESIDAD DE EXTRAER EL PAQUETE ENCOLADO.		//
//					PARA OBTENER ESTA INFROMACION, ENTRAMOS EN LA COLA Y MEDIANTE LA FUNCION front() OBTENEMOS EL TAMANYO DEL 	//
//					PAQUETE QUE SE ENCUENTRA AL PRINCIPIO DE LA COLA Y LO INTRODUCIMOS EN UNA VARIABLE.							//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_SISTqueue::checkpacket()
{
	// FUNCION PARA CHUEQUEAR LOS PAQUETES DEL PRINCIPIO DE LA COLA PARA SABER SU TAMANYO EN BYTES

	ETHERNETmsg *ethernetmsg; // DEFINIMOS LA VARIABLE PARA EL PAQUETE ETHERNET
	ethernetmsg = (ETHERNETmsg *)queue.front(); // OBTENEMOS INFORMACION DEL PRIMER PAQUETE ETHERNET DE LA COLA SIN EXTRAERLO
	tamqueueextract = ethernetmsg->getByteLength(); // TAMANYO DEL PRIMER PAQUETE ETHERNET DE LA COLA SIN EXTRAERLO
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION EXTRACTIONELEMENT(int priority)--> ESTA FUNCION SE INVOCA CON LA PRIORIDAD DEL PAQUETE COMO PARAMETRO	CADA VEZ QUE EL	//
//					MODULO ONU_Rx_Report RECIBE UN PAQUETE REPORT. DE ESTA MANERA PODEMOS EXTRAER EL PRIMER PAQUETE DE LA COLA Y//
//					ENVIARLE HACIA EL OLT.																						//
//					PRIMERAMENTE EXTRAEMOS EL PRIMER PAQUETE DE LA COLA CON LA FUNCION pop() Y METEMOS SU TAMANYO EN UNA VARIABLE//
//					PARA POSTERIORMENTE ACTUALIZAR EL TAMANYO DE LA COLA UNA VEZ SACADOS LOS PAQUETES PERTINENTES. DESPU�S LOS 	//
//					ENVIAMOS HACIA EL OLT POR LA SALIDA DEL MODULO ONU_Rx_Report CORRESPONDIENTE.								//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_SISTqueue::extractionelement(int priority)
{
	// FUNCION PARA EXTRAER LOS PAQUETES DEL PRINCIPIO DE LAS COLAS

	ETHERNETmsg *ethernetmsg; // DEFINIMOS LA VARIABLE PARA EL PAQUETE ETHERNET
	take(ethernetmsg = (ETHERNETmsg *)queue.pop()); // EXTRAEMOS EL PRIMER PAQUETE QUE SE ENCUENTRA EN EL INICIO DE LA COLA
	tamextract = ethernetmsg->getByteLength(); // TAMANYO DEL PRIMER PAQUETE QUE SE ENCUENTRA EN EL INICIO DE LA COLA

	// RESTAMOS EL TAMANYO DEL PAQUETE QUE OBTUVIMOS EN LA FUNCION DE CHEQUEAR LOS PAQUETES AL TAMANYO DE LA COLA EN LA QUE EXTRAIGAMOS EL PAQUETE ETHERNET
	tamqueue[priority] = tamqueue[priority] - tamqueueextract;

	if(ethernetmsg->getIsWireless()==1)
	{
		//<<" Envio de paquete Ethernet de origen inalambrico al modulo 'ONU_WDMSplitter'"<<endl;
	}
	// ENVIAMOS EL PAQUETE ETHERNET HACIA EL MODULO ONU_WDMSPLITTER
	send(ethernetmsg, "onuqueuewdmOut");
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION WIRELESSTOOPTICAL(cMessage *msg)--> TRADUCE LA PDU (Packet Data User) DEL ESTANDAR IEEE 802.11b EN UNA PDU DEL ESTANDAR EPON.	//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
ETHERNETmsg* ONU_SISTqueue::WirelessToOptical(cMessage *msg)
{
	/* Conversion mensajes wireless en mensajes Ethernet */
	DATA *msjdatos = check_and_cast<DATA*>(msg);

	//ev <<" Mensaje recibido -> Ruta seguida: " << msjdatos->getUserOrigin() << " | ";
	for(int y = 0; y < (int)msjdatos->getRutaArraySize(); y++)
	{
		//ev <<msjdatos->getRuta(y) << " | ";
	}
	//ev <<endl;

	ETHERNETmsg *msgethernet = new ETHERNETmsg("Ethernet",1);
	// Indice de esta ONU:
	msgethernet->setSrcAddress(msjdatos->getDestAddress());
	// Destino --> El OLT (num. direccion 9):
	msgethernet->setDestAddress(9);
	// Longitud (en Bytes) del mensaje:
	msgethernet->setByteLength(msjdatos->getByteLength());
	// Prioridad del mensaje:
	msgethernet->setPriority(msjdatos->getPriority());
	// Id. de servicio del mensaje:
	msgethernet->setId_servicio(msjdatos->getPriority());
	// Longitud de onda por la que van los mensajes en la red EPON:
	msgethernet->setLambdaethernet(0);
	// Longitud (en metros) recorrida por el mensaje en la parte wireless:
	msgethernet->setLength(msjdatos->getMetros());
	// Numero de nodos intermedios wireless por los que ha pasado el mensaje:
	msgethernet->setRelleno(msjdatos->getSaltos());
	// Sello temporal de la creacion del mensaje wireless:
	msgethernet->setTimestamp(msjdatos->getTimestamp());
	// Nombre completo del usuario wireless generador del mensaje inicial:
		//msgethernet->setAnotherField(msjdatos->getUserOrigin());
	// Es un mensaje de origen inalambrico (isWireless = 1):
	msgethernet->setIsWireless(1);
	// Nombre completo de la ONU que reenvia al OLT este mensaje:
	msgethernet->setOrigen(msjdatos->getDestino());
	delete msjdatos;
	return msgethernet;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INSERTPACKET(cMessage *msg)--> INSERTA EN LA COLA DE ESTE MODULO EL PAQUETE ETHERNET PROCEDENTE DE LA PARTE INALAMBRICA	//
//										 DE LA RED SI HAY ESPACIO DISPONIBLE. EN CASO CONTRARIO, LO ELIMINA. LA INSERCION SE REALIZA//
//										 SEGUN EL CRITERIO ELEGIDO EN OMNETPP.INI (PRIORIDAD O SEPARADO).							//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_SISTqueue::insertPacket(cMessage *msg)
{
	ETHERNETmsg *msgethernet=check_and_cast<ETHERNETmsg*>(msg);
	double buffer = (double) this->getParentModule()->getParentModule()->par("tambuffer");
	int metodo_insercion = (int)this->getParentModule()->getParentModule()->par("insercionmethod_separatequeue0_priorityqueue1");
	switch(metodo_insercion)
	{
	case 0: // Metodo de Insercion de Paquetes de Colas Separadas
		buffer = buffer/num_colas;
		// SUMAMOS LA LONGITUD (BYTES) DE LOS PAQUETES QUE INSERTAMOS EN LAS COLAS:
		tamqueue[msgethernet->getPriority()] = tamqueue[msgethernet->getPriority()] + msgethernet->getByteLength();
		if (buffer >= tamqueue[msgethernet->getPriority()])
		{
			// INTRODUCIMOS EN EL PAQUETE ETHERNET EL TIEMPO DE INSERCION EN COLA PARA DESPUES CALCULAR EL RETARDO:
			msgethernet->setTime_enter_queue(simTime());
			//ev<<" Tiempo de insercion del paquete Ethernet en cola: "<<ethernetmsg->getTime_enter_queue()<<endl;
			queue.insert(msgethernet); // INSERTAMOS EL PAQUETE EN LA COLA
			//ev <<" Insercion en cola de la ONU pasarela el paquete Ethernet transformado" << endl;
		}
		else if (buffer < tamqueue[msgethernet->getPriority()])
		{
			tamqueue[msgethernet->getPriority()] = tamqueue[msgethernet->getPriority()] - msgethernet->getByteLength();
			delete msgethernet;
			//ev <<" Borrado del paquete Ethernet transformado porque no cabe en la cola de la ONU" << endl;
		}
		break;
	case 1: // Metodo de Insercion de Paquetes de Prioridad de Colas
		ONU_SISTqueue *cola_onu;
		double bloqueo;
		total_bytes = 0;
		for (int i=0; i<num_colas; i++)
		{
			if(this->getIndex()!=i)
			{
				cola_onu = check_and_cast<ONU_SISTqueue *>(this->getParentModule()->getSubmodule("onu_sistqueue",i));
				total_bytes = total_bytes + cola_onu->tamqueue[i];
			}
			else
			{
				total_bytes = total_bytes + tamqueue[getIndex()];
			}
		}
		total_bytes = total_bytes + msgethernet->getByteLength();
		if (buffer >= total_bytes)
		{
			tamqueue[msgethernet->getPriority()] = tamqueue[msgethernet->getPriority()] + msgethernet->getByteLength();
			// INTRODUCIMOS EN EL PAQUETE ETHERNET EL TIEMPO DE INSERCION EN COLA PARA DESPUES CALCULAR EL RETARDO:
			msgethernet->setTime_enter_queue(simTime());
			//ev<<" Tiempo de insercion del paquete Ethernet en cola: "<<ethernetmsg->getTime_enter_queue()<<endl;
			queue.insert(msgethernet); // INSERTAMOS EL PAQUETE EN LA COLA
			//ev <<" Insercion en cola de la ONU pasarela el paquete Ethernet transformado" << endl;
		}
		else if (buffer < total_bytes)
		{
			// Recorremos todas las colas, de menor a mayor prioridad, para borrar alguno de sus paquetes previos y dejar sitio al nuevo:
			int i = num_colas-1, fuera = -1;
			while(i>=0 && fuera < 0)
			{
				if(this->getIndex()!=i)
				{
					cola_onu = check_and_cast<ONU_SISTqueue *>(this->getParentModule()->getSubmodule("onu_sistqueue",i));
				}
				else
				{
					cola_onu = this;
				}
				// Si el nuevo paquete es de la misma prioridad que la de la cola que se esta checkeando
				// (en principio, la mas baja), se borra directamente:
				if(msgethernet->getPriority() == i)
				{
					//ev <<" MENSAJE BORRADO (Id." << msgethernet->getId() << ")" << endl;
					// Resta de los bytes del paquete borrado a la suma total de todas las colas:
					total_bytes = total_bytes - msgethernet->getByteLength();
					bloqueo = 1.0; //BORRADO PAQUETE
					delete msgethernet; // BORRADO DEL PAQUETE 'msgethernet'
					// Salida del bucle que recorre las colas
					fuera = 1;
				}
				// Si el nuevo paquete es de mayor prioridad que la de la cola que se esta checkeando
				// Y esta cola NO esta vacia, se borran paquetes suyos hasta poder meter el nuevo:
				else if(msgethernet->getPriority()<i && cola_onu->queue.getLength()>0)
				{
					int salir = -1;
					// Recorremos todos los paquetes de esta cola, desde el mas antiguo:
					while (cola_onu->queue.getLength()>0 && salir < 0)
					{
						// Llamada a la funcion del modulo 'bs_queue' para borrar el primer paquete de la cola:
						cola_onu->deleteelement(msgethernet);
						// Resta de los bytes del paquete extraido a la variable 'tamqueuepop':
						total_bytes = total_bytes - cola_onu->tamqueuepop;
						// Si hay espacio suficiente en cola para insertar el nuevo paquete...
						if(buffer >= total_bytes)
						{
							tamqueue[msgethernet->getPriority()] = tamqueue[msgethernet->getPriority()] + msgethernet->getByteLength();
							// INTRODUCIMOS EN EL PAQUETE ETHERNET EL TIEMPO DE INSERCION EN COLA PARA DESPUES CALCULAR EL RETARDO:
							msgethernet->setTime_enter_queue(simTime());
							//ev<<" Tiempo de insercion del paquete Ethernet en cola: "<<ethernetmsg->getTime_enter_queue()<<endl;
							queue.insert(msgethernet); // INSERTAMOS EL PAQUETE EN LA COLA
							//ev <<" Insercion en cola de la ONU pasarela el paquete Ethernet transformado" << endl;
							salir = 1;
							fuera = 1;
							bloqueo=0.0;
						}
						// Si NO hay espacio suficiente en cola para insertar el nuevo paquete...
						else if(buffer < total_bytes){} // Pasamos a la siguiente iteracion
					}
					if(buffer > total_bytes)
					{
						// Salida del bucle que recorre todas las colas
						fuera = 1;
					}
				}
				else if(msgethernet->getPriority() < i && cola_onu->queue.getLength()==0)
				{
					////ev <<"  	No quedan paquetes en la cola P" << i << endl;
				}
				i--;
			}
		}
		break;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION VOLCADOFICHEROS()--> ESCRIBE EN UNO O VARIOS FICHEROS DE TEXTO LOS DATOS DE MAYOR INTERES DE LA	/
//							   SIMULACION, PARA SU POSTERIOR ANALISIS.										/
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_SISTqueue::volcadoFicheros()
{
	//volcado = 1;
	/*
	carga_colas = fopen("results/carga_colas.txt", "a+");
	if(getIndex() == 0) // En la primera cola de cada ONU, se imprime esta cabecera:
	{
		fprintf(carga_colas,"Carga de ONU [%i] (pasarela)\n", this->getParentModule()->getParentModule()->getIndex());
		if(isGateway == 1)
		{
			fprintf(carga_colas,"ONU [%i] (pasarela)\n", this->getParentModule()->getParentModule()->getIndex());
		}
		else if(isGateway == 0)
		{
			fprintf(carga_colas,"ONU [%i] (NO pasarela)\n", this->getParentModule()->getParentModule()->getIndex());
		}
	}
	if(getIndex() != num_colas) // La ultima cola es para los REPORT, no cuenta
	{
		fprintf(carga_colas,"Carga total de la cola P%i: %g \n", getIndex(), (double)carga_cola);
		//fprintf(carga_colas,"Carga total de la cola P%i: %g \n", getIndex(), (double)carga.average());
	}
	fclose(carga_colas);
	*/

	int indiceOnu = this->getParentModule()->getParentModule()->getIndex();

	if(getIndex() != num_colas && isGateway == 1)
	{
		// 'BYTES_RECIBIDOS_ONU': FICHERO CON EL NUMERO DE PAQUETES Y DE BYTES RECIBIDOS EN CADA COLA DE CADA ONU PASARELA.
		bytes_recibidos_onu = fopen("results/bytes_recibidos_onu.txt", "a+");
		fprintf(bytes_recibidos_onu,"ONU [%i] (pasarela)\n", this->getParentModule()->getParentModule()->getIndex());
		fprintf(bytes_recibidos_onu,"\t Cola P%i - Paquetes recibidos en total: %g\n",(int)getIndex(),(double) paquetes_recibidos);
		fprintf(bytes_recibidos_onu,"\t Cola P%i - Bytes recibidos en total: %g\n",(int)getIndex(),(double) bytes_recibidos);
		fclose(bytes_recibidos_onu);

		// 'RETARDO_RED_WIRELESS': FICHERO CON EL RETARDO DE LOS PAQUETES RECIBIDOS EN CADA COLA DE CADA ONU PASARELA,
		//						   MAS EL RETARDO MEDIO ENTRE TODOS LOS PAQUETES LLEGADOS A TODAS LAS ONUS PASARELA (DATO
		//						   INCLUIDO DESDE EL MODULO ONU[15].BS_QUEUE[0]).
		retardo_red_wireless = fopen("results/retardo_red_wireless.txt", "a+");
		if(getIndex() == 0) // En la primera cola de cada ONU, se imprime esta cabecera:
		{
				fprintf(retardo_red_wireless,"ONU [%i] (pasarela)\n", indiceOnu);
		}
		fprintf(retardo_red_wireless, "\tRetardo wireless P%i: %g\n", getIndex(), (double)retardo.average());
		fclose(retardo_red_wireless);

		// 'MEDIA_LONGITUD_SALTOS_WIRELESS': FICHERO CON EL NUMERO MEDIO DE SALTOS Y DE LONGITUD RECORRIDOS POR CADA PAQUETE
		//									 WIRELESS RECIBIDO EN CADA COLA DE CADA ONU PASARELA.
		media_longitud_saltos_wireless = fopen("results/media_longitud_saltos_wireless.txt", "a+");
		if(getIndex() == 0) // En la primera cola de cada ONU, se imprime esta cabecera:
		{
			fprintf(media_longitud_saltos_wireless,"ONU [%i]\n", this->getParentModule()->getParentModule()->getIndex());
		}
		fprintf(media_longitud_saltos_wireless,"\t Cola P%i - Media saltos paquetes wireless: %g\n",(int)getIndex(),(double) saltos.average());
		fprintf(media_longitud_saltos_wireless,"\t Cola P%i - Media longitud recorrida: %g\n",(int)getIndex(),(double) longitud.average());
		fclose(media_longitud_saltos_wireless);
	}

	if(indiceOnu == 15 && getIndex()==0)
	{
		retardo_red_wireless = fopen("results/retardo_red_wireless.txt", "a+");
		fprintf(retardo_red_wireless, "\tTOTAL: %g\n", (double)retardo.average());
		fclose(retardo_red_wireless);
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION FINISH()--> ESTA FUNCION SE INVOCA CUANDO LA SIMULACION HA TERMINADO CON EXITO SIN QUE SE PRODUZCA NINGUN ERROR. 		//
//					  LO USAMOS PARA LA RECOGIDA DE ESTADASTICAS Y VISUALIZACION POR PANTALLA O MEDIANTE UN ARCHIVO.            //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_SISTqueue::finish()
{
	//ev <<" Total Paquetes Recibidos: " << paquetes_recibidos << endl;
	volcadoFicheros();
}
