////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti�n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_SISTQUEUE_H_
#define __RED_WIRELESS_SISTQUEUE_H_

#include <omnetpp.h>
#include <vector>
#include "analysis.h"
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include "DATA_m.h"
#include <string.h>
#include <stdio.h>
#include <math.h>
/*
 * MODULO ONU_SISTqueue:
 */
//DEFINIMOS LOS TIPOS DE std DE LOS VECTORES:
typedef std::vector<int> int_vector_t; // VECTOR DE TIPO ENTERO
typedef std::vector<double> double_vector_t; // VECTOR DE TIPO DOUBLE

class ONU_SISTqueue : public cSimpleModule
{
	private:
		Analysis carga;
		FILE * bytes_recibidos_onu;
		FILE * carga_colas;
		FILE * retardo_red_wireless;
		FILE * media_longitud_saltos_wireless;


	public:
		Analysis retardo;
		Analysis longitud;
		Analysis saltos;
		cQueue queue; // CREAMOS UNA COLA LLAMADA queue
		int_vector_t tamqueue; // VECTOR QUE INDICA EL TAMANYO DE LA COLA
		long tamqueuepop; // VARIABLE DEL TAMANYO DE LOS PAQUETES QUE BORRAMOS DE LAS COLAS
		long tamqueueextract; // VARIABLE DEL TAMANYO DE LOS PAQUETES QUE CHEQUEAMOS ANTES DE SACARLOS DE LAS COLAS
		long tamextract; // VARIABLE DEL TAMANYO DE LOS PAQUETES QUE EXTRAEMOS DE LAS COLAS

		long int paquetes_recibidos;
		double bytes_recibidos;
		int isGateway;
		int num_colas;
		double carga_cola;

		virtual void handleMessage(cMessage *msg);
		virtual void initialize();
		virtual void finish();

		void deleteelement(cMessage *msg); // FUNCION PARA ELIMINAR LOS PAQUETES DEL PRINCIPIO DE LAS COLAS

		void checkpacket(); // FUNCION PARA CHUEQUEAR LOS PAQUETES DEL PRINCIPIO DE LA COLA PARA SABER SU TAMANYO EN BYTES
		void extractionelement(int); // FUNCION PARA EXTRAER LOS PAQUETES DEL PRINCIPIO DE LAS COLAS

		virtual ETHERNETmsg * WirelessToOptical(cMessage * msg);
		virtual void volcadoFicheros();
		int volcado;
		int contador;
		virtual void insertPacket(cMessage *msg);
		long total_bytes;
		simtime_t delay_packets;
		int_vector_t indices_gw_onu;
		int aux_counter;
		int full_onus_gw;
		double_vector_t max_control_admision;
};

#endif
