////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gestin de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_ONU_TABLE_H_
#define __RED_WIRELESS_ONU_TABLE_H_

#include <omnetpp.h>
#include <vector>
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
/*
 * MODULO ONU_Table:
 */
//DEFINIMOS LOS TIPOS DE std DE LOS VECTORES Y MATRICES:
typedef std::vector<simtime_t> simtime_t_vector_t; // VECTOR TIPO TIEMPO
typedef std::vector<double> double_vector_t; // VECTOR TIPO DOUBLE

class ONU_Table : public cSimpleModule
{
	public:
		double_vector_t table_onu_gate; // VECTOR DE TIPO DOUBLE PARA GUARDAR EL ANCHO DE BANDA DE SLOT
		simtime_t_vector_t table_onu_gate_time; // VECTOR DE TIPO TIEMPO PARA GUARDAR EL TIEMPO DE INICIO DE TRANSMISIÓN
		long bw_asignado;

		int numInitStages() const; // FUNCIÓN QUE INICIALIZA VARIAS ETAPAS.

  	protected:
    	 void initialize(int stage);
    	 void handleMessage(cMessage *msg);
};

#endif
