////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti�n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#include "ONU_WDMSplitter.h"
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include <vector>
#include "analysis.h"
#include <string.h>
#include <stdio.h>
#include "ONU_Table.h"

/*
 * MODULO ONU_WDMSplitter:
 */
Define_Module(ONU_WDMSplitter);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPUES DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS      //
//						  PARAMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE //
//						  ASIGNAN ESTRUCTURAS DE DATOS DINAMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  //
//						  PARA EL FUNCIONAMIENTO DE ESTE MODULO.			   													//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_WDMSplitter::initialize()
{
	// RECOGIDA DE ESTADISTICAS DE TIEMPO ENTRE CICLOS MANUALMENTE
	time_cycles.setName("Tiempo entre ciclos");

	// INICIALIZAMOS VARIABLES AL VALOR 0
	timepacketethernet = 0; // TIEMPO EN EL QUE SE ENVIARA EL PAQUETE ETHERNET
	time_report = 0; // TIEMPO EN EL QUE SE ENVIA EL PAQUETE REPORT
	time_gate = 0; // TIEMPO EN EL QUE LLEGA EL PAQUETE GATE A LA ONU
	lambda = 0;
	onu = 0 ;
	tampacketextract = 0;
	bw_perdido=0;
	sent_messages = 0;
	// CODIGO PARA MODIFICAR EL DELAY DEL CANAL QUE UNE EL SPLITTER Y LAS ONUS
	if((int)par("methodlength_longvariable0_longfija1")==0)
	{
		cTopology topo; // DEFINIMOS UN PARAMETRO DE LA TOPOLOGIA DE LA RED
		topo.extractByParameter( "numlong" ); // EXTRAEMOS LOS NODOS DE NUESTRA RED QUE UTILIZAN EL PARAMETRO numlong
		// PARA VISUALIZAR LOS NODOS DE LA TOPOLOGAA Y SUS CONEXIONES
		//for (int i=0; i<topo.getNumNodes(); i++)
		//{
		// cTopology::Node *node = topo.getNode(i);
		//  //ev<<"Node i=" << i << " is " << node->getModule()->getFullPath() << endl;
		//  //ev<<" It has " << node->getNumOutLinks() << " conns to other nodes\n";
		//  //ev<<" and " << node->getNumInLinks() << " conns from other nodes\n";

		//  //ev<<" Connections to other modules are:\n";
		//	for (int j=0; j<node->getNumOutLinks(); j++)
		//	{
		//	  cTopology::Node *neighbour = node->getLinkOut(j)->getRemoteNode();
		//	  cGate *gate = node->getLinkOut(j)->getLocalGate();
		//	  //ev<<" " << neighbour->getModule()->getFullPath()
		//		 << " through gate " << gate->getFullName() << endl;
		//	}

		//	}

		// DEFINIMOS EL PARAMETRO MODULE QUE NOS INDICA EL CAMINO HASTA EL NODO DEL QUE QUEREMOS OBTENER INFORMACION
		cModule *module = getParentModule()->getParentModule()->getSubmodule("onu", getParentModule()->getIndex());
		double delay = intuniform(0,10)*1000*0.000000005; // CALCULAMOS EL RETARDO DEL SEGMENTO QUE UNA EL SPLITTER CON LA ONU MEDIANTE DISTANCIAS ALEATORIAS ENTE 0 Y 10 KM

		cTopology::Node *nodeonuOut = topo.getNodeFor(module);  // NOMBRE DEL NODO QUE SACAMOS DEL GRAFO
		// RECORREMOS CON EL BUCLE FOR TODOS LOS ENLACES DE SALIDA QUE TIENE ESE NODO PARA OBTENER LA INFORMACION QUE SOLICITAMOS
		for(int j=0; j<nodeonuOut->getNumOutLinks(); j++)
		{
			// OBTENEMOS EL VALOR DEL RETARDO QUE HAY EN EL CANAL QUE PASA POR EL NODO EN EL QUE OBTENEMOS LA INFORMACION Y LO VISUALIZAMOS POR PANTALLA
			SIMTIME_DBL((check_and_cast<cDelayChannel*>(nodeonuOut->getLinkOut(j)->getLocalGate()->getChannel()))->getDelay());
			//ev<<" Delay del canal descendente antes de Inicializar: "<<SIMTIME_DBL((check_and_cast<cDelayChannel*>(nodeonuOut->getLinkOut(j)->getLocalGate()->getChannel()))->getDelay())<<endl;

			// INTRODUCIMOS EL NUEVO VALOR DEL RETARDO DEL CANAL  Y LO VISUALIZAMOS POR PANTALLA
			(check_and_cast<cDelayChannel*>(nodeonuOut->getLinkOut(j)->getLocalGate()->getChannel()))->setDelay(delay);
			//ev<<" Nuevo Delay del canal descendente: "<<(check_and_cast<cDelayChannel*>(nodeonuOut->getLinkOut(j)->getLocalGate()->getChannel()))->getDelay()<<endl;
		}

		cTopology::Node *nodeonuIn = topo.getNodeFor(module);  // NOMBRE DEL NODO QUE SACAMOS DEL GRAFO
		// RECORREMOS CON EL BUCLE FOR TODOS LOS ENLACES DE ENTRADA QUE TIENE ESE NODO PARA OBTENER LA INFORMACION QUE SOLICITAMOS
		for(int j=0; j<nodeonuIn->getNumInLinks(); j++)
		{
			// OBTENEMOS EL VALOR DEL RETARDO QUE HAY EN EL CANAL QUE PASA POR EL NODO EN EL QUE OBTENEMOS LA INFORMACION Y LO VISUALIZAMOS POR PANTALLA
			SIMTIME_DBL((check_and_cast<cDelayChannel*>(nodeonuIn->getLinkIn(j)->getRemoteGate()->getChannel()))->getDelay());
			//ev<<" Delay del canal ascendente antes de Inicializar: "<<SIMTIME_DBL((check_and_cast<cDelayChannel*>(nodeonuIn->getLinkIn(j)->getRemoteGate()->getChannel()))->getDelay())<<endl;

			// INTRODUCIMOS EL NUEVO VALOR DEL RETARDO DEL CANAL  Y LO VISUALIZAMOS POR PANTALLA
			(check_and_cast<cDelayChannel*>(nodeonuIn->getLinkIn(j)->getRemoteGate()->getChannel()))->setDelay(delay);
			//ev<<" Nuevo Delay del canal ascendente: "<<(check_and_cast<cDelayChannel*>(nodeonuIn->getLinkIn(j)->getRemoteGate()->getChannel()))->getDelay()<<endl;
		}
	}
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// DEFININOS EL PROCESO PARA PODER ENTRAR DESDE ESTE MODULO AL MODULO ONU_TABLE
	cModule *c_onutable_module;


	c_onutable_module = getParentModule()->getSubmodule("onu_table"); // CAMINO PARA LLEGAR HASTA EL MODULO ONU_TABLE
	table_module = check_and_cast<ONU_Table *>(c_onutable_module); // ENTRAMOS Y CHEQUEAMOS EL MODULO ONU_TABLE


}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//										  UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O  	//
//										  EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//										  DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL	//
//										  CODIGO IMPLEMENTADO.																	//                                                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_WDMSplitter::handleMessage(cMessage *msg)
{
	// VARIABLES
	simtime_t comprobar_tiempo_ciclos; // VARIABLE QUE INDICA EL TIEMPO QUE SE PIERDE ENTRE EL FINAL Y EL PRINCIPIO DE UN CICLO
	int type = msg->getKind(); // VARIABLE TYPE PARA IDENTIFICAR LOS MENSAJES DE LA RED
	long int txrate = (long int)par("txrate"); // TASA DE TRANSMISION EN BITS POR SEGUNDO
	int p= gateSize("wdmnet"); // TAMA�O DE LA PUERTA wdmnet DEL MODULO ONU_WDMSPLITTER


	// ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA LOS MENSAJES QUE LLEGUEN A ESTE MODULO
	switch(type)
	{
		case 0:
			// LLEGA UN PAQUETE GATE CON IDENTIFICADOR = 0
			if(msg->getKind()==0)
			{
				GATEmsg *gatemsg=check_and_cast<GATEmsg*>(msg); // CHEQUEAMOS EL PAQUETE GATE

				// VEMOS SI SE CUMPLEN LAS TRES IGUALDADES PARA QUE SE EJECUTE LA FUNCION:
				// SI EL IDENTIFICADOR DE LA DIRECCION DE DESTINO ES IGUAL AL IDENTIFICADOR = 0,
				// SI EL TIEMPO DE CREACCION DEL PAQUETE GATE ES MAYOR A 1 SEGUNDO,
				// SI EL IDENTIFICADOR DE LA ONU EN LA QUE ESTAMOS ES IGUAL A 0.
				if(gatemsg->getDestAddress()==0 && gatemsg->getCreationTime() > 1 && getParentModule()->getIndex()==0)
				{
					// DAMOS EL VALOR DEL TIEMPO DE SIMULACION A LA VARIABLE time_gate Y LO VISUALIZAMOS POR PANTALLA
					time_gate = simTime();
					//ev<<" Tiempo en el que llega el paquete Gate a la ONU 0: "<<time_gate<<"s."<<endl;
					//ev<<" Tiempo de envio del paquete Report de la ONU "<<((int)par("numOnu")-1)<<": "<<gatemsg->getTimereport()<<"s."<<endl;

					// RECOGIDA DE ESTADISTICAS MANUALMENTE Y LO VISUALIZAMOS POR PANTALLA
					comprobar_tiempo_ciclos = time_gate - gatemsg->getTimereport(); // TIEMPO QUE SE PIERDE ENTRE EL FINAL Y EL PRINCIPIO DE UN CICLO
					//ev<<" Tiempo que se pierde entre el final y el comienzo de un ciclo: "<<comprobar_tiempo_ciclos<<"s."<<endl;
					time_cycles.collect(comprobar_tiempo_ciclos); // RECOGEMOS EL RESULTADO
				}

				send(gatemsg, "wdmptpOut"); // ENVIAMOS EL PAQUETE GATE HACIA EL MODULO POINT TO POINT DE LA ONU
			}
			break;

		case 1:
			// LLEGA UN PAQUETE ETHERNET CON IDENTIFICADOR = 1
			if(msg->getKind()==1)
			{
				// DEFINIMOS EL PARAMETRO ingate QUE NOS INDICA EL PUNTERO DE LA PUERTA POR LA CUAL ENTRA EL MENSAJE QUE LLEGA
				cGate *ingate = msg->getArrivalGate();

				// COMPARAMOS EL NOMBRE DE LA PUERTA POR LA QUE ENTRA EL MENSAJE CON LA PUERTA wdmnet$i
				if(ingate->getName() == gate("wdmnet$i",intuniform(0,p-1))->getName())
				{
					send(msg, "wdmptpOut"); // ENVIAMOS EL PAQUETE ETHERNET HACIA EL MODULO POINT TO POINT DE LA ONU
				}
				else
				{
					ETHERNETmsg *ethernetmsg=check_and_cast<ETHERNETmsg*>(msg); // CHEQUEAMOS EL PAQUETE ETHERNET

					// VISUALIZAMOS EL TAMA�O DEL PAQUETE ETHERNET QUE MANDAMOS HACIA EL OLT
						//ev<<" Longitud del paquete que se manda: "<<ethernetmsg->getByteLength()<<endl;

					// CALCULAMOS EL TIEMPO EN EL QUE SE MANDAN LOS PAQUETES ETHERNET JUNTO CON SU TAMA�O EN BITS Y LO VISUALIZAMOS POR PANTALLA
					double datarate = ethernetmsg->getByteLength()*8/txrate; // CALCULAMOS EL PARAMETRO datarate QUE INDICA LA TASA DE TRANSMISION DEL PAQUETE ETHERNET
					tampacketextract=tampacketextract+ethernetmsg->getByteLength()*8;
					timepacketethernet = timepacketethernet + datarate;
						//ev<<" Tiempo que tarda en enviarse el paquete ethernet: "<<timepacketethernet<<" s."<<endl;
					// ENVIAMOS LOS PAQUETES ETHERNET MEDIANTE EL ENVIO RETARDADO DEL TIEMPO EN EL QUE SE MANDAN LOS PAQUETES
					if(ethernetmsg->getIsWireless()==1)
					{
						//ev<<" Envio de paquete Ethernet de origen inalambrico al SPLITTER."<<endl;
					}
					else
					{
						sent_messages++;
						//ev<<" Envio mensaje Ethernet (Id. " << ethernetmsg->getId() << ") al SPLITTER." << endl;
						//ev<<" Total mensajes generados y enviados por esta ONU: " << sent_messages << endl;
					}
					ethernetmsg->setTime_exit_wdmsplitter(simTime());


					// MODIFICADO POR DAVID
					ethernetmsg->setLambdaethernet(lambda);
					//sendDelayed(ethernetmsg, timepacketethernet, "wdmnet$o", ethernetmsg->getLambdaethernet());
                    sendDelayed(ethernetmsg, timepacketethernet, "wdmnet$o", lambda);


				}
			}
			break;

		case 2:
			// LLEGA UN PAQUETE REPORT CON IDENTIFICADOR = 2
			if(msg->getKind()==2)
			{
				REPORTmsg *reportmsg=check_and_cast<REPORTmsg*>(msg); // CHEQUEAMOS EL PAQUETE REPORT

				lambda=reportmsg->getLambdareport();
				onu=reportmsg->getSrcAddress();
				//ev<<" Envio del paquete report de la ONU "<<onu<< " por la lambda: "<<lambda<<endl;

				// ENVIAMOS EL PAQUETE REPORT EN EL INSTANTE DESPUES DE MANDAR TODOS LOS PAQUETES REPORT
				sendDelayed(reportmsg, timepacketethernet, "wdmnet$o", lambda);

				// COMPARAMOS SI LA DIRECCION FUENTE DEL PAQUETE REPORT ES PARA LA �LTIMA ONU PARA VER EL TIEMPO EN EL QUE SE ENVIA EL REPORT DE LA ULTIMA ONU PARA CALCULAR EL TIEMPO ENTRE CICLOS EN EL METODO DMB DEL OLT
				if(reportmsg->getSrcAddress()==((int)par("numOnu")-1))
				{
					time_report = reportmsg->getSendingTime(); // TIEMPO EN EL QUE SE ENVIA EL PAQUETE REPORT
					reportmsg->setTimesendreport(time_report); // CARGAMOS EL VALOR DE time_report EN UNO DE LOS CAMPOS DEL PAQUETE REPORT Y LO VISUALIZAMOS POR PANTALLA
					//ev<<" Tiempo de envio de paquete REPORT de la �ltima ONU: "<<reportmsg->getTimesendreport()<<endl;
				}

				table_module->bw_asignado=reportmsg->getBandwitch(0);
				bw_perdido=(table_module->bw_asignado)*8-tampacketextract;

				reportmsg->setBand(bw_perdido);

				tampacketextract = 0;
				timepacketethernet = 0; // ACTUALIZAMOS EL PARAMETRO DEL TIEMPO DE ENVIO DE LOS PAQUETES ETHERNET AL VALOR 0
			}
			break;

		default:
			delete msg;
			break;
	}

}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION FINISH()--> ESTA FUNCION SE INVOCA CUANDO LA SIMULACION HA TERMINADO CON EXITO SIN QUE SE PRODUZCA NINGUN ERROR. 		//
//					  LO USAMOS PARA LA RECOGIDA DE ESTADASTICAS Y VISUALIZACION POR PANTALLA O MEDIANTE UN ARCHIVO.            //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ONU_WDMSplitter::finish()
{
	//RECOGIDA DE ESTADISTICAS CON LA CLASE ANALISIS!! GUARDAMOS LOS DATOS EN UN ARCHIVO
	// SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
	tiempo_entre_ciclos=fopen("results/tiempo_entre_ciclos.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
		fprintf(tiempo_entre_ciclos,"ONU[%i]: Tiempo medio entre ciclos: %g\n", this->getParentModule()->getIndex(), time_cycles.getMean()); // MEDIA DEL TIEMPO ENTRE CICLOS
		fclose(tiempo_entre_ciclos); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

}
