////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gestin de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_WDMSPLITTER_H_
#define __RED_WIRELESS_WDMSPLITTER_H_

#include <omnetpp.h>
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include "analysis.h"
#include <vector>
#include "ONU_Table.h"
/*
 * MODULO ONU_WDMSplitter:
 */
//DEFINIMOS LOS TIPOS DE std DE LOS VECTORES:
typedef std::vector<int> int_vector_t;
typedef std::vector<double> double_vector_t; // VECTOR DE TIPO DOUBLE
typedef std::vector<simtime_t> simtime_t_vector_t; // VECTOR DE TIPO TIEMPO

class ONU_WDMSplitter : public cSimpleModule
{
  protected:

	cStdDev time_cycles; // PARAMETRO DE ESTADISTICAS DEFINIDO PARA OBTENERLAS MANUALMENTE
	Analysis tiempo_ciclos; // DEFININOS EL PARAMETRO PARA LA CLASE ANALISIS
	FILE * tiempo_entre_ciclos; // ARCHIVO DONDE SE GUARDARAN LOS RESULTADOS DE LA CLASE ANALISIS

	simtime_t timepacketethernet; // VARIABLE QUE CONTIENE EL TIEMPO EN EL QUE SE ENVIARA EL PAQUETE ETHERNET
	simtime_t time_report; // VARIABLE QUE CONTIENE EL TIEMPO EN EL QUE SE ENVIA EL PAQUETE REPORT
	simtime_t time_gate; // VARIABLE QUE CONTIENE EL TIEMPO EN EL QUE LLEGA EL PAQUETE GATE A LA ONU
	int lambda;
	int onu;
	long tampacketextract;
	long bw_perdido;
	double sent_messages;
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);


    virtual void finish(); // DEFINICION DE LA FUNCION FINALIZAR

  private:

	ONU_Table *table_module; // DEFINIMOS VARIABLE PARA PODER ENTRAR EN EL MODULO ONU_TABLE



};

#endif
