////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti�n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#include "SPLITTER.h"
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include "DATA_m.h"
/*
 * MODULO SPLITTER:
 */
Define_Module(SPLITTER);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPUES DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS      //
//						  PARAMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE //
//						  ASIGNAN ESTRUCTURAS DE DATOS DINAMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  //
//						  PARA EL FUNCIONAMIENTO DE ESTE MODULO.			   													//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void SPLITTER::initialize()
{
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//										  UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O  	//
//										  EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//										  DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL	//
//										  CODIGO IMPLEMENTADO.																	//                                                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void SPLITTER::handleMessage(cMessage *msg)
{
	// VARIABLES
	int type = msg->getKind(); // VARIABLE TYPE PARA IDENTIFICAR LOS MENSAJES DE LA RED

	// ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA LOS MENSAJES QUE LLEGUEN A ESTE MODULO
	switch(type)
	{
		case 0:
			// LLEGA UN PAQUETE GATE CON IDENTIFICADOR = 0
			if(msg->getKind()==0)
			{
				GATEmsg *gatemsg=check_and_cast<GATEmsg*>(msg); // CHEQUEAMOS EL PAQUETE GATE


				// BUCLE FOR PARA GENERAR UNA COPIA DEL MENSAJE GATE QUE SE MANDA A TODAS LAS ONUS DE LA RED
				for( int k=gatemsg->getLambdagate(); k<gateSize("splitterOut"); k=k+(int)par("numlong"))
				{
					GATEmsg *copy = gatemsg->dup(); // DUPLICAMOS EL PAQUETE GATE QUE SE MANDA A TODAS LAS ONUS DE LA RED
					send(copy, "splitterOut$o", k); // ENVIAMOS TODAS LAS COPIAS DEL PAQUETE GATE HACIA TODAS LAS ONUS DE LA RED
				}

				delete msg; // BORRAMOS EL MENSAJE
			}
			break;

		case 1:
			// LLEGA UN PAQUETE ETHERNET CON IDENTIFICADOR = 1
			if(msg->getKind()==1)
			{
				ETHERNETmsg *ethernetmsg=check_and_cast<ETHERNETmsg*>(msg); // CHEQUEAMOS EL PAQUETE ETHERNET

				// COMPARAMOS SI LA EL IDENTIFICADOR DE LA DIRECCION DE DESTINO ES IGUAL AL IDENTIFICADOR = 9 QUE CORRESPONDE CON EL OLT
				if(ethernetmsg->getDestAddress()==9)
				{
					// VISUALIZAMOS EL TAMANYO DEL PAQUETE ETHERNET QUE SE MANDA HACIA EL OLT
					// //ev<<" Longitud del paquete Ethernet que se manda hacia el OLT: " << ethernetmsg->getByteLength() << " Bytes" << endl;
					// ENVIAMOS EL PAQUETE ETHERNET POR LA SALIDA DEL MODULO SPLITTER HACIA EL OLT
					if(ethernetmsg->getIsWireless()==1)
					{
						//ev<<" Envio de paquete Ethernet de origen inalambrico al modulo 'OLT_WDMSplitter'."<<endl;
					}
					else
					{
						//ev<<" Envio mensaje Ethernet (Id. " << ethernetmsg->getId() << ") al modulo 'OLT_WDMSplitter'." << endl;
					}
					send(ethernetmsg, "splitterIn$o", ethernetmsg->getLambdaethernet());
				}
				else
				{
					// BUCLE FOR PARA GENERAR UNA COPIA DEL MENSAJE ETHERNET QUE SE MANDA A TODAS LAS ONUS DE LA RED
					for( int k=ethernetmsg->getLambdaethernet(); k<gateSize("splitterOut"); k=k+(int)par("numlong"))
					{
						ETHERNETmsg *copy = ethernetmsg->dup(); // DUPLICAMOS EL PAQUETE ETHERNET QUE SE MANDA A TODAS LAS ONUS DE LA RED
						send(copy, "splitterOut$o", k); // ENVIAMOS TODAS LAS COPIAS DEL PAQUETE ETHERNET HACIA TODAS LAS ONUS DE LA RED
					}
					delete msg; // BORRAMOS EL MENSAJE
				}
			}
			break;

		case 2:
			// LLEGA UN PAQUETE REPORT CON IDENTIFICADOR = 2
			if(msg->getKind()==2)
			{

				REPORTmsg *reportmsg=check_and_cast<REPORTmsg*>(msg); // CHEQUEAMOS EL PAQUETE REPORT
				// ENVIAMOS EL PAQUETE REPORT POR LA SALIDA DEL MODULO SPLITTER HACIA EL OLT
				send(reportmsg, "splitterIn$o", reportmsg->getLambdareport());
			}
			break;

		default:
			delete msg;
			break;
	}
}
