////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gestin de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////
#include "User_Interface.h"
#include "DATA_m.h"
#include "BS_table.h"
#include "BS_queue.h"
#include <omnetpp.h>
#include <vector>
#include <time.h>
/*
 * MODULO User_Interface:
 * Envia hacia la BS mas cercana los paquetes generados por las diversas fuentes de datos
 * del usuario inalambrico (tantas como prioridades de servicio).
 */
Define_Module(User_Interface);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPUES DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS      //
//						  PARIMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE //
//						  ASIGNAN ESTRUCTURAS DE DATOS DINIMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  //
//						  PARA EL FUNCIONAMIENTO DE ESTE MODULO.			   													//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void User_Interface::initialize()
{
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//										  UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O  	//
//										  EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//										  DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL	//
//										  CODIGO IMPLEMENTADO.																	//                                                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void User_Interface::handleMessage(cMessage *msg)
{
	int type = msg->getKind();
	switch(type)
	{
		case 12:
			// LLEGA UN PAQUETE 'ETHERNET' CON IDENTIFICADOR = 12
			if(msg->getKind()==12)
			{
				//ETHERNETmsg *msjdatos = check_and_cast<ETHERNETmsg*>(msg);
				DATA *msjdatos = check_and_cast<DATA*>(msg);
					//ev << " Envio de paquete inalambrico, de prioridad P" << msjdatos->getPriority() << ", del " << this->getParentModule()->getFullName() << endl;
				// Envio del paquete "datos", con el retardo propio del canal:
				//sendDelayed(msjdatos,(simtime_t) msjdatos->getArrayField1(0),"interface$o");
				// OJO! No considerar el retardo de propagacion del usuario a la estacion base
				//		 (se considera despreciable por estar muy proximos)
				/*
				double prop_del = (double)(check_and_cast<cDelayChannel*>(this->getParentModule()->gate("physicalUser$o")->getChannel()))->par(4);
				simtime_t propag_delay = (simtime_t) prop_del;
				ev << " Retardo de propagacion del mensaje: " << prop_del << "s" << endl;
				double txrate = (double)this->getParentModule()->par("tasabinaria");
				double tx_del = (double) msjdatos->getByteLength()*8/txrate;
				simtime_t tx_delay = (simtime_t) tx_del;
				ev << " Retardo de transmision del mensaje: " << tx_del << "s" << endl;
				ev << " Tiempo en el que tiene que llegar a la BS[" << this->getParentModule()->getIndex() << "]: T=" << SIMTIME_DBL(simTime())+prop_del+tx_del << endl;
				sendDelayed(msjdatos,propag_delay+tx_delay,"interface$o");
				*/
				send(msjdatos,"interface$o");
			}
			break;

		default:
			delete msg;
			break;
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION FINISH()--> ESTA FUNCION SE INVOCA CUANDO LA SIMULACION HA TERMINADO CON EXITO SIN QUE SE PRODUZCA NINGUN ERROR. 		//
//					  LO USAMOS PARA LA RECOGIDA DE ESTADASTICAS Y VISUALIZACION POR PANTALLA O MEDIANTE UN ARCHIVO.            //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void User_Interface::finish()
{
	/* NO SE UTILIZA */
}
