////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gestin de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_USER_INTERFACE_H_
#define __RED_WIRELESS_USER_INTERFACE_H_

#include <omnetpp.h>
#include <vector>
#include <time.h>
#include "BS_queue.h"
#include "BS_table.h"

/*
 * MODULO User_Interface:
 * Envia hacia la BS mas cercana los paquetes generados por las diversas fuentes de datos
 * del usuario inalambrico (tantas como prioridades de servicio).
 */
typedef std::vector<int> int_vector_t; // VECTOR DE TIPO ENTERO
typedef std::vector< int_vector_t > int_matrix_t; // MATRIZ DE TIPO ENTERO

class User_Interface : public cSimpleModule
{
  public:
	BS_queue *cola_bs;
	BS_table *Tabla;
	int_matrix_t indices_rutas;
	int_vector_t num_rutas;

  protected:
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);
    virtual void finish();
};

#endif
