////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti�n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#include "User_traffic.h"
#include "DATA_m.h"
//#include "ETHERNET_m.h"
#include <omnetpp.h>
#include <vector>
#include <time.h>
#include <string.h>
#include <distrib.h>
#include "BS_table.h"
#include "BS_rx_tx.h"
#include "BS_queue.h"


/*
 * MODULO User_traffic:
 * Consta de tantas fuentes de trafico como prioridades de servicio, que generan paquetes
 * segun distintas distribuciones (uniforme o de Pareto).
 */
Define_Module(User_traffic);


User_traffic::User_traffic()
{
	pAG_user = NULL;
}

User_traffic::~User_traffic()
{
	delete pAG_user;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPUES DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS      //
//						  PARIMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE //
//						  ASIGNAN ESTRUCTURAS DE DATOS DINIMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  //
//						  PARA EL FUNCIONAMIENTO DE ESTE MODULO.			   													//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void User_traffic::initialize()
{
	//// DEFINIMOS EL PROCESO PARA PODER ENTRAR DESDE ESTE MODULO AL MODULO 'BS_table' ////
	Tabla = check_and_cast<BS_table *>(this->getParentModule()->gate("physicalUser$o")->getNextGate()->getOwnerModule()->getSubmodule("bs_table")); // ENTRAMOS Y CHEQUEAMOS EL MODULO BS_TABLE

	// INICIALIZACION PARAMETROS:
	////ev << " User[" << this->getParentModule()->getIndex() << "] conectado a la BS[" << bs_owner->getIndex() << "]" << endl;
	packetSize_user = (int) this->getParentModule()->par("longitud_media_paquete");  // TAMANYO DEL PAQUETE (BYTES) FIJO PARA LA FUENTE EXPONENCIAL Y LA SELF-SIMILAR
	txrate = (double) this->getParentModule()->par("tasabinaria"); // Tasa de Tx (en bps)
	double carga = (double) this->getParentModule()->getParentModule()->par("carga_nodo");
	//ev << " Longitud media de los paquetes inalambricos: "<< packetSize_user << "B" << endl;
	tamsumpop_user.resize((int)par("numcolas"),0); // Suma de los Bytes de los paquetes extraidos de las colas
	suma_tam_packets_user = 0; // Suma total del tamanyo (en Bytes) de los paquetes generados por el usuario
	total_load_user = 0.0; // Carga total del nodo del usuario
	time_creation_user = (simtime_t) 0; // Tiempo de creacion
	// Suma total de los Bytes de los paquetes insertados en las colas
	suma_total_user = 0;
	tamsumqueue_user = 0;

	packet_64_user = 0;
	packet_594_user = 0;
	packet_1500_user = 0;
	totalpacket_user = 0;
	//ev << " Carga de la fuente n." << getIndex() << " del usuario[" << this->getParentModule()->getIndex() << "]: " << carga << endl;
	channel_bit_rate = carga*txrate;
	lambda = channel_bit_rate/(packetSize_user*8);
	//lambda = channel_bit_rate/(suma_tam_packets_user*8);
	//lambda = inf;
	//ev << " Valor inicial de lambda: " << lambda << endl;
	inv_lambda = (packetSize_user*8)/channel_bit_rate;
	//inv_lambda = (suma_tam_packets_user*8)/channel_bit_rate;
	//inv_lambda = 0;
	//ev << " Valor inicial de la media exponencial: " << inv_lambda << endl;
	//lambda = txrate/(packetSize_user*8);
	//inv_lambda = (packetSize_user*8)/txrate;
	volcado = 0; // Variable auxiliar para entrar en la funcion VolcadoFicheros() una vez
	contador = 0; // Variable auxiliar para entrar en la funcion VolcadoFicheros() periodicamente
	cuenta_ruta = 0;
	k_paths = (int) this->getParentModule()->par("numGW");
	opcion_caminos = (int) this->getParentModule()->par("caminos");
 // DESCOMENTAR ESTE CODIGO SI SE QUIERE GENERAR TRAFICO SELF-SIMILAR EN LA PARTE INALAMBRICA //
	/*
	load_dmb_user.resize((int)this->getParentModule()->par("numcolas"),0);

	double carga = (double) this->getParentModule()->getParentModule()->par("carga_nodo"); // Carga de las Fuentes de Pareto.


	if((int)this->getParentModule()->par("numcolas")==1)
	{
		// El usuario tiene un solo servicio:
		load_dmb_user[getIndex()] = carga;
		//ev << " CARGA DE LAS FUENTES DEL USUARIO: " << load_dmb_user[getIndex()] << endl;
	}
	else if((int)this->getParentModule()->par("numcolas")>=2)
	{
		// El usuario tiene mas de un servicio:
		if(getIndex()==0)
		{
			// SERVICIO P0
			//ev << " CARGA DE LAS FUENTES DEL USUARIO: 0.0448" << endl;
		}
		else if(getIndex()>=1)
		{
			load_dmb_user[getIndex()] = carga; // VARIABLE CARGA DEL NODO DE LA ONU Y LA VISUALIZAMOS POR PANTALLA
			ev<<" CARGA DE LAS FUENTES DEL USUARIO: "<<load_dmb_user[getIndex()]<<endl;
		}
	}

	int flujos = (int)this->getParentModule()->par("user_numstreamV2_32_128_256"); // NUMERO DE FUENTES O SUB-STREAMS
	int metodo_generador = (int)this->getParentModule()->par("user_longpacketfixed0_trimodal1"); // PARAMETRO PARA DEFINIR LA LONGITUD O TAMANYO DE LOS PAQUETES DE LA RED ( LONGITUD O TAMANYO DE LOS PAQUETES DE LA RED FIJA O LONGITUD O TAMANYO DE LOS PAQUETES DE LA RED TRIMODAL )

	pAG_user = new Generator; // PUNTERO PARA EL GENERADOR
	// COMPARAMOS CON EL SWITCH EL METODO CON EL QUE TRABAJA EL GENERADOR ( MONOMODAL O TRIMODAL )
	switch(metodo_generador)
	{
		case 0:
			// MONOMODAL-> 1 SERVICIO
			//ev << " " << flujos << " flujos self-similar" << endl;
			// pAG_user = new Generator; // PUNTERO PARA EL GENERADOR
			for(int src=0; src<flujos; src++)
			{
				pAG_user->AddSource(new SourcePareto(src, 0, packetSize_user, 0, carga/flujos, 1.4, 1.2));
			}
			break;

		case 1:
			// TRIMODAL-> 3 SERVICIOS
			switch(flujos)
			{
				case 32:
				//	//ev << " Numero de flujos self-similar: 32" << endl;
					//pAG_user = new Generator; // PUNTERO PARA EL GENERADOR
					// MEDIANTE EL BUCLE FOR REPARTIMOS LAS FUENTES O STREAMS PARA GENERAR PAQUETES DE VARIOS TAMANYOS O LONGITUDES
					for(int src=0; src<flujos; src++)
					{
						if(src<3)
						{
							packetSize_user = 64;
							pAG_user->AddSource(new SourcePareto(src, 0, packetSize_user, 0, carga/flujos, 1.4, 1.2));
						}
						else if(src>=3 && src<8)
						{
							packetSize_user = 594;
							pAG_user->AddSource(new SourcePareto(src, 0, packetSize_user, 0, carga/flujos, 1.4, 1.2));
						}
						else if(src>=8)
						{
							packetSize_user = 1500;
							pAG_user->AddSource(new SourcePareto(src, 0, packetSize_user, 0, carga/flujos, 1.4, 1.2));
						}
					}
					break;

				case 128:
				//	//ev << " Numero de flujos self-similar: 128" << endl;
					// MEDIANTE EL BUCLE FOR REPARTIMOS LAS FUENTES O STREAMS PARA GENERAR PAQUETES DE VARIOS TAMANYOS O LONGITUDES
					for(int src=0; src<flujos; src++)
					{
						if(src<12)
						{
							packetSize_user = 64;
							pAG_user->AddSource(new SourcePareto(src, 0, packetSize_user, 0, carga/flujos, 1.4, 1.2));
						}
						else if(src>=12 && src<32)
						{
							packetSize_user = 594;
							pAG_user->AddSource(new SourcePareto(src, 0, packetSize_user, 0, carga/flujos, 1.4, 1.2));
						}
						else if(src>=32)
						{
							packetSize_user = 1500;
							pAG_user->AddSource(new SourcePareto(src, 0, packetSize_user, 0, carga/flujos, 1.4, 1.2));
						}
					}
					break;

				case 256:
				//	//ev << " Numero de flujos self-similar: 256" << endl;
					//pAG_user = new Generator; // PUNTERO PARA EL GENERADOR
					// MEDIANTE EL BUCLE FOR REPARTIMOS LAS FUENTES O STREAMS PARA GENERAR PAQUETES DE VARIOS TAMANYOS O LONGITUDES
					for(int src=0; src<flujos; src++)
					{
						if(src<24)
						{
							packetSize_user = 64;
							pAG_user->AddSource(new SourcePareto(src, 0, packetSize_user, 0, carga/flujos, 1.4, 1.2));
						}
						else if(src>=24 && src<64)
						{
							packetSize_user = 594;
							pAG_user->AddSource(new SourcePareto( src, 0, packetSize_user, 0, carga/flujos, 1.4, 1.2));
						}
						else if(src>=64)
						{
							packetSize_user = 1500;
							pAG_user->AddSource(new SourcePareto(src, 0, packetSize_user, 0, carga/flujos, 1.4, 1.2));
						}
					}
					break;
			}
	}
	*/
	// DESCOMENTAR ESTE CODIGO SI SE QUIERE GENERAR TRAFICO SELF-SIMILAR EN LA PARTE INALAMBRICA //

	//int gateway = check_and_cast<BS_rx_tx *>(this->getParentModule()->gate("physicalUser$o")->getNextGate()->getOwnerModule()->getSubmodule("bs_rx_tx"))->esPasarela;
	/////// ACTIVAR ///////
	/*
	if(opcion_caminos!=2 && gateway==0)
	{
		cMessage *msg = new cMessage("Auto",0);
		scheduleAt((simtime_t)0,msg);
	}
	else if(opcion_caminos==2 && this->getParentModule()->getIndex()==0)
	{
		cMessage *msg = new cMessage("Auto",0);
		scheduleAt((simtime_t)0,msg);
	}
	*/
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//										  UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O  	//
//										  EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//										  DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL	//
//										  CODIGO IMPLEMENTADO.																	//                                                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void User_traffic::handleMessage(cMessage *msg)
{
	// VARIABLES
	int type = msg->getKind();
	// double buffer = (double) this->getParentModule()->par("buffer_size"); // Tamanyo del buffer (MB)
	//int priority = getIndex(); // Prioridad asignada por el identificador de la fuente que se crea
	int metodo = (int) this->par("user_insercionmethod_separatequeue0_priorityqueue1");

	// PARAMETROS IMPORTANTES PARA EL PAQUETE INALAMBRICO:
	int indice = (int) this->getParentModule()->getIndex(); // Este es el usuario user[indice]
	cModule *bsdestino; // El destinatario de este mensaje es la estacion base a la que se conecta el usuario
	bsdestino = this->getParentModule()->gate("physicalUser$o")->getNextGate()->getOwnerModule();
	char* name_dest; // Nombre del tipo de modulo (BS)
	char* dest; // Nombre del modulo (bsx)
	name_dest = (char*)bsdestino->getModuleType()->getName();
	dest = (char*) bsdestino->getFullName();
	int dir_dest = (int) bsdestino->par("indice");
	//int dir_dest = (int) bsdestino->getIndex(); /////// CAMBIO_RED ///////
	// Longitud del canal que coencta a este usuario con la BS correspondiente:
	double length = (double) this->getParentModule()->gate("physicalUser$o")->getChannel()->par(2);

	switch (type)
	{
		case 0: // Si se ha recibido un automensaje (tipo = 0):
			if (type==0)
			{
				// Si existe una sola cola para los paquetes de los usuarios:
				if((int) this->getParentModule()->par("numcolas") == 1)
				{
					// DESCOMENTAR ESTE CODIGO SI SE QUIERE GENERAR TRAFICO SELF-SIMILAR EN LA PARTE INALAMBRICA //
					/*
					Generator &AG = *pAG_user;
					AG.GetNextPacket();
					Trace trc = AG.PeekNextPacket();
					bytestamp_t tiempo = AG.GetTime();
					bytestamp_t ByteStamp = AG.GetByteStamp();
					bytestamp_t intervalo = ByteStamp - tiempo;
					simtime_t interarrivaltime = (simtime_t)(intervalo*8/channel_bit_rate);
					*/
					// DESCOMENTAR ESTE CODIGO SI SE QUIERE GENERAR TRAFICO SELF-SIMILAR EN LA PARTE INALAMBRICA //

					// Creacion del paquete inalambrico tipo DATA, para enviarlo a la BS mas cercana:
					DATA *datos = new DATA("Datos",12);

					// Obtencion de la ruta por la que encaminar los mensajes de este usuario:
					int tam_ruta, ruta_encontrada;
					switch(opcion_caminos)
					{
					case 0: // Un unico camino optimo, el de la tabla 'rutas_optimas'
						tam_ruta = get_index_last_element(indice);
						datos->setRutaArraySize(tam_ruta);
						for(int y=0; y<tam_ruta; y++)
						{
							// NOTA: El usuario no se incluye en el campo 'ruta'
							datos->setRuta(y,Tabla->rutas_optimas[indice][y+1]);
						}
						break;
					case 1: // Hasta k caminos, los de las k tablas 'rutas_optimas_pasarelas' (k=num_pasarelas)
						ruta_encontrada = -1;
						while(ruta_encontrada<0)
						{
							if(cuenta_ruta < k_paths)
							{
								if(strcmp(Tabla->rutas_optimas_pasarelas[cuenta_ruta][indice][0]," ")!=0)
								{
									ruta_encontrada = cuenta_ruta;
								}
								cuenta_ruta++;
							}
							else
							{
								cuenta_ruta=0;
							}
						}

						tam_ruta = get_index_last_element_k(ruta_encontrada, indice);
						datos->setRutaArraySize(tam_ruta);
						for(int y=0; y<tam_ruta; y++)
						{
							// NOTA: El usuario no se incluye en el campo 'ruta'
							datos->setRuta(y,Tabla->rutas_optimas_pasarelas[ruta_encontrada][indice][y+1]);
						}
						break;
					case 2: // Opcion de fijar el camino mas largo (para pruebas entre bs0 y bs7)
						tam_ruta = get_index_last_element(indice);
						datos->setRutaArraySize(tam_ruta);
						for(int y=0; y<tam_ruta; y++)
						{
							// NOTA: El usuario no se incluye en el campo 'ruta'
							datos->setRuta(y,Tabla->rutas_optimas[indice][y+1]);
						}
						/*
						// O tambien vale tomar la ruta para el user[0] de la tabla con las rutas optimas
						// para la pasarela bs7: "rutas_optimas_pasarelas[0][0].size()".
						ruta_encontrada = 0; //k_paths - 1;
						tam_ruta = get_index_last_element_k(ruta_encontrada, indice);
						datos->setRutaArraySize(tam_ruta);
						for(int y=0; y<tam_ruta; y++)
						{
							// NOTA: El usuario no se incluye en el campo 'ruta'
							datos->setRuta(y,Tabla->rutas_optimas_pasarelas[ruta_encontrada][indice][y+1]);
						}
						*/
						break;
					default:
						break;
					}
					double path_weight = (double)check_and_cast<BS_mac *>(this->getParentModule()->gate("physicalUser$o")->getNextGate()->getOwnerModule()->getSubmodule("bs_mac"))->auxiliar_array[this->getParentModule()->getIndex()];
					datos->setPeso(path_weight);
					// Indice de la direccion del origen (el usuario) --> NO SE CAMBIA EN CADA SALTO:
					datos->setSrcAddress(indice);
					// Indice de la direccion de destino --> SI SE CAMBIA EN CADA SALTO:
					datos->setDestAddress(dir_dest);
					// Uso el campo 'Data' del paquete para almacenar la distancia recorrida (en metros):
					datos->setMetros(length);
					// Uso el campo 'Saltos' del paquete para almacenar el numero de saltos recorridos:
					datos->setSaltos(0); // NOTA: NO cuento user->bs como el primer salto
					// Grabacion del tiempo de creacion del paquete en el campo 'timestamp':
					time_creation_user = (simtime_t) simTime();
					datos->setTimestamp(time_creation_user);
					// Uso el campo 'UserOrigin' del paquete para almacenar el nombre del usuario origen (NO SE CAMBIA):
					datos->setUserOrigin(this->getParentModule()->getFullName());
					// Nombre completo del nodo anterior que (re)envia el mensaje (SI SE CAMBIA):
					datos->setOrigen(this->getParentModule()->getFullName());
					// Nombre completo del siguiente nodo receptor del mensaje (SI SE CAMBIA):
					datos->setDestino(dest);
					// Longitud del paquete (en bytes):
						//datos->setByteLength(trc.PacketSize); // DESCOMENTAR ESTE CODIGO SI SE QUIERE GENERAR TRAFICO SELF-SIMILAR EN LA PARTE INALAMBRICA //
					datos->setByteLength(poisson(packetSize_user));

					longitud_user.analyze((double)datos->getByteLength());
					// Prioridad e Id. de servicio (coincide con el indice de la fuente):
					datos->setPriority(getIndex());

					// Calculo de la suma total del tamanyo (en Bytes) de los paquetes generados por el usuario:
					suma_tam_packets_user = suma_tam_packets_user + (double) datos->getByteLength();
					totalpacket_user++; // SUMA TOTAL DE TODOS LOS PAQUETES CREADOS POR LA ONU

					/* Tiempo entre envios exponencial */
					// PROGRAMACION DE UN AUTOMENSAJE (ENVIO DEL MISMO 'msg'):
					// exp(1/lambda) -> 1/lambda [s] = segundos/paquetes -> depende de la tasa de transmisión
					simtime_t interarrivaltime = (simtime_t) exponential(inv_lambda);
					// El tiempo entre llegadas tiene una distribuci�n exponencial con media E[t]=1/lambda.
					simtime_t next_time = simTime() + interarrivaltime;
					scheduleAt(next_time,msg);

					// IMPRESION POR PANTALLA DE ALGUNOS PARAMETROS DEL MENSAJE:
					//ev << " Generacion de un nuevo paquete de datos del usuario inalambrico 'User[" << this->getParentModule()->getIndex() << "]', de longitud " << datos->getByteLength() << " Bytes." << endl;
					////ev << " 	Identificador: " << datos->getId() << endl;
					////ev << " 	Prioridad: " << datos->getPriority() << endl;
					////ev << " 	Longitud: " << datos->getByteLength() << " Bytes" << endl;

						//ev << " 	Ruta completa a seguir: " << this->getParentModule()->getFullName() << " | ";
						//for(int y=0; y<tam_ruta; y++){ ev << datos->getRuta(y) << " | "; }
						//ev << endl;

						// Calculo de la carga del nodo del usuario y visualizacion cada vez que se genera un paquete 'DATA' nuevo:
					double tiempo_creacion_usuario = (double) SIMTIME_DBL(time_creation_user);
					total_load_user = (double) (suma_tam_packets_user * 8/(tiempo_creacion_usuario*txrate)); // Formula para calcular la carga del nodo del usuario
					//total_load_user = (double) (suma_tam_packets_user * 8/(tiempo_creacion_usuario*channel_bit_rate)); // Formula para calcular la carga del nodo del usuario
					//ev << " 	Carga Total de la fuente n." << this->getIndex() << " del " << this->getParentModule()->getFullName() << ": " << total_load_user << "" << endl;
					//ev << " Tiempo de generacion del proximo paquete: " << SIMTIME_DBL(next_time) << endl;

					if(simTime()>0.5)
					{
						//RECOGIDA DE ESTADISTICAS DE LA CARGA TOTAL
						carga_user.analyze((double)total_load_user);
					}

					if(datos->getByteLength()==64)
					{
						// PAQUETES CREADOS DE 64 BYTES
						packet_64_user++;
					}
					else if(datos->getByteLength()==594)
					{
						// PAQUETES CREADOS DE 594 BYTES
						packet_594_user++;
					}
					else if(datos->getByteLength()==1500)
					{
						// PAQUETES CREADOS DE 1500 BYTES
						packet_1500_user++;
					}

					// ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA EL METODO DE INSERCION DE PAQUETES DE LAS COLAS
					switch(metodo)
					{
						case 0:
							// Llamada a la funcion0000015 del metodo de insercion paquetes de colas separadas:
							separatequeue(datos);
							break;

						case 1:
							// Llamada a la funcion del metodo de insercion de paquetes de prioridad de colas:
							priorityqueue(datos);
							break;

						default:
							//ev<<" ERROR AL ELEGIR EL METODO DE INSERCION EN LAS COLAS, ELEGIR 0 o 1."<<endl;
							delete datos;
							//ev << " MENSAJE BORRADO" << endl;
							break;
					}
				}
				else if((int) this->getParentModule()->par("numcolas") >= 2)
				{
					if(getIndex() == 0)
					{
						// FUENTE CONSTANTE DE PAQUETES DE 70 BYTES QUE SE MANDAN CADA 125us
						// Creacion del paquete tipo DATA, para enviarlo a la BS mas cercana:
						//ETHERNETmsg *datos = new ETHERNETmsg("Datos",12);
						DATA *datos = new DATA("Datos",12);

						// Obtencion de la ruta por la que encaminar los mensajes de este usuario:
						int tam_ruta, ruta_encontrada;
						switch(opcion_caminos)
						{
						case 0: // Un unico camino optimo, el de la tabla 'rutas_optimas'
							tam_ruta = get_index_last_element(indice);
							datos->setRutaArraySize(tam_ruta);
							for(int y=0; y<tam_ruta; y++)
							{
								// NOTA: El usuario no se incluye en el campo 'ruta'
								datos->setRuta(y,Tabla->rutas_optimas[indice][y+1]);
							}
							break;
						case 1: // Hasta k caminos, los de las k tablas 'rutas_optimas_pasarelas' (k=num_pasarelas)
							ruta_encontrada = -1;
							while(ruta_encontrada<0)
							{
								if(cuenta_ruta < k_paths)
								{
									if(strcmp(Tabla->rutas_optimas_pasarelas[cuenta_ruta][indice][0]," ")!=0)
									{
										ruta_encontrada = cuenta_ruta;
									}
									cuenta_ruta++;
								}
								else
								{
									cuenta_ruta=0;
								}
							}
							tam_ruta = get_index_last_element_k(ruta_encontrada, indice);
							datos->setRutaArraySize(tam_ruta);
							for(int y=0; y<tam_ruta; y++)
							{
								// NOTA: El usuario no se incluye en el campo 'ruta'
								datos->setRuta(y,Tabla->rutas_optimas_pasarelas[ruta_encontrada][indice][y+1]);
							}
							break;
						case 2: // Opcion de fijar el camino mas largo (para pruebas entre bs0 y bs7)
							tam_ruta = get_index_last_element(indice);
							datos->setRutaArraySize(tam_ruta);
							for(int y=0; y<tam_ruta; y++)
							{
								// NOTA: El usuario no se incluye en el campo 'ruta'
								datos->setRuta(y,Tabla->rutas_optimas[indice][y+1]);
							}
							/*
							// O tambien vale tomar la ruta para el user[0] de la tabla con las rutas optimas
							// para la pasarela bs7: "rutas_optimas_pasarelas[0][0].size()".
							ruta_encontrada = 0; //k_paths - 1;
							tam_ruta = get_index_last_element_k(ruta_encontrada, indice);
							datos->setRutaArraySize(tam_ruta);
							for(int y=0; y<tam_ruta; y++)
							{
								// NOTA: El usuario no se incluye en el campo 'ruta'
								datos->setRuta(y,Tabla->rutas_optimas_pasarelas[ruta_encontrada][indice][y+1]);
							}
							*/
							break;
						default:
							break;
						}
						double path_weight = (double)check_and_cast<BS_mac *>(this->getParentModule()->gate("physicalUser$o")->getNextGate()->getOwnerModule()->getSubmodule("bs_mac"))->auxiliar_array[this->getParentModule()->getIndex()];
						datos->setPeso(path_weight);
						// Indice de la direccion del origen (el usuario) --> NO SE CAMBIA EN CADA SALTO:
						datos->setSrcAddress(indice);
						// Indice de la direccion de destino --> SI SE CAMBIA EN CADA SALTO:
						datos->setDestAddress(dir_dest);
						// Uso el campo 'Metros' del paquete para almacenar la distancia recorrida (en metros):
						datos->setMetros(length);
						// Uso el campo 'Saltos' del paquete para almacenar el numero de saltos recorridos:
						datos->setSaltos(0); // NOTA: NO cuento user->bs como el primer salto
						// Grabacion del tiempo de creacion del paquete en el campo 'timestamp':
						time_creation_user = (simtime_t) simTime();
						datos->setTimestamp(time_creation_user);
						// Uso el campo 'UserOrigin' del paquete para almacenar el nombre del usuario origen (NO SE CAMBIA):
						datos->setUserOrigin(this->getParentModule()->getFullName());
						// Nombre completo del nodo anterior que (re)envia el mensaje (SI SE CAMBIA):
						datos->setOrigen(this->getParentModule()->getFullName());
						// Nombre completo del siguiente nodo receptor del mensaje (SI SE CAMBIA):
						datos->setDestino(dest);
						// Longitud del mensaje:
							//datos->setByteLength(70); // DESCOMENTAR ESTE CODIGO SI SE QUIERE GENERAR TRAFICO SELF-SIMILAR EN LA PARTE INALAMBRICA //
						datos->setByteLength(poisson(packetSize_user));
						longitud_user.analyze((double)datos->getByteLength());
						// Prioridad e Id. de servicio (coincide con el indice de la fuente):
						datos->setPriority(getIndex());

						// Calculo de la suma total del tamanyo (en Bytes) de los paquetes generados por el usuario:
						suma_tam_packets_user = suma_tam_packets_user + (double) datos->getByteLength();
						totalpacket_user++; // SUMA TOTAL DE TODOS LOS PAQUETES CREADOS POR LA ONU

						/* Tiempo entre envios exponencial */
						// PROGRAMACION DE UN AUTOMENSAJE (ENVIO DEL MISMO 'msg'):
						// lambda*exp(1/lambda) -> 1/lambda [s] = segundos/paquetes -> depende de la tasa de transmisión
						simtime_t interarrivaltime = (simtime_t) exponential(inv_lambda);
						// El tiempo entre llegadas tiene una distribuci�n exponencial con media E[t]=1/lambda.
						simtime_t next_time = simTime() + interarrivaltime;
						scheduleAt(next_time,msg);

						// IMPRESION POR PANTALLA DE ALGUNOS PARAMETROS DEL MENSAJE:
						//ev << " Generacion de un nuevo paquete de datos del usuario inalambrico 'User[" << this->getParentModule()->getIndex() << "]', de longitud " << datos->getByteLength() << " Bytes." << endl;
						////ev << " 	Identificador: " << datos->getId() << endl;
						////ev << " 	Prioridad: " << datos->getPriority() << endl;
						////ev << " 	Longitud: " << datos->getByteLength() << " Bytes" << endl;

							//ev << " 	Ruta completa a seguir: " << this->getParentModule()->getFullName() << " | ";
							//for(int y=0; y<tam_ruta; y++){ ev << datos->getRuta(y) << " | "; }
							//ev << endl;

						// Calculo de la carga del nodo del usuario y visualizacion cada vez que se genera un paquete 'DATA' nuevo:
						double tiempo_creacion_usuario = (double) SIMTIME_DBL(time_creation_user);
						total_load_user = (double) (suma_tam_packets_user * 8/(tiempo_creacion_usuario*txrate)); // Formula para calcular la carga del nodo del usuario
						//total_load_user = (double) (suma_tam_packets_user * 8/(tiempo_creacion_usuario*channel_bit_rate)); // Formula para calcular la carga del nodo del usuario
						//ev << " 	Carga Total de la fuente n." << this->getIndex() << " del " << this->getParentModule()->getFullName() << ": " << total_load_user << "" << endl;
						//ev << " Tiempo de generacion del proximo paquete: " << SIMTIME_DBL(next_time) << endl;

						if(simTime()>0.5)
						{
							//RECOGIDA DE ESTADISTICAS DE LA CARGA TOTAL
							carga_user.analyze((double)total_load_user);
						}
						// ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA EL METODO DE INSERCION DE PAQUETES DE LAS COLAS
						switch(metodo)
						{
							case 0:
								// Llamada a la funcion del metodo de insercion paquetes de colas separadas:
								separatequeue(datos);
								break;

							case 1:
								// Llamada a la funcion del metodo de insercion de paquetes de prioridad de colas:
								priorityqueue(datos);
								break;

							default:
								//ev<<" ERROR AL ELEGIR EL METODO DE INSERCION EN LAS COLAS, ELEGIR 0 o 1."<<endl;
								delete datos;
								//ev << " MENSAJE BORRADO" << endl;
								break;
						}
					}
					else if(getIndex() >= 1)
					{
						// DESCOMENTAR ESTE CODIGO SI SE QUIERE GENERAR TRAFICO SELF-SIMILAR EN LA PARTE INALAMBRICA //
						/*
						Generator &AG = *pAG_user;
						AG.GetNextPacket();
						Trace trc = AG.PeekNextPacket();
						bytestamp_t tiempo = AG.GetTime();
						bytestamp_t ByteStamp = AG.GetByteStamp();
						bytestamp_t intervalo = ByteStamp - tiempo;
						simtime_t interarrivaltime = (simtime_t)(intervalo*8/channel_bit_rate);
						*/
						// DESCOMENTAR ESTE CODIGO SI SE QUIERE GENERAR TRAFICO SELF-SIMILAR EN LA PARTE INALAMBRICA //

						// Creacion del paquete tipo DATA, para enviarlo a la BS mas cercana:
						//ETHERNETmsg *datos = new ETHERNETmsg("Datos",12);
						DATA *datos = new DATA("Datos",12);

						// Obtencion de la ruta por la que encaminar los mensajes de este usuario:
						int tam_ruta, ruta_encontrada;
						switch(opcion_caminos)
						{
						case 0: // Un unico camino optimo, el de la tabla 'rutas_optimas'
							tam_ruta = get_index_last_element(indice);
							datos->setRutaArraySize(tam_ruta);
							for(int y=0; y<tam_ruta; y++)
							{
								// NOTA: El usuario no se incluye en el campo 'ruta'
								datos->setRuta(y,Tabla->rutas_optimas[indice][y+1]);
							}
							break;
						case 1: // Hasta k caminos, los de las k tablas 'rutas_optimas_pasarelas' (k=num_pasarelas)
							ruta_encontrada = -1;
							while(ruta_encontrada<0)
							{
								if(cuenta_ruta < k_paths)
								{
									if(strcmp(Tabla->rutas_optimas_pasarelas[cuenta_ruta][indice][0]," ")!=0)
									{
										ruta_encontrada = cuenta_ruta;
									}
									cuenta_ruta++;
								}
								else
								{
									cuenta_ruta=0;
								}
							}
							tam_ruta = get_index_last_element_k(ruta_encontrada, indice);
							datos->setRutaArraySize(tam_ruta);
							for(int y=0; y<tam_ruta; y++)
							{
								// NOTA: El usuario no se incluye en el campo 'ruta'
								datos->setRuta(y,Tabla->rutas_optimas_pasarelas[ruta_encontrada][indice][y+1]);
							}
							break;
						case 2: // Opcion de fijar el camino mas largo (para pruebas entre bs0 y bs7)
							tam_ruta = get_index_last_element(indice);
							datos->setRutaArraySize(tam_ruta);
							for(int y=0; y<tam_ruta; y++)
							{
								// NOTA: El usuario no se incluye en el campo 'ruta'
								datos->setRuta(y,Tabla->rutas_optimas[indice][y+1]);
							}
							/*
							// O tambien vale tomar la ruta para el user[0] de la tabla con las rutas optimas
							// para la pasarela bs7: "rutas_optimas_pasarelas[0][0].size()".
							ruta_encontrada = 0; //k_paths - 1;
							tam_ruta = get_index_last_element_k(ruta_encontrada, indice);
							datos->setRutaArraySize(tam_ruta);
							for(int y=0; y<tam_ruta; y++)
							{
								// NOTA: El usuario no se incluye en el campo 'ruta'
								datos->setRuta(y,Tabla->rutas_optimas_pasarelas[ruta_encontrada][indice][y+1]);
							}
							*/
							break;
						default:
							break;
						}
						double path_weight = (double)check_and_cast<BS_mac *>(this->getParentModule()->gate("physicalUser$o")->getNextGate()->getOwnerModule()->getSubmodule("bs_mac"))->auxiliar_array[this->getParentModule()->getIndex()];
						datos->setPeso(path_weight);

						// Indice de la direccion del origen (el usuario) --> NO SE CAMBIA EN CADA SALTO:
						datos->setSrcAddress(indice);
						// Indice de la direccion de destino --> SI SE CAMBIA EN CADA SALTO:
						datos->setDestAddress(dir_dest);
						// Uso el campo 'Metros' del paquete para almacenar la distancia recorrida (en metros):
						datos->setMetros(length);
						// Uso el campo 'Saltos' del paquete para almacenar el numero de saltos recorridos:
						datos->setSaltos(0); // NOTA: NO cuento user->bs como el primer salto
						// Grabacion del tiempo de creacion del paquete en el campo 'timestamp':
						time_creation_user = (simtime_t) simTime();
						datos->setTimestamp(time_creation_user);
						// Uso el campo 'UserOrigin' del paquete para almacenar el nombre del usuario origen (NO SE CAMBIA):
						datos->setUserOrigin(this->getParentModule()->getFullName());
						// Nombre completo del nodo anterior que (re)envia el mensaje (SI SE CAMBIA):
						datos->setOrigen(this->getParentModule()->getFullName());
						// Nombre completo del siguiente nodo receptor del mensaje (SI SE CAMBIA):
						datos->setDestino(dest);
						// Longitud del paquete (en bytes):
							//datos->setByteLength(trc.PacketSize); // DESCOMENTAR ESTE CODIGO SI SE QUIERE GENERAR TRAFICO SELF-SIMILAR EN LA PARTE INALAMBRICA //
						datos->setByteLength(poisson(packetSize_user));
						longitud_user.analyze((double)datos->getByteLength());
						// Prioridad e Id. de servicio (coincide con el indice de la fuente):
						datos->setPriority(getIndex());

						// Calculo de la suma total del tamanyo (en Bytes) de los paquetes generados por el usuario:
						suma_tam_packets_user = suma_tam_packets_user + (double) datos->getByteLength();
						totalpacket_user++; // SUMA TOTAL DE TODOS LOS PAQUETES CREADOS POR LA ONU

						/* Tiempo entre envios exponencial */
						// PROGRAMACION DE UN AUTOMENSAJE (ENVIO DEL MISMO 'msg'):
						// exp(1/lambda) -> 1/lambda [s] = segundos/paquetes -> depende de la tasa de transmisión
						simtime_t interarrivaltime = (simtime_t) exponential(inv_lambda);
						// El tiempo entre llegadas tiene una distribuci�n exponencial con media E[t]=1/lambda.
						simtime_t next_time = simTime() + interarrivaltime;
						scheduleAt(next_time,msg);

						//ev << " Generacion de un nuevo paquete de datos del usuario inalambrico 'User[" << this->getParentModule()->getIndex() << "]', de longitud " << datos->getByteLength() << " Bytes." << endl;
						////ev << " 	Identificador: " << datos->getId() << endl;
						////ev << " 	Prioridad: " << datos->getPriority() << endl;
						////ev << " 	Longitud: " << datos->getByteLength() << " Bytes" << endl;

							//ev << " 	Ruta completa a seguir: " << this->getParentModule()->getFullName() << " | ";
							//for(int y=0; y<tam_ruta; y++){ ev << datos->getRuta(y) << " | "; }
							//ev << endl;

						// Calculo de la suma total del tamanyo (en Bytes) de los paquetes generados por el usuario:
							//suma_tam_packets_user = suma_tam_packets_user + (double) trc.PacketSize;

						// Calculo de la carga del nodo del usuario y visualizacion cada vez que se genera un paquete 'DATA' nuevo:

						double tiempo_creacion_usuario = (double) SIMTIME_DBL(time_creation_user);
						total_load_user = (double) (suma_tam_packets_user * 8/(tiempo_creacion_usuario*txrate)); // Formula para calcular la carga del nodo del usuario
						//total_load_user = (double) (suma_tam_packets_user * 8/(tiempo_creacion_usuario*channel_bit_rate)); // Formula para calcular la carga del nodo del usuario
						//ev << " 	Carga Total de la fuente n." << this->getIndex() << " del " << this->getParentModule()->getFullName() << ": " << total_load_user << "" << endl;
						//ev << " Tiempo de generacion del proximo paquete: " << SIMTIME_DBL(next_time) << endl;

						if(simTime()>0.5)
						{
							//RECOGIDA DE ESTADISTICAS DE LA CARGA TOTAL
							carga_user.analyze((double)total_load_user);
						}
						if(datos->getByteLength()==64)
						{
							// PAQUETES CREADOS DE 64 BYTES
							packet_64_user++;
						}
						else if(datos->getByteLength()==594)
						{
							// PAQUETES CREADOS DE 594 BYTES
							packet_594_user++;
						}
						else if(datos->getByteLength()==1500)
						{
							// PAQUETES CREADOS DE 1500 BYTES
							packet_1500_user++;
						}

						// ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA EL METODO DE INSERCION DE PAQUETES DE LAS COLAS
						switch(metodo)
						{
							case 0:
								// Llamada a la funcion del metodo de insercion paquetes de colas separadas:
								separatequeue(datos);
								break;

							case 1:
								// Llamada a la funcion del metodo de insercion de paquetes de prioridad de colas:
								priorityqueue(datos);
								break;

							default:
								//ev<<" ERROR AL ELEGIR EL METODO DE INSERCION EN LAS COLAS, ELEGIR 0 o 1."<<endl;
								delete datos;
								//ev << " MENSAJE BORRADO" << endl;
								break;
						}
					}
				}
			}
			break;

		default: // En cualquier otro caso:
				delete msg;
				//ev << " MENSAJE BORRADO" << endl;
				break;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION GET_INDEX_LAST_ELEMENT(INT ROW)--> DEVUELVE EL INDICE DE LA ULTIMA COLUMNA OCUPADA EN UNA DETERMINADA /
//											 FILA DE LA TABLA 'RUTAS_OPTIMAS'. 								 	/
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int User_traffic::get_index_last_element(int row)
{
	// El primer elemento es el usuario, luego podriamos empezar por i=1
	int i=1, encontrado = 0, ocupado, vacio, indice=1;
	while(encontrado == 0 && i<Tabla->columnas)
	{
		ocupado = strcmp(" ", Tabla->rutas_optimas[row][i]);
		vacio = strcmp(" ", Tabla->rutas_optimas[row][i + 1]);
		if(ocupado !=0 && vacio ==0)
		{
			encontrado = 1;
			indice = i;
		}
		i++;
	}
	return indice;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION GET_INDEX_LAST_ELEMENT_K(INT INDEX, INT ROW)--> DEVUELVE EL INDICE DE LA ULTIMA COLUMNA OCUPADA EN UNA DETERMINADA	/
//											   			  FILA DE LA TABLA 'INDEX'-ESIMA DE LA MATRIZ 'RUTAS_OPTIMAS_K'.		/
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int User_traffic::get_index_last_element_k(int index, int row)
{
	// El primer elemento es el usuario, luego podriamos empezar por i=1
	int i=1, encontrado = 0, ocupado, vacio, indice=1;
	while(encontrado == 0 && i<Tabla->columnas)
	{
		ocupado = strcmp(" ", Tabla->rutas_optimas_pasarelas[index][row][i]);
		vacio = strcmp(" ", Tabla->rutas_optimas_pasarelas[index][row][i + 1]);
		if(ocupado !=0 && vacio ==0)
		{
			encontrado = 1;
			indice = i;
		}
		i++;
	}
	return indice;
}

///////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION SEPARATEQUEUE(CMESSAGE *MSG)--> METODO DE INSERCION DE PAQUETES EN COLAS SEPARADAS. /														/
///////////////////////////////////////////////////////////////////////////////////////////////
void User_traffic::separatequeue(cMessage *msg)
{
	////ev << " **Metodo de insercion de paquetes en colas separadas**" << endl;
	double buffer = (double) par("buffer_size"); // Longitud total del buffer (Bytes)
	double bloqueo;

	//ETHERNETmsg *msjdatos = check_and_cast<ETHERNETmsg*>(msg);
	DATA *msjdatos = check_and_cast<DATA*>(msg);

	// Acceso a los submodulos 'bs_rx_tx' y 'bs_queue[<loquetoque>]':
	rxtx_bs = check_and_cast<BS_rx_tx *>(this->getParentModule()->gate("physicalUser$o")->getNextGate()->getOwnerModule()->getSubmodule("bs_rx_tx"));
	// Numero de submodulos 'bs_queue'
	int long_puerta = (int) rxtx_bs->gateSize("queueRxTx");
	// Obtencion del nodo siguiente a la BS que recibe los paquetes de este usuario:
	char* nodo_siguiente = (char*) msjdatos->getRuta(1);
	// Obtencion del indice del modulo 'bs_queue' que nos interesa (aquel que almacena
	// los paquetes dirigidos al 'nodo_siguiente'):
	int j=0, found = -1;
	while(j<long_puerta && found<0)
	{
		cola_bs = check_and_cast<BS_queue *>(rxtx_bs->gate("queueRxTx$o",j)->getNextGate()->getOwnerModule());
		if(strcmp(nodo_siguiente,cola_bs->getTarget())==0)
		{
			found = j;
		}
		j++;
	}

	//buffer = buffer/cola_bs->colas_salida;///////

	/*
	//ev << " Intento de insercion de este paquete en la cola P" << this->getIndex() << " del modulo "
			<< (char*) msjdatos->getRuta(0) << "." << cola_bs->getFullName() << " con destino "
			<< cola_bs->getTarget() << endl;

	// Visualizacion por pantalla del numero de bytes presentes en la cola donde se quiere insertar el nuevo paquete:
	//ev << " 	Longitud de la cola P" << msjdatos->getPriority() << ", donde insertamos el paquete " << ": " << cola_bs->tamqueue[msjdatos->getPriority()] << " Bytes" << endl;
	*/

	// Comprobacion de si hay espacio suficiente o no en el buffer de esta cola:
	// Si hay espacio:
	if(buffer/(int)par("numcolas") >= (cola_bs->tamqueue[msjdatos->getPriority()] + msjdatos->getByteLength()))
	{
		////ev << " 	Como es MENOR que la longitud TOTAL de la cola (" << buffer/(int)par("numcolas") << " bytes) --> ENVIO PAQUETE" << endl;
		bloqueo=0.0; //ENVIO PAQUETE

		// Envio del paquete "msjdatos" a la interfaz del usuario:
		//cola_bs->tamqueue[msjdatos->getPriority()] = cola_bs->tamqueue[msjdatos->getPriority()] + msjdatos->getByteLength();
		//msjdatos->setTime_enter_queue(simTime());
		//cola_bs->queue[getIndex()].insert(msjdatos);
		send(msjdatos, "traffic");
	}
	// Si no hay espacio:
	else if(buffer/(int)par("numcolas") < (cola_bs->tamqueue[msjdatos->getPriority()] + msjdatos->getByteLength()))
	{
		////ev << " 	Como es MAYOR que la longitud TOTAL de la cola (" << buffer/(int)par("numcolas") << " bytes) --> BORRADO PAQUETE" << endl;
		bloqueo=1.0; //BORRADO PAQUETE
		// Borrado del mensaje "msjdatos" al no poderlo insertar en su cola por estar llena:
		delete msjdatos;
		//ev << " MENSAJE BORRADO" << endl;
		// INCREMENTO DE LA VARIABLE PARA CONTROLAR EL BORRADO DE PAQUETES EN LA PARTE INALAMBRICA:
		check_and_cast<BS_table *>(rxtx_bs->getParentModule()->getSubmodule("bs_table"))->paquetes_borrados++;
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION PRIORITYQUEUE(CMESSAGE *MSG)--> METODO DE INSERCION DE PAQUETES EN LAS COLAS TENIENDO SEGUN PRIORIDAD. /														/
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void User_traffic::priorityqueue(cMessage *msg)
{
	////ev << " **Metodo de insercion de paquetes en colas con prioridad**" << endl;
	double buffer = (double) par("buffer_size"); // Longitud total del buffer (Bytes)
	double bloqueo;

	//ETHERNETmsg *msjdatos = check_and_cast<ETHERNETmsg*>(msg);
	DATA *msjdatos = check_and_cast<DATA*>(msg);

	// Acceso a los submodulos 'bs_rx_tx' y 'bs_queue[<loquetoque>]':
	rxtx_bs = check_and_cast<BS_rx_tx *>(this->getParentModule()->gate("physicalUser$o")->getNextGate()->getOwnerModule()->getSubmodule("bs_rx_tx"));
	// Numero de submodulos 'bs_queue'
	int long_puerta = (int) rxtx_bs->gateSize("queueRxTx");
	// Obtencion del nodo siguiente a la BS que recibe los paquetes de este usuario (segundo elemento del array 'Ruta'):
	char* nodo_siguiente = (char*) msjdatos->getRuta(1);
	// Obtencion del indice del modulo 'bs_queue' que nos interesa (aquel que almacena los paquetes dirigidos
	// al 'nodo_siguiente'):
	int j=0, found = -1;
	while(j<long_puerta && found<0)
	{
		cola_bs = check_and_cast<BS_queue *>(rxtx_bs->gate("queueRxTx$o",j)->getNextGate()->getOwnerModule());
		if(strcmp(nodo_siguiente,cola_bs->getTarget())==0)
		{
			found = j;
		}
		j++;
	}

	//ev << " 	Intento de insercion de este paquete en la cola de prioridad P" << this->getIndex()
			//<< " del modulo " << (char*) msjdatos->getRuta(0) << "." << cola_bs->getFullName()
			//<< " con destino " << cola_bs->getTarget() << ":" << endl;

	// Suma de todas las subcolas del modulo BS_QUEUE correspondiente:
	for(int i=0; i<(int)par("numcolas"); i++)
	{
		// Los bytes en todas las cQueue (tantas como prioridades) se almacenan en 'suma_total_user':
		suma_total_user = suma_total_user + cola_bs->tamqueue[i];

	}
	// La variable 'tamsumqueue_user' almacena la suma total de los bytes de todos los paquetes de la bs_queue
	// y la longitud del paquete a enviar:
	tamsumqueue_user = suma_total_user + msjdatos->getByteLength();
	/*
	//ev << " 	Suma de los Bytes de los paquetes insertados en todas las colas del submodulo "
			<< cola_bs->getFullName() << " (mas el nuevo paquete): " << tamsumqueue_user << " Bytes" << endl;
	*/
	// Comprobacion de si hay espacio suficiente en el buffer total (todas las colas):
	// Si los bytes de todas las colas no superan la longitud del buffer total:
	if(buffer >= tamsumqueue_user)
	{
		////ev << " 	 Como es MENOR que la longitud TOTAL del buffer (" << buffer << " bytes) --> ENVIO PAQUETE" << endl;
		bloqueo=0.0; //ENVIO PAQUETE
		// Envio del paquete "msjdatos" a la interfaz del usuario:
		send(msjdatos, "traffic");
		//ev << " MENSAJE ENVIADO." << endl;
	}
	// Si la suma de los bytes de todas las colas supera la longitud del buffer total:
	else if(buffer < tamsumqueue_user)
	{
		////ev << " 	 Como es MAYOR que la longitud TOTAL del buffer (" << buffer << " bytes) --> LIBERACION DE ESPACIO EN LAS COLAS" << endl;
		// Recorremos todas las colas, de menor a mayor prioridad, para borrar alguno de sus paquetes previos
		// y dejar sitio asi al nuevo paquete:
		int i = (int)par("numcolas")-1, fuera = -1; ///////
		while(i>=0 && fuera < 0) ///////
		//for(int i=(int)par("numcolas")-1; i>=0; i--) /////
		{
			// Si el nuevo paquete es de la misma prioridad que la de la cola que se esta checkeando
			// (en principio, la mas baja), se borra directamente:
			if(msjdatos->getPriority() == i)
			{
				//ev << " MENSAJE 'DATA' (Id." << msjdatos->getId() << ") BORRADO" << endl;
				////ev << " 	 Borramos el paquete que llega porque es de la prioridad mas baja (P" << i << ")" << endl;
					////ev << " 	 Longitud del paquete borrado:" << msjdatos->getByteLength() << " Bytes." << endl;
				// Resta de los bytes del paquete borrado a la suma total de todas las colas:
				tamsumqueue_user = tamsumqueue_user - msjdatos->getByteLength();
					////ev << " 	 Suma de los Bytes de los paquetes que estan insertados en todas las colas del submodulo "
					//		<< cola_bs->getFullName() << ": " << tamsumqueue_user << " Bytes" << endl;

				bloqueo = 1.0; //BORRADO PAQUETE
				delete msjdatos; // BORRADO DEL PAQUETE 'msjdatos'
				// INCREMENTO DE LA VARIABLE PARA CONTROLAR EL BORRADO DE PAQUETES EN LA PARTE INALAMBRICA:
				check_and_cast<BS_table *>(rxtx_bs->getParentModule()->getSubmodule("bs_table"))->paquetes_borrados++;

				////ev << " 	 Borro el paquete que llega porque es de la prioridad mas baja (P" << i << ")" << endl;
				// Salida del bucle que recorre las colas
				fuera = 1; ///////
			}
			// Si el nuevo paquete es de mayor prioridad que la de la cola que se esta checkeando
			// Y esta cola NO esta vacia, se borran paquetes suyos hasta poder meter el nuevo:
			else if(msjdatos->getPriority() < i && cola_bs->queue[i].getLength()>0)
			{
				int salir = -1; ///////
				// Recorremos todos los paquetes de esta cola, desde el mas antiguo:
				while (cola_bs->queue[i].getLength()>0 && salir < 0) ///////
				//for(int j=0; j<=cola_bs->queue[i].getLength(); j++) /////
				{
					// Llamada a la funcion del modulo 'bs_queue' para borrar el primer paquete de la cola:
					cola_bs->deleteElement(msjdatos,i);
					// INCREMENTO DE LA VARIABLE PARA CONTROLAR EL BORRADO DE PAQUETES EN LA PARTE INALAMBRICA:
					check_and_cast<BS_table *>(rxtx_bs->getParentModule()->getSubmodule("bs_table"))->paquetes_borrados++;
					// VISUALIZAMOS POR PANTALLA LA LONGITUD DEL PAQUETE QUE VAMOS A ELIMINAR
					////ev << " 	 Extraccion y borrado del mensaje de prioridad P" << i << " y longitud " << cola_bs->user_tamqueuepop[i] << " Bytes.";
					////ev << " Quedan " << cola_bs->queue[i].getLength() << " paquetes en la cola P" << i << endl;
						////ev << " 	 Comprobacion de que hay suficiente espacio para almacenar el paquete a enviar:" << endl;
					// Resta de los bytes del paquete extraido a la variable 'tamsumqueue_user':
					tamsumqueue_user = tamsumqueue_user - cola_bs->user_tamqueuepop[i];
						////ev << " 	 Suma de los bytes de TODAS las colas: " << tamsumqueue_user << " Bytes" << endl;
					// Suma de los bytes de los paquetes que salen de las colas,
					// para restarlo a la longitud de cada una:
					tamsumpop_user[i] = tamsumpop_user[i] + cola_bs->user_tamqueuepop[i];

					// COMPROBACION DE SI LA LONGITUD TOTAL DEL BUFFER SUPERA EL NUMERO DE BYTES QUE LLEGAN
					// A LAS COLAS TRAS HABER BORRADO UN PAQUETE:
					// Si hay espacio suficiente en cola para insertar el nuevo paquete...
					if(buffer >= tamsumqueue_user)
					{
						////ev << " 	 Como es MENOR que la longitud TOTAL del buffer (" << buffer
						//		<< " bytes) --> ENVIO PAQUETE A LA COLA P" << msjdatos->getPriority() << endl;
						bloqueo=0.0; //ENVIO PAQUETE
						// Envio del paquete "msjdatos" a la interfaz del usuario:
						send(msjdatos, "traffic");
						//ev << " MENSAJE ENVIADO" << endl;
						// Salida del bucle que recorre los paquetes de esta cola
						salir = 1; ///////
						fuera = 1; ///////
						//break; /////
					}
					// Si NO hay espacio suficiente en cola para insertar el nuevo paquete...
					else if(buffer < tamsumqueue_user)
					{
						////ev << " 	 Como es MAYOR que la longitud TOTAL del buffer (" << buffer
						//		<< " bytes) --> LIBERACION DE MAS ESPACIO EN LAS COLAS" << endl;
					}
					// Pasamos a la siguiente iteracion
				}
				if(buffer > tamsumqueue_user)
				{
					// Salida del bucle que recorre todas las colas
					//break; /////
					fuera = 1; ///////
				}
			}
			else if(msjdatos->getPriority() < i && cola_bs->queue[i].getLength()==0)
			{
				////ev << "  	No quedan paquetes en la cola P" << i << endl;
			}
			i--; ///////
		}
	}
	// DAMOS EL VALOR CERO A LAS DOS VARIABLES PARA PODER HACER LO CALCULOS NECESARIOS EN SIGUIENTES SITUACIONES CORRECTAMENTE
	suma_total_user = 0;
	tamsumqueue_user = 0;
	/*
	if(simTime()>=10*contador && volcado == 0)
	{
		volcadoFicheros();
		contador++;
	}
	*/
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION VOLCADOFICHEROS()--> ESCRIBE EN UNO O VARIOS FICHEROS DE TEXTO LOS DATOS DE MAYOR INTERES DE LA	/
//							   SIMULACION, PARA SU POSTERIOR ANALISIS.										/
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
void User_traffic::volcadoFicheros()
{
	//volcado = 1;
	// 'CARGA_PAQUETES_USER': FICHERO CON LA CARGA DE CADA FUENTE DE TRAFICO INALAMBRICO EN CADA MODULO USER.
	carga_paquetes_user = fopen("results/carga_paquetes_user.txt", "a+");
	//fprintf(carga_paquetes_user,"Carga total de la fuente %i del User %i: %g\n", getIndex(), this->getParentModule()->getIndex(), total_load_user);
	fprintf(carga_paquetes_user,"Carga total de la fuente %i del User %i: %g\n", getIndex(), this->getParentModule()->getIndex(), (double)carga_user.average());
	fclose(carga_paquetes_user);

	//'PAQUETES_USER': FICHERO CON EL NUMERO TOTAL DE PAQUETES GENERADOS POR CADA FUENTE DE TRAFICO INALAMBRICO EN CADA MODULO USER.
	paquetes_user = fopen("results/paquetes_user.txt", "a+");
	fprintf(paquetes_user,"User [%i]: Fuente P%i \n", this->getParentModule()->getIndex(), getIndex());
	fprintf(paquetes_user,"Total paquetes de longitud media %g Bytes\t",(double)longitud_user.average());
	//fprintf(paquetes_user,"64 Bytes\t");
	//fprintf(paquetes_user,"594 Bytes\t");
	//fprintf(paquetes_user,"1500 Bytes\n");
	fprintf(paquetes_user,"%li \t", totalpacket_user); // SUMA TOTAL DE PAQUETES GENERADOS
	//fprintf(paquetes_user," %li \t", packet_64_user); // PAQUETES GENERADOS DE 64 BYTES
	//fprintf(paquetes_user," %li \t", packet_594_user); // PAQUETES GENERADOS DE 594 BYTES
	//fprintf(paquetes_user," %li\t", packet_1500_user); // PAQUETES GENERADOS DE 1500 BYTES
	fprintf(paquetes_user,"\n");
	fclose(paquetes_user);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION FINISH()--> ESTA FUNCION SE INVOCA CUANDO LA SIMULACION HA TERMINADO CON EXITO SIN QUE SE PRODUZCA NINGUN ERROR. 		//
//					  LO USAMOS PARA LA RECOGIDA DE ESTADASTICAS Y VISUALIZACION POR PANTALLA O MEDIANTE UN ARCHIVO.            //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void User_traffic::finish()
{
		// VISUALIZAMOS POR PANTALLA LA RECOGIDA DE ESTADISTICAS DE LA CARGA CUANDO LLAMAMOS A LA FUNCION FINISH()
		//ev << " Estadisticas tomadas en el Modulo " << this->getFullPath() << endl;
		//ev << " Carga total de la fuente n." << this->getIndex() << " del " << this->getParentModule()->getFullName() << ": " << total_load_user << endl;
		double media_aux = (double) carga_user.average();
		//ev << " MEDIA DE LA carga total de la fuente n." << this->getIndex() << " del " << this->getParentModule()->getFullName() << ": " << media_aux  << endl;
		//ev << " Media de la longitud de los paquetes generados: " << longitud_user.average() << endl;
		volcadoFicheros();
}
