////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gestin de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_USER_TRAFFIC_H_
#define __RED_WIRELESS_USER_TRAFFIC_H_

#include <omnetpp.h>
#include <vector>
#include <time.h>
#include "BS_table.h"
#include "BS_queue.h"
#include "BS_rx_tx.h"
#include "analysis.h"
#include "_types.h"
#include "_rand_MT.h"
#include "_link.h"
#include "trace.h"
#include "aggreg.h"
#include "source.h"
/*
 * MODULO User_traffic:
 * Consta de tantas fuentes de trafico como prioridades de servicio, que generan paquetes
 * segun distintas distribuciones (uniforme o de Pareto).
 */
//DEFINIMOS LOS TIPOS DE std DE LOS VECTORES Y MATRICES:
typedef std::vector<int> int_vector_t; // VECTOR DE TIPO ENTERO
typedef std::vector<double> double_vector_t; // VECTOR DE TIPO DOUBLE

class User_traffic : public cSimpleModule
{

  private:
	Analysis carga_user;
	Analysis longitud_user;
	FILE * carga_paquetes_user;
	FILE * paquetes_user;

  public:
	User_traffic(); // CONSTRUCTOR
	virtual ~User_traffic(); //  DESTRUCTOR
	Generator *pAG_user; // PUNTERO AL GENERADOR DE PAQUETES PARA LA FUENTE SELF SIMILAR VERSION 2
	int packetSize_user; // VARIABLE DEL TAMANYO DEL PAQUETE QUE GENERAMOS EN LAS FUENTES
	double_vector_t load_dmb_user;
	BS_table *Tabla;
	virtual int get_index_last_element(int row);
	virtual int get_index_last_element_k(int index, int row);
	int cuenta_ruta;
	int k_paths;
	int opcion_caminos;
	BS_queue *cola_bs;
	BS_rx_tx *rxtx_bs;
	long tamsumqueue_user;
	int_vector_t tamsumpop_user;
	double suma_tam_packets_user;
	simtime_t time_creation_user;
	double total_load_user;
	long suma_total_user;
	double channel_bit_rate;
	double txrate;
	double lambda;
	double inv_lambda;

	long packet_64_user;
	long packet_594_user;
	long packet_1500_user;
	long totalpacket_user;

  protected:
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);

    // Metodos de insercion de paquetes de los usuarios en las colas de las BSs:
	virtual void separatequeue(cMessage *msg); // Colas separadas
	virtual void priorityqueue(cMessage *msg); // Prioridad de colas

	virtual void volcadoFicheros();
	int volcado;
	int contador;
    virtual void finish();
};

#endif
