//////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA                                                          //                                                  //
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti���n de recursos en //
//           redes de acceso FiWi                                                   //                                          //
// AUTOR: Ana Emma Lopez Mato                                                       //                                                  //
// TUTOR: Noemi Merayo Alvarez                                                      //                                              //
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION           //
// UNIVERSIDAD DE VALLADOLID                                                        //                                              //
////////////////////////////////////////////////////////////////////////////////////

#include <vector>
#include "MAC_OLT.h"
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include "OLT_Table.h"
#include "analysis.h"
#include <math.h>
#include "OLT_Rx.h"


//MODIFICADO POR ALEJANDRO
#include <ga.h>
#include <ga/GASimpleGA.h>  // we're going to use the simple GA
#include <ga/GA2DBinStrGenome.h> // and the 2D binary string genome
#include <pthread.h>
#include <stdlib.h>


//VARIABLES GLOBALES
int num_onus_red;
int num_SLAs;
double Kp, Td, Ti;
double_vector_t bw_acum_ONU; //VECTOR QUE GUARDA EL ANCHO DE BANDA ACUMULADO POR ONU
double_vector_t bw_alg_ONU;//VECTOR QUE GUARDA LA MEDIA DEL ANCHO DE BANDA DE VENTANA
double_vector_t bw_acum_Mbps; //VECTOR QUE GUARDA EL ANCHO DE BANDA ACUMULADO POR ONU EN MBPS
double_vector_t bw_alg_Mbps; //VECTOR QUE GUARDA LA MEDIA DEL ANCHO DE BANDA DE VENTANA EN MBPS
double_vector_t sum_error; //VECTOR QUE GUARDA LA SUMA DEL ERROR POR ONU DEL PID
double_vector_t error_ant; //VECTOR QUE GUARDA LOS ERRORES ANTERIORES POR ONU EN EL PID
double_vector_t error_2antPID; //VECTOR QUE GUARDA LOS ERRORES ANTERIORES POR ONU EN EL PID
double_vector_t B_max_sla; //ANCHO DE BANDA MAXIMO POR SLA
double_vector_t BW_max_PID; //VECTOR DEL ANCHO DE BANDA MAXIMO POR ONU DEL PID
double_vector_t BW_max_PID_ant; //VECTOR DEL ANCHO DE BANDA MAXIMO ANTERIOR POR ONU DEL PID
double_vector_t B_guarantee; //VECTOR QUE GUARDA EL ANCHO DE BANDA GARANTIZADO POR ONU PARA CALCULAR EL ERROR DEL PID
vector<vector<vector<double> > > cola_vector;
int_vector_t numonu_sla;// VECTOR DEL NUMERO DE ONUs ASOCIADAS A CADA SLA
simtime_t tfin_train;


//VARIABLES GLOBALES RECOGER_BW
double_vector_t B_alloc; // VECTOR DEL ANCHO DE BANDA ASIGNADO
double_vector_t B_alloc_lambda;
int cont_aux0;
int cont_aux2;
int cont_aux10;


//VARIABLES GLOBALES PID
FILE * B_alloc_medio;
FILE * B_max_PID;
FILE * BW_Mbps;
FILE * B_total;
FILE * B_max_PID_ant;
FILE * graf_control;
FILE * B_alloc_longitudonda;
int_vector_t BW_SLA_onu;
int cont;
double_vector_t errorPID; //VECTOR QUE GUARDA EL ERROR POR ONU DEL PID
double_vector_t control; //VECTOR QUE GUARDA LA VARIABLE CONTROL POR ONU PARA ESTABLECER EL PID
double_vector_t controlant;
int intento_pid;
int_vector_t pet; //VECTOR QUE INDICA POR CADA ONU SI SE ACTIVA O NO EL PID
FILE * pid_medio_file;
double tiempo_inic_PID;
double tiempo_PID;
double_vector_t B_alloc_total;
double_vector_t B_Mbps_sla;
double txrate; // VARIABLE TASA DE TRANSMISION
double_vector_t PID_MEDIO;
double_vector_t PID_MEDIO_TOTAL;



/* --------------------------------------- Variables Red Neuronal --------------------------------------- */

//VARIABLES GLOBALES RED NEURONAL
int cont1;
int cont2;
double Ki, Kd, alpha, nabla;
int iterRedNeuronal = 4;
double Ts = 3;

// MODIFICADO POR DAVID
int HIDDEN_NN = 6;   //int HIDDEN_NN = 5;
int OUT_NN = 3;
int IN_NN = 4;//int IN_NN = 3;
double V_IN_NN[4];//double V_IN_NN[3];
double errorNN, error_antNN, error_2antNN;
double W1 [6][4];//double W1 [5][3];
double Incremento_W1[6][4];//double Incremento_W1[5][3];
double IncrementoAnt_W1[6][4];//double IncrementoAnt_W1[5][3];
double W2[3][6];    //double W2[3][5];
double Incremento_W2[3][6]; //double Incremento_W2[3][5];
double IncrementoAnt_W2[3][6];  //double IncrementoAnt_W2[3][5];
double min_error_NN, max_error_NN;
int iterAprendizaje;
int numIterAutoaprendizaje = 8;
int tiempoRed;
FILE * Neuronal;
FILE * test;
double sum_errorNN;


// MODIFICADO POR DAVID
//RED NEURONAL FEEDPROPAGATION
double out_hidden[6];   //double out_hidden[5];
double out_final[3];
//RED NEURONAL BACKPROPAGATION
double deltaSalida[3];
double deltaHidden[6];  //double deltaHidden[5];
double in_hidden[6];    //double in_hidden[5];
double back_final[3];
double back_hidden[6];  //double back_hidden[5];

FILE * PruebaErrores;
FILE * PesosCapaOculta;



/* --------------------------------------- Ficheros Algoritmo TWDM --------------------------------------- */

// MODIFICADO POR DAVID
FILE * prueba_B_alloc_lambda;
FILE * prueba_wdm;
FILE * B_total_wdm_fichero;
FILE * prueba_lambda;



/* --------------------------------------- Variables Algoritmo Genético --------------------------------------- */

//VARIABLES GLOBALES ALGORITMO GENETICO
int nIterPID = 2;
int finTraining = 0;
int flagThread = 0;
int counterPID;
int controlVarianza;
int controlVentana;
int onuCola;


const float MAX_VALUE= 5.0;
const float MIN_VALUE= 0.0;
int tamPoblacion =10;
int numGen=10;
pthread_t hiloAlgGenet;
float Objective(GAGenome &);
pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;


//MODIFICADO POR ALEJANDRO (VARIABLES INI HILO)
int num_bits_gen, num_bits_gen_res;
int num_bits_gen_S1, num_bits_gen_S1_res;
int num_bits_gen_S2, num_bits_gen_S2_res;
int num_bits_gen_S3, num_bits_gen_S3_res;
int B_sla1, B_sla1_res;
int B_sla2, B_sla2_res;
int B_sla3, B_sla3_res;
FILE * finalTraining;
FILE * temporal;

FILE * prueba_algoritmo_genetico;
FILE * prueba_initialize;
FILE * prueba_PID;
FILE * prueba_initialize_PID;



// MODIFICADO ALGORITMO FEXDBABandwidth
vector<vector<vector<double> > > cola_vector_demand;
double_vector_t bw_acum_demand_ONU; //VECTOR QUE GUARDA EL ANCHO DE BANDA ACUMULADO POR ONU
double_vector_t bw_demand_ONU;
double tiempo_FAIR;
double tiempo_inic_FAIR;
double T_ciclo;
FILE * BW_exceso;
FILE * jitter_analisis_sla;
FILE * retardo_analisis_sla;
FILE * jitter_analisis_sla_max;
FILE * B_max_PID_total;
FILE * B_onu_intantaneo;



/*
 * MODULO MAC_olt:
 */
Define_Module(MAC_OLT);


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION NUMINITSTAGES()--> ESTA FUNCION INICIALIZA VARIAS ETAPAS. SE DEFINE PARA QUE DEVUELVA EL N��MERO DE ETAPAS DE INICIO.  //
//                           EN NUESTRO CASO, LA FUNCION DEVULEVE EL VALOR 1 YA QUE SOLO TENEMOS UNA ETAPA DE INICIALIZACION.   //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int MAC_OLT::numInitStages() const{return 1;}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPUES DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS      //
//                        PARAMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE //
//                        ASIGNAN ESTRUCTURAS DE DATOS DINIMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  //
//                        PARA EL FUNCIONAMIENTO DE ESTE MODULO.                                                                //
//                        LA FUNCION INITIALIZE(INT STAGE) SE UTILIZA PARA INICIALIZAR VARIAS ETAPAS SEGUN EL VALOR STAGE.      //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MAC_OLT::initialize(int stage)
{
    ////ACTIVAR////
    // CREAMOS UN AUTOMENSAJE PARA CREAR EL PAQUETE GATE QUE MANDA EL OLT HACIA LAS ONUS PARA LA INICIALIZACION
    cMessage *msg = new cMessage ("mensaje inicial gate");
    msg->setKind(5); // IDENTIFICAMOS EL AUTOMENSAJE CON EL IDENTIFICADOR = 5
    scheduleAt(0, msg); // SI QUE QUITA NO SE INICIALIZAN LAS ONUS, NO SE MANDAN LOS GATES //ACTIVAR//
    // Para quitar la red PON, no enviar este mensaje.

    // INICIALIZAMOS VARIABLES AL VALOR 0
    sumqueue = 0; // VARIABLE DEL TAMANYO DE LA SUMA DE LOS PAQUETES DE LAS COLAS
    sumbdemand = 0; // VARIABLE DEL TAMANYO DE LA SUMA DEL ANCHO DE BANDA DEMANDADO
    B_sobra = 0; // VARIABLE DEL ANCHO DE BANDA DE SOBRA
    B_exceded = 0; // VARIABLE DEL ANCHO DE BANDA EN EXCESO
    tstarttime = 0; // VARIABLE DEL TIEMPO DE INICIO DE TRANSMISION
    B_alloc.resize((int)par("numOnu"),0); // VECTOR DEL ANCHO DE BANDA ASIGNADO. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL N��MERO DE ONUS QUE DEFINAMOS
    B_demand.resize((int)par("numOnu"),0); // VECTOR DEL ANCHO DE BANDA DEMANDADO. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL N��MERO DE ONUS QUE DEFINAMOS
    B_extra.resize((int)par("numOnu"),0); // VECTOR DEL ANCHO DE BANDA EXTRA QUE SE ASIGNA A MAYORES. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL N��MERO DE ONUS QUE DEFINAMOS
    B_alloc_lambda.resize((int)par("numlong"),0);

    t_slot.resize((int)par("numOnu"),0); // VECTOR DE TIEMPO DE SLOT DE LA ONU. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL N��MERO DE ONUS QUE DEFINAMOS
    t_slot_initialization.resize((int)par("numOnu"),0); // VECTOR DE TIEMPO DE SLOT DE LA ONU. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL N��MERO DE ONUS DE NUESTRA RED
    T_alloc.resize((int)par("numOnu"),0); // VECTOR DE TIEMPO ASIGNADO PARA TRANSMITIR. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL N��MERO DE ONUS QUE DEFINAMOS
    tiempo_tx_siguiente = 0; // VARIABLE DE TIEMPO DE TRANSMISION DE LA SIGUIENTE ONU
    tiempo_sim_delay_datarate = 0; // VARIABLE DE TIEMPO DE LA SUMA DEL TIEMPO DE SIMULACION, RETARDO Y TIEMPO DE TRANSMISION DEL PAQUETE GATE
    delay = 0; // RETARDO DE NUESTRA RED DEPENDIENDO DE LA LONGITUD TOTAL DE LA RED
    delay_pon1 = 0; // RETARDO DEL SEGMENTO DE LA RED QUE UNE EL OLT Y EL SPLITTER
    delay_pon2.resize((int)par("numOnu"),0); // VECTOR DEL RETARDO DEL SEGMENTO DE LA RED QUE UNE EL SPLITTER Y CADA ONU. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL N��MERO DE ONUS DE NUESTRA RED
    delay_total.resize((int)par("numOnu"),0); // // VECTOR DE LA SUMA DE LOS RETARDOS DE CADA SEGMENTO DE LA RED (OLT-SPLITTER Y SPLITTER-ONU). SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL N��MERO DE ONUS DE NUESTRA RED
    B_ex_sla.resize((int)par("numOnu"),0); // VECTOR DEL ANCHO DE BANDA ASOCIADO A CADA ONU SEGUN EL SLA ASOCIADO A LA ONU. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL N��MERO DE ONUS DE NUESTRA RED
    B_max_dmb.resize((int)par("numOnu"),0); // VECTOR DEL ANCHO DE BANDA MAXIMO PARA CADA ONU. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL N��MERO DE ONUS DE NUESTRA RED
    SLA_onu.resize((int)par("numOnu"),0); // VECTOR EN EL QUE SE INTRODUCIRA LOS PESOS ASOCIADOS AL SLA QUE CORRESPONDE A CADA ONU. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL N��MERO DE ONUS DE NUESTRA RED
    numsla.resize((int)par("numOnu"),0); // VECTOR QUE GAS GUARDA EL N��MERO DE SLA ASOCIADO A CADA ONU. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL N��MERO DE ONUS DE NUESTRA RED
    Wsla.resize((int)par("numSLA")+2,0); // VECTOR DE LOS PESOS DE CADA SLA. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL N��MERO DE SLAs + 2 YA QUE SE UTILIZAN 3 SLA Y HEMOS DEFINIDO MANUALMENTE 4 PESOS PARA NUESTRA RED
    numonu_sla.resize((int)par("numSLA")+2,0); //  VECTOR DEL N��MERO DE ONUs ASOCIADAS A CADA SLA. SE INICIALIZA A 0 CON UN TAMANYO IGUAL AL N��MERO DE SLAs + 2 YA QUE SE UTILIZAN 3 SLA Y HEMOS DEFINIDO MANUALMENTE 4 PESOS PARA NUESTRA RED
    id_onu = 0; // IDENTIFICADOR DE LA ONU
    W_min = 0; // PESO MINIMO CON UN VALOR FIJO DE 0.34
    long_max = 0; // LONGITUD MAXIMA QUE TIENE UNA ONU PARA TRANSMITIR DEPENDIENDO DEL B_cycle Y DEL N��MERO DE ONUs
    B_basico = 0; // ANCHO DE BANDA BASICO RedPARA TRANSMITIR QUE TIENE CADA ONU.
    sumatorio = 0; // VARIABLE QUE NOS INDICA EL SUMATORIO DE CADA PESO ASOCIADO A UN SLA POR SU N��MERO DE ONUS ASOCIADOS A SLA
    tiempo_tx_sig.resize((int)par("numlong"),0);
    aux = 0; //VARIABLE AUXILIAR PARA GUARDAR LA LAMBDA POR LA QUE SE ENVIA EL PAQUETE
    id=0;
    tiempo_inic_PID = 3; //TIEMPO EN EL QUE SE INICIA EL PID // En el paper: Tsample=10s.
    tiempo_PID = 3; //INTERVALO DE TIEMPO EN EL QUE VA A SALTAR EL PID // En el paper: Tsample=10s.
    numero_sla.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA EL NUMERO DE SLA PARA MANDAR EL GATE
    pet.resize((int)par("numOnu"),1); //VECTOR QUE INDICA POR CADA ONU SI SE ACTIVA (1) O NO (0) EL PID
    errorPID.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA EL ERROR POR ONU DEL PID

    error.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA EL ERROR POR ONU DEL PID
    sum_error.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA LA SUMA DEL ERROR POR ONU DEL PID
    B_max_sla.resize((int)par("numOnu"),0); //ANCHO DE BANDA MAXIMO POR SLA
    B_max_sla_ant.resize((int)par("numOnu"),0); //ANCHO DE BANDA MAXIMO POR SLA
    BW_max_PID.resize((int)par("numOnu"),0); //VECTOR DEL ANCHO DE BANDA MAXIMO POR ONU DEL PID
    BW_max_PID_ant.resize((int)par("numOnu"),0); //VECTOR DEL ANCHO DE BANDA MAXIMO ANTERIOR POR ONU DEL PID
    sum_error_delay.resize((int)par("numOnu"),0);
    error_ant_delay.resize((int)par("numOnu"),0);
    cont=1;

    flagPrioridad = 0;
    flag_control_delay = 0;


    //MODIFICADO POR ALEJANDRO, RED NEURONAL
    counterPID=0;
    iterAprendizaje=0;
    double auxKp;
    double auxTi;
    double auxTd;


    delay_onu.resize((int)par("numOnu")); // Retardo total de los paquetes recibidos en cada ciclo de cada ONU, clasificados por prioridad.
    for(int i=0; i<(int)par("numOnu"); i++)
    {
        delay_onu[i].resize(2,0.0); // Solo se controla el retardo de las clases P0 y P1.
    }
    paq_onu.resize((int)par("numOnu")); // Total paquetes recibidos en cada ciclo de cada ONU, clasificados por prioridad.
    for(int i=0; i<(int)par("numOnu"); i++)
    {
        paq_onu[i].resize(2,0); // Solo se controla el retardo de las clases P0 y P1.
    }
    retardo_alg_ONU.resize((int)par("numOnu"));
    for(int i=0; i<(int)par("numOnu"); i++)
    {
        retardo_alg_ONU[i].resize(2,0.0); // Solo se controla el retardo de las clases P0 y P1.
    }
    retardo_max_ONU.resize((int)par("numOnu"));
    for(int i=0; i<(int)par("numOnu"); i++)
    {
        retardo_max_ONU[i].resize(2,0.0); // Solo se controla el retardo de las clases P0 y P1.
    }

    control.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA LA VARIABLE CONTROL POR ONU PARA ESTABLECER EL PID
    controlant.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA LA VARIABLE CONTROL ANTERIOR POR ONU PARA ESTABLECER EL PID

    error_ant.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA LOS ERRORES ANTERIORES POR ONU EN EL PID
    error_2antPID.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA LOS ERRORES ANTERIORES POR ONU EN EL PID

    B_guarantee.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA EL ANCHO DE BANDA GARANTIZADO POR ONU PARA CALCULAR EL ERROR DEL PID
    cola_vector.resize((int)par("numOnu")); //VECTOR QUE USAREMOS PARA LA FUNCION recoger_bw_por_onu
    vector_ventana.resize((int)par("numSLA")); //ARRAY QUE SE USA PARA LA FUNCION recoger_delay_por_sla
    for(int i=0; i<(int)par("numSLA"); i++)
    {
        vector_ventana[i].resize(2); // Solo se controla el retardo de las clases P0 y P1.
    }
    no_capacidad = 0; //���?
    bw_acum_ONU.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA EL ANCHO DE BANDA ACUMULADO POR ONU
    retardo_alg_SLA.resize((int)par("numSLA")); // ARRAY QUE GUARDA LA MEDIA DEL RETARDO DE VENTANA POR SLA Y PRIORIDAD
    for(int i=0; i<(int)par("numSLA"); i++)
    {
        retardo_alg_SLA[i].resize(2,0); // Solo se controla el retardo de las clases P0 y P1.
    }
    retardo_acum_SLA.resize((int)par("numSLA")); // ARRAY QUE GUARDA EL RETARDO ACUMULADO POR SLA Y PRIORIDAD
    for(int i=0; i<(int)par("numSLA"); i++)
    {
        retardo_acum_SLA[i].resize(2,0); // Solo se controla el retardo de las clases P0 y P1.
    }
    aux_cont = 0; // VARIABLE AUXILIAR
    cont_auxiliar = 0; // VARIABLE AUXILIAR
    contador_aux = 0; // VARIABLE AUXILIAR
    bw_alg_ONU.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA LA MEDIA DEL ANCHO DE BANDA DE VENTANA
    bw_acum_Mbps.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA EL ANCHO DE BANDA ACUMULADO POR ONU EN MBPS
    bw_alg_Mbps.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA LA MEDIA DEL ANCHO DE BANDA DE VENTANA EN MBPS
    intento_pid=0;
    intento=0;
    BW_sla.resize((int)par("numSLA")+2,0);
    BW_SLA_onu.resize((int)par("numOnu"),0);
    prueba=0;
    B_Mbps.resize((int)par("numOnu"),0);
    B_alloc_total.resize((int)par("numOnu"),0);
    desviacionBwMaxGuar.resize((int)par("numSLA")+2,0);
    cont_var_BwMax.resize((int)par("numSLA")+2,0);
    var.resize((int)par("numSLA")+2,0);
    var_Mbps.resize((int)par("numSLA")+2,0);
    cont_var.resize((int)par("numSLA")+2,0);
    error_abs.resize((int)par("numSLA")+2,0);
    error_rel.resize((int)par("numSLA")+2,0);
    var_Mbps_instantaneo.resize((int)par("numSLA")+2,0);
    desviacionBwMax.resize((int)par("numSLA"));
    desviacion.resize((int)par("numSLA"));
    PID_MEDIO.resize((int)par("numSLA"));
    PID_MEDIO_TOTAL.resize((int)par("numSLA"));
    cont_aux0=0;
    cont_aux2=0;
    cont_aux10=0;
    cont=1;
    cont1=1;
    cont2=1;
    B_Mbps_sla.resize((int)par("numSLA")+2,0);



    // MODIFICADO POR DAVID: Inicialización de las variables para el algoritmo TWDM
    B_alloc_lambda_prueba.resize((int)par("numlong"),0);
    B_total_wdm.resize((int)par("numOnu"),0);
    overhead=0.0;
    cont3=1;
    cont4=1;



    // MODIFICADO ALGORITMO FEXDBABandwidth
    contprueba=1;
    contadorFair=1;

    BW_sla[0] = (int)par("BW_garantizado0"); //ANCHO DE BANDA ASOCIADO AL SLA0
    BW_sla[1] = (int)par("BW_garantizado1"); //ANCHO DE BANDA ASOCIADO AL SLA1
    BW_sla[2] = (int)par("BW_garantizado2"); //ANCHO DE BANDA ASOCIADO AL SLA2


    //Variables nuevas para el algoritmo Fair Excess Bandwidth

    tiempo_inic_FAIR = 3; //TIEMPO EN EL QUE SE INICIA El FAIR EXCESS BANDWIDTH //
    tiempo_FAIR = 3; //INTERVALO DE TIEMPO EN EL QUE VA A SALTAR EL FAIR Excess Bandwith //
    B_init.resize((int)par("numOnu"),0); // VECTOR DEL ANCHO DE BAND
    B_min.resize((int)par("numOnu"),0); // VECTOR DEL ANCHO DE BAND
    B_max_onu.resize((int)par("numOnu"),0);//Ancho de banda máximo para cada oNU
    B_excess_onu.resize((int)par("numOnu"),0);
    w_onu.resize((int)par("numOnu"),0);
    pi_onu.resize((int)par("numOnu"),0);
    xm_onu.resize((int)par("numOnu"),0);
    bw_demand_ONU.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA LA MEDIA DEL ANCHO DE BANDA DE VENTANA
    cola_vector_demand.resize((int)par("numOnu")); //VECTOR QUE USAREMOS PARA LA FUNCION recoger_bw_por_onu
    bw_acum_demand_ONU.resize((int)par("numOnu"),0); //VECTOR QUE GUARDA EL ANCHO DE BANDA ACUMULADO POR ONU

    T_ciclo = 0.002 - 0.000001*((int)par("numOnu")) -0.000000512*((int)par("numOnu")); // TIEMPO DE CICLO FINAL Y LO VISUALIZAMOS POR PANTALLA

    long double B_ciclo_util = 1000000000*T_ciclo; // ANCHO DE BANDA MÁXIMO DEL CICLO EN BYTES Y LO VISULAIZAMOS POR PANTALLA

    //ev<<" Ancho de banda del ciclo: "<<T_ciclo<<" segundos "<<" y bits: "<<B_ciclo_util<<"  y en bytes:  "<<(B_ciclo_util/8)<<endl;

    double total_garantizado = (double) 0.0;

    //inicializamos vectores del algoritmo Fair Excess Bandwidht
    for(int i=0; i<(int)par("numOnu"); i++)
    {
        w_onu[i]=1; // asignamos a todos los usuarios la misma priodad en el acceso.
        pi_onu[i]=0.0;
        xm_onu[i]=(long double)0.0;

        if(i==0)
        {
            B_min[i]=(double) ((T_ciclo*(double)par("BW_garantizado0")*1000000))/8;
            //ev<<" Ancho de banda minimo garantizado: "<<B_min[i]<<"Bytes"<<endl;
            total_garantizado+=B_min[i];
        }
        else if(i<6)
        {
            B_min[i]=(double) ((T_ciclo*(double)par("BW_garantizado1")*1000000))/8;
            //ev<<" Ancho de banda minimo garantizado: "<<B_min[i]<<"Bytes"<<endl;
            total_garantizado+=B_min[i];
        }
        else
        {
            B_min[i]=double ((T_ciclo*(double)par("BW_garantizado2")*1000000))/8;
            //ev<<" Ancho de banda minimo garantizado: "<<B_min[i]<<"Bytes"<<endl;
            total_garantizado+=B_min[i];
        }
    }
    //ev<<"total garantizado a las ONUS: "<<total_garantizado<<"y sobrante: "<<((B_ciclo_util/8)-total_garantizado)<<endl;


    // DEFININOS EL PROCESO PARA PODER ENTRAR DESDE ESTE MODULO AL MODULO OLT_TABLE
    cModule *c_table_module;
    if(stage==0)
    {
        c_table_module = getParentModule()->getSubmodule("olt_table"); // CAMINO PARA LLEGAR HASTA EL MODULO OLT_TABLE
        table_module = check_and_cast<OLT_Table *>(c_table_module); // ENTRAMOS Y CHEQUEAMOS EL MODULO OLT_TABLE
    }

    ////ACTIVAR////
    //SOLO QUEREMOS QUE SALTE EL PID PARA EL METODO POLLING IPACT
    if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3_DaSPID4")==3)
    //if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3")==3)
    {
        cMessage *msg1 = new cMessage ("Mensaje inicial gate");
        msg1->setKind(6); // IDENTIFICAMOS EL AUTOMENSAJE CON EL IDENTIFICADOR = 6
        scheduleAt(tiempo_inic_PID, msg1); // SI QUE QUITA NO SE INICIALIZAN LAS ONUS, NO SE MANDAN LOS GATES
    }
    //NUEVO:
    else if((int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3_DaSPID4")==4)
    {
        cMessage *msg1 = new cMessage ("Mensaje inicial gate");
        msg1->setKind(7); // IDENTIFICAMOS EL AUTOMENSAJE CON EL IDENTIFICADOR = 6
        scheduleAt(tiempo_inic_PID, msg1); // SI QUE QUITA NO SE INICIALIZAN LAS ONUS, NO SE MANDAN LOS GATES

        paquetes_borrados_P1.resize((int)par("numSLA"),0);
        paquetes_recibidos_P1.resize((int)par("numSLA"),0);
        simtime_t next_period = simTime() + (simtime_t) 50;
        cMessage *msg0 = new cMessage ("Control_Bloqueo",0);
        scheduleAt(next_period, msg0);
    }



    //MODIFICADO POR ALEJANDRO
    //INITIALIZE DEL OLT_RX
    num_sla.resize((int)par("numOnu"),0); // VECTOR PARA GUARDAR EL IDENTIFICADOR DEL SLA DE LA ONU ASOCIADA. SE INICIALIZA A 0 CON UN TAMAxO IGUAL AL NÚMERO DE ONUS DE NUESTRA RED
    numReceived = 0; // INICIALIZAMOS EL NÚMERO DE PAQUETES ETHERNET RECIBIDOS A 0
    total_bytes_received = 0; // INICIALIZAMOS EL TOTAL DE LOS BYTES DE LOS PAQUETES ETHERNET RECIBIDOS A 0
    total_bits_received = 0; // INICIALIZAMOS EL TOTAL DE LOS BITS DE LOS PAQUETES ETHERNET RECIBIDOS A 0
    throughput = 0; // INICIALIZAMOS EL RENDIMIENTO A 0

    retardo_global_P.resize((int)par("numqueue"));
    retardo_sla.resize((int)par("numSLA"));
    retardo_servicios_sla.resize((int)par("numSLA"));
    for(int i=0; i<retardo_servicios_sla.size(); i++)
    {
        retardo_servicios_sla[i].resize((int)par("numqueue"));
    }
    media_bytes_total_onus.resize((int)par("numqueue"));
    retardo_P.resize((int)par("numqueue"),0);
    retardo.resize((int)par("numSLA"),0);
    tam_packet_queue.resize((int)par("numqueue"),0);



    // MODIFICADO ALGORITMO FEXDBABandwidth
    jitter_servicios_sla.resize((int)par("numSLA"));
    jitter_servicios_sla_anterior.resize((int)par("numSLA"));
    jitter_servicios_sla_max.resize((int)par("numSLA"));
    retardoAnterior.resize((int)par("numSLA"));

    for(int i=0; i<jitter_servicios_sla.size(); i++)
    {
        jitter_servicios_sla[i].resize((int)par("numqueue"));
        jitter_servicios_sla_anterior[i].resize((int)par("numqueue"));
        jitter_servicios_sla_max[i].resize((int)par("numqueue"));
        retardoAnterior[i].resize((int)par("numqueue"));
    }

    for(int i=0; i<jitter_servicios_sla.size(); i++)
    {
        for(int j=0; j<(int)par("numqueue"); j++)
        {
            retardoAnterior[i][j]=(double) 0.0;
            //ev<<"retardoAnterior: "<<retardoAnterior[i][j]<<endl;
        }
    }



    media_bytes_total_onus.resize((int)par("numqueue"));
    retardo_P.resize((int)par("numqueue"),0);
    retardo.resize((int)par("numSLA"),0);
    tam_packet_queue.resize((int)par("numqueue"),0);



    //PARA EL PID
    txrate = (int)par("txrate");
    num_onus_red = ((int)par("numOnu"));
    num_SLAs = ((int)par("numSLA"));
    numonu_sla[0] = (int)par("numonu_sla0"); // NÚMERO DE ONUs ASOCIADO AL SLA0
    numonu_sla[1] = (int)par("numonu_sla1"); // NÚMERO DE ONUs ASOCIADO AL SLA1
    numonu_sla[2] = (int)par("numonu_sla2"); // NÚMERO DE ONUs ASOCIADO AL SLA2
    numonu_sla[3] = (int)par("numonu_sla3"); // NÚMERO DE ONUs ASOCIADO AL SLA3
    numonu_sla[4] = (int)par("numonu_sla4"); // NÚMERO DE ONUs ASOCIADO AL SLA4



    ///////////////////////////////////////////////////////////////////////////////////////////////////
    //                                                                                               //
    //   Tenemos dos opciones para la definición inicial de los parámetros de la Red Neuronal.       //
    //   En primer lugar, cogiendo valores aleatorios ente 0 y 5 o definiéndolos con un valor fijo   //
    //                                                                                               //
    ///////////////////////////////////////////////////////////////////////////////////////////////////


    //PARA LA RED NEURONAL (KS INICIALIZADAS ALEATORIAMENTE EN LA INICIALIZACION DE LA RED NEURONAL)
    /*auxKp = rand () % 45678;
    Kp = auxKp/10000;
    auxTi = rand () % 45678;
    Ti = auxTi/10000;
    auxTd = rand () % 45678;
    Td = auxTd/10000;*/


    // MODIFICADO POR DAVID
    // Opción 1: Se inicializan los parámetros de la Red Neuronal con valores aleatorios entre 0 y 5.
    double p1 = dblrand();
    //ev << "p1: " << p1 << endl;
    double p2 = dblrand();
    //ev << "p2: " << p2 << endl;
    double p3 = dblrand();
    //ev << "p3: " << p3 << endl;

    Kp = 5*p1;
    Ti = 5*p2;
    Td = 5*p3;


    // Opción 2: Se inicializan los parámetros de la Red Neuronal con unos valores fijos.
    /*Kp = 1.0;
    Ti = 1.0;
    Td = 1.0;*/

    /*prueba_initialize=fopen("results/prueba_initialize.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
    fprintf(prueba_initialize,"%g\t" , (double)Kp);
    fprintf(prueba_initialize,"\t");
    fprintf(prueba_initialize,"%g\t" , (double)Ti);
    fprintf(prueba_initialize,"\t");
    fprintf(prueba_initialize,"%g\t" , (double)Td);
    fprintf(prueba_initialize,"\t");
    fprintf(prueba_initialize,"%g\t", SIMTIME_DBL(simTime()));
    fprintf(prueba_initialize,"\n");
    fclose(prueba_initialize);*/ // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS


    /* ---------- Automensaje número 8 para llamar al Algortimo Genético ---------- */

    //MODIFICADO POR ALEJANDRO
    //Control del algoritmo genetico
    //Se crea un thread para que haga la parte del genetico.
    /*tiempo_inic_HILO = 2;
    cMessage *msg8 = new cMessage ("Mensaje Hilo");
    msg8->setKind(8); // IDENTIFICAMOS EL AUTOMENSAJE CON EL IDENTIFICADOR = 8
    scheduleAt(tiempo_inic_HILO, msg8);*/
    pthread_mutex_init(&mutex, NULL);


   /* ---------- Automensaje número 9 para llamar a la Red Neuronal ---------- */


    errorNN = 1.0;
    error_antNN = 1.0;
    error_2antNN = 1.0;
    tiempoRed = tiempo_inic_PID;
    Neural_Network_init();
    cMessage *msg10 = new cMessage ("Mensaje Red Neuronal");
    msg10->setKind(9); // IDENTIFICAMOS EL AUTOMENSAJE CON EL IDENTIFICADOR = 9
    scheduleAt(tiempoRed, msg10);


}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//                                        UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O      //
//                                        EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//                                        DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL   //
//                                        CODIGO IMPLEMENTADO.                                                                  //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MAC_OLT::handleMessage(cMessage *msg)
{
    //VARIABLES
    int type = msg->getKind(); // VARIABLE TYPE PARA IDENTIFICAR LOS MENSAJES DE LA RED
    long int txrate = (long int)par("txrate"); // VARIABLE TASA DE TRANSMISION
    double B_slot[(int)par("numqueue")]; // VARIABLE DE ANCHO DE BANDA DE SLOT CON TAMANYO IGUAL AL N��MERO DE COLAS QUE DEFINAMOS
    int srcAddress = 9; // DEFINIMOS EL IDENTIFICADOR DE LA DIRECCION FUENTE DE LOS PAQUETES GATE
    int oltmethod = (int)par("oltmethod_Centralized0_Polling1_wdm2_PollingPID3_DaSPID4"); // VARIABLE QUE NOS INDICA EL METODO DEL OLT ELEGIDO AL PRINCIPIO DE LA SIMULACION
    double tasa_tx_gate = 512/txrate; // VARIABLE QUE NOS INDICA LA TASA DE TRANSMISION DEL PAQUETE GATE CON UN TAMANYO DE 64 BYTES
    double velocidad = 300000000; // DEFINIMOS EL PARAMETRO VELOCIDAD DE LA VELOCIDAD DE LA LUZ (EN M/S)
    double longitud_total_red; // PARIMETOR  QUE NOS INDICA LA LONGITUD TOTAL DE LA RED PARA CUANDO SIMULAMOS LA RED CON UNA LONGITU FIJA
    int lambda=0; //LONGITUD DE ONDA POR LA QUE SE VA A MANDAR EL PAQUETE
    int entero; //VARIABLE QUE RECOGE EL N��MERO DE ONUs QUE VAN POR CADA LONGITUD DE ONDA
    int resto; //VARIABLE AUXILIAR EN CASO DE QUE POR UNA LONGITUD DE ONDA VAYAN MIS PAQUETES
    int entero_aux; //VARIABLE AUXILIAR PARA AUMENTAR EL N��MERO DE ONUs POR LAMBDA
    int auxiliar=0; //VARIABLE AUXILIAR
    int contador=1; //VARIABLE AUXILIAR
    cMessage *msg2;
    cMessage *msg9;
    cMessage *msg11;


    // ESTRUCTURA CONDICIONAL SWITCH QUE NOS DIFERENCIA LOS MENSAJES QUE LLEGUEN A ESTE MODULO
    switch(type)
    {
        case 0:
            if(msg->getKind()==0)
            {
                simtime_t next_period = simTime() + (simtime_t) 50;
                scheduleAt(next_period,msg);

                /*ev << " MAAAAC_OLTTTTTTT" <<endl;
                ev << "     Paquetes P1 borrados SLA0: " << paquetes_borrados_P1[0] << endl;
                ev << "     Paquetes P1 recibidos SLA0: " << paquetes_recibidos_P1[0] << endl;
                ev << " P_bloqueo SLA0: " << (double)(paquetes_borrados_P1[0]/paquetes_recibidos_P1[0]) << endl;
                ev << "     Paquetes P1 borrados SLA1: " << paquetes_borrados_P1[1] << endl;
                ev << "     Paquetes P1 recibidos SLA1: " << paquetes_recibidos_P1[1] << endl;
                ev << " P_bloqueo SLA1: " << (double)(paquetes_borrados_P1[1]/paquetes_recibidos_P1[1]) << endl;
                ev << "     Paquetes P1 borrados SLA2: " << paquetes_borrados_P1[2] << endl;
                ev << "     Paquetes P1 recibidos SLA2: " << paquetes_recibidos_P1[2] << endl;
                ev << " P_bloqueo SLA2: " << (double)(paquetes_borrados_P1[2]/paquetes_recibidos_P1[2]) << endl;*/


                //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE LA PROBABILIDAD DE BLOQUEO PARA LA CLASE P1, POR CADA SLA:
                bloqueo_cad_daspid_P1=fopen("results/bloqueo_CAD_DaSPID_P1.txt", "a+");
                //" T \t  SLA_0  \t  SLA_1  \t  SLA_2  \n"
                fprintf(bloqueo_cad_daspid_P1," %g \t %g \t %g \t %g \n" , SIMTIME_DBL(simTime()), (double)(paquetes_borrados_P1[0]/paquetes_recibidos_P1[0]), (double)(paquetes_borrados_P1[1]/paquetes_recibidos_P1[1]), (double)(paquetes_borrados_P1[2]/paquetes_recibidos_P1[2]));
                fclose(bloqueo_cad_daspid_P1);

                paquetes_borrados_P1.clear();
                paquetes_recibidos_P1.clear();
            }
        break;

        //MODIFCADO POR ALEJANDRO
        case 1:
            // LLEGA UN PAQUETE ETHERNET CON IDENTIFICADOR = 1
            if(msg->getKind()==1)
            {
                ETHERNETmsg *ethernetmsg=check_and_cast<ETHERNETmsg*>(msg); // CHEQUEAMOS EL PAQUETE ETHERNET

                // VARIABLES
                int id_servicio = ethernetmsg->getId_servicio(); // PARxMETRO QUE INDICA EL IDENTIFICADOR DEL SERVICIO DE LA ONU
                int numero_sla = num_sla[ethernetmsg->getSrcAddress()]; // PARxMETRO QUE INDICA EL IDENTIFICADOR DEL SLA ASOCIADO A LA ONU

                //COMPARAMOS EL TIEMPO DE SIMULACIxN CON EL VALOR 1 (SE EMPIEZAN A CREAR LOS PAQUETES ETHERNET) PARA EMPEZAR A COGER ESTADxSTICAS MANUALMENTE Y CON LA CLASE ANxLISIS
                if(simTime()>=1)
                {
                    // RECOGIDA DE ESTADISTICAS DEL RETARDO GLOBAL CON LA CLASE ANxLISIS PARA TODAS LAS CLASES DE SERVICIOS
                    retardo_P[id_servicio] = simTime() - ethernetmsg->getTime_enter_queue(); // PARAMETRO PARA CALCULAR EL RETARDO CON LA CLASE ANxLISIS
                    retardo_global_P[id_servicio].analyze(SIMTIME_DBL(retardo_P[id_servicio])); // RECOGEMOS EL RESULTADO CON LA CLASE ANxLISIS
                }

                numReceived++; // INCREMENTAMOS EN UNO EL CONTADOR DE NÚMERO DE PAQUETES ETHERNET RECIBIDOS
                total_bytes_received = total_bytes_received + ethernetmsg->getByteLength();
                delete ethernetmsg; // BORRAMOS LOS PAQUETES ETHERNET

                // COMPARAMOS SI EL NUMERO DE ITERACCIONES ES MAYOR O IGUAL UN CIERTO NÚMERO, O QUE LA FUNCIxN ANxLISIS CONVERJA
                if((int)par("oltmethod_Centralized0_Polling1")==0)
                {
                    if( retardo_global_P[0].number_iterations() >= 20  && retardo_sla[0].number_iterations() >= 20 && retardo_sla[1].number_iterations() >= 20)// TENEMOS QUE AxADIR LAS VARIABLES // numReceived >= 5000000)//retardo_global_P[0].converged() && retardo_sla[0].converged()) // NÚMERO DE PAQUETES QUE LLEGAN O SI LA FUNCIxN ANxLSIS CONVERGE
                    {
                        total_bits_received = total_bytes_received*8;
                        throughput = total_bits_received/simTime();

                        endSimulation(); // LLAMAMOS A LA FUNCIxN TERMINAR SIMULACIxN
                        //callFinish(); // LLAMAMOS A LA FUNCIxN FINALIZAR
                    }
                    if(simTime() >= 5000)
                    {
                        endSimulation(); // LLAMAMOS A LA FUNCION TERMINAR SIMULACION
                        callFinish(); // LLAMAMOS A LA FUNCION FINALIZAR
                    }
                }
                else if((int)par("oltmethod_Centralized0_Polling1")==1)
                {
                    if( retardo_global_P[0].number_iterations() >= 30 ) // TENEMOS QUE AxADIR LAS VARIABLES // numReceived >= 5000000)//retardo_global_P[0].converged()) // NÚMERO DE PAQUETES QUE LLEGAN O SI LA FUNCIxN ANxLSIS CONVERGE
                    {
                        total_bits_received = total_bytes_received*8;
                        throughput = total_bits_received/simTime();

                        //endSimulation(); // LLAMAMOS A LA FUNCIxN TERMINAR SIMULACIxN
                        //callFinish(); // LLAMAMOS A LA FUNCIxN FINALIZAR
                    }
                    if(simTime() >= 5000)
                    {
                        endSimulation(); // LLAMAMOS A LA FUNCION TERMINAR SIMULACION
                        callFinish(); // LLAMAMOS A LA FUNCION FINALIZAR
                    }
                }
            }

        break;


        case 2:
            // LLEGA UN PAQUETE REPORT CON IDENTIFICADOR = 2
            if(msg->getKind()==2)
            {
                REPORTmsg *reportmsg = check_and_cast<REPORTmsg *>(msg); // CHEQUEAMOS EL MENSAJE REPORT
                //ev<<" Llega al final un paquete report de la ONU "<<reportmsg->getSrcAddress()<< " por la lambda: "<<reportmsg->getLambdareport()<<endl;

                // BULCE FOR PARA GUARDAR EN LA TABLA DEL MODULO OLT_TABLE EL ESTADO DE LAS COLAS
                for(int j=0; j<(int)par("numqueue"); j++)
                {
                    table_module->table_olt_report[reportmsg->getSrcAddress()][j] = reportmsg->getQueue_estado(j);
                }
                /*
                // VISUALIZAMOS POR PANTALLA CON LOS BUCLES FOR LA TABLA COMPLETA DEL MODULO OLT_TABLE
                for(int i=0; i<(int)par("numOnu"); i++)
                {
                    for(int j=0; j<(int)par("numqueue"); j++)
                    {
                        ev<<"ONU "<< i<<"->"<< "Queue Estado "<< j <<": "<<table_module->table_olt_report[i][j]<<endl;
                    }
                    ev<<"ONU "<< i<<"->"<< "Bandwidth Demandado: "<<table_module->table_olt_report[i][(int)par("numqueue")]<<endl;
                    ev<<"ONU "<< i<<"->"<< "Bandwidth Asignado: "<<table_module->table_olt_report[i][(int)par("numqueue")+1]<<endl;
                }
                */
                // ESTRUCTURA CONDICIONAL Sdwidth QUE NOS DIFERENCIA LOS METODOS DEL OLT
                switch(oltmethod)
                {
                    case 0:
                        // METODO DMB O CENTRALIZADO DEL OLT
                        centralizedmethod_DMB(msg);
                        break;

                    case 1:
                        // METODO IPACT O DE POLLING DEL OLT
                        pollingmethod_IPACT(msg);
                        break;

                    case 2:
                        // METODO PARA MODULACION WDM
                        wdmmethod(msg);
                        break;

                    case 3:
                        // METODO IPACT O DE POLLING CON ALGORITMO PID
                        DBA_polling_PID(msg);
                        break;

                    case 4:
                        // METODO IPACT O DE POLLING CON ALGORITMO DaSPID
                        DBA_polling_DaSPID(msg);
                        break;

                    default:
                        //ev<<" ERROR AL ELEGIR EL METODO DEL OLT, ELEGIR 0 , 1, 2, 3 o 4."<<endl;
                        break;
                }

            }
            break;

        case 5:
            // LLEGA UN AUTOMENSAJE CON IDENTIFICADOR = 5 PARA GENERAR EL PAQUETE GATE
            if(msg->getKind()==5)
            {
                delete msg; // BORRAMOS EL AUTOMENSAJE YA QUE NO SE UTILIZA MAS ADELANTE

                //UNA LONGITUD DE ONDA
                if((int)par("numlong")==1)
                {
                    // CALCULAMOS EL DELAY O RETARDO DEPENDIENDO DE LA LONGITUD DE NUESTRA RED
                    longitud_total_red = ((int)par("longpon1")+(int)par("longpon2")); // DEFINIMOS EL PARAMETRO QUE INDICA LA LONGITUD TOTAL DE LA RED EN METROS
                    delay = (longitud_total_red*3)/(velocidad*2); // CALCULAMOS EL RETARDO O DELAY PARA LA RED SEGUN LA LONGITU QUE DEFINAMOS AL PRINCIPION DE LA SIMULACION

                    // INICIALIZAMOS EL OLT MANDANDO UN MENSAJE GATE A CADA ONU INDICANDO EL ANCHO DE BANDA DE SLOT Y EL TIEMPO DE INICIO DE TRANSMISION
                    // MEDIANTE EL BUCLE FOR CREAMOS LOS PAQUETES GATE PARA LAS ONUS DE NUESTRA RED
                    for(int i=0; i<(int)par("numOnu"); i++)
                    {
                        // CREAMOS EL PAQUETE GATE
                        GATEmsg *packet = new GATEmsg("Gate");
                        packet->setSrcAddress(srcAddress); // DIRECCION DE ORIGEN O FUENTE
                        packet->setDestAddress(i); // DIRECCION DE DESTINO
                        packet->setByteLength(64); // TAMANYO DEL PAQUETE GATE
                        packet->setLambdagate(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE GATE
                        packet->setKind(0); // IDENTIFICADOR DEL PAQUETE GATE
                        packet->setGrant_IntervalTxArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ANCHO DE BANDA DE SLOT

                        // DEPENDIENDO DEL METODO DE EXTRACCION DE PAQUETES, SE DEFINE UN ANCHO DE BANDA DE SLOT GENERAL O UNO PARA CADA COLA
                        if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
                        {
                            B_slot[0]= 564;//1602;//txrate*1/8; // DEFINIMOS ANCHO DE BANDA DE SLOT
                            packet->setGrant_IntervalTx(0,B_slot[0]);
                            t_slot_initialization[0] = (B_slot[0]*8/txrate); // CALCULAMOS EL TIEMPO DE SLOT DE INICIALIZACION

                            packet->setGrant_IniTime(i*t_slot_initialization[0]+tasa_tx_gate+delay); // TIEMPO DE INICIO DE TRANSIMISION PARA CADA ONU
                        }
                        else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
                        {
                            //FALTA ALGORITMO PARA ASIGNAR POR COLAS!!!!!!!!!
                            // BUCLE FOR PARA DEFINIR UN ANCHO DE BANDA DE SLOT PARA CADA COLA
                            for(int b=0; b<(int)par("numqueue"); b++)
                            {
                                B_slot[b] = 564;//1602;//txrate*1/8; // DEFINIMOS EL ANCHO DE BANDA DE SLOT PARA CADA COLA
                                packet->setGrant_IntervalTx(b,B_slot[b]);
                                //ev<<" Ancho de Banda de slot "<<b<<" "<<B_slot[b]<<endl;
                                t_slot_initialization[b] = (B_slot[b]*8/txrate); // CALCULAMOS EL TIEMPO DE SLOT DE INICIALIZACION
                                packet->setGrant_IniTime(i*t_slot_initialization[b]+tasa_tx_gate+delay); // TIEMPO DE INICIO DE TRANSIMISION PARA CADA ONU

                            }
                        }

                        // ENVIAMOS LOS PAQUETES GATE MEDIANTE EL ENVIO RETARDADO
                        sendDelayed(packet, tasa_tx_gate, "mactxOut");

                    }

                    //CALCULAMOS EL TIEMPO DE TX SIGUIENTE QUE UTILIZAREMOS EN EL METODOD DE POLLING DE IPACT
                    tiempo_tx_siguiente = ((int)par("numOnu")*t_slot_initialization[0])+tasa_tx_gate+delay;
                    //ev<<" Tiempo Transmision Siguiente: "<<tiempo_tx_siguiente<<endl;
                }

                //MIS DE UNA LONGITUD DE ONDA
                else if((int)par("numlong")>1)
                {
                   // CALCULAMOS EL DELAY O RETARDO DEPENDIENDO DE LA LONGITUD DE NUESTRA RED
                    longitud_total_red = ((int)par("longpon1")+(int)par("longpon2")); // DEFINIMOS EL PARAMETRO QUE INDICA LA LONGITUD TOTAL DE LA RED EN METROS
                    delay = (longitud_total_red*3)/(velocidad*2); // CALCULAMOS EL RETARDO O DELAY PARA LA RED SEGUN LA LONGITU QUE DEFINAMOS AL PRINCIPION DE LA SIMULACION

                    // INICIALIZAMOS EL OLT MANDANDO UN MENSAJE GATE A CADA ONU INDICANDO EL ANCHO DE BANDA DE SLOT Y EL TIEMPO DE INICIO DE TRANSMISION
                    // MEDIANTE EL BUCLE FOR CREAMOS LOS PAQUETES GATE PARA LAS ONUS DE NUESTRA RED
                    for(int i=0; i<(int)par("numOnu"); i++)
                    {
                        // CREAMOS EL PAQUETE GATE
                        GATEmsg *packet = new GATEmsg("gate");
                        packet->setSrcAddress(srcAddress); // DIRECCION DE ORIGEN O FUENTE
                        packet->setDestAddress(i); // DIRECCION DE DESTINO
                        packet->setByteLength(64); // TAMANYO DEL PAQUETE GATE
                        packet->setLambdagate(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE GATE
                        packet->setKind(0); // IDENTIFICADOR DEL PAQUETE GATE
                        packet->setGrant_IntervalTxArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ANCHO DE BANDA DE SLOT

                        lambda++; //ACTUALIZAMOS LA VARIABLE LAMBDA

                        if(lambda==(int)par("numlong"))
                        {
                            lambda=0;
                        }

                        // DEPENDIENDO DEL METODO DE EXTRACCION DE PAQUETES, SE DEFINE UN ANCHO DE BANDA DE SLOT GENERAL O UNO PARA CADA COLA
                        if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
                        {
                            B_slot[0]= 564;//1602;//txrate*1/8; // DEFINIMOS ANCHO DE BANDA DE SLOT
                            packet->setGrant_IntervalTx(0,B_slot[0]);
                            t_slot_initialization[0] = (B_slot[0]*8/txrate); // CALCULAMOS EL TIEMPO DE SLOT DE INICIALIZACION
                            packet->setGrant_IniTime(auxiliar*t_slot_initialization[0]+tasa_tx_gate+delay); // TIEMPO DE INICIO DE TRANSIMISION PARA CADA ONU
                            contador++;
                            if(contador>(int)par("numlong"))
                            {
                                auxiliar++;
                                contador=1;
                            }
                        }

                        else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
                        {
                            //FALTA ALGORITMO PARA ASIGNAR POR COLAS!!!!!!!!!
                            // BUCLE FOR PARA DEFINIR UN ANCHO DE BANDA DE SLOT PARA CADA COLA
                            for(int b=0; b<(int)par("numqueue"); b++)
                            {
                                B_slot[b] = 564;//1602;//txrate*1/8; // DEFINIMOS EL ANCHO DE BANDA DE SLOT PARA CADA COLA
                                packet->setGrant_IntervalTx(b,B_slot[b]);
                                //ev<<" Ancho de Banda de slot "<<b<<" "<<B_slot[b]<<endl;
                                t_slot_initialization[b] = (B_slot[b]*8/txrate); // CALCULAMOS EL TIEMPO DE SLOT DE INICIALIZACION
                                packet->setGrant_IniTime(auxiliar*t_slot_initialization[b]+tasa_tx_gate+delay); // TIEMPO DE INICIO DE TRANSIMISION PARA CADA ONU
                                contador++;
                                if(contador>(int)par("numlong"))
                                {
                                    auxiliar++;
                                    contador=1;
                                }
                            }
                        }


                        // ENVIAMOS LOS PAQUETES GATE MEDIANTE EL ENVIO RETARDADO
                        sendDelayed(packet, tasa_tx_gate, "mactxOut");
                    }

                    entero=(int)(int)par("numOnu")/(int)par("numlong");
                    resto=(int)par("numOnu")%(int)par("numlong");

                    for(int k=0; k<(int)par("numlong");k++)
                    {
                        tiempo_tx_sig[k]=(entero*t_slot_initialization[0])+tasa_tx_gate+delay;
                    }

                    for(int f=0; f<(int)par("numlong");f++)
                    {
                        if(resto>0)
                        {
                            entero_aux=entero+1;
                            tiempo_tx_sig[f]=(entero_aux*t_slot_initialization[0])+tasa_tx_gate+delay;
                        }
                    resto--;
                    }

                    for(int m=0; m<(int)par("numlong");m++)
                    {
                        //ev<<"Tiempo de Transmision Siguiente para lambda "<< m <<":"<<" "<< tiempo_tx_sig[m]<<endl;
                    }
                }
                break;
            }
        case 6:
              PID(msg);
              tiempo_inic_PID+=tiempo_PID;
              msg2 = new cMessage ("Mensaje PID");
              msg2->setKind(6); // IDENTIFICAMOS EL AUTOMENSAJE CON EL IDENTIFICADOR = 6
              scheduleAt(tiempo_inic_PID, msg2); // SI QUE QUITA NO SE INICIALIZAN LAS ONUS, NO SE MANDAN LOS GATES


              //FairExcessBandwidht(msg);


              break;
        case 7:
            PID_control_delay(msg);
            break;

        // Case 8: Llama al Algoritmo Genético
        case 8:
            delete msg;
            if(flagThread==0)
            {
                //ev<<"Entra donde el algoritmo"<<endl;
                //Solo lo hacemos una vez
                flagThread=1;
                pthread_create(&hiloAlgGenet, NULL,Algoritmo_Genetico, NULL);
            }

            if(finTraining==1)
            {
                //printf(" He terminado el train con el GA.\n");
                finTraining=0; //lo volvemos a poner a 0 para que no entre nunca más
                num_bits_gen_res=num_bits_gen;
                num_bits_gen_S1_res = num_bits_gen_S1;
                num_bits_gen_S2_res = num_bits_gen_S2;
                num_bits_gen_S3_res = num_bits_gen_S3;
                B_sla1_res = B_sla1;
                B_sla2_res = B_sla2;
                B_sla3_res = B_sla3;
                tfin_train = simTime();

                finalTraining = fopen("ResultadosSimulaciones/PID_GA/TiempoFinTraining.txt", "a+");
                fprintf (finalTraining, "%d\t %d\t %g\n", tamPoblacion, numGen, SIMTIME_DBL(tfin_train));
                fclose (finalTraining);

                temporal = fopen("ResultadosSimulaciones/PID_GA/temporal.txt", "a+");
                fprintf (temporal, "----------------------------------------------------------------------------\n");
                fclose (temporal);

                //op_sim_end ("Fin del entrenamiento.", "", "", "");
                endSimulation(); // LLAMAMOS A LA FUNCION TERMINAR SIMULACION
                callFinish(); // LLAMAMOS A LA FUNCIxN FINALIZAR

            }

            //tiempo_fin_training = 10;
            tiempo_fin_training = ((nIterPID * tiempo_PID * tamPoblacion * numGen)+ 2*(nIterPID * tiempo_PID));
            msg9 = new cMessage ("Mensaje Fin Training");
            msg9->setKind(8); // IDENTIFICAMOS EL AUTOMENSAJE CON EL IDENTIFICADOR = 8
            scheduleAt(tiempo_fin_training, msg9);

            break;

        // Case 9: Llama a la Red Neuronal
        case 9:
            delete msg;
            if (counterPID==iterRedNeuronal)
            {
                counterPID = 0;

                //Metemos las entradas de la red neuronal en el vector de entradas:
                V_IN_NN[0]=errorNN;
                V_IN_NN[1]=error_antNN;
                V_IN_NN[2]=error_2antNN;

                //MODIFICADO POR DAVID
                V_IN_NN[3]=1.0; // Primera entrada de bias añadida

                min_error_NN=0.0;
                //max_error_NN=100000.0;
                max_error_NN=1000000000.0;    // PARÁMETRO PARA DEFINIR LA NORMALIZACIÓN DE LA RED

                /*for(int i=0; i<IN_NN; i++)
                {
                    if(V_IN_NN[i]>max_error_NN)
                    {
                        max_error_NN=V_IN_NN[i];
                    }
                    if(V_IN_NN[i]<min_error_NN)
                    {
                        min_error_NN=V_IN_NN[i];
                    }
                }*/

              //Normalizamos
              for(int i=0; i<IN_NN; i++)
              {

                  V_IN_NN[i]= (V_IN_NN[i]-min_error_NN)/(max_error_NN-min_error_NN);

              }

              /*errorNN=V_IN_NN[0];
              error_antNN=V_IN_NN[1];
              error_2antNN=V_IN_NN[2];*/

              if(iterAprendizaje==numIterAutoaprendizaje)
              {
                  iterAprendizaje=0;
                  Neural_Network_BackPropagation();     //Autoaprendemos y se modifican los pesos
                  Neural_Network_FeedPropagation();     //Propagación hacia delante para hallar los valores de las Ks

              }
              else
              {
                  Neural_Network_FeedPropagation();     //Propagación hacia delante para hallar los valores de las Ks
              }

              Neuronal = fopen("ResultadosSimulaciones/PID_GA/RedNeuronal.txt", "a+");
              fprintf (Neuronal, "%g\t\t %g\t\t %g\t\t %g\n", Kp, Ti, Td, SIMTIME_DBL(simTime()));
              fprintf (Neuronal, "\t\t\t %g\t\t %g\n", Ki, Kd);
              fclose (Neuronal);
            }
            tiempoRed += tiempo_PID;
            msg11 = new cMessage ("Mensaje Red Neuronal");
            msg11->setKind(9); // IDENTIFICAMOS EL AUTOMENSAJE CON EL IDENTIFICADOR = 8
            scheduleAt(tiempoRed, msg11);
        break;


        default:
            delete msg;
            break;
    }

}



//////////////////////////////////////////////////////////////////////////////////////////

////FUNCIÓN FAIR EXCESS BANDWITH**********************************

//////////////////////////////////////////////////////////////////////////////////////////////////
void MAC_OLT::FairExcessBandwidht(cMessage *msg)
{
    //borramos el automensaje

    //CMessage *reportmsg = check_and_cast<REPORTmsg *>(msg);

    delete msg;

    double T_cycle=0.002; // TIEMPO DE CICLO MAXIMO EN MILISEGUNDOS
    double txrate = (int)par("txrate"); // VARIABLE TASA DE TRANSMISION
    double tasa_tx_report = 512/txrate; // TASA DE TRANSMISION DEL PAQUETE REPORT DE 64 BYTES
    double T_guarda = 0.000001; //TIEMPO DE GUARDA QUE SE ESPERA ENTRA LA TRANSMISION DE DOS ONUS    double Total_PID=0.0;
    double B_init_total=0.0;
    double B_excess_total=0.0;
    double B_excess_onu_total=0.0;
    double T_cycle_util = T_cycle - T_guarda*((int)par("numOnu")) -tasa_tx_report*((int)par("numOnu")); // TIEMPO DE CICLO FINAL Y LO VISUALIZAMOS POR PANTALLA
    long double B_cycle_util = txrate*T_cycle_util/8; // ANCHO DE BANDA MÁXIMO DEL CICLO EN BYTES Y LO VISULAIZAMOS POR PANTALLA
    //ev<<" Ancho de banda del ciclo util: "<<B_cycle_util<<"Bytes"<<endl;

    //parámetro alfa de la función utilidad
    double alfa= 1;

    //double alfa_invertido= 1;

    //parámetro temporal para reordena
    double temp=0;
    int num_onus_excess=0;
    double pi=0.0;
    double pi_optimo=0.0;
    int salir=0;
    int recorrer=0;
    double w_total=0.0;
    double B_m_total=0.0;
    double xm_onu_total=0.0;
    //double cantidad=1000;

    //El algoritmo modifica el ancho de banda máximo para ajustarlo de la forma más justa

    tiempo_inic_FAIR+=tiempo_FAIR;

    for(int i=0; i<(int)par("numOnu"); i++)
    {
        if(i==0)
        {
            w_onu[i]=1;
        }
        else if((i>0)&&(i<6))
        {
             w_onu[i]=2;
        }
        else
        {
             w_onu[i]=3;
        }
    }

    for(int i=0; i<(int)par("numOnu"); i++)
    {
        //B_demand[i]=rand();
        //ev<<"B_demand[i] EN  MEDIA:  "<<bw_demand_ONU[i]<<endl;
    }

    /*if (simTime()>150*contprueba)
    {
        contprueba++;

        for(int i=0; i<(int)par("numOnu"); i++)
        {
              if (i==0)
              {
                  B_min[i]=(double) ((T_ciclo*(double)70*1000000))/8;
                  ev<<" Ancho de banda minimo garantizado: "<<B_min[i]<<"Bytes"<<endl;
              }
              else if (i<6)
              {
                  B_min[i]=(double) ((T_ciclo*(double)40*1000000))/8;
                  ev<<" Ancho de banda minimo garantizado: "<<B_min[i]<<"Bytes"<<endl;
              }
              else
              {
                  B_min[i]=double ((T_ciclo*(double)60*1000000))/8;
                  ev<<" Ancho de banda minimo garantizado: "<<B_min[i]<<"Bytes"<<endl;
              }
        }
    }*/


    //Se envía un automensaje para que se vuelva a ejecutar el algoritmo
    cMessage *msg2 = new cMessage ("Mensaje algoritmo Fair Excess Bandwith");
    msg2->setKind(6); // IDENTIFICAMOS EL AUTOMENSAJE CON EL IDENTIFICADOR = 6
    scheduleAt(tiempo_inic_FAIR, msg2); // SI QUE QUITA NO SE INICIALIZAN LAS ONUS, NO SE MANDAN LOS GATES


    //RECORREMOS TODAS LAS ONU para asignarles su ancho de banda inicial a todas

    //Este ancho de banda viene en función de su ancho de banda garantizado

    for(int i=0; i<(int)par("numOnu"); i++)
    {
        //ev<<"Ancho de banda demandado último: "<<B_demand[i]<<" y ancho de banda minimo garantizado:  "<<B_min[i]<<endl;

        //if(B_demand[i]<B_min[i])

        if(bw_demand_ONU[i]<B_min[i])
        {
            //B_init[i]=B_demand[i];
            B_init[i]=bw_demand_ONU[i];
        }
        else
        {
              B_init[i]=B_min[i];
        }

        //asignamos este valor al B_max de la ONU
        B_max_onu[i]=B_init[i];
        //ev<<"Ancho de banda asignado inicialmente B_max_onu: "<<B_max_onu[i]<<endl;

        B_init_total +=B_init[i];

    }//fin del bucle for

    B_excess_total= B_cycle_util-B_init_total;

    //ev<<"Ancho de banda total en exceso: "<<B_excess_total<<" y B_init_total: "<<B_init_total<<endl;

    //HAY EXCESO DE ANCHO DE BANDA PARA REPARTIR

    //si tenemos ancho de banda en exceso

    if(B_excess_total>0)
    {
        //ev<<"Hay ancho de banda que sobra"<<endl;

        //recorremos todas las ONUs para saber qué ONUs piden más de su mínimo

        for(int i=0; i<(int)par("numOnu"); i++)
         {
            //lA ONU ha pedido más de lo asignado inicialmente B_init

            //if((B_demand[i]-B_init[i])>0)

            if((bw_demand_ONU[i]-B_init[i])>0)
            {
                //B_excess_onu[i]=B_demand[i]-B_init[i];

                B_excess_onu[i]=bw_demand_ONU[i]-B_init[i];

            }//fin de comprobar si tiene más ancho de banda que su inicila B_init
            else
            {
                B_excess_onu[i]=(double) 0.0;
            }//fin de comprobar si tiene más ancho de banda que su inicila B_init

            B_excess_onu_total+=B_excess_onu[i];

            //ev<<"Ancho de banda que necesita cada onu: "<<B_excess_onu[i]<<"y total de todas las ONUs: "<<B_excess_onu_total<<endl;

         }//fin del bucle for para comprobar el exceso


        //ASIGNAMOS EL EXCESO DE ANCHO DE BANDA ENTRE LAS ONUS

        //asignamos el exceso de ancho de banda en el ciclo entre las ONUs que demandan más B_excess_onu>0

        if (B_excess_onu_total< B_excess_total)
        {

            //ev<<"Podemos dar todo el ancho de banda que tienen en exceso a todas las ONUs"<<endl;

             for(int i=0; i<(int)par("numOnu"); i++)
             {
                 //ev<<"Ancho de banda asignado inicialmente B_max_onu: "<<B_max_onu[i]<<endl;

                 B_max_onu[i]+=(double)B_excess_onu[i];

                  //ev<<"Les damos todo lo que piden luego B_excess_onu[i] "<<B_excess_onu[i]<<" y total: "<<B_max_onu[i]<<endl;

             }//fin del bucle for

        }
        //no se puede dar todo lo que demandan las ONUs, se hace un reparto justo
        else
        {
            //1. Hacemos cómputo de todas los valores de pi para todas las ONUs que piden más
             for(int i=0; i<(int)par("numOnu"); i++)
             {
                 if(B_excess_onu[i]>0)
                 {
                     //pi_onu[num_onus_excess]=(double) w_onu[i]/(B_excess_onu[i]*alfa);
                     pi_onu[num_onus_excess]=(double) (w_onu[i])/pow(B_excess_onu[i],alfa);
                     //AQUÍ TENGO QUE ESCOGER LAS ONUS que demandan más
                     num_onus_excess+=1;
                     //ev<<"valor de pi_onu: "<< pi_onu[i]<<" pow(B_excess_onu[i],alfa) "<<(double) pow(B_excess_onu[i],alfa)<<endl;
                 }

             }//fin del bucle for para hallar valores de pi_onu

             //2. Reordenamos pi_onu del menor valor al mayor
             for(int i=0; i<num_onus_excess; i++)
             {
                 for(int j=i+1; j<(int)par("numOnu"); j++)
                 {
                     if(pi_onu[j]<pi_onu[i])
                     {
                         temp=pi_onu[j];
                         pi_onu[j]=pi_onu[i];
                         pi_onu[i]=pi_onu[j];
                         pi_onu[i]=temp;
                     }//fin del if
                 }
             }//fin del ordenar valores de pi

             //Visualizamos el vector ya ordenado
             for(int i=0; i<num_onus_excess; i++)
             {
                 //ev<<"valor de pi_onu ordenado: "<<pi_onu[i]<<endl;
             }

             recorrer=0;

             long  double prueba_xm=(long double) 0.0;

             // 3. Empezamos a hacer las iteraciones para hallar el valor óptimo de pi

            //TENEMOS QUE COGER A LAS ONUS que demandan más ancho de banda durante su ciclo
            while ((salir==0) && (recorrer<num_onus_excess))
            {
                 //tomamos el pi por orden
                 pi=(double) pi_onu[recorrer];
                 //ev<<"pi "<<pi<<endl;
                 xm_onu_total = (double) 0.0;

                 //(a) hallamos xm para cada iteración
                 for(int i=1; i<(int)par("numOnu"); i++)
                 {
                     if(B_excess_onu[i]>0)
                     {
                       //analizamos el valor de xm para cada onu xm_onu
                       prueba=(long double) (w_onu[i]/pi);
                       //ev<<"prueba "<< prueba << " y 1/alfa "<< 1/alfa<< " alfa__invertido "<<alfa_invertido<<endl;
                       xm_onu[i]=(long double) pow((long double)prueba,(1/alfa));
                       // xm_onu[i]=(long double) pow((long double)prueba,(double)(alfa));

                       if(xm_onu[i]>B_excess_onu[i])
                       {
                           xm_onu[i]=B_excess_onu[i];
                           //ev<<"xm_onu[i]>B_excess_onu[i por lo que limito: "<<xm_onu[i]<<endl;
                       }//fin del xm

                       xm_onu_total= xm_onu_total+xm_onu[i];
                       //ev<<"xm_onu[i] dentro del bucle:  "<<(long double)xm_onu[i]<<"  con pi: "<<pi<<endl;
                     }//fin de comprobar si la onu demanda más ancho de banda
                 }//fin del for de las iteraciones

                 //(b) computamos la suma de xm de todas las ONUs
                 if(xm_onu_total<B_excess_total)
                 {
                     //ev<<"Salimos con : "<<xm_onu_total<<"  y B_excess_total "<<" y pi  "<<pi<<endl;
                     salir=1;
                 }
                 recorrer= recorrer+1;

             }//fin del do while

             //ev<<"hemos salido del do while con xm_onu_total: "<<xm_onu_total<<"  y B_excess_total "<< B_excess_total<<endl;
             //ev<<"recorrer: "<<recorrer<<endl;
             w_total=0;
             B_m_total=0;

             //4. Salimos y hallamos el valor de pi final y computamos los valores de xm
             for(int k=0; k<(int)par("numOnu"); k++)
             {
                 if(B_excess_onu[k]>0)
                 {
                     if(k<=(recorrer-1))
                     {
                         //w_total=w_total+w_onu[k];
                         w_total=w_total+pow(w_onu[k],(1/alfa));
                     }
                     else
                     {
                         B_m_total=B_m_total+B_excess_onu[k];
                     }
                 }
             }
             //ev<<"w_total ANTES: "<<w_total<<" B_m_total "<<B_m_total<<endl;
             //pi_optimo=(double)((w_total*(1/alfa))/(B_excess_total-B_m_total))*alfa;
             //w_total = (double) pow(w_total, (1/alfa));
             //ev<<"w_total: "<<w_total<<endl;
             //ev<<"(B_excess_total-B_m_total):  "<<(B_excess_total-B_m_total)<<endl;
             pi_optimo=(double)pow((w_total/(B_excess_total-B_m_total)),alfa);

             //ev<<"Este es el valor óptimo pi_optimo: "<<pi_optimo<<endl;

             for(int i=0; i<(int)par("numOnu"); i++)
             {
                  if(B_excess_onu[i]>0)
                  {
                      xm_onu[i]=(double) pow((w_onu[i]/pi_optimo),(1/alfa));

                      if(xm_onu[i]>B_excess_onu[i])
                      {
                          xm_onu[i]=B_excess_onu[i];
                      }

                      //ev<<"El ancho de banda en exceso DADO a esa oNU FINAL: " <<xm_onu[i]<<" y B_excess_onu[i]: "<<B_excess_onu[i]<<endl;

                      B_max_onu[i]=B_init[i]+xm_onu[i];
                  }//fin de if-esle
             }//fin de for
         }//fin de if-else de asignacion
    }//if de B_excess_total>0
    else
    {
        for(int i=0; i<(int)par("numOnu"); i++)
         {
            B_max_onu[i]=B_init[i];
         }
    }

    long double ancho=(double)0.0;

    for(int i=0; i<(int)par("numOnu"); i++)
    {
        //ev<<"ANCHO DE BANDA MÁXMO FINAL actualizado a cada oNU: "<<B_max_onu[i]<<endl;
        ancho=ancho+B_max_onu[i];
    }
    //ev<<" Ancho de banda del ciclo util: "<<B_cycle_util<<" y Btotal: "<<ancho<<endl;

    //finalmente se lo asignamos a B_max_sla[] que es el utilizado por el algoritmo DBA_POLLING_PID

    //lo dejamos tapado de momento para no alterar el ancho de banda máximo inicial

    for (int i=0; i<(int)par("numOnu"); i++)
    {
        B_max_sla[i]=B_max_onu[i]*8;
    }
    //ev<<"el siguiente contador es: "<<contadorFair<<endl;

    if(simTime()>=10*contadorFair)
    {
        contadorFair++;
        //ev<<"el siguiente contador es: "<<contadorFair<<endl;

        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL B_ALLOC_MEDIO , VALOR MEDIO DE LA VENTANA
        //SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
        B_alloc_medio=fopen("results/B_alloc_medio.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        fprintf(B_alloc_medio,"%g\t" , (double)bw_alg_ONU[0]);
        fprintf(B_alloc_medio,"\t");
        fprintf(B_alloc_medio,"%g\t" , (double)bw_alg_ONU[1]);
        fprintf(B_alloc_medio,"\t");
        fprintf(B_alloc_medio,"%g\t" , (double)bw_alg_ONU[6]);
        fprintf(B_alloc_medio,"\t");
        fprintf(B_alloc_medio,"%g\t" , SIMTIME_DBL(simTime()));
        fprintf(B_alloc_medio,"\n");
        fclose(B_alloc_medio); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS


        BW_exceso=fopen("results/B_exceso.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        fprintf(BW_exceso,"%g\t" , (double)B_cycle_util);
        fprintf(BW_exceso,"\t");
        fprintf(BW_exceso,"%g\t" , (double)B_excess_total);
        fprintf(BW_exceso,"\t");
        fprintf(BW_exceso,"%g\t" , (double)xm_onu[0]);
        fprintf(BW_exceso,"\t");
        fprintf(BW_exceso,"%g\t" , (double)xm_onu[1]*5);
        fprintf(BW_exceso,"\t");
        fprintf(BW_exceso,"%g\t" , (double)xm_onu[10]*10);
        fprintf(BW_exceso,"\t");
        fprintf(BW_exceso,"%g\t" , (double) (xm_onu[0]+xm_onu[1]*5+xm_onu[10]*10));
        fprintf(BW_exceso,"\t");
        fprintf(BW_exceso,"%g\t" , (double)B_max_onu[0]);
        fprintf(BW_exceso,"\t");
        fprintf(BW_exceso,"%g\t" , (double)B_max_onu[1]*5);
        fprintf(BW_exceso,"%g\t" , (double)B_max_onu[10]*10);
        fprintf(BW_exceso,"\t");
        fprintf(BW_exceso,"%g\t" , (double)B_max_onu[0]+B_max_onu[1]*5+B_max_onu[10]*10);
        fprintf(BW_exceso,"\t");
        fprintf(BW_exceso,"%g\t" , SIMTIME_DBL(simTime()));
        fprintf(BW_exceso,"\n");
        fclose(BW_exceso); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS


        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL B_MAX_PID
        //SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
        B_max_PID=fopen("results/B_max_PID.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        fprintf(B_max_PID,"%g\t" , (double)B_max_sla[0]);
        fprintf(B_max_PID,"\t");
        fprintf(B_max_PID,"%g\t" , (double)B_max_sla[1]);
        fprintf(B_max_PID,"\t");
        fprintf(B_max_PID,"%g\t" , (double)B_max_sla[10]);
        fprintf(B_max_PID,"\t");
        fprintf(B_max_PID,"%g\t" , SIMTIME_DBL(simTime()));
        fprintf(B_max_PID,"\n");
        fclose(B_max_PID); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS


        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL B_MAX_PID
        //SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
        B_max_PID_total=fopen("results/B_max_PID_total.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        for(int i=0; i<(int)par("numOnu"); i++)
        {
            fprintf(B_max_PID_total,"%g\t" , (double)B_max_sla[i]);
            fprintf(B_max_PID_total,"\t");
        }
        fprintf(B_max_PID_total,"%g\t" , SIMTIME_DBL(simTime()));
        fprintf(B_max_PID_total,"\n");
        fclose(B_max_PID_total); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

         //SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
         B_onu_intantaneo=fopen("results/B_onu_intantaneo.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
         for(int i=0; i<(int)par("numOnu"); i++)
         {
             fprintf(B_onu_intantaneo,"%g\t" , (double) B_alloc[i]);
             fprintf(B_onu_intantaneo,"\t");
         }
         fprintf(B_onu_intantaneo,"%g\t" , SIMTIME_DBL(simTime()));
         fprintf(B_onu_intantaneo,"\n");
         fclose(B_onu_intantaneo); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS


        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL B_Mbps

        //SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
         /* BW_Mbps=fopen("results/BW_Mbps.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        fprintf(BW_Mbps,"%g\t" , (double)B_Mbps_sla[0]/SIMTIME_DBL(simTime())/1000000);
        fprintf(BW_Mbps,"\t");
        fprintf(BW_Mbps,"%g\t" , (double)B_Mbps_sla[1]/SIMTIME_DBL(simTime())/5/1000000);
        fprintf(BW_Mbps,"\t");
        fprintf(BW_Mbps,"%g\t" , (double)B_Mbps_sla[2]/SIMTIME_DBL(simTime())/10000000);
        fprintf(BW_Mbps,"\t");
        fprintf(BW_Mbps,"%g\t" , SIMTIME_DBL(simTime()));
        fprintf(BW_Mbps,"\n");
        fclose(BW_Mbps); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS*/


        BW_Mbps=fopen("results/BW_Mbps.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        for(int i=0; i<(int)par("numOnu"); i++)
        {
            fprintf(BW_Mbps,"%g\t" , (double)B_Mbps_sla[i]/SIMTIME_DBL(simTime())/1000000);
            fprintf(BW_Mbps,"\t");
        }
        fprintf(BW_Mbps,"\n");
        fclose(BW_Mbps); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS


        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL B_TOTAL
        //SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
        B_total=fopen("results/B_total.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        fprintf(B_total,"%g\t" , (double)B_alloc_total[0]/SIMTIME_DBL(simTime()));
        fprintf(B_total,"\t");
        fprintf(B_total,"%g\t" , (double)B_alloc_total[1]/SIMTIME_DBL(simTime()));
        fprintf(B_total,"\t");
        fprintf(B_total,"%g\t" , (double)B_alloc_total[6]/SIMTIME_DBL(simTime()));
        fprintf(B_total,"\n");
        fclose(B_total); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS


        retardo_analisis_sla=fopen("results/retardo_analisis_sla.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        fprintf(retardo_analisis_sla,"%g\t", SIMTIME_DBL(simTime())); // MEDIA DEL RETARDO GLOBAL DE CADA SLA

        for(int i=0; i<(int)par("numSLA"); i++)
        {
             // RECORREMOS ESTE BUCLE FOR PARA OBTENER LA MEDIA DE CADA SERVICIO ASOCIADA A CADA SLA
             for(int j=0; j<(int)par("numqueue"); j++)
             {
                 fprintf(retardo_analisis_sla,"%g\t", (double)retardo_servicios_sla[i][j].average());
                // fprintf(retardo_analisis_sla,"%g\t", (double)retardo_servicios_sla[i][j].half_confidence_interval()); // MEDIA DEL RETARDO GLOBAL DE CADA SLA
             }
            fprintf(retardo_analisis_sla,"\t");
         }
         fprintf(retardo_analisis_sla,"\n");
         fclose(retardo_analisis_sla); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS


         jitter_analisis_sla=fopen("results/jitter_analisis_sla.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
         fprintf(jitter_analisis_sla,"%g\t", SIMTIME_DBL(simTime())); // MEDIA DEL RETARDO GLOBAL DE CADA SLA

         for(int i=0; i<(int)par("numSLA"); i++)
         {
             // RECORREMOS ESTE BUCLE FOR PARA OBTENER LA MEDIA DE CADA SERVICIO ASOCIADA A CADA SLA

             for(int j=0; j<(int)par("numqueue"); j++)
             {
                      //fprintf(jitter_analisis_sla,"%g\t", (double)jitter_servicios_sla[i][j].average());
                      //fprintf(jitter_analisis_sla,"%g\t", (double)jitter_servicios_sla[i][j].half_confidence_interval()); // MEDIA DEL RETARDO GLOBAL DE CADA SLA
             }
             fprintf(jitter_analisis_sla,"\t");

         }
         fprintf(jitter_analisis_sla,"\n");
         fclose(jitter_analisis_sla); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS


         jitter_analisis_sla_max=fopen("results/jitter_max.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
         fprintf(jitter_analisis_sla_max,"%g\t", SIMTIME_DBL(simTime())); // MEDIA DEL RETARDO GLOBAL DE CADA SLA

         for(int i=0; i<(int)par("numSLA"); i++)
         {
            // RECORREMOS ESTE BUCLE FOR PARA OBTENER LA MEDIA DE CADA SERVICIO ASOCIADA A CADA SLA
            for(int j=0; j<(int)par("numqueue"); j++)
            {
                fprintf(jitter_analisis_sla_max,"%g\t", (double)jitter_servicios_sla_max[i][j]);
                //fprintf(jitter_analisis_sla,"%g\t", (double)jitter_servicios_sla[i][j].half_confidence_interval()); // MEDIA DEL RETARDO GLOBAL DE CADA SLA
            }
            fprintf(jitter_analisis_sla_max,"\t");
         }
         fprintf(jitter_analisis_sla_max,"\n");
         fclose(jitter_analisis_sla_max); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

         //endSimulation(); // LL77AMAMOS A LA FUNCIxN TERMINAR SIMULACIxN
         //callFinish();

    }//final de recoger datos

}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION CENTRALIZEDMETHOD_DMB(CMESSAGE *MSG)--> FUNCION QUE SE INVOCA CON EL MENSAJE O PAQUETE COMO PARAMETRO UNA VEZ QUE     //
//          LLEGUE AL OLT EL PAQUETE REPORT DE LA ��LTIMA ONU DE LA RED Y TENEMOS SELECCIONADO EL PARAMETRO                         //
//          oltmethod_Centralized0_Polling1_wdm2 EN EL OMNETPP.INI CON VALOR 0.                                                 //
//          ESTE ALGORITMO SE ENCARGA DE ASIGNAR EL INSTANTE DE TIEMPO DE INICIO DE LA TRANSMISION Y EL ANCHO DE BANDA DESIGNADO//
//          PARA TRANSMITIR CADA ONU CADA VEZ QUE LE LLEGA EL PAQUETE REPORT DE LA ��LTIMA ONU DE LA RED. CREA TODOS    LOS PAQUETES//
//          GATE A LA VEZ Y LOS ENVIA CON LOS VALORES CORRESPONDIENTES DE TRANSMISION HACIA CADA ONU, LAS CUALES TRANSMITEN     //
//          EN EL INSTANTE DESIGNADO POR EL OLT Y UNA CANTIDAD DE BYTES DESIGNADOS POR EL OLT                                   //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MAC_OLT::centralizedmethod_DMB(cMessage *msg)
{
    //ev<<" EJECUTAMOS EL METODO CENTRALIZADO DMB EN EL OLT."<<endl;

    REPORTmsg *reportmsg = check_and_cast<REPORTmsg *>(msg); // CHEQUEAMOS EL PAQUETE REPORT

    //VARIABLES
    double txrate = (double)par("txrate"); // TASA DE TRANSMISION EN BITS POR SEGUNDO
    double tasa_tx_gate = 512/txrate; // TASA DE TRANSMISION DE UN MENSAJE GATE CON UN TAMANYO DE 64 BYTES
    double tasa_tx_report = 512/txrate; // TASA DE TRANSMISION DE UN MENSAJE REPORT CON UN TAMANYO DE 64 BYTES
    double T_cycle = 0.002; // TIEMPO DE CICLO MAXIMO EN MILISEGUNDOS
    double T_guarda = 0.000001; // TIEMPO DE GUARDA QUE SE ESPERA ENTRA LA TRANSMISION DE DOS ONUS
    double T_guarda_nonu = T_guarda*(int)par("numOnu"); // TIEMPO DE GUARDA TOTAL DE TODAS LAS ONUS MENOS LA ULTIMA
    double T_report_nonu = tasa_tx_report*((int)par("numOnu")); // TASA DE TRANSMISION TOTAL DE LOS PAQUETES REPORT DE TODAS LAS ONUS
    double T_cycle_total = T_cycle - T_guarda_nonu - T_report_nonu; // TIEMPO DE CICLO FINAL Y LO VISUALIZAMOS POR PANTALLA
    //ev<<" Tiempo de ciclo total: "<<T_cycle_total<<"s"<<endl;
    double B_cycle = txrate*T_cycle_total/8; // ANCHO DE BANDA MAXIMO DEL CICLO EN BYTES Y LO VISULAIZAMOS POR PANTALLA
    //ev<<" Ancho de banda del ciclo: "<<B_cycle<<"Bytes"<<endl;
    double B_report = txrate*tasa_tx_report/8; // TAMANYO DEL PAQUETE REPORT (BYTES)
    double B_slot[(int)par("numqueue")]; // VARIABLE DE ANCHO DE BANDA DE SLOT CON TAMANYO EL N��MERO DE COLAS QUE SE DEFINEN
    int srcAddress = 9; // DEFINICION DEL IDENTIFICADOR DE LA DIRECCION DE ORIGEN O FUENTE
    simtime_t time_tx_onu0; // TIEMPO DE TRANSMISION DE LA PRIMERA ONU
    double velocidad = 300000000; // DEFINIMOS EL PARAMETRO VELOCIDAD DE LA VELOCIDAD DE LA LUZ (EN M/S)
    double longitud_total_red; // DEFINIMOS LA VARIABLE QUE NOS INDICA LA LONGITUD TOTAL DE LA RED

    // ASIGANCION DE PESOS
    Wsla[0] = (int)par("w_sla0"); // PESO DEL SLA0 DEFINIDO EN NUESTRA RED
    Wsla[1] = (int)par("w_sla1"); // PESO DEL SLA1 DEFINIDO EN NUESTRA RED
    Wsla[2] = (int)par("w_sla2"); // PESO DEL SLA2 DEFINIDO EN NUESTRA RED
    Wsla[3] = (int)par("w_sla3"); // PESO DEL SLA3 DEFINIDO EN NUESTRA RED
    Wsla[4] = (int)par("w_sla4"); // PESO DEL SLA4 DEFINIDO EN NUESTRA RED

    // ASIGNACION DEL N��MERO DE ONUS
    numonu_sla[0] = (int)par("numonu_sla0"); // N��MERO DE ONUs ASOCIADO AL SLA0
    numonu_sla[1] = (int)par("numonu_sla1"); // N��MERO DE ONUs ASOCIADO AL SLA1
    numonu_sla[2] = (int)par("numonu_sla2"); // N��MERO DE ONUs ASOCIADO AL SLA2
    numonu_sla[3] = (int)par("numonu_sla3"); // N��MERO DE ONUs ASOCIADO AL SLA3
    numonu_sla[4] = (int)par("numonu_sla4"); // N��MERO DE ONUs ASOCIADO AL SLA4

    // CALCULAMOS EL DELAY DEPENDIENDO DE LA LONGITUD Y LE SUMAMOS LA TASA DE TRANSMISION DEL PAQUETE GATE PARA SUMARLE DESPUES AL TIEMPO DE INICIO DE TRANSMISION
    longitud_total_red = ((int)par("longpon1")+(int)par("longpon2")); // DEFINIMOS EL PARAMETRO QUE INDICA LA LONGITUD TOTAL DE LA RED EN METROS
    delay = (longitud_total_red*3)/(velocidad*2); // CALCULAMOS EL RETARDO O DELAY PARA LA RED SEGUN LA LONGITU QUE DEFINAMOS AL PRINCIPION DE LA SIMULACION
    //ev<<" Retardo de la Red PON: "<<delay<<endl; // VISUALIZAMOS EL RETARDO DE LA RED

    //LEEMOS EL TIEMPO CUANDO SE ENVIO EL REPORT DE LA ONU 15 Y LO GUARDAMOS EN EL VECTOR DE LA TABLA
    table_module->table_olt_report_time[0] = reportmsg->getTimesendreport();
    //ev<<" Tiempo en el que se envio el paquete Report "<<table_module->table_olt_report_time[0]<<endl;

    //VAMOS A CALCULAR EL ANCHO DE BANDA DEMANDADO Y LO GUARDAMOS EN LA TABLA DEL OLT
    //ev<<" Calculamos el Bandwidth Demandado y lo guardamos en la tabla del OLT."<<endl;
    // SUMAMOS EL TAMANYO DEL ESTADO DE LAS COLAS DE LA ONU QUE A MANDADO EL REPORT QUE LLEGA AL OLT
    for(int i=0; i<(int)par("numqueue"); i++)
    {
        sumqueue = sumqueue + reportmsg->getQueue_estado(i);
    }
    // SI LA SUMA TOTAL DEL TAMANYO DE LAS COLAS ES 0, DAMOS UN VALOR PREDETERMINADO DE 20 BYTES
    if(sumqueue == 0)
    {
        sumqueue = 20;
    }

    // ASIGNAMOS LA SUMA TOTAL A LA VARIABLE DEL ANCHO DE BANDA DEMANDADO DE LA ONU
    B_demand[reportmsg->getSrcAddress()] = sumqueue;

    sumqueue = 0; // DAMOS EL VALOR 0 A LA SUMA DE LAS COLAS. DE ESTA MANERA LA INICIALIZAMOS DE NUEVO A 0

    // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE EL ANCHO DE BANDA DEMANDADO POR LA ONU Y LO VISUALIZAMOS POR PANTALLA
    table_module->table_olt_report[reportmsg->getSrcAddress()][(int)par("numqueue")] = B_demand[reportmsg->getSrcAddress()];
    //ev<<"ONU "<< reportmsg->getSrcAddress()<<"->"<< "Bandwidth Demandado: "<< B_demand[reportmsg->getSrcAddress()]<<"Bytes"<<endl;

    // SUMAMO EL ANCHO DE BANDA DEMANDADO DE CADA ONU PARA DESPUES COMPARARLO CON EL ANCHO DE BANDA MAXIMO DEL CICLO
    sumbdemand = sumbdemand + B_demand[reportmsg->getSrcAddress()];

    // EJECUTAMOS EL METODO DMB DEL OLT CUANDO NOS LLEGUE EL PAQUETE REPORT DE LA ��LTIMA ONU DE LA RED
    if(reportmsg->getSrcAddress()==((int)par("numOnu")-1))
    {
        //ev<<" EJECUTAMOS EL METODO CENTRALIZADO DEL OLT, METODO DMB."<<endl;
        //ev<<" Suma del Ancho de Banda Demandado por todas las ONUs: "<<sumbdemand<<"Bytes"<<endl;

        // ASIGANCION DE LOS SLA A CADA ONU CON SU RESPECTIVO PESO
        // RECORREMOS MEDIANTE ESTE BUCLE FOR TODOS LOS SLA DEFINIDOS EN LA RED
        for(int j=0; j<(int)par("numSLA"); j++)
        {
            // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs ASOCIADAS A UN SLA
            for(int i=0; i<numonu_sla[j]; i++)
            {
                SLA_onu[id_onu+i] = Wsla[j]; // ASIGANAMOS A LA VARIABLE SLA_onu[] EL VALOR DEL PESO DEL SLA AL QUE ESTA ASOCIADA ESA ONU
                //ev<<" ONU "<<id_onu+i<<": Peso="<<Wsla[j]<<endl; // VISUALIZAMOS EL PESO ASOCIADO A CADA ONU
                numsla[id_onu+i] = j; // INTRODUCIMOS EN LA VARIABLE numsla[] EL IDENTIFICADOR DEL SLA PARA CADA ONU YA QUE LO UTILIZAREMOS PARA RECOGER EL RETARDO DE CADA SLA
                // MEDIANTE ESTE IF, VAMOS INCREMENTANDO EL IDENTIFICADOR DE LA ONU QUE
                if(i==(numonu_sla[j]-1))
                {
                    id_onu=id_onu+1+i;
                }
            }
        }
        id_onu=0; // IGUALAMOS EL IDENTIFICADOR DE LA ONU AL VALOR 0

        // DEFINIMOS EL ANCHO DE BANDA MAXIMO
        W_min = 0.34; // PESO MINIMO CON VALOR FIJO DE 0.34
        long_max = B_cycle/(int)par("numOnu"); // LONGITUD MAXIMA QUE TIENE UNA ONU PARA TRANSMITIR DEPENDIENDO DEL B_cycle Y DEL N��MERO DE ONUs
        B_basico = W_min*long_max; // ANCHO DE BANDA BASICO PARA TRANSMITIR QUE TIENE CADA ONU Y LO VISUALIZAMOS POR PANTALLA
        //ev<<" Ancho de Banda Basico: "<<B_basico<<endl;

        // RECORREMOS MEDIANTE ESTE BUCLE FOR LOS SLAs DEFINIDOS EN NUESTRA RED PARA REALIZAR EL SUMATORIO PARA CALCULAR EL ANCHO DE BANDA ASOCIADO A CADA SLA
        for(int i=0; i<(int)par("numSLA"); i++)
        {
            sumatorio = sumatorio + (numonu_sla[i]*Wsla[i]); // CALCULAMOS EL SUMATORIO Y LO VISUALIZAMOS POR PANTALLA
            //ev<<" Sumatorio: "<<sumatorio<<endl;
        }

        // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs PARA CALCULAR EL ANCHO DE BANDA DE CADA ONU ASIGNADO POR EL SLA QUE CORRESPONDE A CADA ONU
        for(int j=0; j<(int)par("numOnu"); j++)
        {
            B_ex_sla[j] = (B_cycle - (B_basico*(int)par("numOnu")))*SLA_onu[j]/sumatorio; // CALCULAMOS EL ANCHO DE BANDA ASOCIADO A CADA ONU SEGUN EL SLA ASOCIADO A LA ONU
            //ev<<" Ancho de Banda de SLA de la ONU"<<j<<": "<<B_ex_sla[j]<<endl; // VISUALIZAMOS EL ANCHO DE BANDA
        }
        // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs PARA CALCULAR EL ANCHO DE BANDA MAXIMO DE CADA ONU
        for(int j=0; j<(int)par("numOnu"); j++)
        {
            B_max_dmb[j] = B_basico + B_ex_sla[j]; // CALCULAMOS EL ANCHO DE BANDA MAXIMO Y LO VISUALIZAMOS POR PANTALLA
            //ev<<" Ancho de Banda Maximo de la ONU"<<j<<": "<<B_max_dmb[j]<<endl;
        }
        sumatorio = 0; // DAMOS EL VALOR 0 AL SUMATORIO PARA QUE NO SE INCREMENTE

        // COMPARAMOS SI LA SUMA TOTAL DE ANCHO DE BANDA DEMANDADO ES MAYOR O MENOR QUE EL ANCHO DE BANDA MAXIMO DEL CICLO
        if(sumbdemand < B_cycle)
        {
            B_alloc[0] = B_demand[0] + B_report; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA DEMANDADO MAS EL TAMANYO DEL PAQUETE REPORT
            // VISUALIZAMOS POR PANTALLA EL ANCHO DE BANDA ASIGANDO
            //ev<<"Ancho de Banda Asignado ONU 0: "<<B_alloc[0]<<endl;
            // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
            table_module->table_olt_report[0][(int)par("numqueue")+1] = B_alloc[0];
            //ev<<"ONU "<< 0<<"->"<< "Bandwidth Asignado: "<< B_alloc[0]<<"Bytes"<<endl;

            t_slot[0] = B_alloc[0]*8/txrate; // ASIGNAMOS EL TIEMPO DE SLOT PARA LA ONU 0

            time_tx_onu0 = simTime() + delay + tasa_tx_gate; // TIEMPO DE TRANSMISION PARA LA ONU 0 CON DISTANCIAS FIJAS
            //ev<<" Tiempo de inicio de transmision de la ONU 0: "<<time_tx_onu0<<endl;

            // CREAMOS EL PAQUETE GATE QUE MANDA EL OLT PARA LA ONU 0
            GATEmsg *packet = new GATEmsg("gate");
            packet->setSrcAddress(srcAddress); // DIRECCION DE ORIGEN O FUENTE
            packet->setDestAddress(0); // DIRECCION DE DESTINO
            packet->setByteLength(64); // TAMANYO DEL PAQUETE GATE
            packet->setLambdagate(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE GATE
            packet->setKind(0); // IDENTIFICADOR DEL PAQUETE GATE
            packet->setGrant_IntervalTxArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ANCHO DE BANDA DE SLOT
            packet->setNumsla(numsla[0]); // IDENTIFICADOR DEL SLA DE LA ONU DE DESTINO

            // DEPENDIENDO DEL METODO DE EXTRACCION DE PAQUETES, SE DEFINE UN ANCHO DE BANDA DE SLOT GENERAL O UNO PARA CADA COLA
            if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
            {
                B_slot[0]= B_alloc[0]; // DEFINIMOS ANCHO DE BANDA DE SLOT
                packet->setGrant_IntervalTx(0,B_slot[0]);
            }
            else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
            {
                //FALTA ALGORITMO PARA ASIGNAR POR COLAS!!!!!!!!!
                // BUCLE FOR PARA DEFINIR UN ANCHO DE BANDA DE SLOT PARA CADA COLA
                for(int b=0; b<(int)par("numqueue"); b++)
                {
                    B_slot[b] = B_alloc[b]; // DEFINIMOS EL ANCHO DE BANDA DE SLOT PARA CADA COLA
                    packet->setGrant_IntervalTx(b,B_slot[b]);
                    //ev<<"Ancho de Banda de Slot "<<b<<" "<<B_slot[b]<<endl;
                }
            }
            packet->setGrant_IniTime(time_tx_onu0); // TIEMPO DE INICIO DE TRANSMISION
            packet->setTimereport(table_module->table_olt_report_time[0]); // PASAMOS A ESTE CAMPO DESDE LA TABLA DEL MODULO OLT_TABLE EL TIEMPO CUANDO SE ENVIA EL REPORT EN LA ONU

            // ENVIAMOS LOS PAQUETES GATE MEDIANTE EL ENVIO RETARDADO
            sendDelayed(packet, tasa_tx_gate, "mactxOut");

            tstarttime = time_tx_onu0; // ASIGNAMOS A LA VARIABLE tstarttime EL TIEMPO DE INICIO DE TRANSMISION DE LA ONU 0

            // CREAMOS CON EL BUCLE FOR LOS PAQUETES GATE PARA LAS DEMAS ONUS
            for(int i=1; i<(int)par("numOnu"); i++)
            {
                B_alloc[i] = B_demand[i] + B_report; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA DEMANDADO MAS EL TAMANYO DEL PAQUETE REPORT
                // VISUALIZAMOS POR PANTALLA EL ANCHO DE BANDA ASIGNADO
                //ev<<" Ancho de Banda Asigando ONU "<<i<<": "<<B_alloc[i]<<endl;
                // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
                table_module->table_olt_report[i][(int)par("numqueue")+1] = B_alloc[i];
                //ev<<"ONU "<< i<<"->"<< "Bandwidth Asignado: "<< B_alloc[i]<<"Bytes"<<endl;

                t_slot[i] = B_alloc[i]*8/txrate; //ASIGNAMOS EL TIEMPO DE SLOT PARA CADA ONU

                //ASIGNAMOS EL TIEMPO DE INICIO DE TRANSMISION DE LAS ONUS Y LO VISUALIZAMOS POR PANTALLA
                tstarttime = tstarttime + T_guarda + t_slot[i-1];
                //ev<<" Tiempo de tslot de la onu "<<i-1<<" "<<t_slot[i-1]<<endl;

                // CREAMOS EL PAQUETE GATE QUE MANDA EL OLT PARA LAS DEMIS ONUS
                GATEmsg *packet = new GATEmsg("gate");
                packet->setSrcAddress(srcAddress); // DIRECCION DE ORIGEN O FUENTE
                packet->setDestAddress(i); // DIRECCION DE DESTINO
                packet->setByteLength(64); // TAMANYO DEL PAQUETE GATE
                packet->setLambdagate(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE GATE
                packet->setKind(0); // IDENTIFICADOR DEL PAQUETE GATE
                packet->setGrant_IntervalTxArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ANCHO DE BANDA DE SLOT
                packet->setNumsla(numsla[i]); // IDENTIFICADOR DEL SLA DE LA ONU DE DESTINO

                // DEPENDIENDO DEL METODO DE EXTRACCION DE PAQUETES, SE DEFINE UN ANCHO DE BANDA DE SLOT GENERAL O UNO PARA CADA COLA
                if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
                {
                    B_slot[0]= B_alloc[i]; // DEFINIMOS ANCHO DE BANDA DE SLOT
                    packet->setGrant_IntervalTx(0,B_slot[0]);
                }
                else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
                {
                    //FALTA ALGORITMO PARA ASIGNAR POR COLAS!!!!!!!!!
                    // BUCLE FOR PARA DEFINIR UN ANCHO DE BANDA DE SLOT PARA CADA COLA
                    for(int b=0; b<(int)par("numqueue"); b++)
                    {
                        B_slot[b] = B_alloc[i]; // DEFINIMOS EL ANCHO DE BANDA DE SLOT PARA CADA COLA
                        packet->setGrant_IntervalTx(b,B_slot[b]);
                        //ev<<" Ancho de Banda de Slot "<<b<<" "<<B_slot[b]<<endl;
                    }
                }
                packet->setGrant_IniTime(tstarttime); // TIEMPO DE INICIO DE TRANSMISION

                // ENVIAMOS LOS PAQUETES GATE MEDIANTE EL ENVIO RETARDADO
                sendDelayed(packet, tasa_tx_gate, "mactxOut");
            }

            sumbdemand = 0; // PONEMOS A 0 EL VALOR DE LA SUMA DEL ANCHO DE BANDA DEMANDADO DE TODAS LAS ONUS PARA EL PROXIMO CICLO
        }
        else if(sumbdemand > B_cycle)
        {
            //RECORREMOS LAS ONUS PARA VER SI EL ANCHO DE BANDA DEMANDADO ES MAYOR O MENOR QUE EL ANCHO DE BANDA MAXIMO
            for(int i=0; i<(int)par("numOnu"); i++)
            {
                //ev<<" ONU "<<i<<endl; // VISUALIZAMOS EN LA ONU EN LA QUE NOS ENCONTRAMOS

                // COMPARAMOS SI EL ANCHO DE BANDA DEMANDADO ES MAYOR O MENOR QUE EL ANCHO DE BANDA MAXIMO
                if(B_demand[i] <= B_max_dmb[i])
                {
                    B_alloc[i] = B_demand[i] + B_report; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA DEMANDADO MAS EL TAMANYO DEL PAQUETE REPORT
                    // VISUALIZAMOS POR PANTALLA EL ANCHO DE BANDA ASIGNADO
                    //ev<<" Ancho de Banda Asigando ONU "<<i<<": "<<B_alloc[i]<<endl;
                    // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
                    table_module->table_olt_report[i][(int)par("numqueue")+1] = B_alloc[i];
                    //ev<<"ONU "<< i<<"->"<< "Bandwidth Asignado: "<< B_alloc[i]<<"Bytes"<<endl;

                    // GUARDAMOS EL ANCHO DE BANDA QUE SOBRA EN LA VARIABLE B_SOBRA Y LO VISUALIZAMOS POR PANTALLA
                    B_sobra = B_sobra + (B_max_dmb[i] - B_demand[i]); //vemos el ancho de banda que sobra
                    //ev<<" Ancho de Banda que Sobra: "<<B_sobra<<endl;
                }
                else if(B_demand[i] > B_max_dmb[i])
                {
                    B_alloc[i] = B_max_dmb[i] + B_report; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA MAXIMO MIS EL TAMANYO DEL PAQUETE REPORT
                    // VISUALIZAMOS POR PANTALLA EL ANCHO DE BANDA ASIGNADO
                    //ev<<" Ancho de Banda Asigando ONU "<<i<<": "<<B_alloc[i]<<endl;
                    // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
                    table_module->table_olt_report[i][(int)par("numqueue")+1] = B_alloc[i];
                    //ev<<"ONU "<< i<<"->"<< "Bandwidth Asignado: "<< B_alloc[i]<<"Bytes"<<endl;

                    // GUARDAMOS EL ANCHO DE BANDA QUE SE DEMANDA EN EXCESO EN LA VARIABLE B_exceded Y LO VISUALIZAMOS POR PANTALLA
                    B_exceded = B_exceded + (B_demand[i] - B_max_dmb[i]);
                    //ev<<" Ancho de Banda en Exceso: "<<B_exceded<<endl;
                }
            }

            //AHORA RECORREMOS LAS ONUS QUE DEMANDAN MIS ANCHO DE BANDA QUE EL MAXIMO PARA ASIGNARLE UNA PARTE PROPORCIONAL DE LO QUE SOBRA
            for(int i=0; i<(int)par("numOnu"); i++)
            {
                // COMPARAMOS SI EL ANCHO DE BANDA DEMANDADO ES MAYOR QUE EL ANCHO DE BANDA MAXIMO
                if(B_demand[i] > B_max_dmb[i])
                {
                    // CALCULAMOS EL ANCHO DE BANDA PROPORCINAL QUE ASIGNAREMOS A LA ONU QUE PIDE UN ANCHO DE BANDA EN EXCESO
                    B_extra[i] = B_sobra*(B_demand[i] - B_max_dmb[i])/B_exceded;

                    // ASIGNAMOS EL ANCHO DE BANDA TOTAL A LA ONU Y LO CARGAMOS EN LA TABLA EN LA COLUMNA DE ANCHO DE BANDA ASIGNADO
                    B_alloc[i] = B_alloc[i] + B_extra[i]; // ANCHO DE BANDA ASIGANDO TOTAL
                    // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
                    table_module->table_olt_report[i][(int)par("numqueue")+1] = B_alloc[i];
                    //ev<<"ONU "<< i<<"->"<< "Bandwidth Asignado: "<< B_alloc[i]<<"Bytes"<<endl;
                }
            }

            t_slot[0] = B_alloc[0]*8/txrate; //ASIGNAMOS EL TIEMPO DE SLOT PARA LA ONU 0

            //ASIGNAMOS EL TIEMPO DE INICIO DE TRANSMISION DE LA PRIMERA ONU Y LO VISUALIZAMOS POR PANTALLA
            time_tx_onu0 = simTime() + delay + tasa_tx_gate; // TIEMPO DE TRANSMISION PARA LA ONU 0 CON DISTANCIAS FIJAS
            //ev<<" Tiempo de inicio de transmision de la ONU 0: "<<time_tx_onu0<<endl;

            //CREAMOS EL PAQUETE GATE PARA LA ONU 0
            GATEmsg *packet = new GATEmsg("gate");
            packet->setSrcAddress(srcAddress); // DIRECCION DE ORIGEN O FUENTE
            packet->setDestAddress(0); // DIRECCION DE DESTINO
            packet->setByteLength(64); // TAMANYO DEL PAQUETE GATE
            packet->setLambdagate(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE GATE
            packet->setKind(0); // IDENTIFICADOR DEL PAQUETE GATE
            packet->setGrant_IntervalTxArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ANCHO DE BANDA DE SLOT
            packet->setNumsla(numsla[0]); // IDENTIFICADOR DEL SLA DE LA ONU DE DESTINO

            // DEPENDIENDO DEL METODO DE EXTRACCION DE PAQUETES, SE DEFINE UN ANCHO DE BANDA DE SLOT GENERAL O UNO PARA CADA COLA
            if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
            {
                B_slot[0]= B_alloc[0]; // DEFINIMOS ANCHO DE BANDA DE SLOT
                packet->setGrant_IntervalTx(0,B_slot[0]);
            }
            else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
            {
                //FALTA ALGORITMO PARA ASIGNAR POR COLAS!!!!!!!!!
                // BUCLE FOR PARA DEFINIR UN ANCHO DE BANDA DE SLOT PARA CADA COLA
                for(int b=0; b<(int)par("numqueue"); b++)
                {
                    B_slot[b] = B_alloc[b]; // DEFINIMOS EL ANCHO DE BANDA DE SLOT PARA CADA COLA
                    packet->setGrant_IntervalTx(b,B_slot[b]);
                    //ev<<" Ancho de Banda de Slot "<<b<<" "<<B_slot[b]<<endl;
                }
            }
            packet->setGrant_IniTime(time_tx_onu0); // TIEMPO DE INICIO DE TRANSMISION
            packet->setTimereport(table_module->table_olt_report_time[0]); // PASAMOS A ESTE CAMPO DESDE LA TABLA DEL MODULO OLT_TABLE EL TIEMPO CUANDO SE ENVIA EL REPORT EN LA ONU

            // ENVIAMOS LOS PAQUETES GATE MEDIANTE EL ENVIO RETARDADO
            sendDelayed(packet, tasa_tx_gate, "mactxOut");

            tstarttime = time_tx_onu0; // ASIGNAMOS A LA VARIABLE tstarttime EL TIEMPO DE INICIO DE TRANSMISION DE LA ONU 0

            // CREAMOS EL PAQUETE GATE QUE MANDA EL OLT PARA LAS DEMIS ONUS
            for(int i=1; i<(int)par("numOnu"); i++)
            {
                t_slot[i] = B_alloc[i]*8/txrate;//ASIGNAMOS EL TIEMPO DE SLOT PARA CADA ONU

                //ASIGNAMOS EL TIEMPO DE INICIO DE TRANSMISION DE LAS ONUS Y LO VISUALIZAMOS POR PANTALLA
                tstarttime = tstarttime + T_guarda + t_slot[i-1];
                //ev<<" Tiempo de tslot de la onu "<<i-1<<" "<<t_slot[i-1]<<endl;

                // CREAMOS EL PAQUETE GATE QUE MANDA EL OLT PARA LAS DEMIS ONUS
                GATEmsg *packet = new GATEmsg("gate");
                packet->setSrcAddress(srcAddress); // DIRECCION DE ORIGEN O FUENTE
                packet->setDestAddress(i); // DIRECCION DE DESTINO
                packet->setByteLength(64); // TAMANYO DEL PAQUETE GATE
                packet->setLambdagate(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE GATE
                packet->setKind(0); // IDENTIFICADOR DEL PAQUETE GATE
                packet->setGrant_IntervalTxArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ANCHO DE BANDA DE SLOT
                packet->setNumsla(numsla[i]); // IDENTIFICADOR DEL SLA DE LA ONU DE DESTINO

                // DEPENDIENDO DEL METODO DE EXTRACCION DE PAQUETES, SE DEFINE UN ANCHO DE BANDA DE SLOT GENERAL O UNO PARA CADA COLA
                if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
                {
                    B_slot[0]= B_alloc[i]; // DEFINIMOS ANCHO DE BANDA DE SLOT
                    packet->setGrant_IntervalTx(0,B_slot[0]);
                }
                else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
                {
                    //FALTA ALGORITMO PARA ASIGNAR POR COLAS!!!!!!!!!
                    // BUCLE FOR PARA DEFINIR UN ANCHO DE BANDA DE SLOT PARA CADA COLA
                    for(int b=0; b<(int)par("numqueue"); b++)
                    {
                        B_slot[b] = B_alloc[i]; // DEFINIMOS EL ANCHO DE BANDA DE SLOT PARA CADA COLA
                        packet->setGrant_IntervalTx(b,B_slot[b]);
                        //ev<<" Ancho de Banda de Slot "<<b<<" "<<B_slot[b]<<endl;
                    }
                }
                packet->setGrant_IniTime(tstarttime); // TIEMPO DE INICIO DE TRANSMISION

                // ENVIAMOS LOS PAQUETES GATE MEDIANTE EL ENVIO RETARDADO
                sendDelayed(packet, tasa_tx_gate, "mactxOut");

            }

            sumbdemand = 0; // PONEMOS A 0 EL VALOR DE LA SUMA DEL ANCHO DE BANDA DEMANDADO DE TODAS LAS ONUS PARA EL PROXIMO CICLO
            B_sobra = 0; // PONEMOS A 0 EL VALOR DEL ANCHO DE BANDA DE SOBRA PARA EL PROXIMO CICLO
            B_exceded = 0; // PONEMOS A 0 EL VALOR DEL ANCHO DE BANDA EN EXCESO PARA EL PROXIMO CICLO
        }
    }

    delete reportmsg; // BORRAMOS EL MENSAJE REPORT
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION POLLINGMETHOD_IPACT(CMESSAGE *MSG)--> FUNCION QUE SE INVOCA CON EL MENSAJE O PAQUETE COMO PARAMETRO CADA VEZ QUE      //
//          LLEGUE AL OLT EL PAQUETE REPORT  DE UNA ONU DE LA RED Y TENEMOS SELECCIONADO EL PARAMETRO                           //
//          oltmethod_Centralized0_Polling1_wdm2 EN EL OMNETPP.INI CON VALOR 1.                                                 //
//          ESTE ALGORITMO SE ENCARGA DE ASIGNAR EL INSTANTE DE INICIO DE LA TRANSMISION Y EL ANCHO DE BANDA DESIGNADO PARA     //
//          TRANSMITIR DE CADA ONU CADA VEZ QUE LE LLEGA EL PAQUETE REPORT DE UNA ONU DE LA RED. CREA EL PAQUETE GATE CON       //
//          DICRECCION DE DESTINO LA ONU QUE ENVIO EL PAQUETE REPORT Y LE ENVIA HACIA LA ONU CON LOS VALORES CORRESPONDIENTES   //
//          DE TRANSMISION HACIA LA ONU, LA CUAL TRANSMITE  EN EL INSTANTE DESIGNADO POR EL OLT Y UNA CANTIDAD DE BYTES         //
//          DESIGNADOS POR EL OLT.                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MAC_OLT::pollingmethod_IPACT(cMessage *msg)
{
    //ev<<" EJECUTAMOS EL METODO IPACT DE POLLING EN EL OLT."<<endl;

    REPORTmsg *reportmsg = check_and_cast<REPORTmsg *>(msg); // CHEQUEAMOS EL PAQUETE REPORT

    //VARIABLES
    double txrate = (double)par("txrate"); // TASA DE TRANSMISION EN BITS POR SEGUNDO
    double tasa_tx_gate = 512/txrate; // TASA DE TRANSMISION DEL PAQUETE GATE DE 64 BYTES
    double tasa_tx_report = 512/txrate; // TASA DE TRANSMISION DEL PAQUETE REPORT DE 64 BYTES
    double T_cycle = 0.002; // TIEMPO DE CICLO MAXIMO EN MILISEGUNDOS
    double T_guarda = 0.000005; // TIEMPO DE GUARDA QUE SE ESPERA ENTRA LA TRANSMISION DE DOS ONUS
    double T_guarda_nonu = T_guarda*((int)par("numOnu")); // TIEMPO DE GUARDA TOTAL DE TODAS LAS ONUS
    double T_report_nonu = tasa_tx_report*((int)par("numOnu")); // TASA DE TRANSMISION TOTAL DE LOS PAQUETES REPORT DE TODAS LAS ONUS
    double T_cycle_total = T_cycle - T_guarda_nonu - T_report_nonu; // TIEMPO DE CICLO FINAL Y LO VISUALIZAMOS POR PANTALLA
    //ev<<" Tiempo de ciclo total: "<<T_cycle_total<<"s"<<endl;
    double T_tx_onu; // TIEMPO DE TRANSMISION DE UNA ONU
    double B_cycle = txrate*T_cycle_total/8; // ANCHO DE BANDA MAXIMO DEL CICLO EN BYTES
    //ev<<" Ancho de banda del ciclo: "<<B_cycle<<"Bytes"<<endl;
    long double B_report = txrate*tasa_tx_report/8; // TAMANYO DEL PAQUETE REPORT
    double B_slot[(int)par("numqueue")]; // VARIABLE DE ANCHO DE BANDA DE SLOT CON TAMANYO EL N��MERO DE COLAS QUE SE DEFINEN
    int srcAddress = 9; // DEFINICION DEL IDENTIFICADOR DE LA DIRECCION DE ORIGEN O FUENTE
    simtime_t time_tx_onu0; // TIEMPO DE TRANSIMISION DE LA PRIMERA ONU
    int onu = reportmsg->getSrcAddress(); // VARIABLE QUE NOS INDICA EL IDENTIFICADOR DE LA ONU CORRESPONDIENTE
    int lengthmethod = (int)par("methodlength_longvariable0_longfija1");
    double velocidad = 300000000; // DEFINIMOS EL PARAMETRO VELOCIDAD DE LA VELOCIDAD DE LA LUZ (EN M/S)
    cTopology topo; // DEFINIMOS UN PARAMETRO DE LA TOPOLOGIA DE LA RED
    double longitud_total_red; // DEFINIMOS LA VARIABLE QUE NOS INDICA LA LONGITUD TOTAL DE LA RED
    // ASIGANCION DE PESOS
    Wsla[0] = (int)par("w_sla0"); // PESO DEL SLA0 DEFINIDO EN NUESTRA RED
    Wsla[1] = (int)par("w_sla1"); // PESO DEL SLA1 DEFINIDO EN NUESTRA RED
    Wsla[2] = (int)par("w_sla2"); // PESO DEL SLA2 DEFINIDO EN NUESTRA RED

    // ASIGNACION DEL N��MERO DE ONUS
    numonu_sla[0] = (int)par("numonu_sla0"); // N��MERO DE ONUs ASOCIADO AL SLA0
    numonu_sla[1] = (int)par("numonu_sla1"); // N��MERO DE ONUs ASOCIADO AL SLA1
    numonu_sla[2] = (int)par("numonu_sla2"); // N��MERO DE ONUs ASOCIADO AL SLA2

    //ASIGNACION DE ANCHO DE BANDAS
    BW_sla[0] = (int)par("BW_garantizado0"); //ANCHO DE BANDA ASOCIADO AL SLA0
    BW_sla[1] = (int)par("BW_garantizado1"); //ANCHO DE BANDA ASOCIADO AL SLA1
    BW_sla[2] = (int)par("BW_garantizado2"); //ANCHO DE BANDA ASOCIADO AL SLA2

    // CALCULAMOS EL DELAY O RETARDO DEPENDIENDO DE LA LONGITUD DE NUESTRA RED
    switch(lengthmethod)
    {
        case 0:
            // METODO DE LONGITUD VARIABLE
            topo.extractByParameter( "numlong" ); // EXTRAEMOS LOS NODOS DE NUESTRA RED QUE UTILIZAN EL PARAMETRO numlong
            delay_pon1 = ((int)par("longpon1")*3)/(velocidad*2); // CALCULAMOS EL RETARDO DEL SEGMENTO DE LA RED QUE UNE EL OLT Y EL SPLITTER
            // RECORREMOS CON EL BUCLE FOR TODAS LAS ONUS PARA CALCULAR EL RETARDO DEL CANAL QUE UNE EL SPLITTER CON CADA ONU
            for(int i=0; i<(int)par("numOnu"); i++)
            {
                cModule *module = getParentModule()->getParentModule()->getSubmodule("onu", i); // DEFINIMOS EL PARAMETRO MODULE QUE NOS INDICA EL CAMINO HASTA EL NODO DEL QUE QUEREMOS OBTENER INFORMACION
                cTopology::Node *nodeonuOut = topo.getNodeFor(module); // NOMBRE DEL NODO QUE SACAMOS DEL GRAFO
                // RECORREMOS CON EL BUCLE FOR TODOS LOS ENLACES DE SALIDA QUE TIENE ESE NODO PARA OBTENER LA INFORMACION QUE SOLICITAMOS
                for(int j=0; j<nodeonuOut->getNumOutLinks(); j++)
                {
                    delay_pon2[i] = (check_and_cast<cDelayChannel*>(nodeonuOut->getLinkOut(j)->getLocalGate()->getChannel()))->getDelay();
                    //ev<<" Retardo Onu"<<i<<": "<<delay_pon2[i]<<endl; // VISUALIZAMOS EL VALOR DEL RETARDO
                    delay_total[i] = delay_pon1 + delay_pon2[i]; // CALCULAMOS EL RETARDO TOTAL DE LA RED Y LO VISUALIZAMOS
                    //ev<<" Retardo Total de la red PON: "<<delay_total[i]<<endl;
                }
            }
            break;

        case 1:
            // METODO DE LONGITUD FIJA
            longitud_total_red = ((int)par("longpon1")+(int)par("longpon2")); // DEFINIMOS EL PARAMETRO QUE INDICA LA LONGITUD TOTAL DE LA RED EN METROS
            delay = (longitud_total_red*3)/(velocidad*2); // CALCULAMOS EL RETARDO O DELAY PARA LA RED SEGUN LA LONGITU QUE DEFINAMOS AL PRINCIPION DE LA SIMULACION
            break;

        default:
            //ev<<"Error al elegir el metodo de longitudes."<<endl;
            break;

    }

    // OBTENEMOS Y VISUALIZAMOS POR PANTALLA EL TIEMPO DE SIMULACION + DELAY CORRESPONDIENTE + TASA DE TRANSMISION DEL PAQUETE GATE
    // COMPARAMOS SI SE TRATA DE LONGITUD DE LA RED VARIABLE O LONGITUD DE LA RED FIJA
    if((int)par("methodlength_longvariable0_longfija1")==0)
    {
        // METODO DE LONGITUD VARIABLE
        // TIEMPO DE SIMULACION + DELAY CORRESPONDIENTE + TASA DE TRANSMISION DEL PAQUETE GATE CON DISTANCIAS ALEATORIAS
        tiempo_sim_delay_datarate = simTime() + delay_total[onu] + tasa_tx_gate;
        //ev<<" Tiempo de simulacion + delay + tasa tx gate: "<<tiempo_sim_delay_datarate<<" s."<<endl;
    }
    else if((int)par("methodlength_longvariable0_longfija1")==1)
    {
        // METODO DE LONGITUD FIJA
        // TIEMPO DE SIMULACION + DELAY CORRESPONDIENTE + TASA DE TRANSMISION DEL PAQUETE GATE CON DISTANCIAS FIJAS
        tiempo_sim_delay_datarate = simTime() + delay + tasa_tx_gate;
        //ev<<" Tiempo de simulacion + delay + tasa tx gate: "<<tiempo_sim_delay_datarate<<" s."<<endl;
    }

    // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs PARA CALCULAR EL ANCHO DE BANDA DE CADA ONU ASIGNADO POR EL SLA QUE CORRESPONDE A CADA ONU
    // (SOLO LA PRIMERA VEZ)
    if(prueba==0)
    {
        for(int j=0; j<(int)par("numSLA"); j++)
        {
            // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs ASOCIADAS A UN SLA
            for(int i=0; i<numonu_sla[j]; i++)
            {
                SLA_onu[id_onu+i] = Wsla[j]; // ASIGANAMOS A LA VARIABLE SLA_onu[] EL VALOR DEL PESO DEL SLA AL QUE ESTA ASOCIADA ESA ONU
                BW_SLA_onu[id_onu+i] = BW_sla[j]; //ASIGNAMOS A LA VARIABLE BW_SLA_onu[] EL VALOR DEL ANCHO DE BANDA GARANTIZADO POR SLA
                //ev<<" ONU "<<id_onu+i<<": Peso="<<Wsla[j]<<endl; // VISUALIZAMOS EL PESO ASOCIADO A CADA ONU
                numsla[id_onu+i] = j; // INTRODUCIMOS EN LA VARIABLE numsla[] EL IDENTIFICADOR DEL SLA PARA CADA ONU YA QUE LO UTILIZAREMOS PARA RECOGER EL RETARDO DE CADA SLA
                numero_sla[id_onu+i]=j;
                // MEDIANTE ESTE IF, VAMOS INCREMENTANDO EL IDENTIFICADOR DE LA ONU
                if(i==(numonu_sla[j]-1))
                {
                    id_onu=id_onu+1+i;
                }
            }
        }
        id_onu=0; // IGUALAMOS EL IDENTIFICADOR DE LA ONU AL VALOR 0
        // RECORREMOS MEDIANTE ESTE BUCLE FOR LOS SLAs DEFINIDOS EN NUESTRA RED PARA REALIZAR EL SUMATORIO PARA CALCULAR EL ANCHO DE BANDA ASOCIADO A CADA SLA
        for(int i=0; i<(int)par("numSLA"); i++)
        {
            sumatorio = sumatorio + (numonu_sla[i]*Wsla[i]); // CALCULAMOS EL SUMATORIO Y LO VISUALIZAMOS POR PANTALLA
            //ev<<" Sumatorio: "<<sumatorio<<endl;
        }
        for(int j=0; j<(int)par("numSLA"); j++)
        {
            // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs ASOCIADAS A UN SLA
            for(int i=0; i<numonu_sla[j]; i++)
            {
                B_max_sla[id+i] = B_cycle*Wsla[j]/sumatorio; // CALCULAMOS EL ANCHO DE BANDA ASOCIADO A CADA ONU SEGUN EL SLA ASOCIADO A LA ONU
                // MEDIANTE ESTE IF, VAMOS INCREMENTANDO EL IDENTIFICADOR DE LA ONU
                if(i==(numonu_sla[j]-1))
                {
                    id=id+1+i;
                }
            }
        }
        prueba=1;
    }
    id=0;
    sumatorio=0;
    //ev << " ONU[" << onu << "] --> SLA[" << numsla[onu] << "]." << endl;
    //ev << " Ancho de banda maximo para la ONU[" << onu << "]: " << B_max_sla[onu] << " Bytes" << endl;

    //VAMOS A CALCULAR EL ANCHO DE BANDA DEMANDADO Y LO GUARDAMOS EN LA TABLA
    //ev<<" Calculamos el Bandwidth Demandado y lo guardamos en la tabla del OLT."<<endl;
    // SUMAMOS EL TAMANYO DEL ESTADO DE LAS COLAS DE LA ONU QUE A MANDADO EL REPORT QUE LLEGA AL OLT
    for(int i=0; i<(int)par("numqueue"); i++)
    {
        sumqueue = sumqueue + reportmsg->getQueue_estado(i); // Suma Bytes de todas las colas Ethernet de la ONU[]
    }
    // SI LA SUMA TOTAL DEL TAMANYO DE LAS COLAS ES 0, DAMOS UN VALOR PREDETERMINADO DE 20 BYTES
    if(sumqueue == 0)
    {
        sumqueue = 20; // Longitud minima: 20 Bytes
    }

    // ASIGNAMOS LA SUMA TOTAL A LA VARIABLE DEL ANCHO DE BANDA DEMANDADO DE LA ONU
    B_demand[onu] = sumqueue;

    sumqueue = 0;// DAMOS EL VALOR 0 A LA SUMA DE LAS COLAS. DE ESTA MANERA LA INICIALIZAMOS DE NUEVO A 0

    // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE EL ANCHO DE BANDA DEMANDADO POR LA ONU Y LO VISUALIZAMOS POR PANTALLA
    table_module->table_olt_report[onu][(int)par("numqueue")] = B_demand[onu];
    //ev << " ONU[" << onu << "] --> " << "Bandwidth Demandado: " << B_demand[onu] << " Bytes" << endl;

    /* Recoger delay por sla */
    if(simTime()>=1 && onu==(int)par("numOnu")-1)
    {
        int prioridades = 2; // Clases de servicio de las que se controla el retardo con el PID (P0 y P1)
        double delay_sla[(int)par("numSLA")][prioridades]; // Suma del retardo de todos los paquetes recibidos en un ciclo de cada SLA y prioridad
        int paquetes_sla[(int)par("numSLA")][prioridades]; // Numero total de paquetes recibidos en un ciclo de cada SLA y prioridad

        // Se ponen a cero todas las variables auxiliares para este nuevo ciclo:
        for(int i=0; i<(int)par("numSLA"); i++)
        {
            for(int j=0; j<prioridades; j++)
            {
                delay_sla[i][j]=0.0;
                paquetes_sla[i][j]=0;
            }
        }
        int acum=0, k=0;
        for (int j=0; j<(int)par("numSLA"); j++)
        {
            for(k=acum; k<numonu_sla[j]+acum; k++)
            {
                for(int p=0; p<prioridades; p++)
                {
                    // Aunque se va imprimiendo con cada actualizacion de cada onu de cada sla, el valor correcto
                    // del retardo total y numero de paquetes de cada sla es el ultimo que sale impreso en el Tkenv.
                    delay_sla[j][p]=delay_sla[j][p]+delay_onu[k][p];
                    //ev<<" Retardo de los paquetes del SLA " << j << " con prioridad P" << p << ": " << delay_sla[j][p] << " segundos." << endl;
                    paquetes_sla[j][p]=paquetes_sla[j][p] + paq_onu[k][p];
                    //ev<<" Paquetes recibidos en el SLA " << j << " con prioridad P" << p << ": " << paquetes_sla[j][p] << endl;
                    delay_onu[k][p]=0.0; // Para el siguiente ciclo
                    paq_onu[k][p]=0.0; // Para el siguiente ciclo
                }
            }
            acum=k;
            for(int p=0; p<prioridades; p++)
            {
                if(paquetes_sla[j][p]>0) //Si hay alg���n paquete, entonces puedo dividir para sacar el delay:
                {
                    recoger_delay_por_sla(j, (double)(delay_sla[j][p]/paquetes_sla[j][p]), p);
                }
            }
        }
        if(simTime() >= 3*contador_aux)
        {
            contador_aux++;
            //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL RETARDO MEDIO DE VENTANA PARA LA CLASE P0, POR CADA SLA:
            evaluacion_retardo_slas_P0=fopen("results/retardo_medio_P0_slas.txt", "a+");
            //" T \t  SLA_0  \t  SLA_1  \t  SLA_2  \n"
            fprintf(evaluacion_retardo_slas_P0," %g \t %g \t %g \t %g \n" , SIMTIME_DBL(simTime()), (double)retardo_alg_ONU[0][0], (double)retardo_alg_ONU[2][0], (double)retardo_alg_ONU[8][0]);
            fclose(evaluacion_retardo_slas_P0);

            //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL RETARDO MEDIO DE VENTANA PARA LA CLASE P1, POR CADA SLA:
            evaluacion_retardo_slas_P1=fopen("results/retardo_medio_P1_slas.txt", "a+");
            //" T \t  SLA_0  \t  SLA_1  \t  SLA_2  \n"
            fprintf(evaluacion_retardo_slas_P1," %g \t %g \t %g \t %g \n" , SIMTIME_DBL(simTime()), (double)retardo_alg_ONU[0][1], (double)retardo_alg_ONU[2][1], (double)retardo_alg_ONU[8][1]);
            fclose(evaluacion_retardo_slas_P1);
        }
    }

    // EJECUTAMOS EL ALGORITMO IPACT YA QUE SE EJECUTA CADA VEZ QUE LLEGA UN MENSAJE REPORT DESDE LAS ONUS
    if(tiempo_tx_siguiente <= tiempo_sim_delay_datarate)
    {
        //ev<<" **CASO A. Tiempo de Transmision siguiente menor.**"<<endl;

        // COMPARAMOS SI EL ANCHO DE BANDA DEMANDADO ES MAYOR O MENOR QUE EL ANCHO DE BANDA MAXIMO
        if(B_demand[onu] <= B_max_sla[onu])
        {
            //ev << "   No se supera el BW maximo" << endl;
            B_alloc[onu] = B_demand[onu] + B_report; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA DEMANDADO MAS EL TAMANYO DEL PAQUETE REPORT
            // VISUALIZAMOS POR PANTALLA EL ANCHO DE BANDA ASIGNADO
            // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
            table_module->table_olt_report[onu][(int)par("numqueue")+1] = B_alloc[onu];

            T_alloc[onu] = B_alloc[onu]*8/txrate; // CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU CON RESPECTO AL ANCHO DE BANDA ASIGNADO
        }
        else if(B_demand[onu] > B_max_sla[onu])
        {
            //ev << "   Se pide mas del BW maximo" << endl;
            B_alloc[onu] = B_max_sla[onu] + B_report; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA  MAXIMO MIS EL TAMANYO DEL PAQUETE REPORT
            // VISUALIZAMOS POR PANTALLA EL ANCHO DE BANDA ASIGNADO
            //ev<<" Ancho de Banda Asigando ONU "<<onu<<": "<<B_alloc[onu]<<endl;
            // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
            table_module->table_olt_report[onu][(int)par("numqueue")+1] = B_alloc[onu];
            T_alloc[onu] = B_alloc[onu]*8/txrate; // CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU CON RESPECTO AL ANCHO DE BANDA ASIGNADO
        }
        //ev << " ONU[" << onu << "] --> " << "Bandwidth Asignado: " << B_alloc[onu] << " Bytes" << endl;
        T_tx_onu = T_alloc[onu] + T_guarda; //CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU

        //CREAMOS EL PAQUETE GATE PARA LA ONU
        GATEmsg *packet = new GATEmsg("gate");
        packet->setSrcAddress(srcAddress); // DIRECCION DE ORIGEN O FUENTE
        packet->setDestAddress(onu); // DIRECCION DE DESTINO
        packet->setByteLength(64); // TAMANYO DEL PAQUETE GATE
        packet->setLambdagate(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE GATE
        packet->setKind(0); // IDENTIFICADOR DEL PAQUETE GATE
        packet->setGrant_IntervalTxArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ANCHO DE BANDA DE SLOT

        // DEPENDIENDO DEL METODO DE EXTRACCION DE PAQUETES, SE DEFINE UN ANCHO DE BANDA DE SLOT GENERAL O UNO PARA CADA COLA
        if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
        {
            B_slot[0]= B_alloc[onu]; // DEFINIMOS ANCHO DE BANDA DE SLOT
            packet->setGrant_IntervalTx(0,B_slot[0]);
        }
        else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
        {
            //FALTA ALGORITMO PARA ASIGNAR POR COLAS!!!!!!!!!
            // BUCLE FOR PARA DEFINIR UN ANCHO DE BANDA DE SLOT PARA CADA COLA
            for(int b=0; b<(int)par("numqueue"); b++)
            {
                B_slot[b] = B_alloc[onu]; // DEFINIMOS EL ANCHO DE BANDA DE SLOT PARA CADA COLA
                packet->setGrant_IntervalTx(b,B_slot[b]);
                //ev<<" Ancho de Banda de Slot "<<b<<" "<<B_slot[b]<<endl;
            }
        }
        packet->setGrant_IniTime(tiempo_sim_delay_datarate); // TIEMPO DE INICIO DE TRANSMISION

        // ENVIAMOS LOS PAQUETES GATE MEDIANTE EL ENVIO RETARDADO
        sendDelayed(packet, tasa_tx_gate, "mactxOut");
        //ACTUALIZAMOS EL TIEMPO DE INICIO DE TRANSMISION PARA LA SIGUIENTE ONU
        tiempo_tx_siguiente = tiempo_sim_delay_datarate + T_tx_onu;
        //ev<<" Tiempo de Transmision Siguiente: "<<tiempo_tx_siguiente<<endl;
    }
    else if(tiempo_tx_siguiente > tiempo_sim_delay_datarate)
    {
        //ev<<" **CASO B. Tiempo de Transmision siguiente mayor.**"<<endl;

        // COMPARAMOS SI EL ANCHO DE BANDA DEMANDADO ES MAYOR O MENOR QUE EL ANCHO DE BANDA MAXIMO
        if(B_demand[onu] <= B_max_sla[onu])
        {
            //ev << "   No se supera el BW maximo" << endl;
            B_alloc[onu] = B_demand[onu] + B_report; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA DEMANDADO MAS EL TAMANYO DEL PAQUETE REPORT
            // VISUALIZAMOS POR PANTALLA EL ANCHO DE BANDA ASIGNADO
            //ev<<" Ancho de Banda Asigando ONU "<<onu<<": "<<B_alloc[onu]<<endl;
            // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
            table_module->table_olt_report[onu][(int)par("numqueue")+1] = B_alloc[onu];
            //ev<<" ONU "<< onu<<"->"<< "Bandwidth Asignado: "<< B_alloc[onu]<<"Bytes"<<endl;

            T_alloc[onu] = B_alloc[onu]*8/txrate; // CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU CON RESPECTO AL ANCHO DE BANDA ASIGNADO
        }
        else if(B_demand[onu] > B_max_sla[onu])
        {
            //ev << "   Se pide mas del BW maximo" << endl;
            B_alloc[onu] = B_max_sla[onu] + B_report; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA  MAXIMO MIS EL TAMANYO DEL PAQUETE REPORT
            // VISUALIZAMOS POR PANTALLA EL ANCHO DE BANDA ASIGNADO
            //ev<<" Ancho de Banda Asigando ONU "<<onu<<": "<<B_alloc[onu]<<endl;
            // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
            table_module->table_olt_report[onu][(int)par("numqueue")+1] = B_alloc[onu];
            //ev<<" ONU "<< onu<<"->"<< "Bandwidth Asignado: "<< B_alloc[onu]<<"Bytes"<<endl;
            T_alloc[onu] = B_alloc[onu]*8/txrate; // CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU CON RESPECTO AL ANCHO DE BANDA ASIGNADO
        }
        //ev << " ONU[" << onu << "] --> " << "Bandwidth Asignado: " << B_alloc[onu] << " Bytes" << endl;
        T_tx_onu = T_alloc[onu] + T_guarda; //CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU

        //CREAMOS EL PAQUETE GATE PARA LA ONU
        GATEmsg *packet = new GATEmsg("gate");
        packet->setSrcAddress(srcAddress); // DIRECCION DE ORIGEN O FUENTE
        packet->setDestAddress(onu); // DIRECCION DE DESTINO
        packet->setByteLength(64); // TAMANYO DEL PAQUETE GATE
        packet->setLambdagate(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE GATE
        packet->setKind(0); // IDENTIFICADOR DEL PAQUETE GATE
        packet->setGrant_IntervalTxArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ANCHO DE BANDA DE SLOT

        // DEPENDIENDO DEL METODO DE EXTRACCION DE PAQUETES, SE DEFINE UN ANCHO DE BANDA DE SLOT GENERAL O UNO PARA CADA COLA
        if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
        {
            B_slot[0]= B_alloc[onu]; // DEFINIMOS ANCHO DE BANDA DE SLOT
            packet->setGrant_IntervalTx(0,B_slot[0]);
        }
        else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
        {
            //FALTA ALGORITMO PARA ASIGNAR POR COLAS!!!!!!!!!
            // BUCLE FOR PARA DEFINIR UN ANCHO DE BANDA DE SLOT PARA CADA COLA
            for(int b=0; b<(int)par("numqueue"); b++)
            {
                B_slot[b] = B_alloc[onu]; // DEFINIMOS EL ANCHO DE BANDA DE SLOT PARA CADA COLA
                packet->setGrant_IntervalTx(b,B_slot[b]);
                //ev<<" Ancho de Banda de Slot "<<b<<" "<<B_slot[b]<<endl;
            }
        }
        packet->setGrant_IniTime(tiempo_tx_siguiente); // TIEMPO DE INICIO DE TRANSMISION

        // ENVIAMOS LOS PAQUETES GATE MEDIANTE EL ENVIO RETARDADO
        sendDelayed(packet, tasa_tx_gate, "mactxOut");
        //ACTUALIZAMOS EL TIEMPO DE INICIO DE TRANSMISION PARA LA SIGUIENTE ONU
        tiempo_tx_siguiente = tiempo_tx_siguiente + T_tx_onu;
        //ev<<" Tiempo de Transmision Siguiente: "<<tiempo_tx_siguiente<<endl;
    }
    delete reportmsg; // BORRAMOS EL PAQUETE REPORT
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION wdmmethod(cMessage *msg)--> FUNCION QUE SE INVOCA CON EL MENSAJE O PAQUETE COMO PARAMETRO CADA VEZ QUE                //
//          LLEGUE AL OLT EL PAQUETE REPORT DE UNA ONU DE LA RED Y TENEMOS SELECCIONADO EL PARAMETRO                            //
//          oltmethod_Centralized0_Polling1_wdm2 EN EL OMNETPP.INI CON VALOR 2.                                                 //
//          ESTE ALGORITMO SE ENCARGA DE ASIGNAR EL INSTANTE DE INICIO DE LA TRANSMISION Y EL ANCHO DE BANDA DESIGNADO PARA     //
//          TRANSMITIR DE CADA ONU CADA VEZ QUE LE LLEGA EL PAQUETE REPORT DE UNA ONU DE LA RED. CREA EL PAQUETE GATE CON       //
//          DICRECCION DE DESTINO LA ONU QUE ENVIO EL PAQUETE REPORT Y LE ENVIA HACIA LA ONU CON LOS VALORES CORRESPONDIENTES   //
//          DE TRANSMISION HACIA LA ONU, LA CUAL TRANSMITE EN EL INSTANTE DESIGNADO POR EL OLT Y UNA CANTIDAD DE BYTES          //
//          DESIGNADOS POR EL OLT.                                                                                              //
//          ADEMÁS SE HA DESARROLLADO EL ALGORITMO TWDM BASADO EN EL ESTÁNDAR NGPON2                                            //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MAC_OLT::wdmmethod(cMessage *msg)
{
    /*ev<<" "<<endl;
    ev<<" EJECUTAMOS EL METODO CON MODULACION WDM."<<endl;
    ev<<" "<<endl;*/

    REPORTmsg *reportmsg = check_and_cast<REPORTmsg *>(msg); // CHEQUEAMOS EL PAQUETE REPORT

    //VARIABLES
    double T_guarda = 0.000001; // TIEMPO DE GUARDA QUE SE ESPERA ENTRA LA TRANSMISION DE DOS ONUS
    double T_cycle = 0.002; // TIEMPO DE CICLO MAXIMO EN MILISEGUNDOS
    long double T_guarda_nonu = (long double)T_guarda*((int)par("numOnu")); // TIEMPO DE GUARDA TOTAL DE TODAS LAS ONUS
    long int txrate = (long int)par("txrate"); // TASA DE TRANSMISION EN BITS POR SEGUNDO
    long double tasa_tx_gate = (long double)512/txrate; // TASA DE TRANSMISION DEL PAQUETE GATE DE 64 BYTES
    long double tasa_tx_report = (long double)512/txrate; // TASA DE TRANSMISION DEL PAQUETE REPORT DE 64 BYTES
    double longitud_total_red; // DEFINIMOS LA VARIABLE QUE NOS INDICA LA LONGITUD TOTAL DE LA RED
    double velocidad = 300000000; // DEFINIMOS EL PARAMETRO VELOCIDAD DE LA VELOCIDAD DE LA LUZ (EN M/S)
    int onu = reportmsg->getSrcAddress(); // VARIABLE QUE NOS INDICA EL IDENTIFICADOR DE LA ONU CORRESPONDIENTE
    long double B_report = (long double)txrate*tasa_tx_report/8; // TAMANYO DEL PAQUETE REPORT
    double T_tx_onu; // TIEMPO DE TRANSMISION DE UNA ONU
    int srcAddress = 9; // DEFINICION DEL IDENTIFICADOR DE LA DIRECCION DE ORIGEN O FUENTE
    int B_max; //VARIABLE QUE EMPLEAREMOS PARA DETERMINAR EL ANCHO DE BANDA MAXIMO
    simtime_t t_tx = 99999; //VARIABLE AUXILIAR EMPLEADA PARA COMPARAR
    double B_slot[(int)par("numqueue")]; // VARIABLE DE ANCHO DE BANDA DE SLOT CON TAMANYO EL N��MERO DE COLAS QUE SE DEFINEN
    long double T_report_nonu = (long double)tasa_tx_report*((int)par("numOnu")); // TASA DE TRANSMISION TOTAL DE LOS PAQUETES REPORT DE TODAS LAS ONUS
    long double T_cycle_total = (long double)T_cycle - T_guarda_nonu - T_report_nonu; // TIEMPO DE CICLO FINAL Y LO VISUALIZAMOS POR PANTALLA
    long double B_cycle = (long double)txrate*T_cycle_total/8; // ANCHO DE BANDA MAXIMO DEL CICLO EN BYTES


    // MODIFICADO POR DAVID
    double t_tuning = 0.0;      //vale entre 10 us y 50 us    0.00001;
    int lambda_anterior;
    simtime_t tiempo_lamdba_anterior;


    // ASIGNACION DE PESOS
    Wsla[0] = (int)par("w_sla0"); // PESO DEL SLA0 DEFINIDO EN NUESTRA RED
    Wsla[1] = (int)par("w_sla1"); // PESO DEL SLA1 DEFINIDO EN NUESTRA RED
    Wsla[2] = (int)par("w_sla2"); // PESO DEL SLA2 DEFINIDO EN NUESTRA RED

    // ASIGNACION DEL N��MERO DE ONUS
    numonu_sla[0] = (int)par("numonu_sla0"); // N��MERO DE ONUs ASOCIADO AL SLA0
    numonu_sla[1] = (int)par("numonu_sla1"); // N��MERO DE ONUs ASOCIADO AL SLA1
    numonu_sla[2] = (int)par("numonu_sla2"); // N��MERO DE ONUs ASOCIADO AL SLA2

    //CALCULAMOS EL RETARDO QUE TENDREMOS SUPONIENDO QUE LAS LONGITUDES VAN A SER FIJAS
    longitud_total_red = ((int)par("longpon1")+(int)par("longpon2")); // DEFINIMOS EL PARAMETRO QUE INDICA LA LONGITUD TOTAL DE LA RED EN METROS
    delay = (longitud_total_red*3)/(velocidad*2); // CALCULAMOS EL RETARDO O DELAY PARA LA RED SEGUN LA LONGITU QUE DEFINAMOS AL PRINCIPION DE LA SIMULACION

    tiempo_sim_delay_datarate = simTime() + delay + tasa_tx_gate + t_tuning;
    //ev<<" Tiempo de simulacion + delay + tasa tx gate: "<<tiempo_sim_delay_datarate<<" s."<<endl<<endl;

    t_tx=SIMTIME_DBL(t_tx);

    for(int j=0; j<(int)par("numSLA"); j++)
    {
        // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs ASOCIADAS A UN SLA
        for(int i=0; i<numonu_sla[j]; i++)
        {
            SLA_onu[id_onu+i] = Wsla[j]; // ASIGANAMOS A LA VARIABLE SLA_onu[] EL VALOR DEL PESO DEL SLA AL QUE ESTA ASOCIADA ESA ONU
            //ev<<" ONU "<<id_onu+i<<": Peso="<<Wsla[j]<<endl; // VISUALIZAMOS EL PESO ASOCIADO A CADA ONU
            numsla[id_onu+i] = j; // INTRODUCIMOS EN LA VARIABLE numsla[] EL IDENTIFICADOR DEL SLA PARA CADA ONU YA QUE LO UTILIZAREMOS PARA RECOGER EL RETARDO DE CADA SLA
            numero_sla[id_onu+i]=j;
            // MEDIANTE ESTE IF, VAMOS INCREMENTANDO EL IDENTIFICADOR DE LA ONU QUE
            if(i==(numonu_sla[j]-1))
            {
                id_onu=id_onu+1+i;
            }
        }
    }
    id_onu=0; // IGUALAMOS EL IDENTIFICADOR DE LA ONU AL VALOR 0


    // RECORREMOS MEDIANTE ESTE BUCLE FOR LOS SLAs DEFINIDOS EN NUESTRA RED PARA REALIZAR EL SUMATORIO PARA CALCULAR EL ANCHO DE BANDA ASOCIADO A CADA SLA
    for(int i=0; i<(int)par("numSLA"); i++)
    {
        sumatorio = sumatorio + (numonu_sla[i]*Wsla[i]); // CALCULAMOS EL SUMATORIO Y LO VISUALIZAMOS POR PANTALLA
    }

    // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs PARA CALCULAR EL ANCHO DE BANDA DE CADA ONU ASIGNADO POR EL SLA QUE CORRESPONDE A CADA ONU
    for(int j=0; j<(int)par("numSLA"); j++)
    {
            // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs ASOCIADAS A UN SLA
            for(int i=0; i<numonu_sla[j]; i++)
            {

                // MODIFICADO POR DAVID
                //B_max_sla[id+i] = B_cycle*(int)par("numlong")*Wsla[j]/sumatorio; // CALCULAMOS EL ANCHO DE BANDA ASOCIADO A CADA ONU SEGUN EL SLA ASOCIADO A LA ONU
                B_max_sla[id+i] = B_cycle*Wsla[j]/sumatorio; // CALCULAMOS EL ANCHO DE BANDA ASOCIADO A CADA ONU SEGUN EL SLA ASOCIADO A LA ONU

                //ev<<" Ancho de Banda de SLA de la ONU"<<id+i<<": "<<B_max_sla[id+i]<<endl; // VISUALIZAMOS EL ANCHO DE BANDA
                // MEDIANTE ESTE IF, VAMOS INCREMENTANDO EL IDENTIFICADOR DE LA ONU:

                /*ev<<" B_cycle"<<": "<<B_cycle<<endl; // VISUALIZAMOS EL ANCHO DE BANDA
                ev<<" T_cycle_total"<<": "<<T_cycle_total<<endl; // VISUALIZAMOS EL ANCHO DE BANDA
                ev<<" longitudes"<<": "<<(int)par("numlong")<<endl; // VISUALIZAMOS EL ANCHO DE BANDA
                ev<<" Pesos"<<": "<<Wsla[j]<<endl; // VISUALIZAMOS EL ANCHO DE BANDA

                ev<<" tasa_tx_gate"<<": "<<tasa_tx_gate<<endl; // VISUALIZAMOS EL ANCHO DE BANDA
                ev<<" tasa_tx_report"<<": "<<tasa_tx_report<<endl; // VISUALIZAMOS EL ANCHO DE BANDA
                ev<<" tx"<<": "<<txrate<<endl;*/ // VISUALIZAMOS EL ANCHO DE BANDA

                if(i==(numonu_sla[j]-1))
                {
                    id=id+1+i;
                }

            }
    }
    id=0;
    sumatorio=0;

    // SUMAMOS EL TAMANYO DEL ESTADO DE LAS COLAS DE LA ONU QUE HA MANDADO EL REPORT QUE LLEGA AL OLT
    for(int i=0; i<(int)par("numqueue"); i++)
    {
        sumqueue = sumqueue + reportmsg->getQueue_estado(i);
    }

    // SI LA SUMA TOTAL DEL TAMANYO DE LAS COLAS ES 0, DAMOS UN VALOR PREDETERMINADO DE 20 BYTES
    if(sumqueue == 0)
    {
        sumqueue = 20;
    }

    // ASIGNAMOS LA SUMA TOTAL A LA VARIABLE DEL ANCHO DE BANDA DEMANDADO DE LA ONU
    B_demand[onu] = sumqueue;

    sumqueue = 0;// DAMOS EL VALOR 0 A LA SUMA DE LAS COLAS. DE ESTA MANERA LA INICIALIZAMOS DE NUEVO A 0

    // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE EL ANCHO DE BANDA DEMANDADO POR LA ONU Y LO VISUALIZAMOS POR PANTALLA
    table_module->table_olt_report[onu][(int)par("numqueue")] = B_demand[onu];
    //ev<<" ONU "<< onu<<"->"<< "Bandwidth Demandado: "<< B_demand[onu]<<"Bytes"<<endl;

    //CALCULAMOS ANCHO DE BANDA MAXIMO DE CADA ONU DEPENDIENDO DEL SLA
    B_max = 15000; // ASIGNAMOS UN VALOR AL ANCHO DE BANDA MAXIMO Y LO VISUALIZAMOS POR PANTALLA (BYTES)
    //ev<<" Ancho de Banda Maximo asignado por ONU "<<onu<<": " <<B_max_sla[onu]<<endl;


    // COMPARAMOS SI EL ANCHO DE BANDA DEMANDADO ES MAYOR O MENOR QUE EL ANCHO DE BANDA MAXIMO
    if(B_demand[onu] <= B_max_sla[onu])
    {
        B_alloc[onu] = B_demand[onu] + B_report; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA DEMANDADO MAS EL TAMANYO DEL PAQUETE REPORT
        // VISUALIZAMOS POR PANTALLA EL ANCHO DE BANDA ASIGNADO
        //ev<<" Ancho de Banda Asigando ONU "<<onu<<": "<<B_alloc[onu]<<endl;
        // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
        table_module->table_olt_report[onu][(int)par("numqueue")+1] = B_alloc[onu];
        //ev<<" ONU "<< onu<<"->"<< "Bandwidth Asignado: "<< B_alloc[onu]<<"Bytes"<<endl;
        T_alloc[onu] = B_alloc[onu]*8/txrate; // CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU CON RESPECTO AL ANCHO DE BANDA ASIGNADO
    }
    else if(B_demand[onu] > B_max_sla[onu])
    {
        B_alloc[onu] = B_max_sla[onu] + B_report; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA  MAXIMO MIS EL TAMANYO DEL PAQUETE REPORT
        // VISUALIZAMOS POR PANTALLA EL ANCHO DE BANDA ASIGNADO
        //ev<<" Ancho de Banda Asigando ONU "<<onu<<": "<<B_alloc[onu]<<endl;
        // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
        table_module->table_olt_report[onu][(int)par("numqueue")+1] = B_alloc[onu];
        //ev<<" ONU "<< onu<<"->"<< "Bandwidth Asignado: "<< B_alloc[onu]<<"Bytes"<<endl;
        //ev<<" "<<endl;
        T_alloc[onu] = B_alloc[onu]*8/txrate; // CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU CON RESPECTO AL ANCHO DE BANDA ASIGNADO
    }
    T_tx_onu = T_alloc[onu] + T_guarda; //CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU
    //BUCLE PARA RECORRER LAS DISTINTAS LONGITUDES DE ONDA EN LAS QUE ESTAMOS TRABAJANDO


    //MODIFICADO POR DAVID
    // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA LONGITUD DE ONDA ANTERIOR POR LA QUE SE HA ENVIADO
    lambda_anterior = (int) table_module->table_olt_report[onu][(int)par("numqueue")+2];

    // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE EL TIEMPO EN QUE SE USO LA LONGITUD DE ONDA ANTERIOR PARA TRANSMITIR
    tiempo_lamdba_anterior = table_module->table_olt_wavelength_time[onu];

    for(int i=0; i<(int)par("numlong"); i++)
    {
        
        if(tiempo_tx_sig[i]<t_tx)
        {
            // Una ONU no puede transmitir en dos longitudes de onda al mismo tiempo
            if((lambda_anterior=!i)&&(tiempo_tx_sig[i]<tiempo_lamdba_anterior))
            {

            }
            else
            {
                t_tx=tiempo_tx_sig[i];
                aux=i;
            }
        }
    }

    // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA LONGITUD DE ONDA POR LA QUE SE HA ENVIADO AHORA
    table_module->table_olt_report[onu][(int)par("numqueue")+2] = aux;

    // SI SE USA LA MISMA LONGITUD DE ONDA QUE ANTES, NO ES NECESARIO QUE HAYA UN TIEMPO DE CONMUTACION
    if(lambda_anterior==aux)
    {
        tiempo_sim_delay_datarate = tiempo_sim_delay_datarate - t_tuning;
    }


    if(t_tx<=tiempo_sim_delay_datarate)
    {
        //CREAMOS EL PAQUETE GATE PARA LA ONU
        GATEmsg *packet = new GATEmsg("gate");
        packet->setSrcAddress(srcAddress); // DIRECCION DE ORIGEN O FUENTE
        packet->setDestAddress(onu); // DIRECCION DE DESTINO
        packet->setByteLength(64); // TAMANYO DEL PAQUETE GATE
        packet->setLambdagate(aux); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE GATE
        packet->setKind(0); // IDENTIFICADOR DEL PAQUETE GATE
        packet->setGrant_IntervalTxArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ANCHO DE BANDA DE SLOT
        packet->setNumsla(numero_sla[onu]);
        packet->setGrant_IniTime(tiempo_sim_delay_datarate); // TIEMPO DE INICIO DE TRANSMISION

        // DEPENDIENDO DEL METODO DE EXTRACCION DE PAQUETES, SE DEFINE UN ANCHO DE BANDA DE SLOT GENERAL O UNO PARA CADA COLA
        if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
        {
            B_slot[0]= B_alloc[onu]; // DEFINIMOS ANCHO DE BANDA DE SLOT
            packet->setGrant_IntervalTx(0,B_slot[0]);
        }
        else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
        {
            // BUCLE FOR PARA DEFINIR UN ANCHO DE BANDA DE SLOT PARA CADA COLA
            for(int b=0; b<(int)par("numqueue"); b++)
            {
                B_slot[b] = B_alloc[onu]; // DEFINIMOS EL ANCHO DE BANDA DE SLOT PARA CADA COLA
                packet->setGrant_IntervalTx(b,B_slot[b]);
                //ev<<" Ancho de Banda de Slot "<<b<<" "<<B_slot[b]<<endl;
            }
        }

        // ENVIAMOS LOS PAQUETES GATE MEDIANTE EL ENVIO RETARDADO
        sendDelayed(packet, tasa_tx_gate, "mactxOut");
        //ACTUALIZAMOS EL TIEMPO DE CADA LAMBDA SUMANDO EL TIEMPO ACTUAL DE LA LAMBDA QUE SE VACIO ANTES CON EL TIEMPO DE TRANSMISION DE LA ONU
        tiempo_tx_sig[aux]=tiempo_sim_delay_datarate+T_tx_onu; // t_tuning añadido por David
    }
    else if(t_tx>tiempo_sim_delay_datarate)
    {
        //CREAMOS EL PAQUETE GATE PARA LA ONU
        GATEmsg *packet = new GATEmsg("gate");
        packet->setSrcAddress(srcAddress); // DIRECCION DE ORIGEN O FUENTE
        packet->setDestAddress(onu); // DIRECCION DE DESTINO
        packet->setByteLength(64); // TAMANYO DEL PAQUETE GATE
        packet->setLambdagate(aux); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE GATE
        packet->setKind(0); // IDENTIFICADOR DEL PAQUETE GATE
        packet->setGrant_IntervalTxArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ANCHO DE BANDA DE SLOT
        packet->setNumsla(numero_sla[onu]);
        packet->setGrant_IniTime(t_tx); // TIEMPO DE INICIO DE TRANSMISION

        // DEPENDIENDO DEL METODO DE EXTRACCION DE PAQUETES, SE DEFINE UN ANCHO DE BANDA DE SLOT GENERAL O UNO PARA CADA COLA
        if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
        {
                B_slot[0]= B_alloc[onu]; // DEFINIMOS ANCHO DE BANDA DE SLOT
                packet->setGrant_IntervalTx(0,B_slot[0]);
        }
        else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
        {
            // BUCLE FOR PARA DEFINIR UN ANCHO DE BANDA DE SLOT PARA CADA COLA
            for(int b=0; b<(int)par("numqueue"); b++)
            {
                B_slot[b] = B_alloc[onu]; // DEFINIMOS EL ANCHO DE BANDA DE SLOT PARA CADA COLA
                packet->setGrant_IntervalTx(b,B_slot[b]);
            }
        }

        // ENVIAMOS LOS PAQUETES GATE MEDIANTE EL ENVIO RETARDADO
        sendDelayed(packet, tasa_tx_gate, "mactxOut");
        //ACTUALIZAMOS EL TIEMPO DE CADA LAMBDA SUMANDO EL TIEMPO ACTUAL DE LA LAMBDA QUE SE VACIO ANTES CON EL TIEMPO DE TRANSMISION DE LA ONU
        tiempo_tx_sig[aux]=t_tx+T_tx_onu;  // t_tuning añadido por David
    }


    // MODIFICADO POR DAVID
    // Guardamos el ancho de banda que se asigna para cada longitud de onda y el total
    B_alloc_lambda_prueba[aux]= B_alloc_lambda_prueba[aux]+8*B_alloc[onu];

    if(simTime()>=5*cont3)
    {
        cont3++;

        prueba_B_alloc_lambda=fopen("results/prueba_B_alloc_lambda.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        fprintf(prueba_B_alloc_lambda,"%g\t", SIMTIME_DBL(simTime()));
        fprintf(prueba_B_alloc_lambda,"\t");
        fprintf(prueba_B_alloc_lambda,"%g\t" , ((double)B_alloc_lambda_prueba[0]/simTime())/(1000000));
        fprintf(prueba_B_alloc_lambda,"\t");
        fprintf(prueba_B_alloc_lambda,"%g\t" , ((double)B_alloc_lambda_prueba[1]/simTime())/(1000000));
        fprintf(prueba_B_alloc_lambda,"\t");
        fprintf(prueba_B_alloc_lambda,"%g\t" , ((double)B_alloc_lambda_prueba[2]/simTime())/(1000000));
        fprintf(prueba_B_alloc_lambda,"\t");
        fprintf(prueba_B_alloc_lambda,"%g\t" , ((double)B_alloc_lambda_prueba[3]/simTime())/(1000000));
        fprintf(prueba_B_alloc_lambda,"\t");
        fprintf(prueba_B_alloc_lambda,"%g\t" , ((double)((B_alloc_lambda_prueba[0]+B_alloc_lambda_prueba[1]+B_alloc_lambda_prueba[2]+B_alloc_lambda_prueba[3])/simTime())/(1000000000)));
        fprintf(prueba_B_alloc_lambda,"\t");
        fprintf(prueba_B_alloc_lambda,"\n");
        fclose(prueba_B_alloc_lambda); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS
    }


    // MODIFICADO POR DAVID
    // Guardamos para una ONU su ancho de banda asignado, la longitud de onda anterior por la que se envió el paquete
    // y el tiempo en el que se hizo, para después compararlo con la longitud de onda por la que se transmite ahora
    // y ver también el instante de tiempo en el que lo hace.
    table_module->table_olt_wavelength_time[onu]=tiempo_tx_sig[aux];

    if((onu==10)&&(simTime()>=200))
    {
        prueba_lambda=fopen("results/prueba_lambda.txt", "a+");
        fprintf(prueba_lambda,"%i\t", onu);
        fprintf(prueba_lambda,"\t");
        fprintf(prueba_lambda,"%g\t" , B_alloc[onu]);
        fprintf(prueba_lambda,"\t");
        fprintf(prueba_lambda,"%i\t" , lambda_anterior);
        fprintf(prueba_lambda,"\t");
        fprintf(prueba_lambda,"%g\t" , SIMTIME_DBL(tiempo_lamdba_anterior));
        fprintf(prueba_lambda,"\t");
        fprintf(prueba_lambda,"%i\t" , aux);
        fprintf(prueba_lambda,"\t");
        fprintf(prueba_lambda,"%g\t" , SIMTIME_DBL(tiempo_tx_sig[aux]));
        fprintf(prueba_lambda,"\t");
        fprintf(prueba_lambda,"\n");
        fclose(prueba_lambda); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS
    }


    // MODIFICADO POR DAVID
    // Guardamos el ancho de banda asignado para una ONU de cada SLA
    B_total_wdm[onu]=B_total_wdm[onu]+8*B_alloc[onu]; //B_ALLOC TOTAL EN Bits

    // Y el ancho de banda en Gbps que falta para llegar a la capacidad total de la red
    // Este se calcula sumandole 512 bits que son del tamano del paquete Report (64 bytes)+
    // +T_guarda pero transformado a bits para poder sumarlo, es decir, T_guarda*txrate = 10000 bits
    overhead = overhead + 512 + 10000;

    if(simTime()>=5*cont4)
    {
        cont4++;

        B_total_wdm_fichero=fopen("results/B_total_wdm_fichero.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        fprintf(B_total_wdm_fichero,"%g\t", SIMTIME_DBL(simTime()));
        fprintf(B_total_wdm_fichero,"\t");
        fprintf(B_total_wdm_fichero,"%g\t" , (double)(8*B_alloc[0]));
        fprintf(B_total_wdm_fichero,"\t");
        fprintf(B_total_wdm_fichero,"%g\t" , (double)(8*B_alloc[2]));
        fprintf(B_total_wdm_fichero,"\t");
        fprintf(B_total_wdm_fichero,"%g\t" , (double)(8*B_alloc[8]));
        fprintf(B_total_wdm_fichero,"\t\t");
        fprintf(B_total_wdm_fichero,"%g\t" , (double)((B_total_wdm[0]/simTime())/1000000));
        fprintf(B_total_wdm_fichero,"\t");
        fprintf(B_total_wdm_fichero,"%g\t" , (double)((B_total_wdm[2]/simTime())/1000000));
        fprintf(B_total_wdm_fichero,"\t");
        fprintf(B_total_wdm_fichero,"%g\t" , (double)((B_total_wdm[8]/simTime())/1000000));
        fprintf(B_total_wdm_fichero,"\t");
        fprintf(B_total_wdm_fichero,"%g\t" , (double)((overhead/simTime())/1000000000));
        fprintf(B_total_wdm_fichero,"\n");
        fclose(B_total_wdm_fichero); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS
    }



    delete reportmsg; // BORRAMOS EL PAQUETE REPORT
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION DBA_polling_PID(cMessage *msg)--> FUNCION QUE SE INVOCA CON EL MENSAJE O PAQUETE COMO PARAMETRO CADA VEZ QUE          //
//          LLEGUE AL OLT EL PAQUETE REPORT DE UNA ONU DE LA RED Y TENEMOS SELECCIONADO EL PARAMETRO                            //
//          oltmethod_Centralized0_Polling1_wdm2 EN EL OMNETPP.INI CON VALOR 3.                                                 //
//          ESTE ALGORITMO SE ENCARGA DE ASIGNAR EL INSTANTE DE INICIO DE LA TRANSMISION Y EL ANCHO DE BANDA DESIGNADO PARA     //
//          TRANSMITIR DE CADA ONU CADA VEZ QUE LE LLEGA EL PAQUETE REPORT DE UNA ONU DE LA RED. CREA EL PAQUETE GATE CON       //
//          DICRECCION DE DESTINO LA ONU QUE ENVIO EL PAQUETE REPORT Y LE ENVIA HACIA LA ONU CON LOS VALORES CORRESPONDIENTES   //
//          DE TRANSMISION HACIA LA ONU, LA CUAL TRANSMITE EN EL INSTANTE DESIGNADO POR EL OLT Y UNA CANTIDAD DE BYTES          //
//          DESIGNADOS POR EL OLT.                                                                                              //
//          SIRVE PARA LLAMAR A LA FUNCIÓN PID EN LA QUE SE ENCUENTRA DESARROLLADO EL CONTROLADOR.                              //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MAC_OLT::DBA_polling_PID(cMessage *msg)
{
    // NOTA:
    // BW_sla[], SW_SLA_onu[] --> Mbits
    // B_max_sla, sumqueue, B_demand[], BW_max_PID[], B_cycle, B_report,B_alloc[], B_alloc_total[], B_Mbps_sla[] --> bit

    //ev<<" EJECUTAMOS EL METODO IPACT DE POLLING CON EL ALGORITMO PID."<<endl;
    REPORTmsg *reportmsg = check_and_cast<REPORTmsg *>(msg); // CHEQUEAMOS EL PAQUETE REPORT
    //VARIABLES
    long int txrate = (long int)par("txrate"); // TASA DE TRANSMISION EN BITS POR SEGUNDO
    long double tasa_tx_gate = (long double)512/txrate; // TASA DE TRANSMISION DEL PAQUETE GATE DE 64 BYTES
    long double tasa_tx_report = (long double)512/txrate; // TASA DE TRANSMISION DEL PAQUETE REPORT DE 64 BYTES
    double T_cycle = 0.002; // TIEMPO DE CICLO MAXIMO EN MILISEGUNDOS
    double T_guarda = 0.000001; // TIEMPO DE GUARDA QUE SE ESPERA ENTRA LA TRANSMISION DE DOS ONUS
    double T_guarda_nonu = T_guarda*((int)par("numOnu")); // TIEMPO DE GUARDA TOTAL DE TODAS LAS ONUS
    long double T_report_nonu = (long double)tasa_tx_report*((int)par("numOnu")); // TASA DE TRANSMISION TOTAL DE LOS PAQUETES REPORT DE TODAS LAS ONUS
    long double T_cycle_total = (long double)T_cycle - T_guarda_nonu - T_report_nonu; // TIEMPO DE CICLO FINAL Y LO VISUALIZAMOS POR PANTALLA
    //ev<<" Tiempo de ciclo total: "<<T_cycle_total<<"s"<<endl;
    double T_tx_onu; // TIEMPO DE TRANSMISION DE UNA ONU
    long double B_cycle = (long double)txrate*T_cycle_total; // ANCHO DE BANDA MAXIMO DEL CICLO EN BITS
    //ev<<" Ancho de banda del ciclo: "<<B_cycle<<"Bytes"<<endl;
    long double B_report = (long double)txrate*tasa_tx_report/8; // TAMANYO DEL PAQUETE REPORT
    double B_slot[(int)par("numqueue")]; // VARIABLE DE ANCHO DE BANDA DE SLOT CON TAMANYO EL N��MERO DE COLAS QUE SE DEFINEN
    int srcAddress = 9; // DEFINICION DEL IDENTIFICADOR DE LA DIRECCION DE ORIGEN O FUENTE
    simtime_t time_tx_onu0; // TIEMPO DE TRANSIMISION DE LA PRIMERA ONU
    int onu = reportmsg->getSrcAddress(); // VARIABLE QUE NOS INDICA EL IDENTIFICADOR DE LA ONU CORRESPONDIENTE
    int lengthmethod = (int)par("methodlength_longvariable0_longfija1");
    double velocidad = 300000000; // DEFINIMOS EL PARAMETRO VELOCIDAD DE LA VELOCIDAD DE LA LUZ (EN M/S)
    cTopology topo; // DEFINIMOS UN PARAMETRO DE LA TOPOLOGIA DE LA RED
    double longitud_total_red; // DEFINIMOS LA VARIABLE QUE NOS INDICA LA LONGITUD TOTAL DE LA RED

    // ASIGANCION DE PESOS
    Wsla[0] = (int)par("w_sla0"); // PESO DEL SLA0 DEFINIDO EN NUESTRA RED
    Wsla[1] = (int)par("w_sla1"); // PESO DEL SLA1 DEFINIDO EN NUESTRA RED
    Wsla[2] = (int)par("w_sla2"); // PESO DEL SLA2 DEFINIDO EN NUESTRA RED

    // ASIGNACION DEL N��MERO DE ONUS
    numonu_sla[0] = (int)par("numonu_sla0"); // N��MERO DE ONUs ASOCIADO AL SLA0
    numonu_sla[1] = (int)par("numonu_sla1"); // N��MERO DE ONUs ASOCIADO AL SLA1
    numonu_sla[2] = (int)par("numonu_sla2"); // N��MERO DE ONUs ASOCIADO AL SLA2

    //ASIGNACION DE ANCHO DE BANDAS
    BW_sla[0] = (int)par("BW_garantizado0"); //ANCHO DE BANDA ASOCIADO AL SLA0
    BW_sla[1] = (int)par("BW_garantizado1"); //ANCHO DE BANDA ASOCIADO AL SLA1
    BW_sla[2] = (int)par("BW_garantizado2"); //ANCHO DE BANDA ASOCIADO AL SLA2


    // CALCULAMOS EL DELAY O RETARDO DEPENDIENDO DE LA LONGITUD DE NUESTRA RED
    switch(lengthmethod)
    {
        case 0:
            // METODO DE LONGITUD VARIABLE
            topo.extractByParameter( "numlong" ); // EXTRAEMOS LOS NODOS DE NUESTRA RED QUE UTILIZAN EL PARAMETRO numlong
            delay_pon1 = ((int)par("longpon1")*3)/(velocidad*2); // CALCULAMOS EL RETARDO DEL SEGMENTO DE LA RED QUE UNE EL OLT Y EL SPLITTER
            // RECORREMOS CON EL BUCLE FOR TODAS LAS ONUS PARA CALCULAR EL RETARDO DEL CANAL QUE UNE EL SPLITTER CON CADA ONU
            for(int i=0; i<(int)par("numOnu"); i++)
            {
                cModule *module = getParentModule()->getParentModule()->getSubmodule("onu", i); // DEFINIMOS EL PARAMETRO MODULE QUE NOS INDICA EL CAMINO HASTA EL NODO DEL QUE QUEREMOS OBTENER INFORMACION
                cTopology::Node *nodeonuOut = topo.getNodeFor(module); // NOMBRE DEL NODO QUE SACAMOS DEL GRAFO
                // RECORREMOS CON EL BUCLE FOR TODOS LOS ENLACES DE SALIDA QUE TIENE ESE NODO PARA OBTENER LA INFORMACION QUE SOLICITAMOS
                for(int j=0; j<nodeonuOut->getNumOutLinks(); j++)
                {
                    delay_pon2[i] = (check_and_cast<cDelayChannel*>(nodeonuOut->getLinkOut(j)->getLocalGate()->getChannel()))->getDelay();
                    //ev<<" Retardo Onu"<<i<<": "<<delay_pon2[i]<<endl; // VISUALIZAMOS EL VALOR DEL RETARDO
                    delay_total[i] = delay_pon1 + delay_pon2[i]; // CALCULAMOS EL RETARDO TOTAL DE LA RED Y LO VISUALIZAMOS
                    //ev<<" Retardo Total de la red PON: "<<delay_total[i]<<endl;
                }
            }
            break;

        case 1:
            // METODO DE LONGITUD FIJA
            longitud_total_red = ((int)par("longpon1")+(int)par("longpon2")); // DEFINIMOS EL PARAMETRO QUE INDICA LA LONGITUD TOTAL DE LA RED EN METROS
            delay = (longitud_total_red*3)/(velocidad*2); // CALCULAMOS EL RETARDO O DELAY PARA LA RED SEGUN LA LONGITU QUE DEFINAMOS AL PRINCIPION DE LA SIMULACION
            break;

        default:
            //ev<<"Error al elegir el metodo de longitudes."<<endl;
            break;

    }

    // OBTENEMOS Y VISUALIZAMOS POR PANTALLA EL TIEMPO DE SIMULACION + DELAY CORRESPONDIENTE + TASA DE TRANSMISION DEL PAQUETE GATE
    // COMPARAMOS SI SE TRATA DE LONGITUD DE LA RED VARIABLE O LONGITUD DE LA RED FIJA
    if((int)par("methodlength_longvariable0_longfija1")==0)
    {
        // METODO DE LONGITUD VARIABLE
        // TIEMPO DE SIMULACION + DELAY CORRESPONDIENTE + TASA DE TRANSMISION DEL PAQUETE GATE CON DISTANCIAS ALEATORIAS
        tiempo_sim_delay_datarate = simTime() + delay_total[onu] + tasa_tx_gate;
        //ev<<" Tiempo de simulacion + delay + tasa tx gate: "<<tiempo_sim_delay_datarate<<" s."<<endl;
    }
    else if((int)par("methodlength_longvariable0_longfija1")==1)
    {
        // METODO DE LONGITUD FIJA
        // TIEMPO DE SIMULACION + DELAY CORRESPONDIENTE + TASA DE TRANSMISION DEL PAQUETE GATE CON DISTANCIAS FIJAS
        tiempo_sim_delay_datarate = simTime() + delay + tasa_tx_gate;
        //ev<<" Tiempo de simulacion + delay + tasa tx gate: "<<tiempo_sim_delay_datarate<<" s."<<endl;
    }

    for(int j=0; j<(int)par("numSLA"); j++)
    {
        // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs ASOCIADAS A UN SLA
        for(int i=0; i<numonu_sla[j]; i++)
        {
            SLA_onu[id_onu+i] = Wsla[j]; // ASIGANAMOS A LA VARIABLE SLA_onu[] EL VALOR DEL PESO DEL SLA AL QUE ESTA ASOCIADA ESA ONU
            BW_SLA_onu[id_onu+i] = BW_sla[j]; //ASIGNAMOS A LA VARIABLE BW_SLA_onu[] EL VALOR DEL ANCHO DE BANDA GARANTIZADO POR SLA
            //ev<<" ONU "<<id_onu+i<<": Peso="<<Wsla[j]<<endl; // VISUALIZAMOS EL PESO ASOCIADO A CADA ONU
            numsla[id_onu+i] = j; // INTRODUCIMOS EN LA VARIABLE numsla[] EL IDENTIFICADOR DEL SLA PARA CADA ONU YA QUE LO UTILIZAREMOS PARA RECOGER EL RETARDO DE CADA SLA
            numero_sla[id_onu+i]=j;
            // MEDIANTE ESTE IF, VAMOS INCREMENTANDO EL IDENTIFICADOR DE LA ONU
            if(i==(numonu_sla[j]-1))
            {
                id_onu=id_onu+1+i;
            }
        }
    }
    id_onu=0; // IGUALAMOS EL IDENTIFICADOR DE LA ONU AL VALOR 0

    // RECORREMOS MEDIANTE ESTE BUCLE FOR LOS SLAs DEFINIDOS EN NUESTRA RED PARA REALIZAR EL SUMATORIO PARA CALCULAR EL ANCHO DE BANDA ASOCIADO A CADA SLA
    for(int i=0; i<(int)par("numSLA"); i++)
    {
        sumatorio = sumatorio + (numonu_sla[i]*Wsla[i]); // CALCULAMOS EL SUMATORIO Y LO VISUALIZAMOS POR PANTALLA
        //ev<<" Sumatorio: "<<sumatorio<<endl;
    }

    // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs PARA CALCULAR EL ANCHO DE BANDA DE CADA ONU ASIGNADO POR EL SLA QUE CORRESPONDE A CADA ONU
    // (SOLO LA PRIMERA VEZ)
    if(prueba==0)
    {
        for(int j=0; j<(int)par("numSLA"); j++)
        {
            // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs ASOCIADAS A UN SLA
            for(int i=0; i<numonu_sla[j]; i++)
            {
                B_max_sla[id+i] = B_cycle*Wsla[j]/sumatorio; // CALCULAMOS EL ANCHO DE BANDA ASOCIADO A CADA ONU SEGUN EL SLA ASOCIADO A LA ONU
                // MEDIANTE ESTE IF, VAMOS INCREMENTANDO EL IDENTIFICADOR DE LA ONU QUE
                if(i==(numonu_sla[j]-1))
                {
                    id=id+1+i;
                }
            }
        }
        prueba=1;
    }
    id=0;
    sumatorio = 0; // DAMOS EL VALOR 0 AL SUMATORIO PARA QUE NO SE INCREMENTE

    //VAMOS A CALCULAR EL ANCHO DE BANDA DEMANDADO Y LO GUARDAMOS EN LA TABLA
    //ev<<" Calculamos el Bandwidth Demandado y lo guardamos en la tabla del OLT."<<endl;
    // SUMAMOS EL TAMANYO DEL ESTADO DE LAS COLAS DE LA ONU QUE A MANDADO EL REPORT QUE LLEGA AL OLT
    for(int i=0; i<(int)par("numqueue"); i++)
    {
        sumqueue = sumqueue + (reportmsg->getQueue_estado(i)*8);
    }
    // SI LA SUMA TOTAL DEL TAMANYO DE LAS COLAS ES 0, DAMOS UN VALOR PREDETERMINADO DE 20 BYTES
    if(sumqueue == 0)
    {
        sumqueue = 20*8; //POR 8 PARA PASARLO A BITS
    }

    // ASIGNAMOS LA SUMA TOTAL A LA VARIABLE DEL ANCHO DE BANDA DEMANDADO DE LA ONU
    //ev<<" sumqueue "<<sumqueue<<endl;
    B_demand[onu] = sumqueue;



    // MODIFICADO
    if(simTime()>=1)
    {
         recoger_Bdemand(msg);
         //endSimulation();
    }



    sumqueue = 0;// DAMOS EL VALOR 0 A LA SUMA DE LAS COLAS. DE ESTA MANERA LA INICIALIZAMOS DE NUEVO A 0

    // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE EL ANCHO DE BANDA DEMANDADO POR LA ONU Y LO VISUALIZAMOS POR PANTALLA
    table_module->table_olt_report[onu][(int)par("numqueue")] = B_demand[onu];
    //ev<<"ONU "<< onu<<"->"<< "Bandwidth Demandado: "<< B_demand[onu]<<" Bits"<<endl; //cambiado

    //CALCULAMOS ANCHO DE BANDA MAXIMO DE CADA ONU DEPENDIENDO DEL SLA
    // (SOLO LA PRIMERA VEZ)
    if(intento==0)
    {
        for(int j=0 ; j<(int)par("numOnu"); j++)
        {
            BW_max_PID[j]=B_max_sla[j];
        }
        intento=1;
    }
    /*
    for(int i=0; i<(int)par("numOnu"); i++)
    {
        ev<<"ANCHO DE BANDA MAXIMO PARA ONU "<<i<<" : "<<B_max_sla[i]<<endl;
    }
    */

    // EJECUTAMOS EL ALGORITMO IPACT YA QUE SE EJECUTA CADA VEZ QUE LLEGA UN MENSAJE REPORT DESDE LAS ONUS
    if(tiempo_tx_siguiente <= tiempo_sim_delay_datarate)
    {
        //ev<<" **CASO A. Tiempo de Transmision siguiente menor.**"<<endl;

        // COMPARAMOS SI EL ANCHO DE BANDA DEMANDADO ES MAYOR O MENOR QUE EL ANCHO DE BANDA MAXIMO
        if(B_demand[onu] <= B_max_sla[onu])
        {
            //ev<<" ANCHO DE BANDA MAXIMO PARA ONU "<<onu<<" => "<<B_max_sla[onu]<<endl;
            B_alloc[onu] = B_demand[onu] + B_report*8; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA DEMANDADO MAS EL TAMANYO DEL PAQUETE REPORT

            // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
            table_module->table_olt_report[onu][(int)par("numqueue")+1] = B_alloc[onu];
            //ev<<" ONU "<< onu<<"->"<< "Bandwidth Asignado: "<< B_alloc[onu]<<" Bits"<<endl;

            T_alloc[onu] = B_alloc[onu]/txrate; // CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU CON RESPECTO AL ANCHO DE BANDA ASIGNADO

            if(simTime()>=1)
            {
                recoger_bw_por_onu(msg);
                //calcularvarianza(msg);
            }
            pet[onu]=0;
        }
        else if(B_demand[onu] > B_max_sla[onu])
        {
            //ev<<" ANCHO DE BANDA MAXIMO PARA ONU "<<onu<<" => "<<B_max_sla[onu]<<endl;
            B_alloc[onu] = B_max_sla[onu] + B_report*8; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA  MAXIMO MIS EL TAMANYO DEL PAQUETE REPORT

            // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
            table_module->table_olt_report[onu][(int)par("numqueue")+1] = B_alloc[onu];
            //ev<<" ONU "<< onu<<"->"<< "Bandwidth Asignado: "<< B_alloc[onu]<<" Bits"<<endl;

            T_alloc[onu] = B_alloc[onu]/txrate; // CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU CON RESPECTO AL ANCHO DE BANDA ASIGNADO

            if(simTime()>=1)
            {
                recoger_bw_por_onu(msg);
                //calcularvarianza(msg);
            }

            //ACTIVAMOS EL PID
            pet[onu]=1;
        }

        T_tx_onu = T_alloc[onu] + T_guarda; //CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU

        //CREAMOS EL PAQUETE GATE PARA LA ONU
        GATEmsg *packet = new GATEmsg("gate");
        packet->setSrcAddress(srcAddress); // DIRECCION DE ORIGEN O FUENTE
        packet->setDestAddress(onu); // DIRECCION DE DESTINO
        packet->setByteLength(64); // TAMANYO DEL PAQUETE GATE
        packet->setLambdagate(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE GATE
        packet->setKind(0); // IDENTIFICADOR DEL PAQUETE GATE
        packet->setGrant_IntervalTxArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ANCHO DE BANDA DE SLOT
        packet->setNumsla(numero_sla[onu]);


        // DEPENDIENDO DEL METODO DE EXTRACCION DE PAQUETES, SE DEFINE UN ANCHO DE BANDA DE SLOT GENERAL O UNO PARA CADA COLA
        if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
        {
            B_slot[0]= B_alloc[onu]/8; // DEFINIMOS ANCHO DE BANDA DE SLOT
            packet->setGrant_IntervalTx(0,B_slot[0]);
        }
        else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
        {
            //FALTA ALGORITMO PARA ASIGNAR POR COLAS!!!!!!!!!
            // BUCLE FOR PARA DEFINIR UN ANCHO DE BANDA DE SLOT PARA CADA COLA
            for(int b=0; b<(int)par("numqueue"); b++)
            {
                B_slot[b] = B_alloc[onu]/8; // DEFINIMOS EL ANCHO DE BANDA DE SLOT PARA CADA COLA
                packet->setGrant_IntervalTx(b,B_slot[b]);
            }
        }
        packet->setGrant_IniTime(tiempo_sim_delay_datarate); // TIEMPO DE INICIO DE TRANSMISION

        // ENVIAMOS LOS PAQUETES GATE MEDIANTE EL ENVIO RETARDADO
        sendDelayed(packet, tasa_tx_gate, "mactxOut");
        //ACTUALIZAMOS EL TIEMPO DE INICIO DE TRANSMISION PARA LA SIGUIENTE ONU
        tiempo_tx_siguiente = tiempo_sim_delay_datarate + T_tx_onu;
        //ev<<" Tiempo de Transmision Siguiente: "<<tiempo_tx_siguiente<<endl;
    }
    else if(tiempo_tx_siguiente > tiempo_sim_delay_datarate)
    {
        //ev<<" **CASO B. Tiempo de Transmision siguiente mayor.**"<<endl;

        // COMPARAMOS SI EL ANCHO DE BANDA DEMANDADO ES MAYOR O MENOR QUE EL ANCHO DE BANDA MAXIMO
        if(B_demand[onu] <= B_max_sla[onu])
        {
            //ev<<" ANCHO DE BANDA MAXIMO PARA ONU "<<onu<<" => "<<B_max_sla[onu]<<endl;
            B_alloc[onu] = B_demand[onu] + B_report*8; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA DEMANDADO MAS EL TAMANYO DEL PAQUETE REPORT

            // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
            table_module->table_olt_report[onu][(int)par("numqueue")+1] = B_alloc[onu];
            //ev<<" ONU "<< onu<<"->"<< "Bandwidth Asignado: "<< B_alloc[onu]<<" Bits"<<endl;

            T_alloc[onu] = B_alloc[onu]/txrate; // CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU CON RESPECTO AL ANCHO DE BANDA ASIGNADO

            if(simTime()>=1)
            {
                recoger_bw_por_onu(msg);
                //calcularvarianza(msg);
            }
            pet[onu]=0;
        }
        else if(B_demand[onu] > B_max_sla[onu])
        {
            //ev<<" ANCHO DE BANDA MAXIMO PARA ONU "<<onu<<" => "<<B_max_sla[onu]<<endl;
            B_alloc[onu] = B_max_sla[onu] + B_report*8; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA  MAXIMO MIS EL TAMANYO DEL PAQUETE REPORT

            // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
            table_module->table_olt_report[onu][(int)par("numqueue")+1] = B_alloc[onu];
            //ev<<" ONU "<< onu<<"->"<< "Bandwidth Asignado: "<< B_alloc[onu]<<" Bits"<<endl;

            T_alloc[onu] = B_alloc[onu]/txrate; // CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU CON RESPECTO AL ANCHO DE BANDA ASIGNADO

            if(simTime()>=1)
            {
                recoger_bw_por_onu(msg);
                //calcularvarianza(msg);
            }
            //ACTIVAMOS EL PID
            pet[onu]=1;
        }

        T_tx_onu = T_alloc[onu] + T_guarda; //CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU

        //CREAMOS EL PAQUETE GATE PARA LA ONU
        GATEmsg *packet = new GATEmsg("gate");
        packet->setSrcAddress(srcAddress); // DIRECCION DE ORIGEN O FUENTE
        packet->setDestAddress(onu); // DIRECCION DE DESTINO
        packet->setByteLength(64); // TAMANYO DEL PAQUETE GATE
        packet->setLambdagate(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE GATE
        packet->setKind(0); // IDENTIFICADOR DEL PAQUETE GATE
        packet->setGrant_IntervalTxArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ANCHO DE BANDA DE SLOT
        packet->setNumsla(numero_sla[onu]);

        // DEPENDIENDO DEL METODO DE EXTRACCION DE PAQUETES, SE DEFINE UN ANCHO DE BANDA DE SLOT GENERAL O UNO PARA CADA COLA
        if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
        {
            B_slot[0]= B_alloc[onu]/8; // DEFINIMOS ANCHO DE BANDA DE SLOT
            packet->setGrant_IntervalTx(0,B_slot[0]);
        }
        else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
        {
            //FALTA ALGORITMO PARA ASIGNAR POR COLAS!!!!!!!!!
            // BUCLE FOR PARA DEFINIR UN ANCHO DE BANDA DE SLOT PARA CADA COLA
            for(int b=0; b<(int)par("numqueue"); b++)
            {
                B_slot[b] = B_alloc[onu]/8; // DEFINIMOS EL ANCHO DE BANDA DE SLOT PARA CADA COLA
                packet->setGrant_IntervalTx(b,B_slot[b]);
            }
        }
        packet->setGrant_IniTime(tiempo_tx_siguiente); // TIEMPO DE INICIO DE TRANSMISION

        // ENVIAMOS LOS PAQUETES GATE MEDIANTE EL ENVIO RETARDADO
        sendDelayed(packet, tasa_tx_gate, "mactxOut");

        //ACTUALIZAMOS EL TIEMPO DE INICIO DE TRANSMISION PARA LA SIGUIENTE ONU
        tiempo_tx_siguiente = tiempo_tx_siguiente + T_tx_onu;
        //ev<<" Tiempo de Transmision Siguiente: "<<tiempo_tx_siguiente<<endl;

    }

    B_alloc_total[onu]=B_alloc_total[onu]+B_alloc[onu]; //B_ALLOC TOTAL EN Bits

    //ev<<" B_ALLOC_TOTAL "<<B_alloc_total[onu]<<" onu: "<<onu<<endl;

    //B_Mbps[onu]=B_alloc_total[onu]/(SIMTIME_DBL(simTime()));

    if(onu==0)
    {
        B_Mbps_sla[0]=B_Mbps_sla[0]+(B_alloc[onu]-B_report*8);
    }
    else if(onu>=1 && onu<6)
    {
        B_Mbps_sla[1]=B_Mbps_sla[1]+(B_alloc[onu]-B_report*8);
    }

    else if(onu>=6)
    {
        B_Mbps_sla[2]=B_Mbps_sla[2]+(B_alloc[onu]-B_report*8);
    }
        delete reportmsg; // BORRAMOS EL MENSAJE REPORT
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MAC_OLT::DBA_polling_DaSPID(cMessage *msg)
{
    // NOTA:
    // BW_sla[], SW_SLA_onu[] --> Mbits
    // B_max_sla, sumqueue, B_demand[], BW_max_PID[], B_cycle, B_report,B_alloc[], B_alloc_total[], B_Mbps_sla[] --> bit

    //ev<<" EJECUTAMOS EL METODO IPACT DE POLLING CON EL ALGORITMO DaSPID." << endl;
    REPORTmsg *reportmsg = check_and_cast<REPORTmsg *>(msg);
    //VARIABLES
    long int txrate = (long int)par("txrate"); // TASA DE TRANSMISION EN BITS POR SEGUNDO
    long double tasa_tx_gate = (long double)512/txrate; // TASA DE TRANSMISION DEL PAQUETE GATE DE 64 BYTES
    long double tasa_tx_report = (long double)512/txrate; // TASA DE TRANSMISION DEL PAQUETE REPORT DE 64 BYTES
    double T_cycle = 0.002; // TIEMPO DE CICLO MAXIMO EN MILISEGUNDOS
    double T_guarda = 0.000001; // TIEMPO DE GUARDA QUE SE ESPERA ENTRA LA TRANSMISION DE DOS ONUS
    double T_guarda_nonu = T_guarda*((int)par("numOnu")); // TIEMPO DE GUARDA TOTAL DE TODAS LAS ONUS
    long double T_report_nonu = (long double)tasa_tx_report*((int)par("numOnu")); // TASA DE TRANSMISION TOTAL DE LOS PAQUETES REPORT DE TODAS LAS ONUS
    long double T_cycle_total = (long double)T_cycle - T_guarda_nonu - T_report_nonu; // TIEMPO DE CICLO FINAL Y LO VISUALIZAMOS POR PANTALLA
    // T_cycle_total = 0.001975808s
    //ev<<" Tiempo de ciclo total: "<<T_cycle_total<<"s."<<endl;
    double T_tx_onu; // TIEMPO DE TRANSMISION DE UNA ONU
    long double B_cycle = (long double)txrate*T_cycle_total; // ANCHO DE BANDA MAXIMO DEL CICLO (BITS)
    // B_cycle = 1975808 bits = 246976 Bytes.
    //ev<<" Ancho de banda del ciclo: "<<B_cycle<<" Bits"<<endl;
    long double B_report = 512; // TAMANYO DEL PAQUETE REPORT (64 BYTES)
    double B_slot[(int)par("numqueue")]; // VARIABLE DE ANCHO DE BANDA DE SLOT CON TAMANYO EL N��MERO DE COLAS QUE SE DEFINEN
    int srcAddress = 9; // DEFINICION DEL IDENTIFICADOR DE LA DIRECCION DE ORIGEN O FUENTE
    simtime_t time_tx_onu0; // TIEMPO DE TRANSIMISION DE LA PRIMERA ONU
    int onu = reportmsg->getSrcAddress(); // VARIABLE QUE NOS INDICA EL IDENTIFICADOR DE LA ONU CORRESPONDIENTE
    int lengthmethod = (int)par("methodlength_longvariable0_longfija1");
    double velocidad = 300000000; // DEFINIMOS EL PARAMETRO VELOCIDAD DE LA VELOCIDAD DE LA LUZ (EN M/S)
    cTopology topo; // DEFINIMOS UN PARAMETRO DE LA TOPOLOGIA DE LA RED
    double longitud_total_red; // DEFINIMOS LA VARIABLE QUE NOS INDICA LA LONGITUD TOTAL DE LA RED

    // ASIGNACION DE PESOS
    Wsla[0] = (int)par("w_sla0"); // PESO DEL SLA0 DEFINIDO EN NUESTRA RED (1)
    Wsla[1] = (int)par("w_sla1"); // PESO DEL SLA1 DEFINIDO EN NUESTRA RED (2)
    Wsla[2] = (int)par("w_sla2"); // PESO DEL SLA2 DEFINIDO EN NUESTRA RED (3)

    // ASIGNACION DEL NUMERO DE ONUS
    numonu_sla[0] = (int)par("numonu_sla0"); // NUMERO DE ONUs ASOCIADO AL SLA0 (2)
    numonu_sla[1] = (int)par("numonu_sla1"); // NUMERO DE ONUs ASOCIADO AL SLA1 (6)
    numonu_sla[2] = (int)par("numonu_sla2"); // NUMERO DE ONUs ASOCIADO AL SLA2 (8)

    // ASIGNACION DE ANCHO DE BANDAS
    BW_sla[0] = (int)par("BW_garantizado0"); //ANCHO DE BANDA ASOCIADO AL SLA0 (100Mb)
    BW_sla[1] = (int)par("BW_garantizado1"); //ANCHO DE BANDA ASOCIADO AL SLA1 (75Mb)
    BW_sla[2] = (int)par("BW_garantizado2"); //ANCHO DE BANDA ASOCIADO AL SLA2 (50Mb)

    // ASIGNACION DE LOS LIMITES DE RETARDO MAXIMO (EN SEGUNDOS) POR CADA SLA Y PRIORIDAD:
    /* SLA 0: ONU[0] y ONU[1] */
    retardo_max_ONU[0][0] = 0.001*1.5;  // SLA0-P0: 1.5ms
    retardo_max_ONU[0][1] = 0.001*5;        // SLA0-P1: 5ms
    retardo_max_ONU[1][0] = 0.001*1.5;
    retardo_max_ONU[1][1] = 0.001*5;
    /* SLA 1: ONU[2], ONU[3], ONU[4], ONU[5], ONU[6] y ONU[7] */
    retardo_max_ONU[2][0] = 0.001*1.5;  // SLA1-P0: 1.5ms
    retardo_max_ONU[2][1] = 0.001*20;       // SLA1-P1: 20ms
    retardo_max_ONU[3][0] = 0.001*1.5;
    retardo_max_ONU[3][1] = 0.001*20;
    retardo_max_ONU[4][0] = 0.001*1.5;
    retardo_max_ONU[4][1] = 0.001*20;
    retardo_max_ONU[5][0] = 0.001*1.5;
    retardo_max_ONU[5][1] = 0.001*20;
    retardo_max_ONU[6][0] = 0.001*1.5;
    retardo_max_ONU[6][1] = 0.001*20;
    retardo_max_ONU[7][0] = 0.001*1.5;
    retardo_max_ONU[7][1] = 0.001*20;
    /* SLA 2: ONU[8], ONU[9], ONU[10], ONU[11], ONU[12], ONU[13], ONU[14] y ONU[15] */
    retardo_max_ONU[8][0] = 0.001*1.5;  // SLA2-P0: 1.5ms
    retardo_max_ONU[8][1] = 0.001*60;       // SLA2-P1: 60ms
    retardo_max_ONU[9][0] = 0.001*1.5;
    retardo_max_ONU[9][1] = 0.001*60;
    retardo_max_ONU[10][0] = 0.001*1.5;
    retardo_max_ONU[10][1] = 0.001*60;
    retardo_max_ONU[11][0] = 0.001*1.5;
    retardo_max_ONU[11][1] = 0.001*60;
    retardo_max_ONU[12][0] = 0.001*1.5;
    retardo_max_ONU[12][1] = 0.001*60;
    retardo_max_ONU[13][0] = 0.001*1.5;
    retardo_max_ONU[13][1] = 0.001*60;
    retardo_max_ONU[14][0] = 0.001*1.5;
    retardo_max_ONU[14][1] = 0.001*60;
    retardo_max_ONU[15][0] = 0.001*1.5;
    retardo_max_ONU[15][1] = 0.001*60;

    // CALCULAMOS EL DELAY O RETARDO DEPENDIENDO DE LA LONGITUD DE NUESTRA RED
    switch(lengthmethod)
    {
        case 0:
            // METODO DE LONGITUD VARIABLE
            topo.extractByParameter( "numlong" ); // EXTRAEMOS LOS NODOS DE NUESTRA RED QUE UTILIZAN EL PARIMETRO numlong
            delay_pon1 = ((int)par("longpon1")*3)/(velocidad*2); // CALCULAMOS EL RETARDO DEL SEGMENTO DE LA RED QUE UNE EL OLT Y EL SPLITTER
            // RECORREMOS CON EL BUCLE FOR TODAS LAS ONUS PARA CALCULAR EL RETARDO DEL CANAL QUE UNE EL SPLITTER CON CADA ONU
            for(int i=0; i<(int)par("numOnu"); i++)
            {
                cModule *module = getParentModule()->getParentModule()->getSubmodule("onu", i); // DEFINIMOS EL PARIMETRO MODULE QUE NOS INDICA EL CAMINO HASTA EL NODO DEL QUE QUEREMOS OBTENER INFORMACION
                cTopology::Node *nodeonuOut = topo.getNodeFor(module); // NOMBRE DEL NODO QUE SACAMOS DEL GRAFO
                // RECORREMOS CON EL BUCLE FOR TODOS LOS ENLACES DE SALIDA QUE TIENE ESE NODO PARA OBTENER LA INFORMACION QUE SOLICITAMOS
                for(int j=0; j<nodeonuOut->getNumOutLinks(); j++)
                {
                    delay_pon2[i] = (check_and_cast<cDelayChannel*>(nodeonuOut->getLinkOut(j)->getLocalGate()->getChannel()))->getDelay();
                    //ev<<" Retardo Onu"<<i<<": "<<delay_pon2[i]<<endl; // VISUALIZAMOS EL VALOR DEL RETARDO
                    delay_total[i] = delay_pon1 + delay_pon2[i]; // CALCULAMOS EL RETARDO TOTAL DE LA RED Y LO VISUALIZAMOS
                    //ev<<" Retardo Total de la red PON: "<<delay_total[i]<<endl;
                }
            }
            break;

        case 1:
            // METODO DE LONGITUD FIJA
            longitud_total_red = ((int)par("longpon1")+(int)par("longpon2")); // DEFINIMOS EL PARIMETRO QUE INDICA LA LONGITUD TOTAL DE LA RED EN METROS
            delay = (longitud_total_red*3)/(velocidad*2); // CALCULAMOS EL RETARDO O DELAY PARA LA RED SEGUN LA LONGITU QUE DEFINAMOS AL PRINCIPION DE LA SIMULACION
            break;

        default:
            //ev<<"Error al elegir el metodo de longitudes."<<endl;
            break;
    }
    // OBTENEMOS Y VISUALIZAMOS POR PANTALLA EL TIEMPO DE SIMULACION + DELAY CORRESPONDIENTE + TASA DE TRANSMISION DEL PAQUETE GATE
    // COMPARAMOS SI SE TRATA DE LONGITUD DE LA RED VARIABLE O LONGITUD DE LA RED FIJA
    if((int)par("methodlength_longvariable0_longfija1")==0)
    {
        // METODO DE LONGITUD VARIABLE
        // TIEMPO DE SIMULACION + DELAY CORRESPONDIENTE + TASA DE TRANSMISION DEL PAQUETE GATE CON DISTANCIAS ALEATORIAS
        tiempo_sim_delay_datarate = simTime() + delay_total[onu] + tasa_tx_gate;
        //ev<<" Tiempo de simulacion + delay + tasa tx gate: "<<tiempo_sim_delay_datarate<<" s."<<endl;
    }
    else if((int)par("methodlength_longvariable0_longfija1")==1)
    {
        // METODO DE LONGITUD FIJA
        // TIEMPO DE SIMULACION + DELAY CORRESPONDIENTE + TASA DE TRANSMISION DEL PAQUETE GATE CON DISTANCIAS FIJAS
        tiempo_sim_delay_datarate = simTime() + delay + tasa_tx_gate;
        //ev<<" Tiempo de simulacion + delay + tasa tx gate: "<<tiempo_sim_delay_datarate<<" s."<<endl;
    }

    for(int j=0; j<(int)par("numSLA"); j++)
    {
        // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs ASOCIADAS A UN SLA
        for(int i=0; i<numonu_sla[j]; i++)
        {
            SLA_onu[id_onu+i] = Wsla[j]; // ASIGANAMOS A LA VARIABLE SLA_onu[] EL VALOR DEL PESO DEL SLA AL QUE ESTA ASOCIADA ESA ONU
            BW_SLA_onu[id_onu+i] = BW_sla[j]; //ASIGNAMOS A LA VARIABLE BW_SLA_onu[] EL VALOR DEL ANCHO DE BANDA GARANTIZADO POR SLA
            //ev<<" ONU "<<id_onu+i<<": Peso="<<Wsla[j]<<endl; // VISUALIZAMOS EL PESO ASOCIADO A CADA ONU
            numsla[id_onu+i] = j; // INTRODUCIMOS EN LA VARIABLE numsla[] EL IDENTIFICADOR DEL SLA PARA CADA ONU YA QUE LO UTILIZAREMOS PARA RECOGER EL RETARDO DE CADA SLA
            numero_sla[id_onu+i]=j;
            // MEDIANTE ESTE IF, VAMOS INCREMENTANDO EL IDENTIFICADOR DE LA ONU
            if(i==(numonu_sla[j]-1))
            {
                id_onu=id_onu+1+i;
            }
        }
    }
    id_onu=0; // IGUALAMOS EL IDENTIFICADOR DE LA ONU AL VALOR 0

    // RECORREMOS MEDIANTE ESTE BUCLE FOR LOS SLAs DEFINIDOS EN NUESTRA RED PARA REALIZAR EL SUMATORIO PARA CALCULAR EL ANCHO DE BANDA ASOCIADO A CADA SLA
    for(int i=0; i<(int)par("numSLA"); i++)
    {
            sumatorio = sumatorio + (numonu_sla[i]*Wsla[i]); // CALCULAMOS EL SUMATORIO Y LO VISUALIZAMOS POR PANTALLA
            ////ev<<" Sumatorio de los pesos de todas las ONUs del SLA : " << i << ": " << sumatorio << endl;
    }
    // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs PARA CALCULAR EL ANCHO DE BANDA DE CADA ONU ASIGNADO POR EL SLA QUE CORRESPONDE A CADA ONU
    // (SOLO LA PRIMERA VEZ)
    if(prueba==0)
    {
        for(int j=0; j<(int)par("numSLA"); j++)
        {
            // RECORREMOS MEDIANTE ESTE BUCLE FOR TODAS LAS ONUs ASOCIADAS A UN SLA
            for(int i=0; i<numonu_sla[j]; i++)
            {
                B_max_sla[id+i] = B_cycle*Wsla[j]/sumatorio; // CALCULAMOS EL ANCHO DE BANDA ASOCIADO A CADA ONU SEGUN EL SLA ASOCIADO A LA ONU
                    ////ev<<"BW maximo por SLA: " << B_max_sla[id+i] << endl;
                // MEDIANTE ESTE IF, VAMOS INCREMENTANDO EL IDENTIFICADOR DE LA ONU:
                if(i==(numonu_sla[j]-1))
                {
                    id=id+1+i;
                }
            }
        }
        prueba=1;
    }
    id=0;
    sumatorio = 0; // DAMOS EL VALOR 0 AL SUMATORIO PARA QUE NO SE INCREMENTE
    //VAMOS A CALCULAR EL ANCHO DE BANDA DEMANDADO Y LO GUARDAMOS EN LA TABLA
    //ev<<" Calculamos el Bandwidth demandado y lo guardamos en la tabla del OLT."<<endl;
    // SUMAMOS EL TAMANYO DEL ESTADO DE LAS COLAS DE LA ONU QUE HA MANDADO EL REPORT QUE LLEGA AL OLT
    for(int i=0; i<(int)par("numqueue"); i++)
    {
        //ev<<" Bytes en la cola P" << i << " de la ONU[" << onu << "]: " << reportmsg->getQueue_estado(i) << endl;
        sumqueue = sumqueue + (reportmsg->getQueue_estado(i)*8);
    }
    //ev<<" Total bits presentes en las colas de la ONU[" << onu << "]: " << sumqueue << endl;
    // SI LA SUMA TOTAL DEL TAMANYO DE LAS COLAS ES 0, DAMOS UN VALOR PREDETERMINADO DE 20 BYTES
    if(sumqueue == 0)
    {
        sumqueue = 20*8; //POR 8 PARA PASARLO A BITS
    }
    // ASIGNAMOS LA SUMA TOTAL A LA VARIABLE DEL ANCHO DE BANDA DEMANDADO DE LA ONU
    B_demand[onu] = sumqueue; //bits
    sumqueue = 0;// DAMOS EL VALOR 0 A LA SUMA DE LAS COLAS, PARA LA PROXIMA ASIGNACION DE BW
    // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE EL ANCHO DE BANDA DEMANDADO POR LA ONU Y LO VISUALIZAMOS POR PANTALLA
    table_module->table_olt_report[onu][(int)par("numqueue")] = B_demand[onu];
    //ev<<" ONU[" << onu << "] --> " << "Bandwidth Demandado: " << B_demand[onu] << " Bits" << endl;

    // ASIGNACION A CADA ONU DEL ANCHO DE BANDA MAXIMO, SEGUN SU SLA:
    // (SOLO LA PRIMERA VEZ)
    if(intento==0)
    {
        for(int j=0 ; j<(int)par("numOnu"); j++)
        {
            BW_max_PID[j]=B_max_sla[j]; //bits
        }
        intento=1;
    }

    // **EJECUTAMOS EL ALGORITMO IPACT YA QUE SE EJECUTA CADA VEZ QUE LLEGA UN MENSAJE REPORT DESDE LAS ONUS**
    // NOTA:
    // BW_sla[], SW_SLA_onu[] --> Mbits
    // B_max_sla, sumqueue, B_demand[], BW_max_PID[], B_cycle, B_report,B_alloc[], B_alloc_total[], B_Mbps_sla[] --> bit
    //ev<<" Ancho de banda maximo por PID para la ONU[" << onu << "]: " << BW_max_PID[onu] << " bits" << endl;
    //ev<<"  --> " << "Bandwidth maximo para su SLA (sin contar los 512 bits del Report): " << B_max_sla[onu] << " Bits" << endl;

    // COMPARAMOS SI EL ANCHO DE BANDA DEMANDADO ES MAYOR O MENOR QUE EL ANCHO DE BANDA MAXIMO
    if(B_demand[onu] <= B_max_sla[onu])
    {
        B_alloc[onu] = B_demand[onu] + B_report; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA DEMANDADO MAS EL TAMANYO DEL PAQUETE REPORT
        pet[onu]=0;
    }
    else if(B_demand[onu] > B_max_sla[onu])
    {
        B_alloc[onu] = B_max_sla[onu] + B_report; // DAMOS EL VALOR AL ANCHO DE BANDA ASIGNADO DEL ANCHO DE BANDA  MAXIMO MIS EL TAMANYO DEL PAQUETE REPORT
        pet[onu]=1;
    }
    // En el caso de no haber bits en las colas de la ONU:
    // B_alloc[onu] = B_demand[onu](160b) + B_report(512b) = 672 bits.
    //ev<<"  --> " << "Bandwidth asignado para el proximo periodo: " << B_alloc[onu] << " Bits" << endl;
    /*
    //PET para Controlar DElay!!!!!!!!!!!!!!!
    //Se pone a principio de ciclo de 1 en vez de a 0 xq el PID tiene que estar activo siempre en todas las ONUs hasta que todas cumplan con los retardos
    if(onu==0)
    {
        for(int i=0; i<(int)par("numOnu"); i++)
        {
            pet[i]=1;
        }
    }
    */
    if(simTime()>2)
    {
        recoger_bw_por_onu(msg);
    }
    /* PARA HACER LA VENTANA POR SLAs Y PRIORIDADES (P0 y P1) */
    // Si el Report recibido es de la ultima ONU del array, el ciclo para calcular el retardo ha acabado.
    // Por tanto, ahora se hacen las medias del retardo y se actualiza la ventana.
    if(onu==(int)par("numOnu")-1)
    {
        int prioridades = 2; // Clases de servicio de las que se controla el retardo con el PID (P0 y P1)
        double delay_sla[(int)par("numSLA")][prioridades]; // Suma del retardo de todos los paquetes recibidos en un ciclo de cada SLA y prioridad
        int paquetes_sla[(int)par("numSLA")][prioridades]; // Numero total de paquetes recibidos en un ciclo de cada SLA y prioridad

        // Se ponen a cero todas las variables auxiliares para este nuevo ciclo:
        for(int i=0; i<(int)par("numSLA"); i++)
        {
            for(int j=0; j<prioridades; j++)
            {
                delay_sla[i][j]=0.0;
                paquetes_sla[i][j]=0;
            }
        }
        int acum=0, k=0;
        for (int j=0; j<(int)par("numSLA"); j++)
        {
            for(k=acum; k<numonu_sla[j]+acum; k++)
            {
                for(int p=0; p<prioridades; p++)
                {
                    // Aunque se va imprimiendo con cada actualizacion de cada onu de cada sla, el valor correcto
                    // del retardo total y numero de paquetes de cada sla es el ultimo que sale impreso en el Tkenv.
                    delay_sla[j][p]=delay_sla[j][p]+delay_onu[k][p];
                    //ev<<" Retardo de los paquetes del SLA " << j << " con prioridad P" << p << ": " << delay_sla[j][p] << " segundos." << endl;
                    paquetes_sla[j][p]=paquetes_sla[j][p] + paq_onu[k][p];
                    //ev<<" Paquetes recibidos en el SLA " << j << " con prioridad P" << p << ": " << paquetes_sla[j][p] << endl;
                    delay_onu[k][p]=0.0; // Para el siguiente ciclo
                    paq_onu[k][p]=0.0; // Para el siguiente ciclo
                }
            }
            acum=k;
            for(int p=0; p<prioridades; p++)
            {
                if(paquetes_sla[j][p]>0) //Si hay alg���n paquete, entonces puedo dividir para sacar el delay:
                {
                    recoger_delay_por_sla(j, (double)(delay_sla[j][p]/paquetes_sla[j][p]), p);
                }
            }
        }
        //Fin ventana SLAS
    }
    // Se ajusta el BW al finalizar el ciclo:
    if((simTime()>tiempo_PID) && (onu==(int)par("numOnu")-1))
    {
        int cumplen=0;
        // **PARA DAR PRIORIDAD AL SLA0 Y SLA1 SI NO CUMPLEN TODOS**
        // Comprobamos que cumplen los SLAs prioritarios:
        int acum=0;
        int k=0;
        for (int j=0; j<(int)par("numSLA"); j++)
        {
            for(k=acum; k<numonu_sla[j]+acum; k++)
            {
                ////ev<<" Retardo ONU[" << k << "] = " << retardo_alg_ONU[k][1] << endl;
                if((j==0)||(j==1))
                {
                    if (retardo_alg_ONU[k][1]<retardo_max_ONU[k][1])
                    {
                        cumplen++;
                    }
                }
            }
            acum=k;
        }
        if(no_capacidad==1)
        {
            flag_control_delay=1; // Si no hay capacidad para todas las ONUs.
        }
        else
        {
            if(cumplen==(numonu_sla[0]+numonu_sla[1]))
            {
                flag_control_delay=0; // Si cumplen todas las ONUs.
            }
            else
            {
                flag_control_delay=1; // Si no cumplen todas las ONUs.
            }
        }
    }
    // GUARDAMOS EN LA TABLA DEL MODULO OLT_TABLE LA VARIABLE DEL ANCHO DE BANDA ASIGANDO Y LO VISUALIZAMOS POR PANTALLA
    table_module->table_olt_report[onu][(int)par("numqueue")+1] = B_alloc[onu];
    //ev<<" ONU "<< onu<<"->"<< "Bandwidth Asignado: "<< B_alloc[onu]<<" Bits"<<endl;
    T_alloc[onu] = B_alloc[onu]/txrate; // CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU CON RESPECTO AL ANCHO DE BANDA ASIGNADO
    T_tx_onu = T_alloc[onu] + T_guarda; //CALCULAMOS EL TIEMPO DE TRANSMISION DE LA ONU

    //CREAMOS EL PAQUETE GATE PARA LA ONU
    GATEmsg *packet = new GATEmsg("gate");
    packet->setSrcAddress(srcAddress); // DIRECCION DE ORIGEN O FUENTE
    packet->setDestAddress(onu); // DIRECCION DE DESTINO
    packet->setByteLength(64); // TAMANYO DEL PAQUETE GATE
    packet->setLambdagate(0); // LONGITUD DE ONDA POR LA QUE SE TRANSMITE EL PAQUETE GATE
    packet->setKind(0); // IDENTIFICADOR DEL PAQUETE GATE
    packet->setGrant_IntervalTxArraySize((int)par("numqueue")); // TAMANYO DEL ARRAY QUE CONTIENE EL ANCHO DE BANDA DE SLOT
    packet->setNumsla(numero_sla[onu]);
    // DEPENDIENDO DEL METODO DE EXTRACCION DE PAQUETES, SE DEFINE UN ANCHO DE BANDA DE SLOT GENERAL O UNO PARA CADA COLA
    if((int)par("extractionmethod_StrictPQ0_Centralized1")==0)
    {
        B_slot[0]= B_alloc[onu]/8; // DEFINIMOS ANCHO DE BANDA DE SLOT
        packet->setGrant_IntervalTx(0,B_slot[0]);
    }
    else if((int)par("extractionmethod_StrictPQ0_Centralized1")==1)
    {
        //FALTA ALGORITMO PARA ASIGNAR POR COLAS!!!!!!!!!
        // BUCLE FOR PARA DEFINIR UN ANCHO DE BANDA DE SLOT PARA CADA COLA
        for(int b=0; b<(int)par("numqueue"); b++)
        {
            B_slot[b] = B_alloc[onu]/8; // DEFINIMOS EL ANCHO DE BANDA DE SLOT PARA CADA COLA (BYTES)
            packet->setGrant_IntervalTx(b,B_slot[b]);
        }
    }

    // NOTA: "tiempo_tx_siguiente" --> Tiempo de inicio del proximo ciclo de transmision de la ONU.
    //           "tiempo_sim_delay_datarate" --> simTime() + Retardo propagacion + Tiempo de tx de un paquete Gate.
    // Si el inicio del proximo ciclo es menor que el tiempo en que ha de llegar a la ONU el Gate que ahora
    // va a enviarle el OLT...
    if(tiempo_tx_siguiente <= tiempo_sim_delay_datarate)
    {
        //ev<<" **CASO A. Tiempo de Transmision siguiente menor que la suma del tiempo actual con el retardo de propagacion y el tiempo de transmision de un Gate.**"<<endl;
        packet->setGrant_IniTime(tiempo_sim_delay_datarate); // TIEMPO DE INICIO DE TRANSMISION
        // ENVIAMOS LOS PAQUETES GATE MEDIANTE EL ENVIO RETARDADO
        sendDelayed(packet, tasa_tx_gate, "mactxOut");
        //ACTUALIZAMOS EL TIEMPO DE INICIO DE TRANSMISION PARA LA SIGUIENTE ONU:
        tiempo_tx_siguiente = tiempo_sim_delay_datarate + T_tx_onu;
    }
    // Si el inicio del proximo ciclo es mayor que el tiempo en que ha de llegar a la ONU el Gate que ahora
    // va a enviarle el OLT...
    else if(tiempo_tx_siguiente > tiempo_sim_delay_datarate)
    {
        //ev<<" **CASO B. Tiempo de Transmision siguiente mayor que la suma del tiempo actual con el retardo de propagacion y el tiempo de transmision de un Gate.**"<<endl;
        packet->setGrant_IniTime(tiempo_tx_siguiente); // TIEMPO DE INICIO DE TRANSMISION
        // ENVIAMOS LOS PAQUETES GATE MEDIANTE EL ENVIO RETARDADO
        sendDelayed(packet, tasa_tx_gate, "mactxOut");
        //ACTUALIZAMOS EL TIEMPO DE INICIO DE TRANSMISION PARA LA SIGUIENTE ONU:
        tiempo_tx_siguiente = tiempo_tx_siguiente + T_tx_onu;
    }
    //ev<<" Tiempo de Transmision Siguiente: T="<<tiempo_tx_siguiente<<endl;

    // ADICION DEL ANCHO DE BANDA ASIGNADO EN ESTE CICLO AL ANCHO DE BANDA ASIGNADO EN TOTAL:
    B_alloc_total[onu]=B_alloc_total[onu]+B_alloc[onu]; //B_ALLOC TOTAL EN Bits
    //ev<<" B_ALLOC_TOTAL "<<B_alloc_total[onu]<<" onu: "<<onu<<endl;
    //B_Mbps[onu]=B_alloc_total[onu]/(SIMTIME_DBL(simTime()));

    // ALMACENAMIENTO DEL ANCHO DE BANDA ACUMULADO PARA CALCULAR EL THROUGHPUT POR SLA AL HACER FINISH:
    if(onu==0)
    {
        B_Mbps_sla[0]=B_Mbps_sla[0]+(B_alloc[onu]-B_report);
    }
    else if(onu>=1 && onu<6)
    {
        B_Mbps_sla[1]=B_Mbps_sla[1]+(B_alloc[onu]-B_report);
    }
    else if(onu>=6)
    {
        B_Mbps_sla[2]=B_Mbps_sla[2]+(B_alloc[onu]-B_report);
    }
    delete reportmsg; // BORRAMOS EL MENSAJE REPORT

    if(simTime()> 10*cont_auxiliar)
    {
        cont_auxiliar++;
        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL BW ASIGNADO A CADA SLA:
        B_alloc_periodico=fopen("results/B_alloc.txt", "a+");
        //" T \t  SLA_0  \t  SLA_1  \t  SLA_2  \n"
        fprintf(B_alloc_periodico," %g \t %g \t %g \t %g \n" , SIMTIME_DBL(simTime()), (double)B_alloc[0], (double)B_alloc[2], (double)B_alloc[8]);
        fclose(B_alloc_periodico);
    }
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MAC_OLT::PID_control_delay(cMessage *msg)
{
    // FUNCION PARA CONTROLAR EL RETARDO EN EL PID:
    // Seg���n el error que se comete entre el valor medio del retardo para las clases de servicio
    // P0-P1 y el valor estipulado, se modifican los anchos de banda de cada ONU.
    delete msg;
    //double Kp = 0.5; //PARAMETRO DE NUESTRO DaSPID
    //double Ti = 11; //PARAMETRO DE NUESTRO DaSPID
    //double Td = 2.75; //PARAMETRO DE NUESTRO DaSPID
    double BW_total_ciclo; //ANCHO DE BANDA TOTAL DEL CICLO
    double Total_PID = 0.0;
    double time_slot; //VARIABLE PARA EL TIEMPO DE SLOT
    //double retardo; //VARIABLE PARA EL RETARDO
    double T_cycle=0.002; // TIEMPO DE CICLO MAXIMO EN MILISEGUNDOS
    double T_guarda = 0.000001; //TIEMPO DE GUARDA QUE SE ESPERA ENTRA LA TRANSMISION DE DOS ONUS
    long int txrate = (long int)par("txrate"); // VARIABLE TASA DE TRANSMISION
    long double tasa_tx_gate = (long double)512/txrate; // TASA DE TRANSMISION DEL PAQUETE GATE DE 64 BYTES
    long double tasa_tx_report = (long double)512/txrate; // TASA DE TRANSMISION DEL PAQUETE REPORT DE 64 BYTE

    //ev<<" ENTRA EN EL PID EN EL TIEMPO: " << simTime() << endl;
    tiempo_inic_PID+=tiempo_PID;

    //GENERAMOS EL MENSAJE DE TIPO 7 PARA QUE DESDE EL handleMessage() SE LLAME CADA 'tiempo_inic_PID'
    // AL ALGORITMO PID QUE ACTUALIZA LOS ANCHOS DE BANDA MAXIMOS EN FUNCION DE LOS ERRORES DEL RETARDO.
    // ESTO ES PARALELO A LA ASIGNACION DE ANCHO DE BANDA, CICLO TRAS CICLO, QUE SE REALIZA CON EL ALGORITMO ANTERIOR, 'DBA_polling_DaSPID'.
    cMessage *msg2 = new cMessage ("mensaje inicial");
    msg2->setKind(7); // IDENTIFICAMOS EL AUTOMENSAJE CON EL IDENTIFICADOR = 7
    scheduleAt(tiempo_inic_PID, msg2); // SI QUE QUITA NO SE INICIALIZAN LAS ONUS, NO SE MANDAN LOS GATES
    //ev<<"     Proximo PID en T=" << tiempo_inic_PID << "." << endl;

    // SE CALCULA EL BW MAXIMO DEL PID UNA VEZ POR SLA, PARA LA ULTIMA ONU DE CADA UNO, Y LUEGO SE COPIA EL VALOR OBTENIDO
    // EN LA POSICION CORRESPONDIENTE AL RESTO DE ONUs DEL MISMO SLA:
    int acum_onus_sla = 0;
    for(int i=0; i<(int)par("numSLA"); i++)
    {
        acum_onus_sla += numonu_sla[i];
        // 'acum_onus_sla-1' = indice de la ultima onu asociada a cada sla
        B_max_sla_ant[acum_onus_sla-1] = B_max_sla[acum_onus_sla-1];
        if(pet[acum_onus_sla-1] == 0)
        {
            BW_max_PID[acum_onus_sla-1] = BW_max_PID_ant[acum_onus_sla-1];
            //ev<<"El PID no esta activo. El ancho de banda que propone el PID es el de antes, que es " << BW_max_PID[acum_onus_sla-1] << " bits" << endl;
            flagPrioridad = 1;
        }
        else
        {
            //ev<<" Retardo maximo para los paquetes P0 del SLA " << i << ": " << retardo_max_ONU[acum_onus_sla-1][0] << endl;
            //ev<<" Retardo maximo para los paquetes P1 del SLA " << i << ": " << retardo_max_ONU[acum_onus_sla-1][1] << endl;
            //retardo = (double) retardo_alg_ONU[i][1] - retardo_max_ONU[i][1];
            errorPID[acum_onus_sla-1] = (retardo_max_ONU[acum_onus_sla-1][1] - retardo_alg_ONU[acum_onus_sla-1][1]) + (retardo_max_ONU[acum_onus_sla-1][0] - retardo_alg_ONU[acum_onus_sla-1][0]);
            //error[i] = (retardo_alg_ONU[i][1] - retardo_max_ONU[i][1]) + (retardo_alg_ONU[i][0] - retardo_max_ONU[i][0]);
            //ev<<" Delay_limit: " << retardo_max_ONU[acum_onus_sla-1][1] << ". Delay de la ventana real: " << retardo_alg_ONU[acum_onus_sla-1][1] << endl;
            sum_error_delay[acum_onus_sla-1] = sum_error_delay[acum_onus_sla-1] + error[acum_onus_sla-1];
            //ev<<" SLA " << i << ": Error=" << error[acum_onus_sla-1] << "; sum_error=" << sum_error_delay[acum_onus_sla-1] << "; error_ant=" << error_ant_delay[acum_onus_sla-1] << endl;
            // CALCULO DE LA VARIABLE DE CONTROL:
            control[acum_onus_sla-1] = Kp*error[acum_onus_sla-1]; // TERMINO PROPORCIONAL (P)
            //control[i] = Kp*(error[i]+((tiempo_PID/Ti)*sum_error_delay[i])+((Td/Tsample)*(error[i]-error_ant_delay[i])));  //---- PID
            //control[i] = Kp*(error[i]+((Td/tiempo_PID)*(error[i]-error_ant_delay[i])));  // PD
            //control[i] = Kp*(error[i]+((tiempo_PID/Ti)*sum_error_delay[i]));  // PI
            //control[i] = Kp*(((tiempo_PID/Ti)*sum_error_delay[i]));  // I
            //ev<<" Senyal de control (en tiempo): " << control[acum_onus_sla-1] << endl;
            // CONVERSION DE LA SENYAL DE CONTROL A BITS:
            control[acum_onus_sla-1] = control[acum_onus_sla-1]*100000; // Factor de conversion DaSPID = 100000
            //control[i] = control[i]*bw_alg_ONU[i]/retardo_alg_ONU[i][1];
            //ev<<" Senyal de control (en bits): " << control[acum_onus_sla-1] << endl;
            //ev<<" ANTES -> Maximo BW para este SLA segun el PID: " << BW_max_PID[acum_onus_sla-1] << " bits. "<< endl;
            // OBTENCION DE LOS NUEVOS ANCHOS DE BANDA MAXIMOS PARA CADA SLA:
            BW_max_PID[acum_onus_sla-1] = B_max_sla[acum_onus_sla-1] - control[acum_onus_sla-1];
            //BW_max_PID[i] = B_max_sla[i] + control[i];

            // SI EL VALOR MAXIMO DEL PID ES NEGATIVO:
            if(BW_max_PID[acum_onus_sla-1] <= 0.0)
            {
                BW_max_PID[acum_onus_sla-1] = 80000; // bits
            }
            //ev<<" DESPUES -> Maximo BW para este PID: " << BW_max_PID[acum_onus_sla-1] << " bits. "<< endl;
            BW_max_PID_ant[acum_onus_sla-1] = BW_max_PID[acum_onus_sla-1];
            error_ant_delay[acum_onus_sla-1] = error[acum_onus_sla-1];
        }
        for(int j=acum_onus_sla-numonu_sla[i]; j<acum_onus_sla;j++)
        {
            BW_max_PID[j] = BW_max_PID[acum_onus_sla-1];
            B_max_sla[j] = B_max_sla[acum_onus_sla-1];
            //ev<<" BW max segun el PID para la ONU[" << j << "]: " << BW_max_PID[j] << " bits." << endl;
            control[j] = control[acum_onus_sla-1];
            error[j] = error[acum_onus_sla-1];
            sum_error_delay[j] = sum_error_delay[acum_onus_sla-1];
        }
    }
    /////// PRUEBA ///////

    // ESCALADO DE LA SALIDA PARA QUE EL ANCHO DE BANDA NO SUPERE EL CONTENIDO EN EL CICLO MAXIMO:
    time_slot = T_cycle/((int)par("numOnu"));
    BW_total_ciclo = (int)((time_slot - T_guarda - tasa_tx_gate)*txrate*((int)par("numOnu")));  //Ancho de banda maximo total contenido en el tiempo maximo de un ciclo.

    //ESTO ES PARA CARGAS ALTAS DONDE NO SE PUEDE GARANTIZAR EL DELAY:
    double Bw_min=80000; // BITS
    if(flag_control_delay==1)
    {
        //Hay que dar prioridad al SLA0 y SLA1:
        int acum=0;
        int k=0;
        double suma_BW_prioritarios=0.0;

        for (int j=0; j<(int)par("numSLA"); j++)
        {
            for(k=acum; k<numonu_sla[j]+acum; k++)
            {
                if((j==0)||(j==1))
                {
                    suma_BW_prioritarios = suma_BW_prioritarios + BW_max_PID[k];
                }
            }
            acum=k;
        }
        // Si el ancho de banda supera el maximo para las ONUs de este SLA; hay que escalar:
        if(suma_BW_prioritarios > BW_total_ciclo-(Bw_min*numonu_sla[2]))
        {
            //ev<<" La suma de BW prioritario es mayor que el BW disponible en el ciclo, garantizando un minimo al SLA2 --> Escalamos el BW de los prioritarios." << endl;
            acum=0;
            k=0;
            for (int j=0; j<(int)par("numSLA"); j++)
            {
                for(k=acum; k<numonu_sla[j]+acum; k++)
                {
                    if(j==2)
                    {
                        B_max_sla[k]=Bw_min;
                    }
                    else
                    {
                        B_max_sla[k]=((BW_total_ciclo-Bw_min*numonu_sla[2])*BW_max_PID[k])/suma_BW_prioritarios;
                    }
                }
                acum=k;
            }
        }
        // Si el ancho de banda no supera el maximo para las ONUs prioritarias, se da lo que sobra al SLA2:
        else
        {
            //ev<<" Lo que sugiere el PID para los prioritarios es menor que el disponible menos el minimo del SLA2; asi que se da lo que sugiere el PID y el resto se reparte entre las ONUs del SLA2." << endl;
            acum=0;
            k=0;
            for (int j=0; j<(int)par("numSLA"); j++)
            {
                for(k=acum; k<numonu_sla[j]+acum; k++)
                {
                    if((j==0)||(j==1))
                    {
                        B_max_sla[k]=BW_max_PID[k];
                    }

                    if(j==2)
                    {
                        B_max_sla[k]= (BW_total_ciclo-suma_BW_prioritarios)/numonu_sla[2];
                    }
                }
                acum=k;
            }
        }
    }
    else
    {
        // SE ASEGURA UN ANCHO DE BANDA MINIMO A TODAS LAS ONUs:
        for(int i=0; i<(int)par("numOnu"); i++)
        {
            if(BW_max_PID[i] < Bw_min)
            {
                BW_max_PID[i] = Bw_min;
            }
        }
        //Para que en cargas bajas no se vuelva loco intentando llegar a los estipulados y baje mucho el bw del sla2:
        for(int i=0; i<(int)par("numOnu"); i++)
        {
            Total_PID=Total_PID+BW_max_PID[i];
        }
        //Si es mayor que el ancho total disponible en el tiempo de ciclo m���ximo, hay que escalar:
        for(int i=0; i<(int)par("numOnu"); i++)
        {
            B_max_sla[i]=(BW_total_ciclo*BW_max_PID[i])/Total_PID;
        }
    }
    // LIMITAR QUE LOS BWs ASIGNADOS SUPONGAN DAR BWs MAYORES DE 100Mb/s (TASA MAXIMA):
    double bw_rep;
    int onus_mas=0;
    do
    {
        bw_rep=0;
        double BW_tasa_max = 100*1000000*(T_cycle + 16*T_guarda + 16*tasa_tx_gate);
        double Total_PID_ONUs_menores=0;
        for(int i=0; i<(int)par("numOnu"); i++)
        {
            //ev<<" Antes: B_max_sla[" << i << "]=" << B_max_sla[i] << endl;
        }
        for(int i=0; i<(int)par("numOnu"); i++)
        {
            if(B_max_sla[i]>BW_tasa_max)
            {
                bw_rep=bw_rep+(B_max_sla[i]-BW_tasa_max);
                B_max_sla[i]= BW_tasa_max;
            }
            else
            {
                if(B_max_sla[i]!=0)
                {
                    Total_PID_ONUs_menores=Total_PID_ONUs_menores+B_max_sla[i];
                }
            }
        }
        for(int i=0; i<(int)par("numOnu"); i++)
        {
            if((B_max_sla[i]<BW_tasa_max)&&(Total_PID_ONUs_menores!=0))
            {
                B_max_sla[i]=B_max_sla[i]+(bw_rep*B_max_sla[i]/Total_PID_ONUs_menores);
            }
        }
        onus_mas=0;
        for(int i=0; i<(int)par("numOnu"); i++)
        {
            if(B_max_sla[i]>BW_tasa_max)
            {
                onus_mas++;
            }
        }
    }while(onus_mas!=0);

    for(int i=0; i<(int)par("numOnu"); i++)
    {
        //ev<<" Despues: B_max_sla[" << i << "]=" << B_max_sla[i] << endl;
    }
    // FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE LOS VALORES DADOS A DIFERENTES PARAMETROS EMPLEADOS EN EL PID EN CADA CICLO:
    controlfich = fopen("results/control.txt", "a+");
    fprintf(controlfich,"%g\t", SIMTIME_DBL(simTime()));
    for(int i=0; i<(int)par("numOnu"); i++)
    {
        if((i==0)||(i==2)||(i==8))  // revisar
        {
            fprintf(controlfich,"T=%g -> ONU[%i]: Control=%g\tError=%g\tSuma_error=%g\tBW_max=%g\n", SIMTIME_DBL(simTime()), i, control[i], error[i], sum_error_delay[i], B_max_sla[i]);
        }
    }
    fprintf(controlfich,"\n");
    fclose(controlfich);

    //if(simTime()>=20*aux_cont){
        aux_cont++;

        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL RETARDO MEDIO DE VENTANA PARA LA CLASE P0, POR CADA SLA:
        evaluacion_retardo_slas_P0=fopen("results/retardo_medio_P0_slas.txt", "a+");
        //" T \t  SLA_0  \t  SLA_1  \t  SLA_2  \n"
        fprintf(evaluacion_retardo_slas_P0," %g \t %g \t %g \t %g \n" , SIMTIME_DBL(simTime()), (double)retardo_alg_ONU[0][0], (double)retardo_alg_ONU[2][0], (double)retardo_alg_ONU[8][0]);
        fclose(evaluacion_retardo_slas_P0);

        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL RETARDO MEDIO DE VENTANA PARA LA CLASE P1, POR CADA SLA:
        evaluacion_retardo_slas_P1=fopen("results/retardo_medio_P1_slas.txt", "a+");
        //" T \t  SLA_0  \t  SLA_1  \t  SLA_2  \n"
        fprintf(evaluacion_retardo_slas_P1," %g \t %g \t %g \t %g \n" , SIMTIME_DBL(simTime()), (double)retardo_alg_ONU[0][1], (double)retardo_alg_ONU[2][1], (double)retardo_alg_ONU[8][1]);
        fclose(evaluacion_retardo_slas_P1);

        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL B_ALLOC_MEDIO, VALOR MEDIO DE LA VENTANA:
        B_alloc_medio=fopen("results/B_alloc_medio.txt", "a+");
        //" T \t  SLA_0  \t  SLA_1  \t  SLA_2  \n"
        fprintf(B_alloc_medio," %g \t %g \t %g \t %g \n" , SIMTIME_DBL(simTime()), (double)bw_alg_ONU[0], (double)bw_alg_ONU[2], (double)bw_alg_ONU[8]);
        fclose(B_alloc_medio);

        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL B_MAX_PID:
        B_max_PID=fopen("results/B_max_PID.txt", "a+");
        //" T \t  SLA_0  \t  SLA_1  \t  SLA_2  \n"
        fprintf(B_max_PID," %g \t %g \t %g \t %g \n" , SIMTIME_DBL(simTime()), (double)B_max_sla[0], (double)B_max_sla[2], (double)B_max_sla[8]);
        fclose(B_max_PID);

        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL ANCHO DE BANDA TOTAL ASIGNADO A CADA SLA:
        B_total=fopen("results/B_total.txt", "a+");
        //" T \t  SLA_0  \t  SLA_1  \t  SLA_2  \n"
        fprintf(B_total," %g \t %g \t %g \t %g \n" , SIMTIME_DBL(simTime()), (double)B_alloc_total[0], (double)B_alloc_total[2], (double)B_alloc_total[8]);
        fclose(B_total);

        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL PID_MEDIO:
        pid_medio_file=fopen("results/pid_medio_file.txt", "a+");
        //" T \t  SLA_0  \t  SLA_1  \t  SLA_2  \n"
        fprintf(pid_medio_file," %g \t %g \t %g \t %g \n" ,  SIMTIME_DBL(simTime()), (double)PID_MEDIO[0], (double)PID_MEDIO[1], (double)PID_MEDIO[2]);
        fclose(pid_medio_file);
    //}
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MAC_OLT::recoger_delay_por_sla(int sla, double retardo, int prioridad)
{
    // FUNCION PARA RECOGER EL RETARDO POR SLA CADA VENTANA TEMPORAL:
    // La ventana es ahora un array 2D, 3x2results/tamano_throughput_slas.txt (3 SLAs y 2 clases de servicio controladas).
    // Se tiene una cola para cada SLA y prioridad, y se va insertando la media del retardo de los paquetes
    // en un ciclo ("Tcycle"). Adem���s, se guarda el tiempo en que se obtuvo tal retardo para que si la cola
    // supera un cierto tama���o (en segundos), se borra la primera muestra y se inserta la nueva al final.
    //ev<<" Entro en 'recoger_delay' para las ONUs del SLA " << sla << ", con prioridad de servicio P" << prioridad << " y retardo=" << retardo << endl;
    double win_max = 50; // Tiempo maximo de la ventana deslizante
    double win_time;
    //double delay_giv_aux;
    double delay_giv_ant=0.0;
    double delay_borrar_acum=0;
    double delay_borrar;
    double tiempo_ant=0.0;

    // SI EN LA COLA YA SE TIENE ALGUN PAQUETE, SE GUARDAN LOS PARAMETROS DEL ULTIMO EN ESTAS VARIABLES AUXILIARES:
    if(vector_ventana[sla][prioridad].size()!=0)
    {
        delay_giv_ant = vector_ventana[sla][prioridad][vector_ventana[sla][prioridad].size()-1][0];
        tiempo_ant = vector_ventana[sla][prioridad][vector_ventana[sla][prioridad].size()-1][1];
        //ev<<" Retardo medio del ciclo anterior: " << delay_giv_ant << endl;
        //ev<<" Tiempo de ventana del ciclo anterior: " << tiempo_ant << endl;
    }
    // Redimension de la ventana para albergar un nuevo elemento:
    vector_ventana[sla][prioridad].resize(vector_ventana[sla][prioridad].size()+1);
    vector_ventana[sla][prioridad][vector_ventana[sla][prioridad].size()-1].resize(2,0.0);
    // Almacenamiento en la ventana del retardo medio de este ciclo y el tiempo actual:
    vector_ventana[sla][prioridad][vector_ventana[sla][prioridad].size()-1][0] = retardo;
    vector_ventana[sla][prioridad][vector_ventana[sla][prioridad].size()-1][1] = SIMTIME_DBL(simTime());

    //ev<<" Retardo medio de este ciclo: " << vector_ventana[sla][prioridad][vector_ventana[sla][prioridad].size()-1][0] << endl;
    //ev<<" Tiempo de ventana de este ciclo: " << vector_ventana[sla][prioridad][vector_ventana[sla][prioridad].size()-1][1] << endl;

    // Obtencion del tiempo en que fue registrada la primera muestra:
    win_time = vector_ventana[sla][prioridad][0][1];
    // SI NO SE SUPERA EL TAMANYO MAXIMO DE LA VENTANA (10 segundos)...
    if((SIMTIME_DBL(simTime())-win_time)<win_max)
    {
        //ev<<" La cola del SLA " << sla << " NO ha llegado al maximo tiempo de ventana, que son " << win_max << "s." << endl;
        // CALCULO DEL RETARDO ACUMULADO Y EL RETARDO MEDIO PARA LOS PAQUETES DE ESTE SLA Y ESTA PRIORIDAD:
        retardo_acum_SLA[sla][prioridad] = retardo_acum_SLA[sla][prioridad] + retardo;
        retardo_alg_SLA[sla][prioridad] = (double)retardo_acum_SLA[sla][prioridad]/vector_ventana[sla][prioridad].size();
        //ev<<" Retardo acumulado: " << retardo_acum_SLA[sla][prioridad] << "s | Longitud: " << vector_ventana[sla][prioridad].size() << endl;
        //ev<<" MEDIA del SLA " << sla << ": " << retardo_alg_SLA[sla][prioridad] << endl;
    }
    // SI SE SUPERA EL TAMANYO MAXIMO DE LA VENTANA (10 segundos), SE BORRAN PAQUETES:
    else
    {
        //ev<<" La cola del SLA " << sla << " SI ha llegado al maximo tiempo de ventana, que es: " << win_max << " --> BORRADO DE PAQUETES" << endl;
        delay_borrar_acum = 0.0;
        // MIENTRAS SE SUPERE EL TAMANYO MAXIMO DE LA VENTANA, SE BORRAN PAQUETES:
        while((SIMTIME_DBL(simTime())-win_time) > win_max)
        {
            delay_borrar = vector_ventana[sla][prioridad][0][0];
            vector_ventana[sla][prioridad].erase(vector_ventana[sla][prioridad].begin());
            delay_borrar_acum = delay_borrar_acum + delay_borrar;
            win_time = vector_ventana[sla][prioridad][0][1];
            //ev<<" Retardo borrado: " << delay_borrar << " | Retardo total borrado: " << delay_borrar_acum << endl;
        }
        //ev<<" Longitud de la ventana: " << SIMTIME_DBL(simTime()) - win_time << " segundos." << endl;
        retardo_acum_SLA[sla][prioridad] = retardo_acum_SLA[sla][prioridad] + retardo - delay_borrar_acum;
        retardo_alg_SLA[sla][prioridad] = retardo_acum_SLA[sla][prioridad]/vector_ventana[sla][prioridad].size();
        //ev<<" Retardo acumulado: " << retardo_acum_SLA[sla][prioridad] <<" | Longitud de la ventana: " << vector_ventana[sla][prioridad].size() << endl;
        //ev<<" MEDIA del retardo del SLA " << sla << ", para la prioridad P" << prioridad << ": " << retardo_alg_SLA[sla][prioridad] << endl;
    }
    // Como 'PID_control_delay()' se basa en los retardos de las ONUs individuales, se asigna a cada ONU el retardo correspondiente a su SLA:
    int aux=0, j;
    for(int i=0; i<(int)par("numSLA"); i++)
    {
        for(j=aux; j<(int)numonu_sla[i]+aux; j++)
        {
            for(int k=0; k<2; k++)
            {
                retardo_alg_ONU[j][k] = retardo_alg_SLA[i][k];
            }
        }
        aux = j;
    }
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION PID(cMessage *msg)--> ESTE ALGORITMO SE ENCARGA DE OBTENER LOS PARAMETROS DEL CONTROLADOR PID, TANTO ANCHOS DE BANDA  //
//          GARANTIZADOS, ERRORES, TANTO ACTUAL, COMO ANTERIOR, COMO DOS VECES ANTERIOR                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PID(cMessage *msg)
{
    delete msg;
    //Ku=1.1 y Tu=22
    //double Kp=0.5; //PARAMETRO DE NUESTRO PID Kp=0.6Ku
    //double Ti=11; //PARAMETRO DE NUESTRO PID Ti=0.5Tu
    //double Td=2.75; //PARAMETRO DE NUESTRO PID  Td=0.125Tu
    double time_slot; //VARIABLE PARA EL TIEMPO DE SLOT
    double T_cycle=0.002; // TIEMPO DE CICLO MAXIMO EN MILISEGUNDOS
    int BW_total_ciclo; //ANCHO DE BANDA TOTAL DEL CICLO
    double T_guarda = 0.000001; //TIEMPO DE GUARDA QUE SE ESPERA ENTRA LA TRANSMISION DE DOS ONUS
    //long int txrate = (long int)par("txrate"); // VARIABLE TASA DE TRANSMISION

    long double tasa_tx_gate = (long double)512/txrate; // TASA DE TRANSMISION DEL PAQUETE GATE DE 64 BYTES
    double Total_PID=0.0;
    long double tasa_tx_report = (long double)512/txrate; // TASA DE TRANSMISION DEL PAQUETE REPORT DE 64 BYTES


    //HAY QUE PONER LOCK MUTEX
    pthread_mutex_lock (&mutex);

    //ev<<" ENTRA EN EL PID EN EL TIEMPO: "<<simTime()<<endl;
    //tiempo_inic_PID+=tiempo_PID;

    //GENERAMOS EL MENSAJE DE TIPO 6 PARA QUE DESDE EL handleMessage() SE LLAME CADA
    // 'tiempo_inic_PID' EL ALGORITMO PID QUE ACTUALIZA LOS ANCHOS DE BANDA MAXIMOS
    // EN FUNCION DE LOS ERRORES. ESTO ES PARALELO A LA ASIGNACION DE ANCHO DE BANDA,
    // CICLO TRAS CICLO, QUE SE REALIZA CON EL ALGORITMO ANTERIOR, 'DBA_polling_PID'.
    //cMessage *msg2 = new cMessage ("Mensaje inicial");
    //msg2->setKind(6); // IDENTIFICAMOS EL AUTOMENSAJE CON EL IDENTIFICADOR = 6
    //scheduleAt(tiempo_inic_PID, msg2); // SI QUE QUITA NO SE INICIALIZAN LAS ONUS, NO SE MANDAN LOS GATES
    //ev<<"   Proximo PID en T=" << tiempo_inic_PID << "." << endl;


    /*prueba_PID=fopen("results/prueba_PID.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
      fprintf(prueba_PID,"%g\t" , (double)Kp);
      fprintf(prueba_PID,"\t");
      fprintf(prueba_PID,"%g\t" , (double)Ti);
      fprintf(prueba_PID,"\t");
      fprintf(prueba_PID,"%g\t" , (double)Td);
      fprintf(prueba_PID,"\t");
      fprintf(prueba_PID,"%g\t", SIMTIME_DBL(simTime()));
      fprintf(prueba_PID,"\n");
      fclose(prueba_PID);*/ // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS



    //RECORREMOS TODAS LAS ONU's
    for(int i=0; i<num_onus_red; i++)
    {
        //ev<<" Si es 1 se activa el PID si es 0 no: "<<pet[i]<<" para la onu: "<<i<<endl;

        //NO SE ACTIVA EL PID
        if(pet[i]==0)
        {
            //ENTRAR UNA VEZ QUE EL PID SALTE AL MENOS UNA VEZ
            if(intento_pid==1)
            {
                //ev<<" MAXIMO ANTERIOR "<<BW_max_PID_ant[i]<<endl;
                BW_max_PID[i]=BW_max_PID_ant[i];
            }
            //B_guarantee[i]=BW_SLA_onu[i]*1000000*(T_cycle-(int)par("numOnu")*T_guarda-(int)par("numOnu")*tasa_tx_report); // Bits
            B_guarantee[i]=BW_SLA_onu[i]*1000000*(T_cycle-num_onus_red*T_guarda-num_onus_red*tasa_tx_report); // Bits
            errorPID[i]=B_guarantee[i]-bw_alg_ONU[i];
            //ev<<" Garantizado "<<B_guarantee[i]<<endl;
        }

        //SE ACTIVA EL PID:
        else
        {
            intento_pid=1;

            //B_guarantee[i]=BW_SLA_onu[i]*1000000*(T_cycle-(int)par("numOnu")*T_guarda-(int)par("numOnu")*tasa_tx_report);
            B_guarantee[i]=BW_SLA_onu[i]*1000000*(T_cycle-num_onus_red*T_guarda-num_onus_red*tasa_tx_report);

            //ev<<" GARANTIZADO "<<B_guarantee[i]<<endl;
            //ev<<" MEDIA "<<bw_alg_ONU[i]<<endl;

            //CALCULAMOS EL ERROR
            errorPID[i]=B_guarantee[i]-bw_alg_ONU[i];

            //ACTUALIZAMOS EL ERROR
            sum_error[i]=sum_error[i]+errorPID[i];

            //CALCULAMOS LA VARIABLE DE CONTROL
            //MODIFICADO POR ALEJANDRO
            //control[i]=Kp*(errorPID[i]+((tiempo_PID/Ti)*sum_error[i])+((Td/tiempo_PID)*(errorPID[i]-error_ant[i])));
            control[i] = controlant [i] + Kp*(errorPID[i]-error_ant[i])+Ki*errorPID[i]+Kd*(errorPID[i]-2*error_ant[i]+error_2antPID[i]);
            controlant [i] = control[i];
            //ev<<" control "<<control[i]<<endl;
            //ev<<" error "<<errorPID[i]<<endl;

            //ev<<" error ant "<<error_ant[i]<<endl;
            //ev<<" sum_error "<<sum_error[i]<<endl;
            if(simTime()>=20*cont1)
            {
                cont1++;
                graf_control=fopen("results/control.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
                fprintf(graf_control,"%g\t" , (double)control[0]);
                fprintf(graf_control,"\t");
                fprintf(graf_control,"%g\t" , (double)control[1]);
                fprintf(graf_control,"\t");
                fprintf(graf_control,"%g\t" , (double)control[6]);
                fprintf(graf_control,"\t");
                fprintf(graf_control,"%g\t", SIMTIME_DBL(simTime()));
                fprintf(graf_control,"\n");
                fclose(graf_control); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS
            }

            //CALCULAMOS EL VALOR MAXIMO DEL PID
            BW_max_PID[i]=B_max_sla[i]+control[i];
            if(simTime()>=20*cont2)
           {
               cont2++;
               B_max_PID_ant=fopen("results/B_max_PID_ant.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
               fprintf(B_max_PID_ant,"%g\t" , (double)BW_max_PID[0]);
               fprintf(B_max_PID_ant,"\t");
               fprintf(B_max_PID_ant,"%g\t" , (double)BW_max_PID[1]);
               fprintf(B_max_PID_ant,"\t");
               fprintf(B_max_PID_ant,"%g\t" , (double)BW_max_PID[6]);
               fprintf(B_max_PID_ant,"\t");
               fprintf(B_max_PID_ant,"%g\t", SIMTIME_DBL(simTime()));
               fprintf(B_max_PID_ant,"\n");
               fclose(B_max_PID_ant); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS
           }

            //SI EL VALOR MAXIMO DEL PID ES NEGATIVO
            if(BW_max_PID[i]<0.0)
            {
                BW_max_PID[i]=0.0;
            }

            BW_max_PID_ant[i]=BW_max_PID[i];

            error_ant[i]=errorPID[i];
            error_2antPID[i]=error_ant[i];
        }
    }

    //ev<<" Kp "<<Kp<<endl;
    //ev<<" Ki "<<Ki<<endl;
    //ev<<" Kd "<<Kd<<endl;

    //ESCALAMOS LA SALIDA PARA QUE EL ANCHO DE BANDA NO SUPERE EL CONTENIDO EN EL CICLO MAXIMO
    time_slot= T_cycle/num_onus_red;
    //time_slot= T_cycle/((int)par("numOnu"));

    //BW_total_ciclo = (int)((time_slot - T_guarda - tasa_tx_gate)*txrate*(int)par("numOnu"));
    BW_total_ciclo = (int)((time_slot - T_guarda - tasa_tx_gate)*txrate*num_onus_red);

    //RECORREMOS TODAS LAS ONUs PARA COMPLETAR EL SUMATORIO DE Total_PID
    for(int i=0; i<num_onus_red; i++)
    {
        Total_PID = Total_PID + BW_max_PID[i];
    }

    //ev<<" Total Pid "<<Total_PID<<endl;
    //ev<<" BW_total_ciclo "<<BW_total_ciclo<<endl;

    //SI EL PID TOTAL ES MAYOR QUE EL ANCHO DE BANDA TOTAL DEL CICLO
    if(Total_PID>BW_total_ciclo)
    {
        //ev<<" Total Pid > BW_total_ciclo "<<endl;
        for(int i=0; i<num_onus_red; i++)
        {
            B_max_sla[i]=(BW_total_ciclo*BW_max_PID[i])/Total_PID;
        }
    }
    //SI EL PID TOTAL ES MENOR QUE EL ANCHO DE BANDA TOTAL DEL CICLO
    else
    {
        //ev<<" Total Pid < BW_total_ciclo "<<endl;
        for (int i=0; i<num_onus_red; i++)
        {
            B_max_sla[i]=BW_max_PID[i];
        }
    }

    if(simTime()>=20*cont)
    {
        cont++;
        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL B_ALLOC_MEDIO , VALOR MEDIO DE LA VENTANA
        //SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
        B_alloc_medio=fopen("results/B_alloc_medio.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        fprintf(B_alloc_medio,"%g\t" , (double)bw_alg_ONU[0]);
        fprintf(B_alloc_medio,"\t");
        fprintf(B_alloc_medio,"%g\t" , (double)bw_alg_ONU[1]);
        fprintf(B_alloc_medio,"\t");
        fprintf(B_alloc_medio,"%g\t" , (double)bw_alg_ONU[6]);
        fprintf(B_alloc_medio,"\n");
        fclose(B_alloc_medio); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL B_MAX_PID
        //SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
        B_max_PID=fopen("results/B_max_PID.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        fprintf(B_max_PID,"%g\t" , (double)B_max_sla[0]);
        fprintf(B_max_PID,"\t");
        fprintf(B_max_PID,"%g\t" , (double)B_max_sla[1]);
        fprintf(B_max_PID,"\t");
        fprintf(B_max_PID,"%g\t" , (double)B_max_sla[6]);
        fprintf(B_max_PID,"\n");
        fclose(B_max_PID); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS


        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL B_Mbps
        //SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
        BW_Mbps=fopen("results/BW_Mbps.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        fprintf(BW_Mbps,"%g\t" , (double)((B_Mbps_sla[0]/1000000)/SIMTIME_DBL(simTime()))/numonu_sla[0]);
        fprintf(BW_Mbps,"\t");
        fprintf(BW_Mbps,"%g\t" , (double)((B_Mbps_sla[1]/1000000)/SIMTIME_DBL(simTime()))/numonu_sla[1]);
        fprintf(BW_Mbps,"\t");
        fprintf(BW_Mbps,"%g\t" , (double)((B_Mbps_sla[2]/1000000)/SIMTIME_DBL(simTime()))/numonu_sla[2]);
        fprintf(BW_Mbps,"\t");
        fprintf(BW_Mbps,"%g\t", SIMTIME_DBL(simTime()));
        fprintf(BW_Mbps,"\n");
        fclose(BW_Mbps); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS



        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL B_TOTAL
        //SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
        B_total=fopen("results/B_total.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        fprintf(B_total,"%g\t" , (double)B_alloc_total[0]);
        fprintf(B_total,"\t");
        fprintf(B_total,"%g\t" , (double)B_alloc_total[1]);
        fprintf(B_total,"\t");
        fprintf(B_total,"%g\t" , (double)B_alloc_total[6]);
        fprintf(B_total,"\n");
        fclose(B_total); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

        //FICHERO PARA LA RECOGIDA DE LOS DATOS SOBRE EL PID_MEDIO
        //SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
        pid_medio_file=fopen("results/pid_medio_file.txt", "a+");
        fprintf(pid_medio_file,"%g\t" , (double)PID_MEDIO[0]);
        fprintf(pid_medio_file,"\t");
        fprintf(pid_medio_file,"%g\t" , (double)PID_MEDIO[1]);
        fprintf(pid_medio_file,"\t");
        fprintf(pid_medio_file,"%g\t" , (double)PID_MEDIO[2]);
        fprintf(pid_medio_file,"\n");
        fclose(pid_medio_file); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS
    }


    //MODIFICADO POR ALEJANDRO
    //HAY QUE PONER COUNTERPID++
    counterPID++;
    iterAprendizaje++;
    //HAY QUE PONER UNLOCK MUTEX
    pthread_mutex_unlock (&mutex);
    //ev<<"counterPID: "<<counterPID<<endl;

}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void recoger_bw_por_onu(cMessage *msg)
{
    REPORTmsg *reportmsg = check_and_cast<REPORTmsg *>(msg); // CHEQUEAMOS EL PAQUETE REPORT

    //ev<<" "<<endl;
    //ev<<" ENTRO EN EL CODIGO PARA RECOGER ANCHO DE BANDA POR ONU "<<endl;
    //ev<<" "<<endl;

    double win_max = 7.5; //TAMANYO MAXIMO DE VENTANA //DaSPID->Twindow=10s.
    int onu=reportmsg->getSrcAddress(); //VARIABLE QUE NOS INDICA EL IDENTIFICADOR DE LA ONU CORRESPONDIENTE
    double bw_giv_ant=0.0; //VARIABLE QUE GUARDARI EL ANCHO DE BANDA ANTERIOR
    double tiempo_ant=0.0; //VARIABLE QUE GUARDARI EL TIEMPO ANTERIOR
    double win_time; //VARIABLE PARA EL TIEMPO DE VENTANA
    double bw_borrar_acum; //VARIABLE QUE VA A IR ACUMULANDO LA SUMA DEL ANCHO DE BANDA DE TODOS LOS PAQUETES BORRADOS
    double Mbps_borrar_acum; //VARIABLE QUE VA A IR ACUMULANDO LA SUMA DEL ANCHO DE BANDA DE TODOS LOS PAQUETES BORRADOS EN MBPS
    double bw_borrar; //ANCHO DE BANDA DEL PAQUETE BORRADO
    double Mbps_borrar; //MBPS BORRADOS DE UN PAQUETE

    //HAY QUE PONER UN LOCK MUTEX
    pthread_mutex_lock (&mutex);

    //ENTRAR SI EN LA COLA YA TENEMOS ALGUN PAQUETE
    if(cola_vector[onu].size()!=0)
    {
        bw_giv_ant=cola_vector[onu][cola_vector[onu].size()-1][0];
        tiempo_ant=cola_vector[onu][cola_vector[onu].size()-1][1];
    }

    cola_vector[onu].resize(cola_vector[onu].size()+1);
    cola_vector[onu][cola_vector[onu].size()-1].resize(3, 0.0);

    cola_vector[onu][cola_vector[onu].size()-1][0]= B_alloc[onu];
    cola_vector[onu][cola_vector[onu].size()-1][1]= SIMTIME_DBL(simTime());
    cola_vector[onu][cola_vector[onu].size()-1][2]= ((double)bw_giv_ant/(SIMTIME_DBL(simTime())-tiempo_ant));

    //ACTUALIZAMOS EL TIEMPO DE VENTANA
    win_time = cola_vector[onu][0][1];

    //ENTRAMOS SI NO SUPERAMOS EL TAMANYO MAXIMO DE LA VENTANA
    if((SIMTIME_DBL(simTime())-win_time)<win_max)
    {
        //CALCULAMOS EL BW ACUMULADO Y EL BW MEDIO
        bw_acum_ONU[onu]=bw_acum_ONU[onu]+(double)B_alloc[onu];
        bw_alg_ONU[onu]=(double)(bw_acum_ONU[onu]/cola_vector[onu].size());
        //ev<<" B_acumulado "<<bw_acum_ONU[onu]<<" y tamaño "<<cola_vector[onu].size()<<endl;
        //ev<<" MEDIA de la ONU: "<<onu<<" : "<<bw_alg_ONU[onu]<<endl;
        //ev<<" La cola de la ONU "<<onu<<" NO ha llegado al maximo tiempo de ventana, que es: "<<win_max<<endl;
        bw_acum_Mbps[onu]= bw_acum_Mbps[onu]+(double)(bw_giv_ant/(SIMTIME_DBL(simTime())-tiempo_ant));
        bw_alg_Mbps[onu]=(double)(bw_acum_Mbps[onu]/cola_vector[onu].size());
    }
    //ENTRAMOS SI SUPERAMOS EL TAMANYO MAXIMO DE LA VENTANA
    else
    {
        bw_borrar_acum=0;
        Mbps_borrar_acum=0.0;
        //ev<<" La cola de la ONU "<<onu<<" SI ha llegado al maximo tiempo de ventana, que es: "<<win_max<<endl;
        //BORRAMOS PAQUETES MIENTRAS SUPEREMOS EL TAMANYO MAXIMO DE LA VENTANA
        while ( (SIMTIME_DBL(simTime())-win_time)>win_max)
        {
            bw_borrar=cola_vector[onu][0][0];

            Mbps_borrar=cola_vector[onu][0][2];
            cola_vector[onu].erase(cola_vector[onu].begin());

            bw_borrar_acum = bw_borrar_acum + bw_borrar;
            Mbps_borrar_acum = Mbps_borrar_acum + Mbps_borrar;
            win_time = cola_vector[onu][0][1];
            //ev<<" bw_borrado "<<bw_borrar<<endl;
        }
        //ev<<" El siguiente win time de la ventana es "<<win_time<<endl;
        bw_acum_ONU[onu]=bw_acum_ONU[onu]+(double)B_alloc[onu] - bw_borrar_acum;
        bw_alg_ONU[onu]=bw_acum_ONU[onu]/cola_vector[onu].size();
        //ev<<" B_acumulado "<<bw_acum_ONU[onu]<<" y tamaño "<<cola_vector[onu].size()<<endl;
        //ev<<" MEDIA de la ONU en bits: "<<onu<<" : "<<bw_alg_ONU[onu]<<endl;
        bw_acum_Mbps[onu]=bw_acum_Mbps[onu]+(double)(bw_giv_ant/(SIMTIME_DBL(simTime())-tiempo_ant))- Mbps_borrar_acum;
        bw_alg_Mbps[onu]=(double)(bw_acum_Mbps[onu]/cola_vector[onu].size());
    }
    //CALCULAMOS LA MEDIA DE UNA ONU DE CADA SLA
    if(onu==0)
    {
        PID_MEDIO_TOTAL[0]=PID_MEDIO_TOTAL[0]+BW_max_PID[0];
        cont_aux0++;
        PID_MEDIO[0]=PID_MEDIO_TOTAL[0]/cont_aux0;
    }
    else if(onu==2)//1)
    {
        PID_MEDIO_TOTAL[1]=PID_MEDIO_TOTAL[1]+BW_max_PID[1];
        cont_aux2++;
        PID_MEDIO[1]=PID_MEDIO_TOTAL[1]/cont_aux2;
    }
    else if(onu==8)//6)
    {
        PID_MEDIO_TOTAL[2]=PID_MEDIO_TOTAL[2]+BW_max_PID[2];
        cont_aux10++;
        PID_MEDIO[2]=PID_MEDIO_TOTAL[2]/cont_aux10;
    }

    //HAY QUE PONER UN UNLOCK MUTEX
    pthread_mutex_unlock (&mutex);
}



void MAC_OLT::recoger_Bdemand(cMessage *msg)
{

    REPORTmsg *reportmsg = check_and_cast<REPORTmsg *>(msg); // CHEQUEAMOS EL PAQUETE REPORT

    double ventana = 1; //TAMANYO MAXIMO DE VENTANA //DaSPID->Twindow=10s.
    int onu=reportmsg->getSrcAddress(); //VARIABLE QUE NOS INDICA EL IDENTIFICADOR DE LA ONU CORRESPONDIENTE
    double bw_demand_giv_ant=0.0; //VARIABLE QUE GUARDARI EL ANCHO DE BANDA ANTERIOR
    double tiempo_anterior=0.0; //VARIABLE QUE GUARDARI EL TIEMPO ANTERIOR
    double win_demand_time; //VARIABLE PARA EL TIEMPO DE VENTANA
    double bw_demand_borrar_acum; //VARIABLE QUE VA A IR ACUMULANDO LA SUMA DEL ANCHO DE BANDA DE TODOS LOS PAQUETES BORRADOS
    double bw_borrar; //ANCHO DE BANDA DEL PAQUETE BORRADO

    //ENTRAR SI EN LA COLA YA TENEMOS ALGUN PAQUETE
    if(cola_vector_demand[onu].size()!=0)
    {
        bw_demand_giv_ant=cola_vector_demand[onu][cola_vector_demand[onu].size()-1][0];
        tiempo_anterior=cola_vector_demand[onu][cola_vector_demand[onu].size()-1][1];
    }

    cola_vector_demand[onu].resize(cola_vector_demand[onu].size()+1);
    cola_vector_demand[onu][cola_vector_demand[onu].size()-1].resize(3, 0.0);
    cola_vector_demand[onu][cola_vector_demand[onu].size()-1][0]= B_demand[onu];
    cola_vector_demand[onu][cola_vector_demand[onu].size()-1][1]= SIMTIME_DBL(simTime());
    cola_vector_demand[onu][cola_vector_demand[onu].size()-1][2]= ((double)bw_demand_giv_ant/(SIMTIME_DBL(simTime())-tiempo_anterior));

    //ACTUALIZAMOS EL TIEMPO DE VENTANA
    win_demand_time = cola_vector_demand[onu][0][1];

    //ENTRAMOS SI NO SUPERAMOS EL TAMANYO MAXIMO DE LA VENTANA
    if((SIMTIME_DBL(simTime())-win_demand_time)<ventana)
    {
        bw_acum_demand_ONU[onu]=bw_acum_demand_ONU[onu]+(double)B_demand[onu];
        bw_demand_ONU[onu]=(double)(bw_acum_demand_ONU[onu]/cola_vector_demand[onu].size());
        //ev<<" B_acumulado "<<bw_acum_ONU[onu]<<" y tamaño "<<cola_vector[onu].size()<<endl;
        //ev<<" MEDIA de la ONU: "<<onu<<" : "<<bw_alg_ONU[onu]<<endl;
    }
    else
    {
        bw_demand_borrar_acum=0;
        while ( (SIMTIME_DBL(simTime())-win_demand_time)>ventana)
        {
            bw_borrar=cola_vector_demand[onu][0][0];
            cola_vector_demand[onu].erase(cola_vector_demand[onu].begin());
            bw_demand_borrar_acum = bw_demand_borrar_acum + bw_borrar;
            win_demand_time = cola_vector_demand[onu][0][1];
        }

        //ev<<" El siguiente win time de la ventana es "<<win_time<<endl;
        bw_acum_demand_ONU[onu]=bw_acum_demand_ONU[onu]+(double)B_demand[onu] - bw_demand_borrar_acum;
        bw_demand_ONU[onu]=bw_acum_demand_ONU[onu]/cola_vector_demand[onu].size();
    }

    //ev<<" B_acumulado "<<bw_acum_ONU[onu]<<" y tamaño "<<cola_vector[onu].size()<<endl;
    // ev<<" MEDIA de la ONU en bits: "<<onu<<" : "<<bw_demand_ONU[onu]<<endl;

}




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MAC_OLT::calcularvarianza(cMessage *msg)
{
    REPORTmsg *reportmsg = check_and_cast<REPORTmsg *>(msg); // CHEQUEAMOS EL PAQUETE REPORT

    //ev<<" "<<endl;
    //ev<<" ENTRO EN EL CODIGO PARA CALCULAR VARIANZA "<<endl;
    //ev<<" "<<endl;

    int onu=reportmsg->getSrcAddress(); //VARIABLE QUE NOS INDICA EL IDENTIFICADOR DE LA ONU CORRESPONDIENTE
    int acum=0;
    double T_cycle=0.002; // TIEMPO DE CICLO MAXIMO EN MILISEGUNDOS
    double T_guarda = 0.000001; // TIEMPO DE GUARDA QUE SE ESPERA ENTRA LA TRANSMISION DE DOS ONUS
    long int txrate = (long int)par("txrate"); // TASA DE TRANSMISION EN BITS POR SEGUNDO
    long double tasa_tx_gate = (long double)512/txrate;
    long double tasa_tx_report = (long double)512/txrate; // TASA DE TRANSMISION DEL PAQUETE REPORT DE 64 BYTES
    int m;
    //if(pet[onu]==1) //SI DEMANDA MIS ANCHO DE BANDA QUE EL MAXIMO, CALCULAMOS LA VARIANZA
    //{
        for (int j=0; j<(int)par("numSLA"); j++)
        {
            for(int k=acum; k<numonu_sla[j]+acum; k++)
            {
                B_guarantee[k]=BW_SLA_onu[k]*1000000*(T_cycle-(int)par("numOnu")*T_guarda-(int)par("numOnu")*tasa_tx_report);

                if(k==onu)
                {
                    //ev<<" SLA: "<<j<<" y ONU: "<<k<<endl;

                    desviacionBwMax[j].analyze(B_max_sla[k]);
                    desviacionBwMaxGuar[j]= desviacionBwMaxGuar[j]+((B_guarantee[k]-B_max_sla[k])*(B_guarantee[k]-B_max_sla[k]));
                    cont_var_BwMax[j]++;

                    //ev<<" pet "<<pet[k]<<endl;

                    //if(pet[k]==1)
                    //{

                        var[j]= var[j]+((B_guarantee[k]-bw_alg_ONU[k])*(B_guarantee[k]-bw_alg_ONU[k]));
                        var_Mbps[j]=var_Mbps[j]+ ((B_guarantee[k]/(T_cycle-16*T_guarda - 16*tasa_tx_gate))-bw_alg_Mbps[k])*((B_guarantee[k]/(T_cycle-16*T_guarda - 16*tasa_tx_gate))-bw_alg_Mbps[k]);  //EL CUADRADO DEL ERROR
                        cont_var[j]=cont_var[j]+1;

                        //ev<<" VARIANZA "<<1.960*sqrt(var[j]/cont_var[j])<<endl;
                        //ev<<" VARIANZA MBPS "<<1.960*sqrt(var_Mbps[j]/cont_var[j])<<endl;
                        desviacion[j].analyze(bw_alg_Mbps[k]);
                    //}
                }
            m=k;
            }
            acum=m+1;
        }
    //}
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION FINISH()--> ESTA FUNCION SE INVOCA CUANDO LA SIMULACION HA TERMINADO CON EXITO SIN QUE SE PRODUZCA NINGUN ERROR.      //
//                    LO USAMOS PARA LA RECOGIDA DE ESTADISTICAS MEDIANTE UN ARCHIVO.                                           //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void MAC_OLT::finish()
{

    //RECOGIDA DE ESTADISTICAS CON LA CLASE ANALISIS!! GUARDAMOS LOS DATOS EN UN ARCHIVO
    // SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
    retardo_analisis=fopen("results/retardo_analisis.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        // RECORREMOS ESTE BUCLE FOR PARA OBTENER LA MEDIA GLOBAL DE CADA SERVICIO
        for(int i=0; i<(int)par("numqueue"); i++)
        {
            fprintf(retardo_analisis,"%g\t", (double)retardo_global_P[i].average()); // MEDIA DEL RETARDO
            fprintf(retardo_analisis,"%g\t", (double)retardo_global_P[i].half_confidence_interval()); // DESVIACIxN DEL RETARDO
        }
        fprintf(retardo_analisis,"\n");
        fprintf(retardo_analisis,"%g\n", numReceived);
        fclose(retardo_analisis); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS


        B_alloc_longitudonda=fopen("results/B_alloc_longitudonda.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
         fprintf(B_alloc_longitudonda,"%g\t", SIMTIME_DBL(simTime()));
         fprintf(B_alloc_longitudonda,"\n");
         fprintf(B_alloc_longitudonda,"%g\t" , (double)B_alloc_lambda[0]);
         fprintf(B_alloc_longitudonda,"\t");
         fprintf(B_alloc_longitudonda,"%g\t" , (double)B_alloc_lambda[1]);
         fprintf(B_alloc_longitudonda,"\t");
         fprintf(B_alloc_longitudonda,"%g\t" , (double)B_alloc_lambda[2]);
         fprintf(B_alloc_longitudonda,"\t");
         fclose(B_alloc_longitudonda); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

        // ARCHIVO PARA RECOGER LOS DATOS DEL RETARDO POR CADA SLA GLOBAL Y POR TIPO DE SERVICIOS
        // SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
        /*retardo_analisis_sla=fopen("results/retardo_analisis_sla.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
        for(int i=0; i<(int)par("numSLA"); i++)
        {
            fprintf(retardo_analisis_sla,"%g\t", (double)retardo_sla[i].average()); // MEDIA DEL RETARDO GLOBAL DE CADA SLA
            // RECORREMOS ESTE BUCLE FOR PARA OBTENER LA MEDIA DE CADA SERVICIO ASOCIADA A CADA SLA
            for(int j=0; j<(int)par("numqueue"); j++)
            {
                fprintf(retardo_analisis_sla,"%g\t", (double)retardo_servicios_sla[i][j].average());
            }
            fprintf(retardo_analisis_sla,"%g\t", (double)retardo_sla[i].half_confidence_interval()); // DESVIACIxN DEL RETARDO GLOBAL DE CADA SLA
            // RECORREMOS ESTE BUCLE FOR PARA OBTENER EL INTERVALO DE CONFIANZA DE CADA SERVICIO ASOCIADO A CADA SLA
            for(int j=0; j<(int)par("numqueue"); j++)
            {
                fprintf(retardo_analisis_sla,"%g\t", (double)retardo_servicios_sla[i][j].half_confidence_interval()); // MEDIA DEL RETARDO GLOBAL DE CADA SLA
            }
            fprintf(retardo_analisis_sla,"\n");
        }
        fprintf(retardo_analisis_sla,"\n");
        fclose(retardo_analisis_sla); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS*/

        // RECOGIDA DE ESTADISTICAS DE LAS MEDIAS DE LOS BYTES QUE QUEDAN EN LAS COLAS DE TODAS LAS ONUs DESPUxS DE CADA CICLO CON LA CLASE ANALISIS Y LO GUARDAMOS LOS DATOS EN UN ARCHIVO
        // SE PONE LA RUTA DONDE SE VAN A CREAR LOS ARCHIVOS
        /*media_total_onu=fopen("results/media_total_onu.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
            for(int i=0; i<(int)par("numqueue"); i++)
            {
                    fprintf(media_total_onu,"%g\t", (double)media_bytes_total_onus[i].average()); // MEDIA DE LOS BYTES QUE QUEDAN EN LAS COLAS DESPUxS DE CADA CICLO
            }
            fprintf(media_total_onu,"\n");
            fclose(media_total_onu); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

        throughput_net=fopen("results/throughput_net.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
            fprintf(throughput_net,"%g\t", (double)throughput);
            fprintf(throughput_net,"\n");
            fclose(throughput_net); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS*/


}





//////////////////////////////////////////////////////////////////////////////////////
//                                                                                  //
//                               INICIO ALGORITMO GENÉTICO                          //
//                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//MODIFICADO POR ALEJANADRO
float Objective(GAGenome& g) {

    float error=0.0;
    ofstream outfile;

    GABin2DecGenome& genome = (GABin2DecGenome&)g;

    InitializePID(genome.phenotype(0), genome.phenotype(1), genome.phenotype(2));
    InitializeWindow();

    // cout<< "valen Kp="<< Kp<< "Ti="<<Ti<<" Td="<<Td<<"\n";

    //sleep(30);

    //Analize the commited error


    int counter=0;

    do{
        sleep(1);
        //cout<<" kp"<<genome.gene(0)<<"---"<<genome.score()<< "ti"<<genome.gene(1)<<"---"<<genome.score()<< "td "<<genome.gene(2)<<"---"<<genome.score()<< "\n";
        //cout<<" couterPID"<<counterPID<< "\n";

        for(int i=0; i<num_onus_red; i++)
        {
                error= error +(float)abs(B_guarantee[i]-bw_alg_ONU[i]);
        }

            counter++;

    }while(counterPID<nIterPID);

    error = error/num_onus_red;
    error = error/counter;

    outfile.open("ResultadosSimulaciones/PID_GA/evolucion.txt", (STD_IOS_OUT | STD_IOS_APP));

    outfile<<"El error cometido por Kp="<< Kp<< " Ti="<<Ti<<" Td="<< Td<< "es error="<<error<<"\n";
    outfile.close();

    counterPID=0;


    return error;

}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void* Algoritmo_Genetico(void *t)
{
    float err_pob;
    int xbest=1;
    float err_xbest;
    ofstream outfile;
    ofstream outfile_err;
    void * out;

    /*prueba_algoritmo_genetico=fopen("results/prueba_algoritmo_genetico.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
       fprintf(prueba_algoritmo_genetico,"%g\t" , (double)Kp);
       fprintf(prueba_algoritmo_genetico,"\t");
       fprintf(prueba_algoritmo_genetico,"%g\t" , (double)Ti);
       fprintf(prueba_algoritmo_genetico,"\t");
       fprintf(prueba_algoritmo_genetico,"%g\t" , (double)Td);
       fprintf(prueba_algoritmo_genetico,"\t");
       fprintf(prueba_algoritmo_genetico,"%g\t", SIMTIME_DBL(simTime()));
       fprintf(prueba_algoritmo_genetico,"\n");
       fclose(prueba_algoritmo_genetico); */// CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

    sleep(2);

    GABin2DecPhenotype map;
    map.add(16, MIN_VALUE, MAX_VALUE);
    map.add(16, MIN_VALUE, MAX_VALUE);
    map.add(16, MIN_VALUE, MAX_VALUE);

    GABin2DecGenome genome(map, Objective);

    GASimpleGA ga(genome);
    ga.minimize();
    ga.populationSize(tamPoblacion);
    ga.pMutation(0.01);
    ga.pCrossover(0.9);
    GALinearScaling linearScaling;
    ga.scaling(linearScaling);
    //ga.scoreFilename("ResultadosSimulaciones/PID_GA/NewGen.text");
    ga.scoreFilename("ResultadosSimulaciones/PID_GA/NewGen.txt");
    ga.scoreFrequency(1);
    ga.flushFrequency(10);
    ga.selectScores(GAStatistics::AllScores);

    //Si queremos que converja con el numero de generaciones
    ga.nGenerations(numGen);

    ga.initialize();


    outfile.open("ResultadosSimulaciones/PID_GA/popi.txt", (STD_IOS_OUT | STD_IOS_APP));

      for(int ii=0; ii<ga.population().size(); ii++)
      {
        genome = ga.population().individual(ii);
        //cout<<" kp"<<genome.gene(0)<<"---"<<genome.score()<< "ti"<<genome.gene(1)<<"---"<<genome.score()<< "td "<<genome.gene(2)<<"---"<<genome.score()<< "\n";
        outfile<<" kp="<<genome.phenotype(0)<<" ti="<<genome.phenotype(1)<<" td="<<genome.phenotype(2)<<"----"<<genome.score()<< "\n";

        //Para hacer estadisticas de la media del error de la poblacion
        err_pob+=genome.score();
        if(ii<xbest)
            err_xbest+=genome.score();

      }
    outfile.close();

    //Para guardar la media del error
    outfile_err.open("ResultadosSimulaciones/PID_GA/error_pob.txt", (STD_IOS_OUT | STD_IOS_APP));
    outfile_err<<nIterPID<<"\t"<<tamPoblacion<<"\t"<<numGen<<"\t"<<err_pob/ga.population().size()<< "\t";
    outfile_err.close();

    outfile_err.open("ResultadosSimulaciones/PID_GA/error_5mej.txt", (STD_IOS_OUT | STD_IOS_APP));
    outfile_err<<nIterPID<<"\t"<<tamPoblacion<<"\t"<<numGen<<"\t"<< err_xbest/xbest<< "\t";
    outfile_err.close();


    while(!ga.done())
    {
        //Inicializamos las variables de las estadisticas de los errores
        err_pob=0.0;
        err_xbest=0.0;

        ga.step();
        outfile.open("ResultadosSimulaciones/PID_GA/popintermedia.txt", (STD_IOS_OUT | STD_IOS_APP));

        for(int i=0; i<ga.population().size(); i++)
        {
            genome = ga.population().individual(i);
            outfile<<" kp="<<genome.phenotype(0)<<" ti="<<genome.phenotype(1)<<" td="<<genome.phenotype(2)<<"----"<<genome.score()<< "\n";

            //Para hacer estadisticas de la media del error de la poblacion
            err_pob+=genome.score();
            if(i<xbest)
                err_xbest+=genome.score();


        }
        outfile<< "---------------------------------------------------------------------------------------\n";
        outfile.close();


        ///Para guardar la media del error
        outfile_err.open("ResultadosSimulaciones/PID_GA/error_pob.txt", (STD_IOS_OUT | STD_IOS_APP));
        outfile_err<<err_pob/ga.population().size()<< "\t";
        outfile_err.close();

        outfile_err.open("ResultadosSimulaciones/PID_GA/error_5mej.txt", (STD_IOS_OUT | STD_IOS_APP));
        outfile_err<< err_xbest/xbest<< "\t";
        outfile_err.close();

    }

    // dump the final population to file
    //Inicializamos las variables de las estadisticas de los errores
    err_pob=0.0;
    err_xbest=0.0;

    outfile.open("ResultadosSimulaciones/PID_GA/pofin.txt", (STD_IOS_OUT | STD_IOS_APP));

      for(int i=0; i<ga.population().size(); i++){
        genome = ga.population().individual(i);
        //cout<<" kp"<<genome.gene(0)<<"---"<<genome.score()<< "ti"<<genome.gene(1)<<"---"<<genome.score()<< "td "<<genome.gene(2)<<"---"<<genome.score()<< "\n";
        outfile<<" kp="<<genome.phenotype(0)<<" ti="<<genome.phenotype(1)<<" td="<<genome.phenotype(2)<<"----"<<genome.score()<< "\n";

        //Para hacer estadisticas de la media del error de la poblacion
            err_pob+=genome.score();
            if(i<xbest)
                err_xbest+=genome.score();

      }

      outfile.close();



    //Para guardar la media del error
    outfile_err.open("ResultadosSimulaciones/PID_GA/error_pob.txt", (STD_IOS_OUT | STD_IOS_APP));
    //outfile_err<<err_pob/ga.population().size()<< "\n";
    outfile_err<< "\n";
    outfile_err.close();

    outfile_err.open("ResultadosSimulaciones/PID_GA/error_5mej.txt", (STD_IOS_OUT | STD_IOS_APP));
    //outfile_err<< err_xbest/xbest<< "\n";
    outfile_err<< "\n";
    outfile_err.close();

    //pongo el mejor individuo en los kp, ti y td que no se van  a mover más
    //cout<<"el mejor individuoi es "<< ga.statistics().bestIndividual()<<"\n";


    genome=ga.statistics().bestIndividual();
    //Kp=genome.phenotype(0);
    //Ti=genome.phenotype(1);
    //Td=genome.phenotype(2);

    outfile_err.open("ResultadosSimulaciones/PID_GA/mejorIndividuo.txt", (STD_IOS_OUT | STD_IOS_APP));
    outfile_err<<tamPoblacion<< "\t"<<numGen<<"\t"<< genome.score()<<"\n";
    outfile_err<<"kp="<<genome.phenotype(0)<<" ti="<<genome.phenotype(1)<<" td="<<genome.phenotype(2)<<"----"<<genome.score()<< "\n";
    outfile_err.close();

    ///Inicializmaos el PID y la ventana y le ponemos la Kp, Ti y Td definitivas

    InitializePID(genome.phenotype(0), genome.phenotype(1), genome.phenotype(2));
    InitializeWindow();

    controlVarianza=1;
    controlVentana=1;
    finTraining=1;
    //cout<<"AKBOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO\n";

    return out;

}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void InitializeWindow()
{

    //Funcion que inicializa la ventana donde se calcula la media del ancho de banda asignado a cada ONU

    //cout<<"entro para inicializar la cola\n";

    pthread_mutex_lock(&mutex);
    //cout<< "he bloqueado la cola\n";


    for(int i=0; i<num_onus_red; i++)
    {
            bw_acum_ONU[i]=0;
            bw_alg_ONU[i]=0;
            bw_acum_Mbps[i]=0;
            bw_alg_Mbps[i]=0;

            //cout<<"antes de vaciar el tamaño del vector es "<<cola_vector[i].size()<<"\n";
            //cout<<"antes el vector es tamaño"<<cola_vector[i].size<<"\n";
            cola_vector[i].clear();
            //cout <<"despues el vector es tamaño"<<cola_vector[i].size<<"\n";
    }


    pthread_mutex_unlock(&mutex);

    //cout<<"He inicializado la ventana\n";

}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void InitializePID(double kp, double ti, double td)
{
    int acum=0;
    int k=0;

    pthread_mutex_lock(&mutex);


    Kp=kp;
    Ti=ti;
    Td=td;

    /*prueba_initialize_PID=fopen("results/prueba_initialize_PID.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
          fprintf(prueba_initialize_PID,"%g\t" , (double)Kp);
          fprintf(prueba_initialize_PID,"\t");
          fprintf(prueba_initialize_PID,"%g\t" , (double)Ti);
          fprintf(prueba_initialize_PID,"\t");
          fprintf(prueba_initialize_PID,"%g\t" , (double)Td);
          fprintf(prueba_initialize_PID,"\t");
          fprintf(prueba_initialize_PID,"%g\t", SIMTIME_DBL(simTime()));
          fprintf(prueba_initialize_PID,"\n");
          fclose(prueba_initialize_PID);*/ // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS

    //cout<<"He puesto el valor d kp, ti, td\n";

    for (int i=0; i<num_onus_red; i++)
    {
        sum_error[i]=0.0;
        error_ant[i]=0.0;
        //BW_max_PID_ant[i]=0.0;

    }

    //cout<<"inicializo los errores\n";

    acum=0;
    k=0;


    for (int j=0; j<num_SLAs; j++)
    {
        for(k=acum; k<numonu_sla[j]+acum; k++)
        {

            BW_max_PID[k]=B_max_sla[j];
            //cout<<"entro y el Bw max de la onu "<<k<<" vale "<< BW_max_ONU[k]<<"\n";


        }
        acum=k;
    }

    for (int m=0; m<num_onus_red; m++)
    {
        BW_max_PID_ant[m]=BW_max_PID[m]; //Los primeros anchos de banda propuestos por el PID son = al primer bw de la ONU.

    }
        //asi no se pone a 0 su bw si la primera vez no pide.

    pthread_mutex_unlock(&mutex);

    //cout<<"He inicializado el PID\n";

}
//////////////////////////////////////////////////////////////////////////////////////
//                                                                                  //
//                               FINAL ALGORITMO GENÉTICO                           //
//                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////





//////////////////////////////////////////////////////////////////////////////////////
//                                                                                  //
//                                  INICIO RED NEURONAL                             //
//                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION Neural_Network_init()--> FUNCIÓN QUE SE INVOCA DENTRO DE LA FUNCIÓN initialize() Y EN LA QUE SE INICIALIZAN           //
//          LOS PARÁMETROS DE LA RED NEURONAL, ENTRE ELLOS Kp, Ki, ALPHA Y NABLA                                                //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void Neural_Network_init()
{
    double aux;

    for(int i=0; i<(HIDDEN_NN-1); i++)      // HIDDEN_NN-1 modificado al añadir las señales de bias, antes estaba a HIDDEN_NN, pero sirve para que no se conectan las dos entradas de bias entre sí
    {

        for(int j=0; j<IN_NN; j++)
        {
            aux = rand () % 56789;
            //aux = rand () % 12345;
            //aux = rand() % 34567;
            W1[i][j]= aux/1000000;
            Incremento_W1[i][j]=0.0;
            IncrementoAnt_W1[i][j]=0.0;
            //printf("W1[%d][%d]=%g\n", i,j,W1[i][j]);
        }
    }

    for(int j=0; j<OUT_NN; j++)
    {

        for(int k=0; k<HIDDEN_NN; k++)
        {
            aux = rand () % 2345678;
            //aux = rand () % 12345;
            //aux = rand() % 34567;
            W2[j][k]= aux/100000;
            Incremento_W2[j][k]=0.0;
            IncrementoAnt_W2[j][k]=0.0;
            //printf("W2[%d][%d]=%g\n", j,k,W2[j][k]);
        }
    }

    for(int m=0; m<IN_NN; m++)
    {
        V_IN_NN[IN_NN]=0.0;
    }

    Ki= Kp*Ts/Ti;   // DEFINICIÓN DEL PARÁMETRO DE LA RED NEURONAL Ki
    Kd= Kp*Td/Ts;   // DEFINICIÓN DEL PARÁMETRO DE LA RED NEURONAL Kd
    alpha=0.1;      // DEFINICIÓN DEL PARÁMETRO DE INERCIA ALPHA
    nabla=0.1;      // DEFINICIÓN DEL PARÁMETRO DE INERCIA NABLA

}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION Neural_Network_FeedPropagation()--> FUNCIÓN EN LA QUE EL ERROR DEL CONTROLADOR PID (e[k], e[k-1] y e[k-2]) SE INSERTA     //
//          EN LA CAPA DE ENTRADA Y SE PROPAGA A LAS CAPAS OCULTA Y DE SALIDA, Y EL ALGORITMO OBTIENE LOS NUEVOS PARÁMETROS         //
//          DE SINTONIZACIÓN PARA LOS CICLOS SIGUIENTES.                                                                            //                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void Neural_Network_FeedPropagation()
{

    //double out_hidden[5];
    //double out_final[3];
    double sum;


    //Hacía delante, valores Kp, Ki, Kd
    //-------------------------------------------------------

    for(int i=0; i<HIDDEN_NN; i++)
    {
        out_hidden[i]=0.0;
    }

    for(int i=0; i<OUT_NN; i++)
    {
        out_final[i]=0.0;
        sum=0.0;
    }

    for(int i=0; i<(HIDDEN_NN-1); i++)
    {
        for(int j=0; j<IN_NN; j++)
        {
            sum+=W1[i][j]*V_IN_NN[j];
        }

        //printf("la salida del sumatorio es %g\n", sum);
        out_hidden[i]=Tangente_Hiperbolica(sum);
        //printf("el resultado de tang hiperboica es %g \n", out_hidden[i]);
        sum=0.0;

    }

    //printf("sacando out hidden\n");

    sum=0.0;

    for(int i=0; i<OUT_NN; i++)
    {
        for(int j=0; j<HIDDEN_NN; j++)
        {
            sum+=W2[i][j]*out_hidden[j];
        }

        //printf("entrada a la capa final es %g\n", sum);

        //out_final[i]=exp(2*Sigmoide(sum));
        out_final[i]=Sigmoide(sum);


        //TRUNCAMOS POR SI LA SALIDA DE LA FUNCIÓN SIGMOIDAL ES NEGATIVA
        if(out_final[i]<0.0)
        {
            out_final[i]=0.0001;
        }

        //printf("salida capa final es %g\n", out_final[i]);

        sum=0.0;

    }

    //printf("sacando valores finales\n");

    /*
    Kp=out_final[0];
    Ki=exp(2*out_final[1]);
    Kd=exp(2*out_final[2]);

    Ti=(exp(2*Kp))*Ts/Ki;
    Td=Kd*Ts/(exp(2*Kp));*/

    Kp=out_final[0];        // SE OBTIENE EL PARÁMETRO Kp A LA SALIDA DE LA RED NEURONAL
    Ki=out_final[1];        // SE OBTIENE EL PARÁMETRO Ki A LA SALIDA DE LA RED NEURONAL
    Kd=out_final[2];        // SE OBTIENE EL PARÁMETRO Kd A LA SALIDA DE LA RED NEURONAL

    Ti = Kp*Ts/Ki;
    Td = Kd*Ts/Kp;

}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION Neural_Network_BackPropagation()--> FUNCIÓN EN LA QUE CON LOS PARÁMETROS DE SINTONIZACIÓN OBTENIDOS DE LA FUNCIÓN     //
//          Neural_Network_FeedPropagation(), Y PROPAGÁNDOSE DESDE LA SALIDA HASTA LA ENTRADA, SE CALCULA EL ERROR.             //
//          POR LO TANTO, EN BASE A ESTOS ERRORES, SE VA ACTUALIZANDO LA MATRIZ DE PESOS.                                       //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void Neural_Network_BackPropagation()
{
    //ev<<" ENTRA EN NEURAL_BACKPROPAGATION<<endl;

    //double sum_errorNN=0.0;
    /*double deltaSalida[3];
    double deltaHidden[5];
    double in_hidden[5];
    double back_final[3];
    double back_hidden[5];*/
    ofstream outfile;
    float aux;

    //Guardamos los incrementos de los pesos anteriores y errores
    //-------------------------------------------------
    for(int i=0; i<(HIDDEN_NN-1); i++)
    {
        for(int j=0; j<IN_NN; j++)
        {
            IncrementoAnt_W1[i][j]=Incremento_W1[i][j];
        }
    }

    for(int j=0; j<OUT_NN; j++)
    {
        for(int k=0; k<HIDDEN_NN; k++)
        {
            IncrementoAnt_W2[j][k]=Incremento_W2[j][k];
        }
    }

    //---------------------------------------------------
    //---------------------------------------------------
    //MODIFICADO POR ALEJANDRO
    //Errores para redes neuronales con autoaprendizaje:
    sum_errorNN=0.0;
    error_2antNN=error_antNN;
    error_antNN=errorNN;

    for(int i=0; i<num_onus_red; i++)
    {
        aux = (float)fabs(B_guarantee[i]-bw_alg_ONU[i]);
        sum_errorNN = (aux*aux)/2 + sum_errorNN;
        //sum_errorNN+=(float)abs(B_guarantee[i]-bw_alg_ONU[i]);
    }

    errorNN=(double)(sum_errorNN/num_onus_red);


    //Calculamos incrementos de pesos capa salida
    double sum=0.0;

    for(int i=0; i<(HIDDEN_NN-1); i++)
    {
        for(int j=0; j<IN_NN; j++)
        {
            sum+=W1[i][j]*V_IN_NN[j];
        }

        //printf("entradas capa oculta %g\n", sum);
        in_hidden[i]=Tangente_Hiperbolica(sum);
        //printf("salida capa oculta tang %g \n", in_hidden[i]);
        sum=0.0;

    }


    //MODIFICADO POR DAVID
    in_hidden[5]=1.0;       // SEGUNDA ENTRADA DE BIAS AÑADIDA


    sum=0.0;

    for(int i=0; i<OUT_NN; i++)
    {
        for(int j=0; j<HIDDEN_NN; j++)
        {
            sum+= W2[i][j]*in_hidden[j];
        }

        back_final[i]=sum;
        sum=0.0;
        //printf("entradas capa final %g\n", back_final[i]);

    }

    deltaSalida[0]=(errorNN/max_error_NN)*((errorNN-error_antNN)/max_error_NN)*Derivada_Sigmoide(back_final[0]);
    //printf("valor delta1 %g\n", deltaSalida[0]);
    deltaSalida[1]=(errorNN/max_error_NN)*(errorNN/max_error_NN)*Derivada_Sigmoide(back_final[1]);
    //printf("valor delta2 %g\n", deltaSalida[1]);
    deltaSalida[2]=(errorNN/max_error_NN)*((errorNN-2*error_antNN+error_2antNN)/max_error_NN)*Derivada_Sigmoide(back_final[2]);
    //printf("valor delta3 %g\n", deltaSalida[2]);

    /*outfile.open("ResultadosSimulaciones/PID_GA/PruebaErrores.txt", (STD_IOS_OUT | STD_IOS_APP));
    outfile<<"Error:"<<errorNN<<"\tError anterior:"<<error_antNN<<"\tError 2 veces anterior:"<<error_2antNN<<"\n";
    outfile<<"Salida Delta 0:"<<deltaSalida[0]<<"\tSalida Delta 1:"<<deltaSalida[1]<<"\tSalida Delta 2:"<<deltaSalida[2]<<"\n";
    outfile<<"--------------------------------------------------------------------------------------------------------------------\n";
    outfile.close();*/


    // Se escribe en un archivo tanto los errores como las deltas
    PruebaErrores=fopen("ResultadosSimulaciones/PID_GA/PruebaErrores.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS
    fprintf(PruebaErrores,"Error: %g\t" , (double)errorNN);
    fprintf(PruebaErrores,"\t");
    fprintf(PruebaErrores,"Error anterior: %g\t" , (double)error_antNN);
    fprintf(PruebaErrores,"\t");
    fprintf(PruebaErrores,"Error 2 veces anterior: %g\t" , (double)error_2antNN);
    fprintf(PruebaErrores,"\n");
    fprintf(PruebaErrores,"Salida Delta 0: %g\t" , (double)deltaSalida[0]);
    fprintf(PruebaErrores,"\t");
    fprintf(PruebaErrores,"Salida Delta 1: %g\t" , (double)deltaSalida[1]);
    fprintf(PruebaErrores,"\t");
    fprintf(PruebaErrores,"Salida Delta 2: %g\t" , (double)deltaSalida[2]);
    fprintf(PruebaErrores,"\n\n");
    fclose(PruebaErrores); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS


    for(int i=0; i<OUT_NN; i++)
    {
        for(int j=0; j<HIDDEN_NN; j++)
        {
            Incremento_W2[i][j]=alpha*IncrementoAnt_W2[i][j]+nabla*deltaSalida[i]*in_hidden[j];
            //printf("incremento W2[%d][%d]=%g\n", i,j,Incremento_W2[i][j]);
        }
    }

    //Calculamos incrementos de pesos capa oculta
    sum=0.0;

    for(int i=0; i<(HIDDEN_NN-1); i++)
    {
        for(int j=0; j<IN_NN; j++)
        {
            sum += W1[i][j]*V_IN_NN[j];
        }

        //printf("entradas capa oculta %g\n", sum);
        back_hidden[i]=Derivada_Tang_Hiperbolica(sum);
        //printf("salida capa oculta derivda tanh %g\n", back_hidden[i]);
        sum=0.0;

    }

    sum=0.0;

    for(int m=0; m<HIDDEN_NN; m++)
    {
        for(int k=0; k<OUT_NN; k++)
        {
            sum+=deltaSalida[k]*W2[k][m];
        }

        deltaHidden[m]=back_hidden[m]*sum;
        sum=0.0;

    }

    for(int i=0; i<(HIDDEN_NN-1); i++)
    {
        for(int j=0; j<IN_NN; j++)
        {
            Incremento_W1[i][j]=alpha*IncrementoAnt_W1[i][j]+nabla*deltaHidden[i]*V_IN_NN[j];
            //printf("incremento W1[%d][%d]=%g\n", i,j,Incremento_W1[i][j]);
        }
    }

    //Modificamos los pesos
    for(int i=0; i<(HIDDEN_NN-1); i++)
    {
        for(int j=0; j<IN_NN; j++)
        {
            W1[i][j]=W1[i][j]+Incremento_W1[i][j];
        }
    }

    for(int i=0; i<OUT_NN; i++)
    {
        for(int j=0; j<HIDDEN_NN; j++)
        {
            W2[i][j]=W2[i][j]+Incremento_W2[i][j];
        }
    }

    //outfile.open("ResultadosSimulaciones/PID_GA/PesosCapaOculta.txt", (STD_IOS_OUT | STD_IOS_APP));
    PesosCapaOculta=fopen("ResultadosSimulaciones/PID_GA/PesosCapaOculta.txt", "a+"); // ABRIMOS EL ARCHIVO EN EL QUE GUARDAREMOS LOS RESULTADOS

    for(int i=0; i<(HIDDEN_NN-1); i++)
    {
        for(int j=0; j<IN_NN; j++)
        {
            //outfile<<"W1["<<i<<"]["<<j<<"]="<<W1[i][j]<<"\t";
            fprintf(PesosCapaOculta,"W1[""%d""][""%d""]=: %g\t" , i, j, (double)W1[i][j]);
        }
        //outfile<<"\n";
        fprintf(PesosCapaOculta,"\n");
    }
    /*outfile<<"Error: "<<errorNN;
    outfile<<"-------------------------------------------------------\n";
    outfile.close();*/
    fprintf(PesosCapaOculta,"Error: %g" , (double)errorNN);
    fprintf(PesosCapaOculta,"\n\n");
    fclose(PesosCapaOculta); // CERRAMOS EL ARCHIVO EN EL QUE GUARDAMOS LOS DATOS


}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION Tangente_Hiperbolica(double value)--> FUNCIÓN EN LA QUE SE CALCULA LA TANGENTE HIPERBÓLICA DEL                        //
//          PARÁMETRO QUE SE RECIBE COMO ARGUMENTO.                                                                               //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
double Tangente_Hiperbolica(double value)
{

    double out;

    //FIN(Tangente_Hiperbolica());
    //out=(exp(value)-exp((-1)*value))/(exp(value)+exp((-1)*(value)));
    out=tanh(value);

    return (out);

}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION Sigmoide (double value)--> FUNCIÓN QUE REALIZA LA FUNCIÓN LINEAL DEL PARÁMETRO QUE SE RECIBE COMO ARGUMENTO           //
//                                                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
double Sigmoide (double value)
{

    double out;

    //FIN(Sigomide());
    //out= (exp(value))/(1+exp((-1)*value));
    out = value;
    return (out);

}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION Derivada_Tang_Hiperbolica (double value)--> FUNCIÓN EN LA QUE SE CALCULA LA DERIVADA DE LA                            //
//          TANGENTE HIPERBÓLICA DEL PARÁMETRO QUE SE RECIBE COMO ARGUMENTO.                                                    //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
double Derivada_Tang_Hiperbolica (double value)
{

    double out;

    //FIN(Derivada_Tang_Hiperbolica());
    out= 1 - pow(Tangente_Hiperbolica(value),2);

    return (out);

}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION Derivada_Sigmoide(double value)--> FUNCIÓN EN LA QUE SE REALIZA LA DERIVADA DE LA                                     //
//          FUNCIÓN LINEAL DEL PARÁMETRO QUE SE RECIBE COMO ARGUMENTO, ES DECIR, VAMOS A OBTENER UN VALOR CONSTANTE.            //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
double Derivada_Sigmoide(double value)
{

    double out;

    //FIN(Derivada_Sigmoide());
    //out= 2*Sigmoide(value)*(1-Sigmoide(value));
    out = 1;
    return (out);

}

//////////////////////////////////////////////////////////////////////////////////////
//                                                                                  //
//                                  FINAL RED NEURONAL                              //
//                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////

